define("io.ox/office/editframework/app/editapplication",["exports","io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/dom","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/apputils","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/utils/webfonts","io.ox/office/editframework/utils/dateutils","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,Xt,en,tn,nn,t,n,r,o,i,rn,on,a,s,l,an,sn,ln,cn,dn,un,gn,c,pn,fn,En,hn,On,d,u,_n,Sn,mn,g,In,Nn){"use strict";var Rn=t.isFiniteNumber,An=t.getNumber,Dn=t.getArray,p=t.newPromise,vn=t.newFulfilled,Cn=t.newRejected,yn=n.toPromise,bn=n.stringEndsWith,Tn=n.trimAndCleanString,wn=n.capitalizeFirst,Ln=n.filterArray,Fn=r.getSchemeColorIndex,Un=o.FILTER_MODULE_NAME,xn=o.requireOptModule,$n=i.Logger,kn=i.globalLogger,Pn=hn.SaveAsType,Mn=hn.STORAGE_AVAILABLE,Bn=hn.RENAME_DISABLED,Hn=hn.TRANSFER_EDIT_RIGHTS_TIMEOUT,Gn=hn.getStorageValue,qn=a.IntervalRunner,jn=s.MessageDialog,Vn=l.FlushReason,Wn=l.QuitReason,Yn=l.createTextDownload,zn=c.BaseApplication,Kn=d.otLogger,Qn=d.dbgDumpActions,Zn=u.importWebFonts,Jn=g.acquireEditLogger,Xn=g.AcquireEditRightsWorker,er="accept",tr="decline",nr="inactive",rr=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];function or(e){e=Dn(e,"operations",!0);return e.every(_.isObject)?e:(kn.error("$badge{EditApp} getOperationsFromData: invalid elements in operations array",e),[])}function ir(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:In.RELOAD_ICON,label:In.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:In.EDIT_ICON,label:In.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:In.LOAD_RESTORED_ICON,label:In.LOAD_RESTORED_LABEL};break;default:delete e.action}}function ar(r,o,i){return p(function(e,t){r.done(e).fail(t);var n=window.setTimeout(function(){t("timeout"),kn.warn(i+" - operation timed out")},o);r.always(function(){window.clearTimeout(n)})})}e.EditApplication=zn.extend(function(e,b,T){var w=this,L=null,F=null,t=null,U=null,n=null,x=null,k=null,p=[],o=null,r=!1,i=!1,a=0,P=nn.getFunctionOption(T,"preProcessHandler"),M=nn.getFunctionOption(T,"postProcessHandler"),d=nn.getFunctionOption(T,"fastEmptyLoadHandler"),f=nn.getFunctionOption(T,"previewHandler"),s=nn.getFunctionOption(T,"importFailedHandler",_.noop),l=nn.getFunctionOption(T,"optimizeOperationsHandler"),c=!0,E=nn.getFunctionOption(T,"mergeCachedOperationsHandler"),h=!T||!T.otConfigKey||hn.getFlag(T.otConfigKey,!0),u=h?100:nn.getNumberOption(T,"sendActionsDelay",0),g=nn.getBooleanOption(T,"isMultiSelectionApp",!0),O=nn.getBooleanOption(T,"isSnapshotApp",!0),S=null,m=null,I=!1,N=null,R=null,A=!1,D=!1,v=null,C=!1,y=!1,B=!1,H=null,G=!1,q=!1,j=!1,V=!1,W=null,Y=!1,z=nn.getBooleanOption(T,"localStorageApp",!1)&&!h,K=nn.getIntegerOption(T,"requiredStorageVersion",0),Q=nn.getIntegerOption(T,"supportedStorageVersion",0),Z=!1,J=hn.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!b.auth_code,X=!1,ee={},te=1,ne=[],re=[],oe=[],ie=null,ae=0,se=!1,le=nn.getBooleanOption(T,"supportsOnlineSync",!0),ce=null,de=!1,ue=!1,ge={},pe="",fe={},Ee=[],he=!0,Oe=!1,_e=[],Se=null,me=null,Ie=!1,Ne=!1,Re=!1,Ae=null,De=null,ve=0,Ce=!0,ye=null,be=null,Te=!1,we="slow load",Le=!1,Fe=[],Ue=0,xe=null,$e=-1,ke=-1,Pe=!1,Me=0,Be=[],He={},Ge=null,qe=null,je=!1,Ve=!1,We=!1;function Ye(e,t){var n=w.getState();w.setRootAttribute("data-app-state",n),w.trigger("docs:state",n,e,t),w.trigger("docs:state:"+n,t),Jn.log("statechange",n,e)}function ze(e){var t,n=G?"error":ie?"preview":I?B||!R?"readonly":Lt()?"sending":A?"ready":"initial":"offline";S!==n&&(t=S,S=n,Ye(t,e))}function Ke(e){R!==e&&(R=e,w.setRootAttribute("data-edit-mode",R),w.trigger("docs:editmode",R),Jn.log("$back{LightPink}changeEditMode",R),w.trigger(R?"docs:editmode:enter":"docs:editmode:leave"),ze())}function Qe(){return{documentFileLockedByUser:H,fullFileName:w.getFullFileName(),oldEditUser:N,isEditor:It()}}function Ze(e,t){var n,r=Nn("Read-Only Mode"),o=null,i=null;return _.isString(e)?(i={type:"info",message:e,headline:r},isNaN(t)||(i.duration=t),i=_.extend({},i,{action:"acquireedit"})):(n=Qe(),o=w.getErrorState(),i=ye,_.isObject(i)||(_.isObject(o)&&(o.isError()||o.isWarning())?i=un.getMessageData(o,n):(o=w.getInfoState(),_.isString(o)&&(i=gn.getMessageData(o,n))))),w.extendMessageData(i),F.yell(i)}zn.call(this,e,function(){var a=[],I=w.createDeferred(),e=null,t=null,s=$.Deferred(),l=!1,c=!1,N=[],R=[],A=!1,d=-1,u=w.launchTracker;function D(e,t){N.push(t),Sn.log("Document status update received during document import")}function v(e,t){R.push(t),Sn.log("Clients update received during document import")}function C(e,t){Sn.log("Final operation message received for asynchronous load"),h&&!w.isViewerMode()&&t.docStatus&&At(t.docStatus.serverOSN),t.hasErrors||"error"===w.getState()?I.reject(t):s.always(function(){var e,n,r,o;a.push(t),I.resolve((e=a,n={},r=[],o=null,_.each(e,function(e){var t=e.operations;$.extend(n,e),t&&(delete e.operations,r=r.concat(t)),e.rescueOperations&&(o=e.rescueOperations)}),He=n&&n.syncInfo,Sn.log("loadDocInfo",He),n.operations=r,o&&(n.rescueOperations=o),_.isEmpty(n.operations)&&n.syncInfo&&d===parseInt(n.syncInfo["document-osn"],10)&&(A=!0),n))})}function y(e,t){var n,r,o,i=null;if(se)return delete t.actions,0<a.length?a[0]=_.extend(a[0],t):a.push(t),void s.resolve();if(n=t,nn.getBooleanOption(n,"preview",!1))return l=!0,void a.push(t);if(l&&!c){c=!0,n=a,r=0,o=[],_.each(n,function(e){r=_.isNumber(e.activeSheet)?e.activeSheet:r,o=o.concat(e.operations)}),i={preview:{activeSheet:r,operations:o}},(a=[]).push(t);i=function(n){var e=new an(n),r=nn.getObjectOption(n,"preview"),e=e.isError()?$.Deferred().reject(n):$.when();r&&_.isArray(r.operations)&&(e=function(){var e=(e=yt(P,"previewPreProcessing","Preview preprocess handler finished")).then(function(){P=null;var e=Dn(n.preview,"operations"),t=e?L.applyExternalOperations(e,{expand:!0}):w.createResolvedPromise();return u.asyncStep(t,"previewApplyOperations","$badge{EditApp} "+(e?e.length:0)+" preview operations applied"),t=t.then(function(){return f.call(w,r)?w.leaveBusyDuringImport():$.when()},function(e){e&&"abort"===e||(n.operationError=!0,n.message=Nn("An unrecoverable error occurred while modifying the document."))})});return u.asyncStep(e,"previewEnd","$badge{EditApp} Preview postprocess handler finished")}());return e}(i);return u.asyncStep(i,"previewProcessing","$badge{EditApp} Preview data processed"),i.done(function(){s.resolve()}),void i.fail(function(){s.reject(),bt(t)})}l||"pending"!==s.state()||s.resolve(),a.push(t)}function g(t){var n,r,e,o,i,a,s,l,c,d,u,g,p=or(t),f=(n=t.docStatus,r={},rr.forEach(function(e){e in n&&(r[e]=n[e])}),r),E=new an(t),h=null;function O(e,t){return je=!!e.rescueOperations||nn.getBooleanOption(e.docStatus,"rescueDoc",null),Nt(e).always(function(){_t(e.docStatus)}),me=nn.getStringOption(e.syncInfo,"restore_id",null),Z=nn.getBooleanOption(e.syncInfo,"renameNeedsReload",!1),w.waitForImportSuccess(function(){Sn.log("Applying clients update messages, count = "+R.length),_.each(R,function(e){Nt(e)}),Sn.log("Applying document update messages, count = "+t.length),_.each(t,function(e){Ct(e)}),Gt()&&(k.off(En.RESPONSE_OPEN_DOC_CHUNK,y),k.off(En.RESPONSE_OPEN_DOC,C),k.off(En.BROADCAST_UPDATE_CLIENTS,v).on(En.BROADCAST_UPDATE_CLIENTS,function(e,t){Nt(t)}),k.off(En.BROADCAST_UPDATE,D).on(En.BROADCAST_UPDATE,function(e,t){Ct(t)})),ze(),hn.DEBUG&&e.rescueOperations&&w.trigger("docs:rescueoperations",e.rescueOperations),I.resolve({action:[]})}),$.when()}function S(){return w.getUserInfo(ox.user_id).done(function(e){x=nn.escapeHTML(e.operationName)})}return w.isViewerMode()&&(B=!0,Ke(!(He={}))),U=nn.getStringOption(t.docStatus,"clientId",""),ee[U]=0,e=null,nn.getBooleanOption(t,"hasErrors",!1)?(kn.error("$badge{EditApp} importHandler: server side error"),e="server"):nn.getBooleanOption(t,"operationError",!1)?(kn.error("$badge{EditApp} importHandler: operation failure"),e=t.message):E.isError()?(kn.error("$badge{EditApp} importHandler: server side error, errorCode="+E.getCodeAsConstant()),e="server"):0===U.length?(kn.error("$badge{EditApp} importHandler: missing client identifier"),e="noclientid"):se||A||_.isArray(p)&&0!==p.length||(kn.error("$badge{EditApp} importHandler: missing document operations"),e="noactions"),h=e?{cause:e}:null,_.isObject(h)?(h=_.extend(h,bt(t)),$.Deferred().reject(h)):(d=null,"load"===b.action&&_.isObject(b.file)&&(Mn&&z&&J&&t.syncInfo&&t.syncInfo.fileVersion&&Rn(t.syncInfo["document-osn"])&&t.syncInfo.fileId&&t.syncInfo.folderId&&_.isFunction(L.setFullModelNode)&&_.isFunction(L.getSupportedStorageExtensions)&&(o=t.syncInfo.fileId+"_"+t.syncInfo.folderId,c=o+"_FILEVERSION",i=o+"_STORAGEVERSION",s=o+"_OSN",l=o+"_OPERATIONS",d=L.getSupportedStorageExtensions(),a=localStorage.getItem(i)&&parseInt(localStorage.getItem(i),10)||1,K<=a?(kn.info("$badge{EditApp} importHandler: document-osn="+t.syncInfo["document-osn"]+", document-rev="+t.syncInfo.fileVersion),localStorage.getItem(c)&&localStorage.getItem(c)===t.syncInfo.fileVersion&&localStorage.getItem(s)&&parseInt(localStorage.getItem(s),10)===parseInt(t.syncInfo["document-osn"],10)?!function(){var e=Gn(l);if(_.isArray(e)){0<p.length&&L.setExternalLocalStorageOperationsExist(!0),p=e.concat(p);e=_.last(p);return _.isNumber(e.osn)||(e.opl=1,e.osn=parseInt(localStorage.getItem(s),10)-1),1}}()?(kn.info("$badge{EditApp} importHandler: required operations in local storage not found. Key: "+l),m()):d.some(function(e){var t=o+e.extension,n={usedLocalStorage:!0};_.isObject(e.additionalOptions)&&_.extend(n,e.additionalOptions);var r=localStorage.getItem(t);if(r)kn.info("$badge{EditApp} importHandler: loading document from local storage. Key: "+t+" Length: "+localStorage.getItem(t).length),X=!0,we="local storage",L.setFullModelNode(r,n);else{if(!e.optional)return kn.info("$badge{EditApp} importHandler: key in local storage not found. Key: "+t+". But found OSN key: "+s),m(),!(X=!1);kn.info("$badge{EditApp} importHandler: optional local storage value not found. Key: "+t)}}):(kn.info("$badge{EditApp} importHandler: file in local storage not found. Key: "+o),m())):(kn.info("$badge{EditApp} importHandler: version of file in local storage not supported. Key: "+o),m())),X&&L.trigger("update:model",{usedLocalStorage:!0})),u="",g=nn.getBooleanOption(t,"fastLoad",!1),X||(!t.htmlDoc&&hn.DEBUG&&!se&&L.setFullModelNode&&g&&w.getFileDescriptor()&&!bn(w.getFileDescriptor().filename,"_ox")&&F.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),t.htmlDoc&&_.isFunction(L.setFullModelNode)&&!se&&(kn.info("$badge{EditApp} importHandler: load complete HTML document, osn: ",t.syncInfo["document-osn"]),(g=JSON.parse(t.htmlDoc)).mainDocument&&L.setFullModelNode(g.mainDocument),g.headerFooter&&(_.each(g.headerFooter,function(e){u+=e}),L.setFullModelNode(u,{headerFooterLayer:!0}),L.getPageLayout().headerFooterCollectionUpdate()),g.comments&&(u="",_.each(g.comments,function(e){u+=e}),L.setFullModelNode(u,{commentLayer:!0})),we="fast load",L.trigger("fastload:done"))),N.unshift({docStatus:f}),se?(we="fast empty",O(t,N).then(S)):yt(P,"preProcessing","Import preprocess handler finished").then(S).then(function(){return yt(function(){var e=T&&T.applyActionsDetached;e&&F.detachAppPane();var t=L.applyExternalOperations(p,{expand:!0});return e&&F.finally(t,F.attachAppPane),t},"applyOperations",p.length+" document operations applied").then(function(){if(L.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:Nn("Synchronization Error")});var e=X&&!L.externalLocalStorageOperationsExist();return yt(M?M.bind(w,e):null,"postProcessing","Import postprocess handler finished").then(function(){return O(t,N)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if(Gt()&&k.off(En.RESPONSE_OPEN_DOC,C),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)}));function m(){_.each(d,function(e){localStorage.removeItem(o+e.extension)}),localStorage.removeItem(s),localStorage.removeItem(i),localStorage.removeItem(c),localStorage.removeItem(l)}}L.undoManager.on("undogroup:open",function(){o=Tt()}),L.undoManager.on("undogroup:close",function(){wt()&&Pt(o),o=null,L.setInternalOperationBlocker(!1)}),L.on("operations:success",function(e,t,n,r){n||Oe||(_.isObject(o)?(Sn.log("operations:success - push operations into pending action"),o.operations=o.operations.concat(t),r&&(o.userData=r)):Pt(Tt(t,r)))}),L.on("cacheBuffer:flush",function(){Sn.log("cacheBuffer:flush received - send cached operations"),_.isFunction(E)&&_e.length&&(p=E.call(w,p,_e),xt())}),L.on("operations:error",function(){w.isImportFinished()?(w.setInternalError(cn.ERROR_WHILE_MODIFYING_DOCUMENT,sn.GENERAL),Sn.error("An unrecoverable error occurred while modifying the document")):(w.setInternalError(cn.ERROR_WHILE_LOADING_DOCUMENT,sn.GENERAL),Sn.error("An unrecoverable error occurred while loading the document"),I.reject())}),w.getWindowNode().on("drop",!1),k=w.isViewerMode()||nn.getBooleanOption(b,"isAttachmentFile",!1)?new mn(w,T):new Sn(w);this.rtConnection=k,se||F.enterBusy({skipCancelOnReadOnly:!0,cancelHandler:function(){w.isInQuit()||(jt(".abortOpen"),Wt(),w.quit())},immediate:!0,topLabel:_.noI18n(w.getFullFileName()),warningLabel:Nn("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4});Gt()&&(k.on(fn.EVENT_OFFLINE,rt),k.on(fn.EVENT_ONLINE,ot),k.on(fn.EVENT_ERROR,function(e,t){!function(e,t){var n;Sn.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e);_.isObject(e)&&_.isString(e.error)&&(n=new an(e));w&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?(de=!0,st("RT")):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(ce)?(de=!0,h?St({cause:"error:disposed"}):mt(0,null,null,{cause:"error:disposed"})):w.setInternalError(n,sn.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(de=!0,ce=null,w.setInternalError(n,sn.CONNECTION)):w.isLocked()||w.isInQuit()||_.isString(ce)?_.isString(ce)&&(de=!0,h?St({cause:"reset"}):mt(0,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error||"GENERAL_OFFLINE_CLIENT_IN_NON_SYNC_STATE"===e.error?w.setInternalError(e,sn.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?w.restoreDocument(n):(n=cn.ERROR_UNKNOWN_REALTIME_FAILURE,w.setInternalError(e,sn.CONNECTION)))}(t,I)}),k.on(fn.EVENT_NORESPONSE_IN_TIME,lt),k.on(En.BROADCAST_UPDATE,D),k.on(En.BROADCAST_UPDATE_CLIENTS,v),k.on(En.BROADCAST_SHUTDOWN,ct),k.on(En.BROADCAST_CRASHED,dt),k.on(En.BROADCAST_RENAMED_RELOAD,ft),k.on(En.BROADCAST_HANGUP,ut),k.on(En.BROADCAST_OT_RELOAD,gt));return u.step("initImport","$badge{EditApp} Import process initializated"),t=function(){var t=w.createDeferred();return yt(function(){var e=Gt()?k.connect():w.createRejectedPromise();return Sn.log("Channel UID:",Gt()?k.getChannelUID():null),Ge=Gt()?k.getDocUID():"null",qe=Gt()?k.getClientUID():"null",(e=(e=e.then(function(e){var t=new an(e);if(e.hasErrors||t.isError())throw e;return e})).then(function(t){var e=new an(t);if(e.isWarning()&&"ADVISORY_LOCK_SET_WARNING"===e.getCodeAsConstant()){var n=JSON.parse(e.getErrorValue()),e=new Date(n.since),r=_n.format(e,_n.getDateFormat())+" "+_n.format(e,_n.getTimeFormat()),o=Nn("Document in use");return w.getUserInfo(n.uid).then(function(e){e=Nn("%1$s edits this document since %2$s on %3$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",Nn.noI18n(e.displayName),Nn.noI18n(r),Nn.noI18n(n.hostName));return F.showQueryDialog(o,e)},function(){var e=Nn("Another user edits this document since %1$s on %2$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",Nn.noI18n(r),Nn.noI18n(n.hostName));return F.showQueryDialog(o,e)}).then(function(){return w.quit(),t},function(e){if("close"===e)throw e;return t=_.extend({advisoryLock:"reset"},t)})}return t})).done(function(e){t.resolve(e)}),e.fail(function(e){t.reject(e)}),t.promise()},"connect","Realtime connection established")}(),Je(),(e=t.then(function(e){var t,n,r,o=new an(e),i={fastEmpty:se};if(!o.isError())return Gt()&&(k.on(En.RESPONSE_OPEN_DOC_CHUNK,y),k.on(En.RESPONSE_OPEN_DOC,C)),b.auth_code&&(i=_.extend({auth_code:b.auth_code},i)),e&&e.advisoryLock&&(i=_.extend({advisoryLock:e.advisoryLock},i)),"new"===b.action&&(i=_.extend({newDoc:!0},i)),se&&(i=_.extend({fastEmptyOSN:L.getOperationStateNumber()},i)),Mn&&!se&&J&&(n=i,"load"===(t=b).action&&_.isObject(t.file)&&(r=t.file.id+"_"+t.file.folder_id,o=r+"_OSN",t=r+"_FILEVERSION",r=r+"_STORAGEVERSION",o=localStorage.getItem(o),t=localStorage.getItem(t),r=localStorage.getItem(r),K<=r&&o&&t&&(o=parseInt(o,10),t=parseInt(t,10),_.isNumber(o)&&_.isNumber(t)&&(n.storageOSN=o,n.storageVersion=t))),d=i.storageOSN),Gt()&&k.open(i),I.then(g,function(e){return Cn(e)});bt(e)}).catch(function(e){return Cn(bt(e))})).always(function(){ie=null,ze()}),e},b,_.extend({},T,{initHandler:function(){var e=Zn();hn.DEBUG&&(e=e.then(function(){return xn("io.ox/office/debug/common/main",function(e){return e.initializeApp(w)})}));return e},initFileHandler:function(){if(!w||!b)return kn.warn("$badge{EditApp} initFileHandler: called on an already destroyed instance."),$.Deferred().reject();var e={},n=!1,r=w.launchTracker;e.initial_language=ox.language.replace(/_/g,"-"),b.cryptoAction&&(e.cryptoAction=b.cryptoAction);b.decrypt_auth_code&&(e.cryptoAuth=b.decrypt_auth_code,e.encrypted_file=!0);switch(nn.getStringOption(b,"action","load")){case"load":return on.isDriveFile(b.file)?on.getFile(b.file).done(function(e){b.file=e}):$.when();case"convert":n=!0;break;case"new":var t=T&&T.prepareNewDocHandler;t&&_.extend(e,t.call(w));break;default:return kn.error("$badge{EditApp} initFileHandler: unsupported launch action"),$.Deferred().reject()}var o=nn.getObjectOption(b,"templateFile"),i=nn.getBooleanOption(b,"preserveFileName",!1),a=nn.getStringOption(b,"target_filename",In.DEFAULT_FILE_BASE_NAME),s=nn.getStringOption(b,"target_folder_id",""),l=nn.getObjectOption(o,"origin");function c(e){return w.setInternalError(e,sn.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}_.extend(e,{action:"createdefaultdocument",document_type:w.appType,target_filename:a,target_folder_id:s,preserve_filename:i,convert:n}),b.template&&_.extend(e,{action:"createfromtemplate",file_id:o.id});_.isObject(o)&&_.extend(e,{file_id:o.id,version:o.version});w.waitForImportSuccess(function(){var e=w.getFileDescriptor(),t=!b.template&&s!==e.folder_id;(b.template?e.converted:n)?w.setCurrentInfoState(t?dn.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:dn.INFO_DOC_CONVERTED_AND_STORED):t&&w.setCurrentInfoState(dn.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});i=_.url.hash("fields"),o=_.url.hash("fields-source");(i||o)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),e.fields=i,e.sourcefields=o);o=w.sendRequest(Un,e);return o=o.then(function(e){var t=new an(e);return t.isError()?c(t):e},function(){return c()}),r.asyncStep(o,"createNewDocAfterRequest","$badge{EditApp} New file in remote storage created"),(o=(o=o.then(function(t){return on.getFile(t.file).then(function(e){return t.file=e,t})})).then(function(e){function t(t,n){var e=w.isPresentationApp()?w.createResolvedPromise():w.leaveBusyDuringImport(!t,{immediateShow:!0});return r.asyncStep(e,"afterLeaveBusyEarly","$badge{EditApp} Busy state after creation of document left"),e.then(function(){if(t)return n;throw n},function(e){throw t?e:n})}return _.isObject(e.file)?(l&&(e.file.origin=l),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(se=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&0<e.operations.length)&&d?d.call(w,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(kn.error("$badge{EditApp} initFileHandler: missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(G)return Cn();var t=Mt(e);e===Vn.QUIT&&t.always(function(){Ke(!1)});return t=t.then(function(){return Gt()?k.flushDocument():Cn()})},messageDataHandler:ir,printOptionsHandler:function(){return Gt()?{doc_uid:k.getDocUID(),client_uid:k.getClientUID()}:null}}));var Je=hn.DEBUG?function(){J=w.getUserSettingsValue("debugUseLocalStorage",J)&&!w.isDocumentEncrypted()}:$.noop;function Xe(e){e=_.findWhere(ne,{clientUID:e});return e&&e.userName||""}var et=hn.LOG_PERFORMANCE_DATA?function(){var o=F.toolBarTabs,i=0;o.on("tab:activated",function e(t,n){var r;i++,n&&(r="tabActivated_"+wn(n),w.launchTracker.step(r,'$badge{EditApp} Toolbar tab "'+n+'" activated')),2===i&&o.off("tab:activated",e)})}:$.noop;function tt(){function e(){w.getController().update().done(function(){w.launchTracker.step("considerToolbarUIStable","$badge{EditApp} Toolbar is visually stable"),w.isReloading()&&w.setAppReloadDone(w)})}function t(){Re=!0,w.showEditToolbarAtStart()?F.one("edittoolpane:layout:finished",e):F.one("docs:toolpane:unhide",function(){w.executeDelayed(function(){e()},150)})}w.showEditToolbarAtStart()?F.toolBarTabs.one("tab:activated",t):w.waitForImportSuccess(t)}function nt(e){var t=an.isErrorCode(e)?e:function(e){var t;switch(e){case"reset":t=new an(cn.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new an(cn.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new an(cn.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new an(cn.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}(e);t.setErrorContext(sn.CONNECTION),Gt()?(e=k.hasPendingActions()||w.hasUnsavedChangesOffice(),Ke(!(B=!0)),e?h?w.setInternalError(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,sn.CONNECTION):w.restoreDocument(t):(b.action="load",delete b.template,w.reloadDocument())):w.setInternalError(t,sn.CONNECTION)}function rt(){V=!0,I&&!G&&!w.isInQuit()&&Gt()&&(j=R,I=!1,h&&xe.abort(),ce?k.hasPendingActions()?w.setInternalError(cn.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,sn.OFFLINE):w.setInternalError(cn.ERROR_OFFLINE_WHILE_SYNCHRONIZING,sn.OFFLINE):(Ke(!(B=!0)),ze(),w.setInternalError(cn.WARNING_READONLY_DUE_TO_OFFLINE,sn.OFFLINE)),Sn.log("Connection offline handler called by Realtime!"),ht())}function ot(){var n,r;!V||I||G||w.isInQuit()||(Sn.log("Connection online handler called by Realtime!"),h&&Jt(),I=!0,le&&(h?(Sn.log("Client supports synchronization - starting to sync with server"),_.isObject(w)&&(j?(w.setInternalError(cn.WARNING_SYNC_AFTER_OFFLINE,sn.SYNCHRONIZATION),Sn.log("Client is editor - synchronizing with server using current client state"),ce="editSync",p&&0<p.length&&xt()):(w.setInternalError(cn.WARNING_SYNC_FOR_VIEWER,sn.SYNCHRONIZATION),Sn.log("Client is viewer - waiting for server messages to unlock view"),ce="viewSync"),w.executeDelayed(function(){!de&&ce&&(Sn.log("Synchronization time out detected - no synchronization possible"),St({cause:"timeout"}))},3e4),ce&&Gt()&&k.sync().then(function(){de||k.syncStable().then(function(e){Sn.log("SyncStable response received ",e),e&&e.docStatus?St(null):St({cause:"reset"})},function(){St({cause:"reset"})})}).done(function(){var e=w.setInterval(function(){!ce||de?e.abort():Gt()?St(null):(St({cause:"reset"}),e.abort())},{delay:0,interval:3e3,count:9})}))):(Sn.log("Client supports synchronization - starting to sync with server"),_.isObject(w)&&(j?(w.setInternalError(cn.WARNING_SYNC_AFTER_OFFLINE,sn.SYNCHRONIZATION),Sn.log("Client is editor - synchronizing with server using current client state"),ce="editSync",p&&0<p.length&&xt()):(w.setInternalError(cn.WARNING_SYNC_FOR_VIEWER,sn.SYNCHRONIZATION),Sn.log("Client is viewer - waiting for server messages to unlock view"),ce="viewSync"),w.executeDelayed(function(){!de&&ce&&(Sn.log("Synchronization time out detected - no synchronization possible"),mt(0,null,null,{cause:"timeout"}))},3e4),ce&&Gt()&&(n=-1,r=null,k.sync().then(function(e){if(Sn.log("Sync response received ",e),e&&e.docStatus){var t=L.getOperationStateNumber();return r=nn.getStringOption(e.docStatus,"editUserId",""),n=nn.getIntegerOption(e.docStatus,"serverOSN",-1),mt(W=r,t,n,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){mt(0,null,null,{cause:"reset"})}).then(function(){if(ce&&Gt()){var e=k.syncStable();return e.done(function(e){var t;Sn.log("SyncStable response received ",e),e&&e.docStatus?(t=L.getOperationStateNumber(),r=nn.getStringOption(e.docStatus,"editUserId",""),mt(W=r,t,n,null)):mt(0,null,null,{cause:"reset"})}),e.fail(function(){mt(0,null,null,{cause:"reset"})}),e}throw mt(0,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){mt(0,null,null,{cause:"reset"})}).done(function(){var t=w.setInterval(function(){var e;ce&&Gt()?(e=L.getOperationStateNumber(),mt(_.isString(r),e,n,null)):(mt(0,null,null,{cause:"reset"}),t.abort())},{delay:0,interval:3e3,count:9})}))))),ze(),Ze())}function it(){var n;Sn.log("EditApp: handleSessionChanged called, process is already running? ",We),We||(We=!0,Te||at(),w.hasUnsavedChangesOffice()?(Sn.log("EditApp: handleSessionChanged, has unsaved local changes"),w.setInternalError(cn.ERROR_SESSION_LOST_WITH_LOCAL_CHANGES,sn.CONNECTION)):(Sn.log("EditApp: handleSessionChanged, no unsaved local changes"),n=cn.ERROR_SESSION_LOST_WITH_UNKNOWN_DOCUMENT_STATE,w.sendFileRequest(Un,{action:"getdocumentstate"}).then(function(e){var t=new an(e);return t.isError()?(n=n||t,kn.warn("EditApp: checkDocumentSaved received no save status, reason: ",t&&t.getCodeAsConstant()),w.setInternalError(n,sn.CONNECTION),!1):e.syncInfo["document-osn"]>=ke},function(e){return kn.error("EditApp: checkDocumentSaved",e),!1}).always(function(e){Sn.log("EditApp: handleSessionChanged, document is saved on server: ",e),e?w.reloadDocument():w.setInternalError(cn.ERROR_SESSION_LOST_WITH_LOCAL_CHANGES,sn.CONNECTION)})))}function at(){B=Te=!0,Wt()}function st(e){Sn.log("EditApp: handleSessionInvalidError called, process is already running: ",Te,"; detected by: ",e),Te||(at(),w.setInternalError(cn.WARNING_SESSION_INVALID_DETECTED,sn.CONNECTION),"RT"===e&&w.requestRelogin())}function lt(){Sn.log("NoResponseInTime notification received - Server has not responded in a certain time"),w.isLocked()||w.isInQuit()||w.setInternalError(cn.WARNING_CONNECTION_INSTABLE)}function ct(){var e,t;Sn.log("Shutdown notification received - Document middleware node is going down!"),w.isLocked()||w.isInQuit()||!Gt()||(e=k.hasPendingActions()||w.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}},R&&e?w.setInternalError(cn.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,sn.CONNECTION,null,t):w.setInternalError(cn.ERROR_SERVER_GOING_TO_SHUTDOWN,sn.CONNECTION,null,t))}function dt(){var e,t;Sn.log("Crashed node notification received - Document middleware node is not available anymore!"),w.isLocked()||w.isInQuit()||!Gt()||(e=k.hasPendingActions()||w.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}},R&&e?w.setInternalError(cn.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,sn.CONNECTION,null,t):w.setInternalError(cn.ERROR_SERVER_NODE_UNAVAILABLE,sn.CONNECTION,null,t))}function ut(e,t){var n;Sn.log("Hangup notification received - document cannot be edited anymore!"),w.isLocked()||w.isInQuit()||!Gt()||(n=k.hasPendingActions()||w.hasUnsavedChanges(),(t=new an(t)).isError()||(t=new an(cn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),It()&&(n||function(e){var t=!1;if(an.isErrorCode(e)&&e.isError())switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}return t}(t))?h?w.setInternalError(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,sn.CONNECTION,t):w.restoreDocument(t):"GENERAL_MALICIOUS_ACK_HANDLING_ERROR"!==t.getCodeAsConstant()||n?w.setInternalError(t,sn.CONNECTION):w.reloadDocument())}function gt(e,t){Sn.log("OT reload notification received - client must reload the document"),w.isInQuit()||pt(t=!(t=new an(t)).isError()?new an(cn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM):t,sn.CONNECTION)}function pt(e,t){w.trigger("docs:reload:prepare"),w.setInternalError(e,t),w.executeDelayed(function(){w.reloadDocument()},1500)}function ft(e,t){var n,r;w.isInQuit()||(new an(t).isError()?Se&&Se.reject(t):(n=nn.getStringOption(t,"fileId",null),r=nn.getStringOption(t,"fileName",null),n&&r?(Se&&Se.resolve(t),w.updateFileDescriptor({id:n,filename:r,title:on.getFileBaseName(r)}),b.action="load",delete b.template,A=!1,w.reloadDocument()):Se&&Se.reject(t)))}function Et(e){if(Jn.log("$back{lightgreen}handleEditRequestViaUpdate",e),!w.isInQuit()&&null===ce&&!Y&&W===U){var e=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==U&&e.requestsEditRights}):null,t=e?e.clientUID:null;if(t){if(Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - clientUIDRequesting ",De,Xe(t)),De)return Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",t),void(De.clientUID!==t&&Gt()&&(Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - REQUEST BLOCKED!"),k.declineEditRights(t)));Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - Request edit rights",a);e=function(e){if(Jn.log("$back{MediumAquaMarine}handleEditRightsTransferRequest"),function(){var e=12e4,t=0<a,n=null,r=_.now()-ve;Jn.log("inactivCheck knownWhenLastOpWasSend",t),t?(n=Date.now()-a,Jn.log("inactivCheck sendActionsTime",a,n)):(n=Date.now()-ae,Jn.log("inactivCheck importFinishedTime",ae,n));return Jn.log("inactivCheck User is inactive?",e<n,!nn.wasKeyPressedWithinTime(e),"timeDeltaToLastTransfer",r,e<r),e<n&&!nn.wasKeyPressedWithinTime(e)&&e<r}())return vn(nr);var o=$.Deferred(),t=w.createAbortablePromise(o);De={deferred:o,promise:t,clientUID:e},Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - callForUserInput"),F.yell({type:"question",message:Nn("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",Xe(e),Math.floor(Hn/1e3)),duration:Hn,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var t=$.button({label:Nn("Decline")}).addClass("btn-default").css({marginRight:5});t.on("click tab",function(){Jn.log("$back{Orchid}__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),ve=Date.now(),Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: declined"),o.resolve(tr)});var n=$.button({label:Nn("Accept")}).addClass("btn-primary");n.on("click tab",function(){Jn.log("$back{Orchid}__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: accepted"),o.resolve(er)});var r=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(r.append(t,n))}});var n=w.executeDelayed(function(){Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - DECISION: accepted automatically"),o.resolve(er)},Hn);return t.always(function(){De=null,n.abort(),F&&F.hideYell({priority:!0})}),t}(t);e.done(function(e){if(Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - answer: "+e),e===tr)return Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer declined"),void(Gt()&&k.declineEditRights(t));Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer accepted"),Ke(!(Y=!0)),w.setCurrentInfoState(dn.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===nr}),ze(),w.getController().update();e=T&&T.prepareLoseEditRightsHandler;(e?yn(e.bind(w)):vn()).always(function(){Sn.log("handle PrepareLosingEditRights"),w.executeDelayed(function(){!function e(t){w.hasUnsavedChangesOffice()?w.executeDelayed(function(){e(t)},2e3):xt().then(function(){Gt()&&k.canLoseEditRights(t),Y=!1,w.getController().update(),Sn.log("sent canLoseEditRights")})}(t)},1e3)})}),e.fail(function(e){Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function ht(){Ae.abort(),Jn.log("$back{SandyBrown}abortPendingEditRightsRequest")}function Ot(){De&&(De.promise.abort(),Jn.log("abortPendingEditRightsTransfer"))}function _t(t){Jn.log("$back{lightblue}applyEditState - DOC UPDATE",t);var e=h?null:nn.getStringOption(t,"editUserId",""),n=h?null:Xe(e),r=h?null:n||t.editUser,o=h?null:R,i=h?null:o,a=w.getFileDescriptor(),s=L.getOperationStateNumber(),l=h?null:nn.getIntegerOption(t,"serverOSN",-1),c=new an(t),d=nn.getIntegerOption(t,"lockedByUserId",-1),n=nn.getBooleanOption(t,"writeProtected",null);if(h?Sn.log("$badge{EditApp} applyEditState: clientOSN = "+s):Sn.log("$badge{EditApp} applyEditState: clientOSN = "+s+", localServerOSN = "+l),!G&&rr.some(function(e){return e in t})){if(h||e===W||(Sn.log("Edit rights changed, new editing user id: "+e),i=U===e,w.setCurrentInfoState(dn.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),Jn.log("$back{lightblue}__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",e,"|oldEditClientId:",W),Ae.running&&""!==e&&(Jn.log("$back{lightblue}__applyEditState - FORCE TIMER ABORTED the editor has been changed"),ht())),nn.getBooleanOption(t,"failSafeSaveDone",!1)&&on.propagateChangeFile(a),nn.getBooleanOption(t,"hasErrors",!1))return w.setInternalError(cn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,sn.SYNCHRONIZATION),void Sn.error("synchronization to the server has been lost.");B||(hn.RESCUE_DOCUMENT_READONLY&&w.isRescueDocument()?(Ke(!(B=!0)),w.setInternalError(cn.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,sn.READONLY)):_.isBoolean(n)&&n||nn.getBooleanOption(b,"isAttachmentFile",!1)?(Ke(!(B=!0)),w.setInternalError(cn.WARNING_NO_PERMISSION_FOR_DOC,sn.READONLY,null,{showMessage:!L.isValidReadOnlyMode(),hideError:L.isValidReadOnlyMode()})):-1!==d&&ox.user_id!==d&&(Ke(!(B=!0)),w.setInternalError(cn.WARNING_DOC_IS_LOCKED,sn.READONLY),H=nn.getStringOption(t,"lockedByUser",""))),B||Y||(h?Ke(!0):(Sn.log("Edit mode: "+i),Ke(i),!i&&(!I||o||r!==N&&r.length)&&(N=r,w.setCurrentInfoState(dn.INFO_USER_IS_CURRENTLY_EDIT_DOC)),I&&e&&e!==W&&(function(e){var t=W,n=e,e=[n];_.isString(t)&&0<t.length&&e.push(t);W=n,Nt(e)}(e),N=r),i&&!1===o&&w.setCurrentInfoState(dn.INFO_EDITRIGHTS_RECEIVED),I&&!i&&o&&-1!==l&&l<s&&(w.setInternalError(cn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,sn.SYNCHRONIZATION),Sn.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+i+"Old edit mode: "+o+", local Server OSN: "+l+", Client OSN: "+s))),(c.isError()||c.isWarning())&&w.setInternalError(c,sn.GENERAL)),I=!0,ze()}}function St(e){var t=null,n=function(){if(0<p.length)return!0;var e=Gt()?k.getPendingActions():null;return e&&_.isArray(e.actions)&&0<e.actions.length}();function r(){Sn.log("logSynchronizationState... ","\n     localChanges = ",n,"\n     rtConnection.getPendingActions() = ",Gt()&&JSON.stringify(k.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(p),"\n     mustSyncNowMode = ",ce,"\n     failedData = ",JSON.stringify(e))}if(ce){if(Sn.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":Sn.log("Synchronization not possible - maybe connection instance is gone"),(t=new an(cn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(sn.SYNCHRONIZATION),r(),ce=null;break;case"notMember":case"reset":case"error:disposed":Sn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(t=new an(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(sn.SYNCHRONIZATION),r(),ce=null}nt(t)}switch(ce){case"editSync":if(n)return;Sn.log("Synchronization successfully completed"),Ke(!(B=!1)),w.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":Sn.log("Synchronization for viewer completed"),w.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}r(),ce=null}}function mt(e,t,n,r){var o=null,i=function(){if(0<p.length)return!0;var e=Gt()?k.getPendingActions():null;return _.isObject(e)&&_.isArray(e.actions)&&0<e.actions.length}();function a(e,t){Sn.log("logSynchronizationState... ","\n     localChanges = ",i,"\n     rtConnection.getPendingActions() = ",Gt()&&JSON.stringify(k.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(p),"\n     mustSyncNowMode = ",ce,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",N,"\n     failedData = ",JSON.stringify(r))}if(ce){if(Sn.log("Checking synchronization state with server"),r){switch(r.cause){case"timeout":Sn.log("Synchronization not possible - maybe connection instance is gone"),(o=new an(cn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(sn.SYNCHRONIZATION),a(t,n),ce=null;break;case"notMember":case"reset":case"error:disposed":Sn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(o=new an(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(sn.SYNCHRONIZATION),a(t,n),ce=null}nt(o)}switch(ce){case"editSync":if(It()){if(i)return;Sn.log("Synchronization successfully completed"),Ke(!(B=!1)),w.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else i?(Sn.log("Synchronization not possible - editor changed"),(o=new an(cn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(sn.SYNCHRONIZATION),w.restoreDocument(o)):n<=t?(Sn.log("Synchronization possible - but we lost edit rights"),B=!1,w.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(Sn.log("Synchronization not possible - did not receive missing operations"),w.reloadDocument());break;case"viewSync":n<=t?(Sn.log("Synchronization for viewer completed"),B=!1,w.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(Sn.log("Synchronization not possible - did not receive missing operations"),w.reloadDocument())}a(t,n),ce=null}}function It(){return h||U===W}this.getServerModuleDocUrl=function(e,t,n){if(!Gt()||!ox.session||!this.hasFileDescriptor())return null;n=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:k.getDocUID()},n,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var Nt=this.synchronize(function(e){Jn.log("$back{PaleGoldenRod}applyUserData: CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return kn.error("$badge{EditApp} applyUserData: called without valid data: "+JSON.stringify(t)),$.when();var n,r=re,e=nn.getObjectOption(t,"clients",{}),o=[],i=[];return W===U&&_.isArray(e.changed)&&0<e.changed.length&&Et({activeUsers:e.changed}),_.isArray(e.list)?i=e.list:(_.isArray(e.left)||_.isArray(e.joined)||_.isArray(e.changed))&&(n={},re.forEach(function(e){n[e.clientUID]=e}),_.isArray(e.left)&&e.left.forEach(function(e){delete n[e]}),_.isArray(e.joined)&&e.joined.forEach(function(e){n[e.clientUID]=e}),_.isArray(e.changed)&&e.changed.forEach(function(e){n[e.clientUID]=_.extend({},n[e.clientUID],e)}),Object.keys(n).forEach(function(e){i.push(n[e])})),0===i.length?$.when():(_.each(i,function(t){var e=_.isObject(t)&&_.isString(t.clientUID),n=e&&!_.isNumber(t.userId)&&_.isNumber(t.id);e?n?o.push(w.getUserInfo(t.id).then(function(e){return t.userDisplayName=e.displayName,t.userOperationName=e.operationName,t})):o.push($.when(t)):kn.warn("$badge{EditApp} applyUserData: missing identifier")}),w.createResolvedPromise().then(function(){return $.when.apply($,o)}).done(function(){var e,t;ne=_.map(arguments,function(t){var e=t;_.isNumber(t.userId)||((e={}).clientUID=t.clientUID,e.userId=t.id,e.userName=t.userDisplayName,e.userOperationName=t.userOperationName,e.guest=t.guest);var n=_.find(r,function(e){return e.active&&e===t.clientUID}),n=_.isNumber(t.durationOfInactivity)&&t.durationOfInactivity<60&&n;return e.active=!0===t.active||n,e.remote=U!==e.clientUID,e.editor=W===e.clientUID,_.isObject(t.userData)&&(e.userData=t.userData),e.clientUID in ee||(ee[e.clientUID]=te,te+=1),e.clientIndex=ee[e.clientUID],e.colorIndex=w.getAuthorColorIndex(e.userOperationName),e}),re=_.where(ne,{active:!0}),re=_.sortBy(re,"clientIndex"),_.isEqual(r,re)||(kn.info("$badge{EditApp} applyUserData: activeClients=",re),t=re,(e=r).length===t.length&&(e=_.copy(e,!0),t=_.copy(t,!0),_.each(e,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(t,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(e,t))||w.trigger("docs:users",re),De&&!_.findWhere(re,{clientUID:De.clientUID})&&Ot(),e=_.first(_.pluck(_.where(r,{clientUID:U}),"requestsEditRights")),t=_.first(_.pluck(_.where(re,{clientUID:U}),"requestsEditRights")),!0===e&&!1===t&&(Jn.log("$back{PaleGoldenRod}applyUserData: REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",e,t,W!==U),ht(),W!==U?(Jn.log("$back{PaleGoldenRod}applyUserData: YOUR REQUEST WAS DECLINED"),F.yell({message:Nn("Your request for edit rights has been declined.")})):ve=_.now()),w.trigger("docs:users:selection",re))}))});function Rt(){h&&0<Be.length&&!L.isProcessingActions()&&!function e(t){Dt(t,!0).done(function(){Be.shift(),0<Be.length&&e(Be[0])})}(Be[0])}function At(e,t,n){if(n&&Kn.info("$badge{EditApp} setServerOSN: Coming back to set OSN from ACK triggered by operations:after event. Current server OSN: "+Ue+" Planned new OSN from ACK: "+e),Ue<e)if(t){if(ke=e,h&&L.isProcessingExternalOperations())return Kn.info("$badge{EditApp} setServerOSN: External operations are currently applied -> coming back later. Keeping OSN: "+Ue+". NOT setting OSN from ACK: "+e),void L.one("operations:after",function(){At(e,t,!0)});e===Ue+1?(Ue=e,$e=-1):($e=e,Kn.info("$badge{EditApp} setServerOSN: Saving OSN from ack temporarily: "+$e))}else Ue+1<e&&Kn.info("$badge{EditApp} setServerOSN: Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Ue+" to "+e),n=Ue,(Ue=e)+1<$e&&Kn.info("$badge{EditApp} setServerOSN: Far distance ACK: ACK OSN is: "+$e+". But received external operations with OSN: "+Ue),$e===Ue+1?(Kn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+$e+". Triggering event: docs:ackosn:updated after next operations:after."),Ue=$e,$e=-1,L.one("operations:after",function(){Kn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+$e+". Triggering event: docs:ackosn:updated."),w.trigger("docs:ackosn:updated")})):0<=$e&&$e<Ue&&(Kn.error("$badge{EditApp} setServerOSN: ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+$e),Kn.error("$badge{EditApp} setServerOSN: ERROR: Current locally used server OSN is: "+n),$e=-1,w.trigger("docs:ackosn:updated"));else Kn.info("$badge{EditApp} setServerOSN: Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Ue);Kn.info("$badge{EditApp} setServerOSN: Setting server OSN to: "+Ue),L.trigger("change:osn",Ue)}function Dt(e,t){if(G)return Sn.error("$badge{EditApp} applyRemoteOperations: failed due to internal error"),$.Deferred().reject();var n=h?An(e.docStatus,"serverOSN",-1):0;if(n<0)return kn.error("$badge{EditApp} applyRemoteActions: missing server OSN in external operations"),$.Deferred().reject();var r=or(e);if(0===r.length)return h&&At(n),$.when();if(On.handleMinifiedActions([{operations:r}],!0),h||L.undoManager.clearUndoActions(),Sn.log("$badge{EditApp} applyRemoteOperations: last remote operation: "+JSON.stringify(_.last(r))),h){if(hn.DEBUG&&w.trigger("operationtrace:new:external",r,w.getServerOSN()),L.isProcessingInternalOperations()||0<Be.length&&!t)return t||Be.push(e),w.createResolvedPromise({cached:!0});if(Kn.info("$badge{EditApp} applyRemoteOperations: received external operations with server OSN "+n),At(n),0<Fe.length)try{Me+=r.length,r=w.otManager.transformOperations(r,Fe)}catch(e){return"OTError"===e.name?(p=[],pt(new an(cn.ERROR_CLIENT_OT_UNRESOLVABLE_OP_CONFLICT_ERROR))):Kn.exception(e,"$badge{EditApp} applyRemoteOperations: operation transformation failed"),$.Deferred().reject({cause:"operation"})}else Kn.trace("$badge{EditApp} applyRemoteOperations: external operations not transformed:",r)}r=L.applyExternalOperations(r);return r.done(function(){D=!0}),r.fail(function(){w&&!w.isInQuit()&&Sn.error("$badge{EditApp} applyRemoteOperations: failed")}),r}var vt=this.synchronize(function(i){if(function(e){if(!h){var t=!1,n=L.getOperationStateNumber();return t=hn.RESTORE_DOCUMENT_ENABLED&&0<e.length?!("editSync"!==ce||!Gt()||!k.hasPendingActions())||n!==e[0].osn:t}}(or(i)))return h?w.setInternalError(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,sn.CONNECTION):ce||It()?w.restoreDocument(new an(cn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)):w.setInternalError(cn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,sn.CONNECTION),$.when();var e=Dt(i);return e.done(function(e){var t,n,r,o;_.isObject(i)&&!_.isObject(i.docStatus)&&kn.error("$badge{EditApp} broadcast_update sent bad data "+JSON.stringify(i)),h&&e&&e.cached||(_t(i.docStatus),t=i,n=w.getFileDescriptor(),r=nn.getStringOption(t,"fileName",""),o=nn.getStringOption(t,"com.openexchange.file.sanitizedFilename",""),e=nn.getStringOption(t,"fileVersion",""),t={},0<r.length&&r!==nn.getStringOption(n,"filename")&&(t.filename=r),0<o.length&&o!==nn.getStringOption(n,"com.openexchange.file.sanitizedFilename")&&(t["com.openexchange.file.sanitizedFilename"]=o),0<e.length&&e!==nn.getStringOption(n,"version")&&(t.version=e),G||_.isEmpty(t)||(w.updateFileDescriptor(t),w.getController().update(),ze()))}),e});function Ct(e){if(!_.isObject(e))return kn.error("$badge{EditApp} registerUpdateMessageData: invalid response (object expected):",e),this.setInternalError(cn.ERROR_WHILE_MODIFYING_DOCUMENT,sn.GENERAL),$.Deferred().reject();var t;Sn.log("$badge{EditApp} registerUpdateMessageData: received update message:",e),0<oe.length&&U!==e.editUserId&&(Sn.log(" "+oe.length+' existing pending updates must be changed to user "'+e.editUserId+'"'),t={editUser:e.editUser,editUserId:e.editUserId},oe.forEach(function(e){_.extend(e,t)})),oe.push(e);e=vt(e);return e.always(function(){oe.shift(),Sn.log("$badge{EditApp} registerUpdateMessageData: update processed, "+oe.length+" pending messages left")}),e}function yt(e,t,n){if(!e)return vn();e=(e=yn(e.bind(w)).fail(function(){kn.warn("$badge{EditApp} failed initialization step: "+n)})).then(function(e){return w.isInQuit()?Cn({cause:"closing"}):e});return w.launchTracker.asyncStep(e,t,"$badge{EditApp} "+n)}function bt(e){if(_.isObject(w)&&!w.isInQuit()||(e={cause:"quit"}),ue)return{cause:""};var t,n,r=new an(e),o=r.getCodeAsConstant();return G=!0,s.call(w,e),e=_.clone(e),"GENERAL_FILE_NOT_FOUND_ERROR"===o&&(y=!0),r.isError()||((n=e)&&n.error_desc&&n.error_id&&_.isString(n.error_desc)&&_.isString(n.error_id)?(t=e,r=new an(an.GENERAL_ERROR),t&&t.error_desc&&(t=t.error_desc,r.setDescription(t))):r=new an(cn.ERROR_UNKNOWN_REALTIME_FAILURE)),w.isInQuit()||w.setInternalError(r,sn.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:w.isViewerMode()}),ue=!0,e}function Tt(e,t){e={operations:e||[]};return t&&(e.userData=t),e}function wt(){return o&&o.operations&&0<o.operations.length}function Lt(){return r||0<p.length||wt()}function Ft(t){Ln(Fe,function(e){return!e[t]})}var Ut,xt=(Ut=null,function(){if(Sn.log("$badge{EditApp} sendActions: entered"),r)return Sn.log("$badge{EditApp} sendActions: sending in progress - using current promise"),Ut.promise();if(G)return Sn.error("$badge{EditApp} sendActions: internal error detected - promise rejected!"),$.Deferred().reject();if(h&&(Ln(p,function(e){return 0<e.operations.length}),Ln(Fe,function(e){return 0<e.operations.length})),0===p.length)return Sn.log("$badge{EditApp} sendActions: no need to send action buffer empty"),$.when();if(h){if(0<=$e)return Kn.info("$badge{EditApp} sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),w.once("docs:ackosn:updated",Zt),Ut.promise();if(L.isProcessingExternalOperations())return Kn.info("$badge{EditApp} sendActions: External operations are currently applied. Coming back later in operations:after handler!"),L.one("operations:after",Qt),Ut.promise()}return Ut=w.createDeferred().always(function(){Sn.log("$badge{EditApp} sendActions: current send promise resolved - sendingActions = false"),r=!1,a=_.now(),ze()}),r=!0,ze(),$t(),Ut.promise()});function $t(){var e;if(hn.REALTIME_DEBUGGING&&Y&&p&&0<p.length&&((e=p[p.length-1].operations)&&0<e.length&&kn.log("$badge{EditApp} sendActionsBuffer: last action:",_.last(e))),h&&Le)return w.executeDelayed($t,1e3),void Ut.resolve();l&&c&&(t=h?p.length:0,p=l.call(w,p),h&&p.length!==t&&Ft("_OPTIMIZED_OPERATION_")),Qn("$badge{EditApp} sendActions: sending local actions, serverOSN="+Ue,p),hn.DEBUG&&w.trigger("operationtrace:send:internal",p,w.getServerOSN()),p=On.handleMinifiedActions(p),h&&Fe.forEach(function(e){e.sentToServer=!0});var t=p.map(function(e){return{operations:e.operations}}),n=h?Ue:void 0,t=Gt()?k.sendActions(t,n):w.createRejectedPromise();t.done(function(e){h&&(Kn.info("$badge{EditApp} sendActions: Receiving acknowledge with new OSN sent from server: "+e.body.serverOSN),At(e.body.serverOSN,!0),Kn.info("$badge{EditApp} sendActions: Trying to clear local operation cache after receiving acknowledge"),Kt(),hn.DEBUG&&w.trigger("operationtrace:ackosn",e.body.serverOSN,n)),G?(Sn.error("$badge{EditApp} sendActionsBuffer: sent successfully, but internal error detected!"),Ut.reject()):0===p.length?Ut.resolve():h&&L.isProcessingExternalOperations()?(Kn.info("$badge{EditApp} sendActions: External operations are currently applied. Calling sendActions later in operations:after handler!"),L.one("operations:after",Qt),Ut.resolve()):h&&0<$e?(Kn.info("$badge{EditApp} sendActions: External operations are still missing. Calling sendActions later in operations:after handler!"),L.one("operations:after",Qt),Ut.resolve()):$t()}),t.fail(function(e){Sn.error("$badge{EditApp} sendActionsBuffer: rtConnection.sendActions promise failed!"),Pe=!0,Ut.reject(e)}),p=[]}var kt,Pt=(kt=w.debounce(function(t){var e=!1;Sn.log(function(){var e=0<t.operations.length?JSON.stringify(_.last(t.operations)):null;return"$badge{EditApp} storeAction: "+(e?"last operation: "+e:"no operations provided")}),E&&0<_e.length&&(p=E.call(w,p,_e),_e=[],e=!(E=null)),!G&&(0<t.operations.length||e)&&(0<t.operations.length&&(p.push(t),h&&(Fe.push(t),hn.DEBUG&&w.trigger("operationtrace:new:internal",t.operations,Ue),Qn("$badge{EditApp} registerAction: added local action without ACK to cache",Fe))),i=A=!0,ze())},xt,{delay:u,maxDelay:u}),function(e){he?kt(e):(Sn.log("$badge{EditApp} registerAction: cached action during non-distribution mode"),_e.push(e))});function Mt(t){var e=F.processUnsavedComment(t===Vn.QUIT);return e=(e=(e=e.then(function(){return v})).then(function(){var e=T&&T.prepareFlushHandler;return e?e.call(w,t):null})).then(function(){var e=xt();return e=t===Vn.QUIT?ar(e,5e3,"EditApplication.prepareFlushDocument"):e})}var Bt,Ht=_.once(function(){if(Ve=!0,Gt())try{var e=T&&T.prepareLeaveDataHandler,t=e?e.call(w):null}finally{k.emergencyLeave(t)}Ke(!1)});function Gt(){return!(!k||k.destroyed)}function qt(){k&&(ht(),Ot(),k.destroy(),w.rtConnection=k=null)}function jt(e,t,n){if(Ve||!Gt())return Cn();var r=null,o=k.getConnectOpenState();if(Sn.log("$badge{EditApp} executeShutdownStep: - silentShutdownEntered:",Vt()," connectionOpenState:",o," action:",e),!Vt()){var i=!1,a=!1,s=!1;switch(o){case"unknown":case"joining":s=a=i=!1;break;case"joined":s=!(a=i=!1);break;case"opening":s=!(a=!(i=!0));break;case"opened":s=a=!(i=!1)}r=function(){switch(e){case".abortOpen":return i?k.abortOpen():null;case".closeDocument":return a?k.closeDocument(t):null;case".disconnect":return s?k.disconnect(t):null}}()}return(r=Vt()?function(){switch(e){case".closeDocument:force":return k.closeDocument(t);case".disconnect:force":return k.disconnect(t)}}():r)?n?ar(r,n,'EditApplication.executeShutdownStep("'+e+'")'):r:Cn()}function Vt(){return!(null===be)}function Wt(e){var n,r,o=nn.getBooleanOption(e,"skipCloseDoc",!1),i=nn.getBooleanOption(e,"skipDisconnect",!1);Sn.log("$badge{EditApp} silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",Vt()),Vt()||(Ke(!(B=!0)),h&&xe.abort(),n=$.Deferred(),be=n.promise(),Gt()&&k.off(),(r=o?$.when():jt(".closeDocument:force",{no_restore:Ce},500)).always(function(e){var t=i?$.when():(e="timeout"===e,t="rejected"===r.state(),t=e||Boolean(o)||t,Sn.log("$badge{EditApp} silentShutdownConnection: closeDocument rejected by timeout?:",e),jt(".disconnect:force",t,500));t.always(function(){qt(),Sn.log("$badge{EditApp} silentShutdownConnection is finished"),n.resolve()})}))}function Yt(c,e){var d=w.getWindow();function t(e){var t,n,r,o,i=w.createDeferred(),a=new an(e),s={},l=null;return a.isError()||a.isWarning()?(t=nn.getStringOption(e,ln.RESTORED_FILEID,null),n=nn.getStringOption(e,ln.RESTORED_FILENAME,null),r=nn.getStringOption(e,ln.RESTORED_FOLDERID,null),l=nn.getStringOption(e,ln.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(t)&&_.isString(n)&&_.isString(r)?(l=l===an.CONSTANT_NO_ERROR?new an({errorClass:an.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}):new an({errorClass:an.ERRORCLASS_ERROR,error:l}),s[ln.RESTORED_FILENAME]=n,on.getPath(r).always(function(e){s[ln.RESTORED_PATHNAME]=on.preparePath(e),s[ln.ORIGINAL_FILEID]=w.getFileDescriptor().id,w.updateFileDescriptor({id:t,folder_id:r}),w.setInternalError(l,sn.CLOSE,a,{additionalData:s})})):w.setInternalError(a,sn.CLOSE,null,{additionalData:s}),L&&F?(w.registerQuitHandler(function(){i.reject()}),w.quit=(o=w.quit,function(){return i.reject(),o.call(w)}),d.idle(),i.always(function(){d.busy()}),c===Wn.LOGOUT&&i.reject()):i.reject(),a.getDescription()&&kn.log(a.getDescription()),i.promise()):e}return jt(".closeDocument",e=e||null,8e3).then(t,function(e){return"timeout"===e?w.createRejectedPromise(e):t(e)})}function zt(){Kn.info("$badge{EditApp} clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),Kt()}function Kt(){L.isProcessingExternalOperations()?(L.off("operations:after",zt),Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),L.on("operations:after",zt)):0<$e?(w.off("docs:ackosn:updated",zt),L.off("operations:after",zt),Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),w.on("docs:ackosn:updated",zt),L.on("operations:after",zt)):(Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. Before: "+JSON.stringify(Fe)),L.off("operations:after",zt),w.off("docs:ackosn:updated",zt),Ft("sentToServer"),Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. After: "+JSON.stringify(Fe)))}function Qt(){Kn.info("$badge{EditApp} sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),xt()}function Zt(){Kn.info("$badge{EditApp} sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),xt()}function Jt(){w.isOnline()&&rn.isTabVisible()&&xe.start()}this.leaveBusyDuringImport=_.once(function(e,t){return ie=w.launchTracker.step("previewStart","$badge{EditApp} Busy state during import process left"),ze(),F.showAfterImport(e,t)}),this.createDebouncedFor=function(t,e,n,r){var o=!1;return t.debounce(e,function(){if(!o){if(!w.isImportFinished()||!L.isProcessingActions())return n.call(t);var e=L.waitForActionsProcessed();o=!0,t.await(e,function(){o=!1,n.call(t)})}},r)},this.checkStartOfExternalOperations=function(){!h||o||L.isProcessingInternalOperations()||w.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return h&&!o&&!L.isDrawingChangeActive()},this.getFileFormat=function(){var e;return null===n&&(e=this.hasFileDescriptor()?this.getFullFileName():b&&b.templateFile?b.templateFile.filename:"",n=e?pn.getFileFormat(e):null),n||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&pn.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&pn.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return U},this.getShortClientId=function(){return U.slice(0,4)},this.getDocUID=function(){return Gt()?k.getDocUID():null},this.getLoadMode=function(){return we},this.getEditClientId=function(){return W},this.getEditClientUserName=function(){return Xe(W)},this.getClientOperationName=function(){return x},this.getActiveClients=function(){return re},this.isLocallyModified=function(){return A},this.isPrepareLosingEditRights=function(){return Y},this.sendActionRequest=function(t,n,r){if(!Gt())return w.createRejectedPromise();var e={action:t,docuid:k.getDocUID(),requestdata:JSON.stringify(n)};r=_.extend({method:"POST"},r);e=this.sendFileRequest(Un,e,r);return e.fail(function(e){kn.warn("$badge{EditApp} sendActionRequest: failed: ",t,n,r,e)}),e},this.sendAddImageIdRequest=function(e){return Gt()?k.addImageId(e).then(_.constant(e)):vn(e)},this.sendLogMessage=hn.LOG_ERROR_DATA?function(e){return w&&w.allowStoreLogFile()&&w.sendLogErrorData({errorCode:e}),this}:nn.NOOP,this.sendCommentNotification=function(e,t,n){if(on.isGuest())return $.when();var r=w.getFileDescriptor(),r={recipients:e&&e.map(function(e){return{userId:On.resolveUserId(Number(e.userId.split("::")[1])),emailAddress:e.email,posInComment:e.pos,lengthInComment:e.length}}),comment:t,commentId:n,filename:r.filename,fileId:r.id,folderId:r.folder_id},r={action:"sendcommentnotification",requestdata:JSON.stringify(r)};return w.sendRequest(Un,r,{method:"POST"})},this.isRenameEnabled=function(){return!Bn&&(!Z&&!hn.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!h)},this.rename=function(e){var t=this.getFileDescriptor(),n=nn.getStringOption(t,"filename",this.getFullFileName()),r=nn.getStringOption(t,"com.openexchange.file.sanitizedFilename",n),o=Tn(e);if(v)return kn.warn("$badge{EditApp} rename: multiple calls, ignoring subsequent call"),v;if(0===o.length)return $.Deferred().reject();if(o===this.getShortFileName())return $.when();o+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(o+=on.GUARD_EXT),this.updateFileDescriptor({filename:o}),Se=this.createDeferred();e=T&&T.prepareRenameHandler;return(v=(v=(v=(v=e?yn(e.bind(w)):vn()).then(xt)).then(function(){return Gt()?k.renameDocument({target_filename:o}):Cn()})).then(function(e){var t=new an(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?Se.promise():t.isError()?Cn(t):e})).done(function(e){C=!0,w.updateFileDescriptor({filename:nn.getStringOption(e,"fileName",n),"com.openexchange.file.sanitizedFilename":nn.getStringOption(e,"com.openexchange.file.sanitizedFilename",r)})}),v.fail(function(e){var t;"abort"!==e&&((t=an.isErrorCode(e)?e:new an(e)).setErrorContext(sn.RENAME),(e=un.getMessageData(t)).restoreHidden=!1,kn.warn("$badge{EditApp} rename: error: "+t.getErrorText()),F.yell(e)),w.updateFileDescriptor({filename:n})}),v.always(function(){v=null,w.trigger("docs:rename:finished")})},this.hasUnsavedChangesOffice=function(){return Lt()||!!v||!!w.docController.getUnsavedFileName()||!!L&&L.hasUnsavedComments()||Pe},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||tn.getLoggingOutState()!==tn.LOGGING_OUT_STATE.FOLLOWER)&&(!(!Gt()||!k.isConnected())&&(this.hasUnsavedChangesOffice()||k.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||m===e||(m=e,Ye()),this},this.getState=function(){return m&&!this.isInternalError()?m:S},this.isEditable=function(){return R},this.isOnline=function(){return"offline"!==S},this.isInternalError=function(){return"error"===S},this.setInternalError=function(e,t,n,r){var o=an.isErrorCode(e)?e:new an(e),i=null,a=null,s=null,l=!0,c=nn.getObjectOption(r,"additionalData",{}),d=an.isErrorCode(n)?n:o,u=!1,g=nn.getObjectOption(r,"silentShutdownConfig",{}),e=nn.getBooleanOption(r,"hideError",!1),n=o.isError();if(w.isReloading()&&w.setAppReloadDone(w),_.isString(t)&&o.setErrorContext(t),i=w.getErrorState(),(t=!_.isObject(i)||!i.isError())?(w.setErrorState(o),u=!0):_.isObject(i)&&(o=i,a=ye),s=w.getErrorState(),an.isErrorCode(s)&&!e&&kn.error("$badge{EditApp} setInternalError: "+s.getErrorText()),n?(Ke(!(B=!(I=!(G=!0)))),Wt(g)):(s=_.has(ge,o.getCodeAsConstant()),g=pe===o.getCodeAsConstant()&&un.suppressDirectlyRepeated(o.getCodeAsConstant()),l=!s&&!g,un.showOnceInDocLifetime(o.getCodeAsConstant())&&(ge[o.getCodeAsConstant()]=!0),pe=o.getCodeAsConstant()),ze(o),_.isObject(a)&&!u||(a=un.getMessageData(o,_.extend({causeError:d,viewerMode:w.isViewerMode()},Qe(),c)),w.extendMessageData(a),Ne="document/reload"===nn.getStringOption(a.action,"itemKey"),ye=a),nn.getBooleanOption(r,"showMessage",!0)&&l&&w.waitForImport(function(){F&&F.yell&&F.yell(a)}),n&&t&&!Ve){try{q=w.sendLogErrorData({errorCode:o.getCodeAsConstant()})}catch(e){kn.error("$badge{EditApp} Error when sendLogErrorData is callend in setInternalError error:",e," fileDec:",w&&_.isFunction(w.getFileDescriptor)&&w.getFileDescriptor())}if(w.allowStoreLogFile()&&un.createCrashDataForError(o.getCodeAsConstant()))if(on.isGuest())w.createCrashDataAsDownload(o.getCodeAsConstant());else try{w.createCrashDataInDrive(o.getCodeAsConstant())}catch(e){kn.error("$badge{EditApp} Error when createCrashDataInDrive is callend in setInternalError error:",e," fileDec:",w&&_.isFunction(w.getFileDescriptor)&&w.getFileDescriptor())}}},this.createCrashDataAsDownload=function(e){var t,n,r,o;this.generateLogData()&&(t=Date.now(),n=new jn("A debug report can be downloaded. The report may contain content of previously opened documents.",{title:"Generating debug report",classes:"generate-log-dialog noI18n",okLabel:In.CLOSE_LABEL,showReadOnly:!0}),r=$('<div class="result">'),o=$('<a href="#">').append($('<i class="fa fa-download" aria-hidden="true">'),$('<span style="padding: 0px 10px">').text("Download")),r.append(o),e=$('<div class="details">').append($("<div>").text("Error code: "+e||"<none>"),$("<div>").text("Timestamp (UTC): "+(new Date).toISOString())),n.append(r,e),n.listenTo(o,"click",function(){var e;w?w.downloadFrontendLog():(e=Math.ceil((Date.now()-t)/1e3),o.replaceWith($('<div style="padding-top: 5px; text-align: center">').text("Cannot download. The error happened in a previous document "+e+" seconds ago")))}),n.show())},this.createCrashDataInDrive=function(e){var n,r,o,t=this.generateLogData();t&&(n=Date.now(),r=new jn("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents.",{title:"Generating debug report",classes:"generate-log-dialog noI18n",okLabel:In.CLOSE_LABEL,showReadOnly:!0}),o=$('<div class="result">').append($("<div>").busy({immediate:!0})),e=$('<div class="details">').append($("<div>").text("Error code: "+(e||"<none>")),$("<div>").text("Timestamp (UTC): "+(new Date).toISOString())),r.append(o,e),r.show(),this.sendLogErrorData({logData:t}).done(function(){o.empty().append($('<i class="fa fa-check" aria-hidden="true">'),$('<span style="padding:0px 5px;">').text("Upload finished."))}).fail(function(){o.empty().append($('<i class="fa fa-exclamation-circle" aria-hidden="true">'),$('<span style="padding:0px 5px;">').text("Could not upload file."));var t=$('<div style="padding-top:5px;text-align:center;">').text("You may download the debug report manually."),e=$('<a href="#">').append($('<i class="fa fa-download" aria-hidden="true">'),$('<span style="padding: 0px 10px">').text("Download"));t.append($("<div>").append(e)),o.after(t),r.listenTo(e,"click",function(){var e;w?w.downloadFrontendLog():(e=Math.ceil((Date.now()-n)/1e3),t.replaceWith($('<div style="padding-top: 5px; text-align: center">').text("Cannot download. The error happened in a previous document "+e+" seconds ago")))})}))},this.allowStoreLogFile=function(){return hn.LOG_ERROR_DATA&&!!w&&!w.isDocumentEncrypted()},this.sendLogErrorData=function(e){var t=_.has(e,"errorCode"),n=_.has(e,"logData");if(!t&&!n)return w.createRejectedPromise();function r(e){return a?"hidden":e}var o,i,a=!hn.LOG_ERROR_DATA,s=w.getFileDescriptor(),n={action:"logclientdata",logAnonymous:String(a),fileId:String(r(s&&s.id)),folderId:String(r(s&&s.folder_id)),fileName:String(r(w.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(Ge),errorCode:t?(i=e&&e.errorCode,String(i||"unknownError")):"",logData:n&&w.allowStoreLogFile()?(o=e&&e.logData,String(o)):""};return w.sendRequest(Un,n,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n,r=nn.getBooleanOption(t,"showMessage",!0),o=null;return nn.getBooleanOption(t,"resetWarning",!1)&&(o=w.getErrorState(),_.isObject(o)&&o.isError()||w.setErrorState(new an)),w.setInfoState(e),!(!r||(n=gn.getMessageData(e,_.extend({},Qe(),t)),w.extendMessageData(n),!_.isObject(n)))&&F.yell(n)},this.isLocked=function(){return G||B},this.isAcquireEditRightsEnabled=function(){return!h&&Gt()&&!this.isLocked()&&this.isOnline()&&!R},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&oe.length<=1},this.acquireEditRights=function(){if(Jn.log("$back{Orchid}acquireEditRights - User wants to acquireEditRights -> Button pressed  "),this.isAcquireEditRightsEnabled())return Ae.start();ht()},this.saveDocumentAs=function(n,e,r,o){var i=e,a=null,s=w.getFileDescriptor(),t=null,l=!1;switch(r){case Pn.NATIVE:if(o&&o.encrypted){i+="."+w.getFileExtension()+on.GUARD_EXT,t=(t=(t=on.authorizeGuard().then(function(e){b.auth_code=e},function(){return l=!0,Cn()})).then(function(){return w.flushDocument(Vn.DOWNLOAD)})).then(function(){var e=s.file_options||{},t=e.params||{};return _.extend(t,{cryptoAction:"Encrypt",filedisplay:i,ignoreWarnings:!1}),s.file_options=_.extend(e,{params:t}),on.copyFile(s,n)});break}case Pn.TEMPLATE:i+="."+w.getFileExtension(),t=(t=w.flushDocument(Vn.DOWNLOAD)).then(function(){return Gt()?k.copyDocument({file_id:w.getFileParameters().id,target_filename:e,asTemplate:r===Pn.TEMPLATE,target_folder_id:n}):Cn()});break;case Pn.PDF:i+=".pdf",t=(t=(t=w.flushDocument(Vn.DOWNLOAD)).then(function(){return on.propagateChangeFile(s)})).then(function(){return on.getFileModelFromDescriptor(s).then(function(e){return Xt.sendConverterRequest(e,{documentformat:"pdf",saveas_filename:i,saveas_folder_id:n})})});break;default:return kn.error('$badge{EditApp} saveDocumentAs: unknown file type "'+r+'"'),Cn()}return(t=(t=(t=t.then(function(e){var t=new an(e);return t.isError()?Cn(t):e})).then(function(t){return i=nn.getStringOption(t,"filename")||i,on.deleteFromCache(n),on.getPath(n).then(function(e){return a=on.preparePath(e),t})})).then(function(e){if(r!==Pn.PDF){r===Pn.TEMPLATE&&w.setCurrentInfoState(dn.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:i,fullPathName:a,type:"success",duration:1e4});var t=nn.getStringOption(e,"id",null);return!t&&o&&o.encrypted&&(t=_.isArray(e)?nn.getStringOption(_.first(e),"data",null):e),n=n||nn.getStringOption(e,"folder_id",null),on.getFile({id:t,folder_id:n}).then(function(e){return e.title=on.getFileBaseName(e.filename),w.updateFileDescriptor(e),b.action="load",delete b.template,w.reloadDocument(),w.createAbortablePromise($.Deferred())})}w.setCurrentInfoState(dn.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:i,fullPathName:a,type:"success",duration:1e4})})).fail(function(e){"destroy"!==e&&("cancel"===e||l||(Xt.isDocConverterError(e)?F.yell({type:"error",message:Xt.getErrorTextFromResponse(e)}):((e=an.isErrorCode(e)?e:new an(an.GENERAL_ERROR)).setErrorContext(sn.SAVEAS),kn.warn('$badge{EditApp} saveDocumentAs: Error code "'+e.getCodeAsConstant()+'"'),F.yell(un.getMessageData(e,Qe())))))}),t},this.isReloadEnabled=function(){return Ne},this.reloadDocument=function(e,t){this.trigger("docs:reload:prepare");var n=this.getFileDescriptor(),r=this.getFullFileName(),o=pn.getEditModule(r);if(!o)return kn.error("$badge{EditApp} reloadDocument: unknown application type"),Cn();if(!pn.isNative(r))return kn.error("$badge{EditApp} reloadDocument: unsupported document type"),Cn();e=_.extend({},e,{action:"load",file:n}),b.auth_code&&(e.auth_code=b.auth_code),e.activeTabId=F.toolBarTabs.getActiveTabId(),e.commentsPaneVisible=F.commentsPane&&F.commentsPane.isVisible();n=T&&T.prepareReloadHandler;return n&&_.extend(e,n.call(this)),F.isBusy()||t||F.enterBusy(),kn.info("$badge{EditApp} reloadDocument: start reloading the document",e),this.quit(Wn.RELOAD,{editModule:o+"/main",reloadLaunchOptions:e})},this.restoreDocument=function(l,e){var t,n,r=nn.getArrayOption(e,"actions",null),o=w.getFileDescriptor(),i=null;hn.RESTORE_DOCUMENT_ENABLED?Ie||(Ce=!(Ie=!0),i=_.isNull(r)?(e=On.handleMinifiedActions(p),Gt()?(t=k.getPendingActions(),n=e,t=On.getActionsArray(t),n=On.getActionsArray(n),_.isArray(t)&&_.isArray(n)?t.concat(n):t):e):r,Ke(!(B=!0)),ze(),G=!0,i={action:"saveaswithbackup",file_id:o.id,target_filename:o.filename,target_folder_id:o.folder_id,restore_id:me,operations:_.isNull(i)?i:JSON.stringify(i)},w.sendFileRequest(Un,i,{method:"POST"}).then(function(e){var t=new an(e),n=$.Deferred(),r=nn.getStringOption(e,ln.RESTORED_FILEID,null),o=nn.getStringOption(e,ln.RESTORED_FILENAME,null),i=nn.getStringOption(e,ln.RESTORED_FOLDERID,null),a=null,s={};_.isObject(e)&&_.isString(o)&&_.isString(i)?on.getPath(i).always(function(e){a=on.preparePath(e),n.resolve(a)}):n.resolve(null),n.always(function(e){e=_.isString(e);t.isError()||(t=new an({errorClass:an.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),s[ln.RESTORED_FILENAME]=o,s[ln.RESTORED_PATHNAME]=a,s[ln.ORIGINAL_FILEID]=w.getFileDescriptor().id,e&&w.updateFileDescriptor({id:r,folder_id:i}),w.setInternalError(t,l.getErrorContext(),l,{additionalData:s})})},function(){w.setInternalError(l)})):w.setInternalError(l)},this.rejectEditAttempt=function(e){if(this.isViewerMode())return!1;switch(e){case"image":return F.yell({message:Nn("The image could not be inserted.")});case"siri":return this.setInternalError(cn.ERROR_SIRI_NOT_SUPPORTED,sn.GENERAL),!0;case"loadingInProgress":return this.setCurrentInfoState(dn.INFO_LOADING_IN_PROGRESS);default:return this.isImportFinished()?Ze():this.setCurrentInfoState(dn.INFO_LOADING_IN_PROGRESS)}},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return en.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),r=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name.trim()+" "+e.last_name.trim()):e.last_name?_.noI18n(e.last_name.trim()):e.first_name?_.noI18n(e.first_name.trim()):n;return{id:e.user_id,displayName:n,operationName:r,guest:t}})},this.updateUserData=(Bt=null,w.debounce(function(e){return Bt=e,this},function(){Gt()&&w.isImportSucceeded()&&!G&&!w.isInQuit()&&k.updateUserData("updateuserdata",Bt)},{delay:500,maxDelay:1e3})),this.registerAuthorItem=function(e){var t,n;"authorId"in e&&"authorName"in e&&(t=e.authorId,(n=(_.isFinite(t)||_.isString(t))&&nn.getStringOption(e,"authorName","").trim()||"")&&(fe[t]={id:t,name:n,initials:nn.getStringOption(e,"initials","").trim()||null,providerId:nn.getStringOption(e,"providerId","").trim()||null,userId:nn.getStringOption(e,"userId","").trim()||null}))},this.getRegisteredAuthorItemById=function(e){return fe[e]},this.getAuthorColorIndex=function(e){return Fn((t=e,(e=_.indexOf(Ee,t))<0&&(e=Ee.length,Ee.push(t)),e));var t},this.addAuthors=function(e){return Ee=_.union(Ee,e),this},this.stopOperationDistribution=function(e){return he=!1,w.convertToPromise(e.call(w)).always(function(){he=!0})},this.isOperationsBlockActive=function(){return Oe},this.enterBlockOperationsMode=function(e){Oe=!0,wt()&&(w.trigger("docs:operations:remove",o.operations.length),o=Tt(null,o.userData)),e.call(w),Oe=!1},this.isMultiSelectionApplication=function(){return g},this.isSnapshotApp=function(){return O},this.isFirstTabActivated=function(){return Re},this.getLoadDocInfo=function(){return He},this.isOTEnabled=function(){return h},Object.defineProperty(this,"otManager",{get:function(){return t=t||e.createOTManager(this.docModel)},configurable:!0,enumerable:!0}),this.transformPositionWithLocalActions=function(e,t){return this.otManager.transformPosition(e,Fe,t)},this.getOTStatistics=function(){return{extOpCount:Me,otCount:t?t.getStatistics().otCount:0}},this.setOTBlockingOpsMode=function(e){Le=e},this.isOTBlockingOpsMode=function(){return Le},this.hasLocalActionsWithoutAck=function(){return h&&0<Fe.length},this.getServerOSN=function(){return Ue},this.isRescueDocument=function(){return je},this.isRescueDocMode=function(){return hn.DEBUG&&je},this.generateLogData=function(){var e=$n.getRecordedMessages();if(0===e.length)return"";var t=navigator.userAgent,n=Ge,r=qe,o=this.getFullFileName(),i=on.isGuest();return"__[OX_Documents_UI_log]__\n"+t+"\ndoc_uid: "+n+"\nclient_uid: "+r+"\napp: "+this.appType+"\nguestUser: "+i+"\nfileName: "+o+"\n \n"+e.join("\n")},this.downloadFrontendLog=function(){var e="Documents_UI_log_"+ox.user+(new Date).toISOString()+".txt";Yn(e,this.generateLogData())},this.useOperationOptimization=function(e){c=e},this.showEditToolbarAtStart=function(){return w.getUserSettingsValue("showToolbars",!0)||_.device("!desktop")},this.handleSessionChanged=function(){it()},this.handleSessionInvalidError=function(e){st(e)},this.debugTypeError=hn.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(kn.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Ae=new Xn(this)).startHook.on(function(){w.trigger("docs:acquireeditrights:start")}),Ae.finishHook.on(function(){w.trigger("docs:acquireeditrights:end")}),xe=new qn(function(){return Gt()?k.syncStable().catch(_.noop):vn()},{delay:3e4,interval:3e4}),this.onInit(function(){L=this.docModel,F=this.docView,this.getWindow().addClass("io-ox-office-edit-window"),this.waitForImport(function(){ae=w.launchTracker.step("triggerImportSuccess","$badge{EditApp} End of import process notified"),ve=ae,Sn.log("Load-mode:",we)}),ze(),et(),tt(),this.listenTo(L,"operations:error",function(){Ke(!1)}),this.listenTo(w,"docs:reload",pt),this.on("docs:operations:completed",Rt),pn.supportsEditMode(w.appType)||(Ke(!(B=!0)),ze(),Ze(pn.DOM_TEXT_EDIT_ALERT,-1)),z&&J&&(kn.info("$badge{EditApp} onInit(): saving document to local storage is active"),Mn?kn.info("$badge{EditApp} onInit: current browser supports local storage"):kn.warn("$badge{EditApp} onInit: current browser does not support local storage")),this.on("docs:flush:success",function(){i=!1}),L.listenTo(rn.hideTabHook,function(){kn.info("Tab hidden, must save?",i),i&&w.flushDocument(Vn.USER),h&&xe.abort()}),L.listenTo(rn.showTabHook,function(){h&&Jt()}),L.listenTo(w.getView(),"view:hide",function(){kn.info("App hidden, must save?",i),i&&w.flushDocument(Vn.USER)})},this),this.registerBeforeUnloadHandler(function(e){e||Ht()}),this.registerUnloadHandler(function(){Ht()}),this.registerBeforeQuitHandler(function(){if(hn.DEBUG&&w.debugTypeError.test("sync-beforeQuitHandler"),G)return(q?ar(q,4e3,"EditApplication.waitForInternalErrorLog"):vn()).catch(function(){return vn()});var e=w.docController.getUnsavedFileName();return e=(e=(e=e&&!v&&w.isOnline()?w.docController.executeItem("document/rename",e):vn()).then(function(){return w.isOnline()?Mt(Vn.QUIT).catch(function(e){if("timeout"===e)return e;throw e}):null})).then(function(){var e=It()&&w.hasUnsavedChangesOffice(),t=Nn("This document contains unsaved changes. Do you really want to close?");return e?F.showQueryDialog(null,t):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when(be).always(function(){Sn.log("$badge{EditApp} quitHandler.finalizeRTConnection called"),qt()})}function n(){try{if(Sn.log("$badge{EditApp} quitHandler.connectionGateKeeper entered"),!Gt())return;if(Vt())return;var e=k.getCloseLeaveState();switch(Sn.log("$badge{EditApp} quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void Wt();case"closing":case"closed":return void Wt({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void Wt()}}catch(e){Wt(),kn.warn("$badge{EditApp} quitHandler.connectionGateKeeper: Error caught:",e)}}var r=null;try{Sn.log("$badge{EditApp} quitHandler: reason",e),hn.DEBUG&&w.debugTypeError.test("sync-quithandler"),r=e===Wn.RELOAD?(Wt(),$.when()):function(e){var t=null,n=w.getWindow(),r=w.getFileDescriptor(),i=!1,o=null,a=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],s=e===Wn.LOGOUT,l=w.launchTracker;function c(e){i&&F.updateBusyProgress(e)}function h(n){var e="appsuiteDocsExpiryDates",r=localStorage.getItem(e),o=_.now();r&&(r=JSON.parse(r),_.isObject(r)?_.each(r,function(e,t){t!==n&&e<o&&(e=_.pluck(L.getSupportedStorageExtensions({allApps:!0}),"extension").concat(a),_.each(e,function(e){localStorage.removeItem(t+e)}),delete r[t])}):r=null),(r=r||{})[n]=o+6048e5,localStorage.setItem(e,JSON.stringify(r))}function d(){return on.propagateChangeFile(r)}n&&n.busy();var u=A||C||D||y,n="new"===b.action||b.template;r&&(u||hn.LOG_PERFORMANCE_DATA||!n&&ne.length<=1)&&(o={file:_.extend({last_opened:Date.now()},r),app:w.appType},l.setItem("LocalStorage",X),l.setItem("FastEmptyLoad",se),l.sendData());l=Gt()&&k.isConnected()&&!w.isShutdownReceived();t=r&&l?(o=Ce?o:_.extend({no_restore:Ce},o),(rn.BROWSER_TAB_SUPPORT?Yt(e,o):Yt(e,o).then(function(l){var c,d,u,g,p=null,f=null,e=null,t=A||C||D,n=L.getOperationStateNumber(),E=0,r=20;function o(e){e=nn.getBooleanOption(e,"migration",!1);_.each(a,function(e){localStorage.removeItem(p+e)}),e&&(Rn(l.syncInfo.fileVersion)?_.each(_.range(l.syncInfo.fileVersion>r?l.syncInfo.fileVersion-r:0,l.syncInfo.fileVersion),function(t){_.each(a,function(e){localStorage.removeItem(p+"_"+t+e)})}):(localStorage.removeItem(p+"_"+l.syncInfo.fileVersion),localStorage.removeItem(p+"_CURRENTVERSION")))}return Je(),(t||!X)&&l&&l.syncInfo&&!s&&!w.isDocumentEncrypted()&&Mn&&z&&J&&_.isFunction(L.getFullModelDescription)&&l.syncInfo.fileVersion&&l.syncInfo.fileId&&l.syncInfo.folderId&&Rn(l.syncInfo["document-osn"])&&n===l.syncInfo["document-osn"]&&(h(p=l.syncInfo.fileId+"_"+l.syncInfo.folderId),e=$.Deferred(),w.executeDelayed(function(){i=!0},1500),w.executeDelayed(function(){e.notify(.1),c=_.now(),L.getFullModelDescription(e,.1,.9).always(function(){_.isFunction(L.getSupportedStorageExtensions)&&_.each(L.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&a.push(e.extension)}),o({migration:!0})}).done(function(e){function s(e){return o(),kn.info("$badge{EditApp} quitHandler: "+e),!1}e.every(function(e){var t,n=e.htmlString,r=p+e.extension,e=null;kn.info("$badge{EditApp} quitHandler: created document string with size: "+n.length+". Time for conversion: "+(_.now()-c)+" ms.");try{if(0===E){if(f=p+"_OSN",d=p+"_FILEVERSION",u=p+"_STORAGEVERSION",g=p+"_OPERATIONS",localStorage.setItem(f,l.syncInfo["document-osn"]),localStorage.setItem(u,Q),localStorage.setItem(d,l.syncInfo.fileVersion),t=L.getStorageOperationCollector(),_.each(t,function(e){delete e.osn,delete e.opl}),e=JSON.stringify(t),localStorage.setItem(g,e),!localStorage.getItem(g)||localStorage.getItem(g).length!==e.length)return s("failed to save document operations in local storage");kn.info("$badge{EditApp} quitHandler: successfully saved document operations in local storage with key: "+g)}localStorage.setItem(r,n);var o=localStorage.getItem(r);if(!o||o.length!==n.length)return s("failed to save document in local storage");if(kn.info("$badge{EditApp} quitHandler: successfully saved document in local storage with key: "+r),0===E){var i=localStorage.getItem(f),a=i?parseInt(i,10):-1;if(a!==l.syncInfo["document-osn"])return s("failed to save OSN for document in local storage");kn.info("$badge{EditApp} quitHandler: successfully saved OSN for document in local storage with key: "+f+" : "+a)}return E++,!0}catch(e){return s("failed to save document and/or document OSN in local storage")}})}).always(function(){e.notify(1),e.resolve(l)})})),null===e?l:e.promise()})).progress(c)):$.when();l&&(t=t.then(function(){return hn.DEBUG&&w.debugTypeError.test("async-quithandler"),jt(".disconnect",null,2e3)}));r&&(u?t=t.then(d,d):"reload"!==e&&("new"===b.action||b.template)&&ne.length<=1&&!b.keepFile&&(t=t.then(function(){return on.purgeFile(r)})));return t}(e)}catch(e){r=$.when(),kn.warn("$badge{EditApp} quitHander: Error caught:",e)}return r=(r=r.then(n,n)).then(t,t)}),this.waitForImportSuccess(function(){h&&Jt()}),this.registerDestructor(function(){xe.destroy(),Ae.destroy(),b=T=w=L=F=null,k=p=o=_e=null,P=M=null,d=f=s=null,l=E=null,v=ee=ne=re=null,oe=xe=null,Ae=De=null})})});