define("io.ox/office/editframework/app/editcontroller",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/baseframework/controller/basecontroller","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/view/editlabels","io.ox/office/editframework/view/editdialogs","gettext!io.ox/office/editframework/actions"],function(e,t,n,r,g,v,a,b,o,i,u,E){"use strict";var w=t.newRejected,y=n.trimAndCleanString,S=r.globalLogger,T=a.BaseController,A=o.SaveAsType,x=o.GUARD_AVAILABLE,C=o.CONVERTER_AVAILABLE,R=o.searchLogger,F=i.DEFAULT_FILE_BASE_NAME,O=u.SaveAsFileDialog,k=u.SaveAsTemplateDialog,P=e.SearchCommand={CONFIG:"search:config",PREVIEW:"search:preview",START:"search:start",NEXT:"search:next",PREV:"search:prev",END:"search:end"},D=e.ReplaceCommand={NEXT:"replace:next",ALL:"replace:all"},e=e.EditController=T.extend(function(a,t,o,e){T.call(this,a,t,o,e);var n,r=this,i=null,u="",c="",s={withcase:!1,regexp:!1},l={count:0,complete:!0},d=!0,p=null;function f(n,r){var e=o.processUnsavedComment();return e=(e=(e=e.then(function(){switch(n){case A.NATIVE:return new O(o,r&&r.encrypted?E("Save as (encrypted)"):E("Save as"),_.noI18n.fix(E("Copy of %1$s",a.getShortFileName())));case A.TEMPLATE:return new k(o,E("Save as template (%1$s)",b.getTemplateExtension(a.getFullFileName())),a.getShortFileName());case A.PDF:return new O(o,E("Export as PDF"),a.getShortFileName());default:return S.error('$badge{EditController} showSaveAsDialog: unknown file type "'+n+'"'),w()}})).then(function(e){return e.show()})).then(function(e){var t=_.isString(e.fileName)?y(e.fileName):null;return t?a.saveDocumentAs(e.folderId,t,n,r):(S.error("$badge{EditController} showSaveAsDialog: missing file name"),w())})}function m(e){return R.trace(function(){return'$badge{SearchHandler} implExecuteSearch: command="'+e+'" query="'+u+'"'}),r.executeSearch(e,u,s)}function h(e){return R.trace(function(){return'$badge{SearchHandler} implExecuteReplace: command="'+e+'" query="'+u+'" replace="'+c+'"'}),r.executeReplace(e,u,c,s)}this.registerUndoManager=function(e){i!==e&&(this.stopListeningTo(i),i=e,this.updateOnEvent(i),this.update())},this.restoreUndoManager=function(){this.registerUndoManager(t.undoManager)},this.enableUndoRedo=function(e){d!==!!e&&(d=!!e,this.update())},this.getUnsavedFileName=function(){return p&&p!==a.getShortFileName()?p:void 0},this.registerItems({"app/valid":{parent:"app/imported",enable:function(){return!a.isInternalError()}},"view/appstatuslabel":{},"view/settings/menu":{},"view/toolbars/show":{get:function(){return o.toolPane.isVisible()},set:function(e){a.setUserSettingsValue("showToolbars",e),o.toolPane.toggle(e)}},"view/toolbars/tab":{get:function(){return o.toolBarTabs.getActiveTabId()},set:function(e){o.toolBarTabs.activateTab(e)},focusTarget:function(e){return"keyboard"===e?o.toolPane:null}},"view/new/menu":{parent:"app/valid",enable:function(){return g.BROWSER_TAB_SUPPORT}},"view/saveas/menu":{parent:"app/valid",enable:function(){return!a.getLaunchOption("disableSaveAs")}},"view/drawing/alignment/menu":{parent:"app/valid"},"view/drawing/spacing/menu":{parent:"app/valid"},"view/pane/search":{parent:"app/valid",get:function(){return o.searchPane.isVisible()},set:function(e){o.searchPane.toggle(e)},focusTarget:function(){return o.searchPane},shortcut:{keyCode:"F",ctrlOrMeta:!0,value:!0}},"document/ooxml":{enable:function(){return a.isOOXML()}},"document/odf":{enable:function(){return a.isODF()}},"document/acquireedit":{parent:"app/valid",enable:function(){return a.isAcquireEditRightsEnabled()}},"document/acquireeditOrPending":{parent:"app/valid",enable:function(){return a.isAcquireEditRightsEnabledPendingUpdates()},set:function(){a.acquireEditRights()}},"document/ot/enabled":{parent:"app/imported",enable:function(){return a.isOTEnabled()}},"document/reload":{parent:"app/imported",enable:function(){return a.isReloadEnabled()},set:function(){a.reloadDocument()}},"document/editable":{parent:"app/valid",enable:function(){return a.isEditable()}},"document/readonly":{parent:"app/valid",enable:function(){return!a.isEditable()}},"document/fullname":{get:function(){return a.getFullFileName()}},"document/rename":{parent:["document/editable","app/bundled"],enable:function(){return a.isRenameEnabled()},get:function(){return n||a.getShortFileName()},preview:function(e){p=e},set:function(e){return n=e,a.rename(e).always(function(){n=void 0})},async:"background"},"document/rename/dialog":{parent:"document/rename",set:function(){return o.showRenameDialog()}},"document/undo":{parent:"document/editable",enable:function(){return d&&0<this.value},get:function(){return i.getUndoCount()},set:function(){return i.undo()},shortcut:[{keyCode:"Z",ctrlOrMeta:!0,scope:".app-pane"},{keyCode:"BACKSPACE",alt:!0,scope:".app-pane"}]},"document/redo":{parent:"document/editable",enable:function(){return d&&0<this.value},get:function(){return i.getRedoCount()},set:function(){return i.redo()},shortcut:[{keyCode:"Y",ctrlOrMeta:!0,scope:".app-pane"},{keyCode:"BACKSPACE",shift:!0,alt:!0,scope:".app-pane"}]},"document/saveas/unencrypted":{parent:["app/valid","app/unencrypted"]},"document/saveas/native/dialog":{parent:"document/saveas/unencrypted",set:function(){return f(A.NATIVE)}},"document/saveas/template/dialog":{parent:"document/saveas/unencrypted",enable:function(){return!a.isRescueDocument()},set:function(){return f(A.TEMPLATE)}},"document/saveas/encrypted/dialog":{parent:"app/valid",enable:function(){return x&&!a.isExternalStorage()&&!a.isRescueDocument()},set:function(){return f(A.NATIVE,{encrypted:!0})}},"document/saveas/pdf/dialog":{parent:"document/saveas/unencrypted",enable:function(){return C&&!a.isRescueDocument()},set:function(){return f(A.PDF)}},"document/autosave":{parent:"document/editable",get:function(){return!0},set:function(){o.yell({headline:E("What is AutoSave?"),message:E("In OX Documents all your changes are saved automatically through AutoSave. It is not necessary to save your work manually.")})},shortcut:{keyCode:"S",ctrlOrMeta:!0}},"document/users":{parent:"app/valid",enable:function(){return 1<a.getActiveClients().length},get:function(){return o.collaboratorMenu.isVisible()},set:function(e){o.collaboratorMenu.toggle(e)}},"document/search":{parent:"app/valid"},"document/search/text":{parent:"document/search",get:function(){return u},set:function(e,t){if(u=e,!t||!t.commitEvent||"blur"!==t.commitEvent.sourceType)return m(P.START)},preview:function(e){if(void 0!==e)return u=e,m(P.PREVIEW)}},"document/search/withcase":{parent:"document/search",get:function(){return s.withcase},set:function(e){return s.withcase=e,m(P.CONFIG)}},"document/search/regexp":{parent:"document/search",get:function(){return s.regexp},set:function(e){return s.regexp=e,m(P.CONFIG)}},"document/search/result":{parent:"document/search",get:function(){return l},set:function(e){_.assign(l,e)},preserveFocus:!0},"document/search/start":{parent:"document/search",set:function(){return m(P.START)}},"document/search/prev":{parent:"document/search",set:function(){return m(P.PREV)},shortcut:[{keyCode:"G",ctrlOrMeta:!0,shift:!0},{keyCode:"F3",shift:!0}]},"document/search/next":{parent:"document/search",set:function(){return m(P.NEXT)},shortcut:[{keyCode:"G",ctrlOrMeta:!0},{keyCode:"F3"}]},"document/search/end":{parent:"document/search",set:function(){return u=c="",m(P.END)}},"document/search/close":{parent:"document/search",set:function(){return o.searchPane.hide()}},"document/replace":{parent:["document/search","document/editable"]},"document/replace/text":{parent:"document/replace",get:function(){return c},set:function(e){c=e}},"document/replace/next":{parent:"document/replace",set:function(){return h(D.NEXT)}},"document/replace/all":{parent:"document/replace",set:function(){return h(D.ALL)}},"document/new":{parent:"app/valid",set:function(e){g.openEditorChildTab(e,{target_folder_id:v.getStandardDocumentsFolderId(),target_filename:F,new:!0})}},"document/new/encrypted":{parent:"app/valid",enable:function(){return x},set:function(t){return v.authorizeGuardWithTab().then(function(e){g.openEditorChildTab(t,{target_folder_id:v.getStandardDocumentsFolderId(),target_filename:F,crypto_action:"Encrypt",auth_code:e.authCode,new:!0},e.targetTab)})}},"debug/downloadreport":{enable:function(){return a.allowStoreLogFile()},set:function(){return a.createCrashDataAsDownload()},shortcut:[{keyCode:"D",shift:!0,ctrlOrMeta:!0,alt:!0}]},"document/new/fromTemplate":{parent:"app/valid",set:function(){g.openPortalChildTab(a.appType)}},"document/open":{parent:"app/valid",enable:function(){return g.BROWSER_TAB_SUPPORT},set:function(){return o.showOpenDocumentDialog()}},"format/painter":{parent:"document/editable",enable:function(){var e=t.getSelection();return!e.isMultiSelection()&&!e.isSlideSelection()},get:function(){return t.isFormatPainterActive()},set:function(e){t.handleFormatPainter(e,{reset:!0})}}}),a.onInit(function(){i=t.undoManager,this.updateOnEvent(i)},this),this.waitForImport(function(){this.updateOnEvent(a,"docs:state:error docs:users docs:editmode"),this.updateOnEvent(o.collaboratorMenu,"popup:show popup:hide")},this),this.listenTo(o,"dialog:show",function(e,t,n){n&&n.showReadOnly||t.listenTo(a,"docs:editmode:leave",t.close)})});e.prototype.executeSearch=function(){R.error("$badge{EditController} executeSearch: missing implementation of abstract method")},e.prototype.executeReplace=function(){R.error("$badge{EditController} executeReplace: missing implementation of abstract method")}});