define("io.ox/office/editframework/app/rtconnection",["io.ox/core/uuids","io.ox/core/tk/sessionrestore","io.ox/office/tk/object/baseobject","io.ox/office/editframework/utils/editconfig","io.ox/office/baseframework/utils/clienterror","io.ox/office/rt2/docrtbase","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/rt2/errorcode"],function(l,d,g,f,E,h,R,p,T){"use strict";function m(t,e){var o=this,n=null,r=[],i=d.state("documents.clientuid"),c=3e4,s="unknown",u="unknown";function a(){return null==n&&(n=h.create(t,e),d.state("documents.clientuid",n.getClientUID())),n}g.call(o),this.registerDestructor(function(){m.log("RTConnection.dtor(default) called"),null!=n&&n.destroy(),o=r=n=e=t=null}),this.getClientUID=function(){return a().getClientUID()},this.getDocUID=function(){return a().getDocUID()},this.getChannelUID=function(){return a().getChannelUID()},this.isConnected=function(){return a().isConnected()},this.getCloseLeaveState=function(){return u},this.getConnectOpenState=function(){return s},this.connect=function(){s="joining",m.log("RTConnection.connect called."),m.log("Client UID: "+this.getClientUID()+", document uid: "+this.getDocUID());var e=a().join();return e.done(function(){s="joined"}),e},this.disconnect=function(e){u="disconnecting",m.log("RTConnection.disconnect called, autoClose was",e);e=a().leave(e);return e.done(function(){u="disconnected"}),e},this.open=function(e){s="opening",m.log("RTConnection.open called"),e=_.extend({oldClientUID:i},e);e=a().openDocument(e);return e.done(function(){s="opened"}),e},this.abortOpen=function(){return m.log("RTConnection.abortOpen called"),a().abortOpen()},this.closeDocument=function(e){u="closing",m.log("RTConnection.closeDocument called");e=a().closeDocument(e);return e.done(function(){u="closed"}),e},this.emergencyLeave=function(e){u="leaving",m.log("RTConnection.emergencyLeave called");var n,t=!1,o={client_uid:a().getClientUID(),doc_uid:a().getDocUID(),channel_uid:a().getChannelUID()},n=(n="emergencyleave",o=o,n=ox.apiRoot+"/rt2?action="+n,o=_.map(o,function(e,n){return n+"="+e}).join("&"),_.isString(o)&&0<o.length&&(n+="&"+o),n+="&session="+ox.session),e=JSON.stringify(e||{});try{e=new Blob([e],{type:"text/plain; charset=utf-8"}),t=navigator.sendBeacon(n,e)}catch(e){m.log("RTConnection.emergencyLeave - sendBeacon triggered exception")}return u="left",t},this.reset=function(){return m.log("RTconnection.restart called"),a().reset()},this.sendActions=function(e,n){var t=l.randomUUID(),o={id:t,timeStamp:Date.now(),action:e},i=[];_.each(e,function(e){e&&e.operations&&0<e.operations.length&&(i=i.concat(e.operations))});n=a().send(p.REQUEST_APPLY_OPS,{},{operations:i,serverOSN:n});return o.promise=n,r.push(o),n.done(function(){var n;n=t,_.isString(n)&&0<n.length&&(r=_.filter(r,function(e){return n!==e.id}))}),n},this.updateUserData=f.SHOW_REMOTE_SELECTIONS?function(e,n){return m.log("RTConnection.updateUserData called",n),a().sendAppAction("updateUserData",n)}:function(){},this.addImageId=function(e){return a().sendAppAction("add_image_id_request",{imageInfo:e})},this.renameDocument=function(e){var n=$.Deferred();return m.log("RTConnection.renameDocument called"),a().sendAppAction("rename_document",e).then(function(e){n.resolve(e.body)},function(e){n.reject(e.body)}),n.promise()},this.sync=function(){var n=$.Deferred();return m.log("RTConnection.sync called"),a().sync({osn:t.getModel().getOperationStateNumber()}).then(function(e){n.resolve(e.body||e)},function(e){n.reject(e)}),n.promise()},this.syncStable=function(){var n=$.Deferred();return m.log("RTConnection.syncStable called"),a().syncStable({osn:t.getModel().getOperationStateNumber()}).then(function(e){n.resolve(e.body||e)},function(e){n.reject(e)}),n.promise()},this.flushDocument=function(){return m.log("RTConnection.flushDocument called"),a().send(p.REQUEST_SAVE_DOC,{},{})},this.acquireEditRights=function(){return m.log("RTConnection.acquireedit called"),a().send(p.REQUEST_EDITRIGHTS,{},{action:"request",osn:t.getModel().getOperationStateNumber()})},this.canLoseEditRights=function(e){return m.log("RTConnection.canloseeditrights called"),a().send(p.REQUEST_EDITRIGHTS,{},{action:"approved",value:e,osn:t.getModel().getOperationStateNumber()})},this.declineEditRights=function(e){m.log("RTConnection.declineeditrights called");e=e||"@ALL";return a().send(p.REQUEST_EDITRIGHTS,{},{action:"declined",value:e,osn:t.getModel().getOperationStateNumber()})},this.forceEditRights=function(){return m.log("RTConnection.forceEditRights called"),a().send(p.REQUEST_EDITRIGHTS,{},{action:"force",osn:t.getModel().getOperationStateNumber()})},this.copyDocument=function(e){return m.log("RTConnection.copyDocument called"),a().sendAppAction("copydocument",e).then(function(e){return e.body},function(e){return $.Deferred().reject(e.body)})},this.getPendingActions=function(){var n=[];return _.isArray(r)&&0<r.length&&_.each(r,function(e){n=n.concat(e.action)}),{actions:n}},this.hasPendingActions=function(){return _.isArray(r)&&0<r.length},this.debugTriggerProblem=f.REALTIME_DEBUGGING?function(e){window.setTimeout(function(){"error"===e?o.trigger(R.EVENT_ERROR,E.ERROR_UNKNOWN_REALTIME_FAILURE):a().debugTriggerProblem(e)},0)}:$.noop,m.log("RTConnection initialization"),this.setInterval(function(){var n=Date.now(),t=!1;a().isConnected()&&(_.each(r,function(e){e=n-e.timeStamp;c<e&&(t=!0)}),t&&o.trigger(R.EVENT_NORESPONSE_IN_TIME))},c),a().on(R.EVENT_RECEIVE,function(e,n){null!=o&&o.trigger(n.type,n.body)}),a().on(R.EVENT_CONNECTION_STATE,function(e,n){null!=o&&o.trigger(e.type,n)}),a().on(R.EVENT_ERROR,function(e,n){var t=E.ERROR_UNKNOWN_REALTIME_FAILURE;null!=o&&(T.isErrorCode(n)?t={error:n.getCodeAsStringConstant(),errorClass:n.getErrorClass()}:_.isError(n)&&(t=E.ERROR_UNKNOWN_REALTIME_FAILURE),o.trigger(e.type,t))})}return f.extendWithRTLogger(m),g.extend({constructor:m})});