define("io.ox/office/editframework/model/editmodel",["exports","static/3rd.party/crypto-js/crypto-js.js","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/basemodel","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operations","io.ox/office/editframework/utils/operationerror","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operation/context","io.ox/office/editframework/model/operation/generator","io.ox/office/editframework/model/modelattributesmixin","io.ox/office/editframework/model/undomanager"],function(e,w,E,t,n,o,i,r,k,A,a,P,s,c,l,D,d){"use strict";var C=t.isFulfilled,U=t.isPending,I=t.newFulfilled,N=t.newRejected,R=n.toPromise,j=n.fastThen,B=n.stringifyForDebug,F=o.TMap,o=i.Logger,H=i.globalLogger,T=r.BaseModel,G=a.OperationError,J=s.otLogger,L=s.isOperationRemoved,z=c.OperationContext,K=l.resolveOperations,V=l.OperationGenerator,W=d.UndoManager,q=new o("office:log-ops",{tag:"OP",tagColor:16711935});e.EditModel=T.extend(function(d,s){var c=s&&s.contextClass||z,u=this,t=null,o=new F,i=!1,n=!1,r=!1,a=!1,l=0,p=-1,f=null,g=d.isOTEnabled(),e=!(!s||!s.slideMode),h=e&&(E.IOS||E.CHROME_ON_ANDROID);function O(e){if(u.isProcessingActions())return g&&i&&(r?(J.info("$badge{EditModel} enterProcessActionsMode: Collision! External operations are currently applied"),u.trigger("docs:ot:collision")):n&&J.info("$badge{EditModel} enterProcessActionsMode: Internal operations are currently applied")),G.rejectCause("recursive","$badge{EditModel} enterProcessActionsMode: recursive call");t=$.Deferred().always(function(){var e=t?t.state().replace(/ed$/,"ing"):"destructed";q.log("$badge{EditModel} enterProcessActionsMode: "+e+" promise...")});e=R(J.profileMethod("$badge{EditModel} enterProcessActionsMode",e.bind(u)));return e.progress(t.notify.bind(t)),e.done(t.resolve.bind(t)),e.fail(t.reject.bind(t)),e}function m(e,t){i&&(g&&(r&&!t?J.info("$badge{EditModel} beginProcessOperations: Collision! Receiving internal operation during applying external operations"):n&&t?J.info("$badge{EditModel} beginProcessOperations: Collision! Receiving external operation during applying internal operations"):J.info("$badge{EditModel} beginProcessOperations: Collision! State of external: "+t+", processingExternalOperations: "+r+", processingInternalOperations: "+n)),G.throwCause("recursive","$badge{EditModel} beginProcessOperations: recursive call - currently processing operations.")),d.isInternalError()&&G.throwCause("recursive","$badge{EditModel} beginProcessOperations: illegal call - application is in error state."),u.trigger("operations:before",e,t),i=!0,g&&(t?r=!0:u.setInternalOperationBlocker(!0))}function M(e,t,n,o){i=!1,g&&(r=!1),e&&(e.operation&&(e.message+="; op="+B(e.operation)),q.exception(e),d.sendLogMessage(e.message)),u.trigger("operations:after",t,n,o),u.trigger(e?"operations:error":"operations:success",t,n,o)}function b(e){var t=e.getStr("name"),n=o.get(t,null);return e.ensure(n,"unknown operation %s",t),n}function S(e){return e||d.isEditable()||d.isRescueDocMode()}function v(e,t,n,o){if(q.log("i="+l+", op=",e),!_.isObject(e))throw new G("$badge{EditModel} applyOperation: JSON object expected.",{operation:e});var i=new c(u,e,t,o),r=b(i);t&&i.has("osn")&&(a=i.getInt("osn"),i.ensure(0<=a,"Invalid OSN: %d",a),-1===p&&u.setOperationStateNumber(a),g||p===a||i.error("Wrong OSN (current=%d operation=%d)",p,e.osn)),t||(e.osn=g?d.getServerOSN():p,e.opl=1,k.DEBUG&&(e.dbg_user_id=ox.user_id)),k.DEBUG&&t&&u.trigger("operationtrace:apply:external",e,d.getServerOSN()),0<=p&&u.setOperationStateNumber(p+i.optInt("opl",1));var a=s&&s.storageOperationCollector;a&&a.call(u,e);a=i.optStr("scope");n||"filter"===a||g&&L(e)||(r.call(u,i),f=e,g&&!o&&u.trigger(t?"operation:external":"operation:internal",e)),l+=1}function y(e,t,n){var o=n&&n.sendOnly,i=n&&n.userData,r=!u.isImportFinished();if(e=K(e,n),!S(t)||0===e.length)return 1;n=!t&&s&&s.operationsFinalizer;n&&(e=n.call(u,e));var a=null;try{m(e,t),u.undoManager.enterUndoGroup(function(){try{e.forEach(function(e){v(e,t,o,r)})}catch(e){a=e}})}catch(e){a=e}if(M(a,e,t,i),a)throw a}function x(n,o,e){var i=e&&e.sendOnly,t=e&&e.userData,r=!u.isImportFinished(),a=l;if(0===(n=K(n,e)).length)return u.createResolvedPromise(null);try{m(n,o)}catch(e){return M(e,n,o,t),u.createRejectedPromise(e)}e=u.undoManager.enterUndoGroup(function(){return u.iterateArraySliced(n,function(e,t){return S(o)?void v(e,o,i,r):(n=n.slice(0,t),E.BREAK)})});return u.await(e,function(){M(void 0,n,o,t)}),u.catch(e,function(e){"abort"===e?M(void 0,n.slice(0,l-a),o,t):M(e,n,o,t)}),e}T.call(this,d),this.registerOperationHandler=function(e,t){return o.insert(e,t),this},this.registerPlainOperationHandler=function(e,n){return this.registerOperationHandler(e,function(e){var t=n.call(this,e.operation,e.external);e.ensure(!1!==t,"operation handler failed")})},this.serializeToJSON=function(){return H.warn("$badge{EditModel} serializeToJSON: not implemented"),{}},this.getSelectionState=function(){},this.setSelectionState=function(){H.error("$badge{EditModel} setSelectionState: missing implementation")},this.isProcessingActions=function(){return!!t&&U(t)},this.waitForActionsProcessed=function(){return t?j(t,_.noop,_.noop):this.createResolvedPromise()},this.isProcessingOperations=function(){return i},this.isProcessingExternalOperations=function(){return r},this.isProcessingInternalOperations=function(){return n},this.setInternalOperationBlocker=function(e){g&&(e?n=e:n&&u.isProcessingActions()?t.always(function(){u.setInternalOperationBlocker(e)}):n&&!d.isRemovalOfInternalBlockerPossible()||(n=e,d.checkStartOfExternalOperations()))},this.setDrawingChangeActive=function(e){a=e},this.isDrawingChangeActive=function(){return a},this.sendOperations=q.profileMethod("$badge{EditModel} sendOperations",function(e,t){try{return y(e,!1,_.extend({},t,{sendOnly:!0})),!0}catch(e){return!1}}),this.applyOperationsAsync=q.profileMethod("$badge{EditModel} applyOperationsAsync",function(e,t){return O(function(){return x(e,!1,t)})}),this.applyOperations=q.profileMethod("$badge{EditModel} applyOperations",function(e,t){var n=O(function(){y(e,!1,t)});return C(n)}),this.applyExternalOperations=q.profileMethod("$badge{EditModel} applyExternalOperations",function(e,t){return 0===e.length?I():(t&&t.expand&&P.handleMinifiedActions([{operations:e}],!0),O(function(){return x(e,!0)}))}),this.invokeOperationHandlers=function(e){this.undoManager.disableUndoSync(function(){K(e).forEach(function(e,t){try{var n=new c(this,e,!1);b(n).call(this,n)}catch(e){throw e.index=t,e}},this)},this)},this.createOperationGenerator=function(e){return new V(this,e)},this.createAndApplyOperations=q.profileMethod("$badge{EditModel} createAndApplyOperations",function(r,a){var s=a&&a.generator||this.createOperationGenerator(a),c=!0===(a&&a.storeSelection)?_.noop:E.getFunctionOption(a,"storeSelection",null),l=s.isImmediateApplyMode();return O(function(){var t={preventSelectionChange:!(!a||!a.preventSelectionChange)};c&&(t.undoSelectionState=a&&a.undoSelectionState||u.getSelectionState());var n=!1;function e(){n=!0}this.on("operations:immediate",e);var o,i=null;try{i=u.convertToPromise(r.call(u,s))}catch(e){i=N(e)}return i.done(function(e){o=e}),i.always(function(){u.off("operations:immediate",e)}),i.fail(function(e){l&&n&&(q.error("$badge{EditModel} createAndApplyOperations: failure with immediate operations, reloading...",e),d.reloadDocument())}),i=j(i,function(){var e=s.getUserData(),e=e?{userData:e}:void 0;return l?u.sendOperations(s,e)?null:N({cause:"operation"}):x(s,!1,e)}),i=j(i,function(){c&&(c.call(u),t.redoSelectionState=a&&a.redoSelectionState||u.getSelectionState()),a&&a.afterApplyHandler&&a.afterApplyHandler.call(u,s);var e=u.undoManager;switch(a&&a.undoMode||"generate"){case"generate":t.undoUserData=s.getUserData({undo:!0}),t.redoUserData=s.getUserData(),e.addUndo(s.getOperations({undo:!0}),s.getOperations(),t);break;case"clear":e.clearUndoActions();break;case"skip":break;default:H.error("$badge{EditModel} createAndApplyOperations: unknown undo mode")}return o})})}),this.getOperationsCount=function(){return l},this.getOperationStateNumber=function(){return p},this.setOperationStateNumber=function(e){return p!==e&&(p=e,g||this.trigger("change:osn",e)),this},this.getLastOperation=function(){return f},this.getUndoManager=function(){return this.undoManager},this.useSlideMode=function(){return e},this.getSlideTouchMode=function(){return h},this.getDocumentChecksum=function(){var e=this.serializeToJSON(),e=w.MD5(JSON.stringify(e)).toString();return u.trigger("update:checksum",e),e},this.hasUnsavedComments=function(){return!1},this.checkUndoOperations=function(){},this.deleteUnsavedComments=function(){},this.isPresentationMode=function(){return!1},this.showRemoteSelections=function(){return!0},this.blockPopupMenus=function(){return!1},this.isValidReadOnlyMode=function(){return!0},this.undoManager=new W(this,s),D.call(this,s),this.registerOperationHandler(A.NOOP,_.noop),this.registerDestructor(function(){this.undoManager.destroy(),o.clear()})})});