define("io.ox/office/editframework/model/undomanager",["exports","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operation/context"],function(e,t,y,n,o){"use strict";var k=t.globalLogger,w=n.otLogger,r=o.OperationContext,M=1,A=2;function i(e,t,n){return t?0<e.length&&_.isFunction(t)!==_.isFunction(e[0])?(k.error("$badge{UndoManager} callback function and JSON operations cannot be mixed!"),e):(_.isFunction(t)?t=[t]:(t=_.getArray(_.copy(t instanceof r?t.operation:t,!0)),n===A&&(t=t.filter(function(e){return!e._SKIP_REDO_}))),n===M?t.concat(e):e.concat(t)):e}function x(e,t,n){this.undoOperations=[],this.redoOperations=[],this.preventSelectionChange=!(!n||!n.preventSelectionChange),this.undoSelectionState=n&&n.undoSelectionState,this.redoSelectionState=n&&n.redoSelectionState,this.undoUserData=n&&n.undoUserData,this.redoUserData=n&&n.redoUserData,this.restoreActions=null,this.otMarker=void 0,this.appendOperations(e,t)}x.prototype.empty=function(){return 0===this.undoOperations.length&&0===this.redoOperations.length},x.prototype.appendOperations=function(e,t){this.undoOperations=i(this.undoOperations,e,M),this.redoOperations=i(this.redoOperations,t,A)},e.UndoManager=y.extend(function(a,e){var c=this,l=a.docApp,r=e&&e.mergeUndoActionHandler,o=e&&e.updateSelectionInUndo,u=e&&e.disableRedoWithOT,s=l.isOTEnabled(),d=[],p=null,f=0,n=0,i=0,g=null,h=null;function S(){0===f&&(p=null),f<d.length&&(d.splice(f),c.trigger("change:stack"))}function O(e){var t=null,n=d.length;if(f<n){if(h){if(!s)return void k.error("$badge{UndoManager} pushAction: OT must be enabled if processing is true in function pushAction!");var o=d[f];return void(h===M&&(o.redoOperations=e.undoOperations,m(o)))}S()}else{if(u&&h===M)return;if(r&&0<n&&(t=_.last(d),!0===r.call(c,t,e)))return void(t.redoSelectionState=e.redoSelectionState)}d.push(e),f=d.length,s&&m(e),c.trigger("change:stack")}function m(e){e.otMarker=p?p.length:0}function v(){return d[f].otMarker}function b(e,t,n,o){h=e,a.setInternalOperationBlocker(!0);o=_.isFunction(t[0])?t.reduce(function(e,t){return e.then(function(){var e=t.call(c);return!1===e?$.Deferred().reject():e})},c.createResolvedPromise()):a.applyOperationsAsync(_.copy(t,!0),{userData:o});return c.await(o,function(){_.isObject(n)&&a.setSelectionState(n)}),c.finally(o,function(){h=null,a.setInternalOperationBlocker(!1)}),o}function U(e,t,n,o){var r,i,a=p.slice(v());e===M?(i=a,d[f].restoreActions=0<i.length?_.copy(i,!0):null):(s=d[f].restoreActions,d[f].restoreActions=null,s&&(r=s.length,i=v()-r,p.splice.apply(p,[i,r].concat(s))));var s={operations:t,selection:!0};if(0===a.length)return s;u&&e===M&&(w.info("$badge{UndoManager} transformOperations: dropping untransformable redo actions"),S());try{w.info("$badge{UndoManager} transformOperations: stackIndex="+f+", transforming operations..."),s.operations=l.otManager.transformOperations(t,a,{swapped:!0,userData:o}),n&&(s.selection=l.otManager.transformSelectionState(n,a),s.selection&&c.trigger("transform:selectionstate",n,a))}catch(e){"OTError"===e.name?w.warn("$badge{UndoManager} transformOperations: transformation failed"):w.exception(e,"$badge{UndoManager} transformOperations: transformation failed"),w.warn("$badge{UndoManager} transformOperations: clearing undo stack"),c.clearUndoActions(),delete s.operations}return s}y.call(this,a),this.isUndoEnabled=function(){return(!h||s)&&0===n&&this.isImportFinished()},this.clearUndoActions=function(){f=0,S()},this.enterUndoGroup=function(e,t,n){this.isUndoEnabled()&&0===i&&(g=new x(null,null,n),o&&!g.undoSelectionState&&(g.undoSelectionState=a.getSelectionState()),c.trigger("undogroup:open")),i+=1;n=null;try{n=this.convertToPromise(e.call(t))}catch(e){n=this.createRejectedPromise(e)}return this.finally(n,function(){--i,g&&0===i&&(g.empty()||l.isOperationsBlockActive()||(o&&!g.redoSelectionState&&(g.redoSelectionState=a.getSelectionState()),O(g)),g=null,c.trigger("undogroup:close"))}),n},this.disableUndoSync=function(e,t){try{return n+=1,e.call(t)}finally{--n}},this.addUndo=function(e,t,n){l.isEditable()&&this.isUndoEnabled()&&(e||t)&&(g?g.appendOperations(e,t):(o&&((n=n||{}).undoSelectionState||(n.undoSelectionState=a.getSelectionState())),O(new x(e,t,n))))},this.getUndoCount=function(){return f},this.undo=function(){if(0===f)return $.when();var e=d[--f],t=e.undoOperations,n=e.undoUserData;if(s&&p&&!_.isFunction(t[0])){var o=U(M,t,e.undoSelectionState,n);if(!o.operations)return $.when();t=o.operations,o.selection||delete e.undoSelectionState}var r=_.isFunction(t[0])?[]:t,i={preventSelectionChange:e.preventSelectionChange},o=e.undoSelectionState;o&&(i.selectionState=o),n&&(i.userData=n),this.trigger("undo:before",r,i),s&&0===t.length&&(e.redoOperations=[],m(e));n=b(M,t,o,n);return this.finally(n,function(){this.trigger("undo:after",r,i)}),n},this.getRedoCount=function(){return d.length-f},this.redo=function(){if(f===d.length)return $.when();var e=d[f],t=e.redoOperations,n=e.redoUserData;if(s&&p&&!_.isFunction(t[0])){var o=U(A,t,e.redoSelectionState,n);if(!o.operations)return $.when();t=o.operations,o.selection||delete e.redoSelectionState}var r=_.isFunction(t[0])?[]:t,i={preventSelectionChange:e.preventSelectionChange},o=e.redoSelectionState;o&&(i.selectionState=o),n&&(i.userData=n),this.trigger("redo:before",r,i);n=b(A,t,o,n);return this.finally(n,function(){f+=1,this.trigger("redo:after",r,i),s&&0===t.length&&a.checkUndoOperations(p,e.undoOperations)}),n},s&&this.listenTo(a,"operations:success",function(e,t,n){n&&0<d.length&&((p=p||[]).push({operations:t,sentToServer:!0}),u&&(w.info('$badge{UndoManager} event "operations:success": dropping untransformable redo actions'),S()))})})});