define("io.ox/office/presentation/utils/presentationutils",["io.ox/office/tk/dom","io.ox/office/tk/utils","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/drawinglayer/view/drawingframe","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom","io.ox/office/textframework/utils/position","gettext!io.ox/office/presentation/main"],function(t,S,w,O,y,f,p,e){"use strict";var R=t.Rectangle,L={PLACEHOLDER_DRAWING_IMPORTANT_ATTRS:["left","top","width","height","rotation","flipH","flipV"],DEFAULT_PLACEHOLDER_TYPE:"body",TABLE_PLACEHOLDER_TYPE:"tbl",IMAGE_PLACEHOLDER_TYPE:"pic",CONTENTBODY:"contentbody",TITLE_PLACEHOLDER_TYPES:{title:1,ctrTitle:1},TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES:{title:1,ctrTitle:1,subTitle:1},ODF_MASTER_READONLY_TYPES:{title:1,body:1},NO_TEXT_PLACEHOLDER_TYPE:{media:1,clipArt:1,chart:1,dgm:1,tbl:1,pic:1},NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY:{media:null,clipArt:"image",chart:null,dgm:null,tbl:"table",pic:"image"}};return L.PLACEHOLDER_TEMPLATE_TEXTS={body:e("Click to add text"),title:e("Click to add title"),ctrTitle:e("Click to add title"),subTitle:e("Click to add subtitle"),media:e("Media clip"),clipArt:e("Online image"),chart:e("Chart"),dgm:e("Smart Art"),tbl:e("Click to add table"),pic:e("Click to add image"),sldNum:e("Slide Number"),ftr:e("Footer"),dt:e("Date")},L.PLACEHOLDER_TEMPLATE_TEXTS_ODF={body:e("Click to add text"),title:e("Click to add title"),ctrTitle:e("Click to add title"),subTitle:e("Click to add text"),media:e("Media clip"),clipArt:e("Online image"),chart:e("Chart"),dgm:e("Smart Art"),tbl:e("Click to add table"),pic:e("Click to add image"),sldNum:e("Slide Number"),ftr:e("Footer"),dt:e("Date")},L.PLACEHOLDER_TEMPLATE_TEXTS_CLICK={pic:e("Click icon to add image"),tbl:e("Click icon to add table"),chart:e("Click icon to add chart"),dgm:e("Click icon to add smart art graphic"),clipArt:e("Click icon to add clip art"),media:e("Click icon to add media")},L.PLACEHOLDER_TEMPLATE_BUTTONS={contentBody:["picture","table"],body:null,title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},L.PLACEHOLDER_TEMPLATE_BUTTONS_ODF={contentBody:["picture","table"],body:["picture","table"],title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},L.PLACEHOLDER_DRAWING_NAMES={content:e("Content placeholder"),contentv:e("Vertical content placeholder"),text:e("Text placeholder"),textv:e("Vertical text placeholder"),picture:e("Image placeholder"),table:e("Table placeholder")},L.PLACEHOLDER_TEXT_CONTENT=[e("Edit Master text styles"),e("Second level"),e("Third level"),e("Fourth level"),e("Fifth level")],L.PLACEHOLDER_TITLE_CONTENT=e("Click to edit Master title style"),L.DEFAULT_PLACEHOLDER_INDEX=0,L.isPlaceHolderAttributeSet=function(t){return!(!t||!t.presentation||!t.presentation.phType&&!_.isNumber(t.presentation.phIndex))},L.isTitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&L.TITLE_PLACEHOLDER_TYPES[t.presentation.phType])},L.isTitleOrSubtitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&L.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES[t.presentation.phType])},L.isBodyPlaceHolderAttributeSet=function(t){return!(!(t&&t.presentation&&_.isNumber(t.presentation.phIndex))||t.presentation.phType!==L.DEFAULT_PLACEHOLDER_TYPE&&t.presentation.phType)},L.isTextBodyPlaceHolderAttributeSet=function(t,e){return!(e||!1||!t||!t.presentation||!_.isNumber(t.presentation.phIndex)||t.presentation.phType!==L.DEFAULT_PLACEHOLDER_TYPE)},L.isContentBodyPlaceHolderAttributeSet=function(t,e){e=e||!1;return!(!t||!t.presentation||!_.isNumber(t.presentation.phIndex)&&!e||t.presentation.phType&&(!e||t.presentation.phType!==L.DEFAULT_PLACEHOLDER_TYPE))},L.isPlaceHolderWithoutTextAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&L.NO_TEXT_PLACEHOLDER_TYPE[t.presentation.phType])},L.isCustomPromptPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.customPrompt)},L.isODFReadOnlyPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&L.ODF_MASTER_READONLY_TYPES[t.presentation.phType])},L.isBodyPlaceHolderAttributeSetWithoutIndex=function(t){return!(!t||!t.presentation||_.isNumber(t.presentation.phIndex)||t.presentation.phType!==L.DEFAULT_PLACEHOLDER_TYPE)},L.isUserModifiedPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.userTransformed)},L.isPlaceHolderDrawing=function(t){return L.isPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.getPlaceHolderDrawingType=function(t,e){t=e||y.getExplicitAttributeSet(t);return t&&t.presentation&&t.presentation.phType?t.presentation.phType:null},L.getPlaceHolderDrawingIndex=function(t,e){t=e||y.getExplicitAttributeSet(t);return t&&t.presentation&&_.isNumber(t.presentation.phIndex)?t.presentation.phIndex:null},L.isTitlePlaceHolderDrawing=function(t){return L.isTitlePlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isTitleOrSubtitlePlaceHolderDrawing=function(t){return L.isTitleOrSubtitlePlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isBodyPlaceHolderDrawing=function(t){return L.isBodyPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isTextBodyPlaceHolderDrawing=function(t){return L.isTextBodyPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isContentBodyPlaceHolderDrawing=function(t){return L.isContentBodyPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isPlaceHolderWithoutTextDrawing=function(t){return L.isPlaceHolderWithoutTextAttributeSet(y.getExplicitAttributeSet(t))},L.isEmptyPlaceHolderDrawing=function(t){var e,i=y.getExplicitAttributeSet(t),r=!1;return L.isPlaceHolderWithoutTextAttributeSet(i)?"undefined"!==$(t).attr("data-type")&&(e=L.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY[i.presentation.phType],i&&e&&i[e]||(r=!0)):L.isPlaceHolderAttributeSet(i)&&(r=f.isEmptyTextframe(t,{ignoreTemplateText:!0})),r},L.isCustomPromptPlaceHolderDrawing=function(t){return L.isCustomPromptPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isODFReadOnlyPlaceHolderDrawing=function(t){return L.isODFReadOnlyPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.isBodyPlaceHolderWithoutIndexDrawing=function(t){return L.isBodyPlaceHolderAttributeSetWithoutIndex(y.getExplicitAttributeSet(t))},L.isUserModifiedPlaceHolderDrawing=function(t){return L.isUserModifiedPlaceHolderAttributeSet(y.getExplicitAttributeSet(t))},L.requiresUserTransformedProperty=function(t){t=y.getExplicitAttributeSet(t);return L.isPlaceHolderAttributeSet(t)&&!L.isUserModifiedPlaceHolderAttributeSet(t)},L.getDrawingModelDescriptor=function(t,e){var i=y.getExplicitAttributeSet(t),r=S.getBooleanOption(e,"useDefaultValues",!0),e=null;return L.isPlaceHolderAttributeSet(i)&&((e={}).target=f.getTargetContainerId($(t).parent()),e.type=i.presentation.phType,e.index=i.presentation.phIndex,r&&(e.type&&!_.isNumber(e.index)&&(e.index=L.DEFAULT_PLACEHOLDER_INDEX),_.isNumber(e.index)&&!e.type&&(e.type=L.DEFAULT_PLACEHOLDER_TYPE))),e},L.getValidTypeIndexSet=function(t){return t&&t.presentation&&("phType"in t.presentation||"phIndex"in t.presentation)?{type:S.getStringOption(t.presentation,"phType",L.DEFAULT_PLACEHOLDER_TYPE),index:S.getIntegerOption(t.presentation,"phIndex",L.DEFAULT_PLACEHOLDER_INDEX)}:null},L.getPlaceHolderTemplateText=function(t,e){var i=L.getPlaceHolderDrawingType(t),e=e||!1;return(i=!i&&_.isNumber(L.getPlaceHolderDrawingIndex(t))?L.DEFAULT_PLACEHOLDER_TYPE:i)?(e?L.PLACEHOLDER_TEMPLATE_TEXTS_ODF:L.PLACEHOLDER_TEMPLATE_TEXTS)[i]:null},L.getPlaceHolderTemplateButtonsList=function(t,e){return(e?L.PLACEHOLDER_TEMPLATE_BUTTONS_ODF:L.PLACEHOLDER_TEMPLATE_BUTTONS)[t||"contentBody"]},L.getODFFooterRepresentation=function(t){t=L.PLACEHOLDER_TEMPLATE_TEXTS_ODF[t];return t?"<"+t+">":""},L.convertAppContentBoxToOperationBox=function(t,e,i){var r=t.getView().getZoomFactor(),n=t.getModel().getSlideById(t.getModel().getActiveSlideId()).offset(),o=t.getView().getContentRootNode(),l=o.offset(),a=o.scrollLeft(),t=o.scrollTop(),o={},i=!!_.isBoolean(i)&&i;return o.left=(e.left-(n.left-l.left)-a)/r,o.top=(e.top-(n.top-l.top)-t)/r,o.width=i?e.width:Math.round(e.width/r),o.height=i?e.height:Math.round(e.height/r),o.left=S.convertLengthToHmm(o.left,"px"),o.top=S.convertLengthToHmm(o.top,"px"),o.width=S.convertLengthToHmm(o.width,"px"),o.height=S.convertLengthToHmm(o.height,"px"),o.left<0&&(o.left=0),o},L.extendPlaceholderProp=function(t,e,i){var r;i&&i.attrs&&i.attrs.drawing&&(r=y.getExplicitAttributeSet(e),L.isPlaceHolderAttributeSet(r)&&(e=t.getModel().getDrawingStyles().getElementAttributes(e).drawing,_.each(e,function(t,e){e in i.attrs.drawing||!_.contains(L.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS,e)||e in r.drawing||(i.attrs.drawing[e]=t)})))},L.checkEventPosition=function(t,e,i,r){var n=!0,o=t.getModel();if(f.isTextSpan(e.target)||f.isParagraphNode(e.target))return n;if(e.target&&$(e.target.parentNode).is(".borders"))return n;if(L.isPlaceHolderDrawing(i))return n;if(O.isGroupDrawingFrame(i))return!n;if(!O.isShapeDrawingFrame(i))return n;var l=O.getCanvasNode(i);if(!l||0===l.length)return n;var a,p,d,c=r||y.getExplicitAttributes(i,"drawing"),u=o.getActiveSlide().offset(),s=0,g=0,r=0,o=c.flipH,c=c.flipV,e=L.normalizeRotationAndGrouping(t,i,e,u),u=e.rect;if(!e.point)return n;a=u.left,p=u.top,d=u.width,r=u.height,s=e.point.left,g=e.point.top,s-=a,g-=p,o&&(s=d-s),c&&(g=r-g);var T=Math.max(s-6,0),E=Math.max(g-6,0),E=l[0].getContext("2d").getImageData(T,E,12,12);return n=!_.every(E.data,function(t){return 0===t})},L.findValidDrawingNodeBehindDrawing=function(t,e,i){for(var r=0,n=!1,o=(O.isGroupedDrawingFrame(i)?O.getGroupNode(i,{farthest:!0,rootNode:t.getModel().getCurrentRootNode()}):i).prevAll(".drawing"),l=o.length,a=null;r<l&&!n;){var p=$(o[r]);r++,(a=L.checkEventPositionInDrawing(t,e.pageX,e.pageY,p))&&(n=!0)}return a},L.checkEventPositionInDrawing=function(d,c,u,t){var e,r,i,n=d.getModel().getActiveSlide().offset(),o=y.getExplicitAttributes(t,"drawing"),l=L.normalizeRotationAndGrouping(d,t,{pageX:c,pageY:u},n),a=l.rect,p=l.drawingRect,s=l.point.left,g=l.point.top,T=d.getView().getZoomFactor(),E=null,f=null,h=!1,A=null;function P(t,e,i){var r,n,o,l,a,p;O.isTextFrameShapeDrawingFrame(t)&&(E=O.getTextFrameNode(t))&&(r=E,n=i,o=e,l=Math.round(S.convertCssLength(r.css("left"),"px")),a=Math.round(S.convertCssLength(r.css("top"),"px")),p=r.width(),i=r.height(),r=o.flipH,o=o.flipV,r&&(l=n.width-p-l),o&&(a=n.height-i-a),l+=n.left,a+=n.top,i=new R(l,a,p,i),w.pointInsideRect({x:s,y:g},i,1)?(f=t,h=!0,A={rect:i,posX:s,posY:g}):E=null),h||L.checkEventPosition(d,{pageX:c,pageY:u,target:null},t,e)&&(f=t,h=!0)}return w.pointInsideRect({x:s,y:g},a,6)&&(O.isGroupDrawingFrame(t)?_.each(t.find(".drawing"),function(t){var e,i,r;O.isGroupDrawingFrame(t)||(t=$(t),e=(r=L.normalizeRotationAndGrouping(d,t,{pageX:c,pageY:u},n)).rect,i=r.drawingRect,s=r.point.left,g=r.point.top,r=y.getExplicitAttributes(t,"drawing"),w.pointInsideRect({x:s,y:g},e,6)&&P(t,r,i))}):O.isTableDrawingFrame(t)?(e=t,r=null,(i=_.find(e.find("div.cell"),function(t){var e=(t=$(t)).offset(),i=(e.left-n.left)/T,e=(e.top-n.top)/T;return r=new R(i,e,t.width(),t.height()),w.pointInsideRect({x:s,y:g},r,1)}))&&(f=e,E=i,h=!0,A={rect:r,posX:s,posY:g})):P(t,o,p)),h?{drawing:f,textFrameNode:E,info:A}:null},L.normalizeRotationAndGrouping=function(o,t,e,i){var r,n,l,a,p,d,c,u,s=o.getView().getZoomFactor(),g=O.isGroupedDrawingFrame(t),T=!!e,E=i||{left:0,top:0},f=0,h=0,A=0,P=0,L=0,m=!1,x=y.getExplicitAttributes(t,"drawing"),b=x.rotation,D=0<t.children(".canvasexpansion").length,H=null,i=null;function C(t,e){var i=0,r=0,n=O.isGroupedDrawingFrame(t);_.isNumber(e.left)&&_.isNumber(e.top)||(e=o.getModel().getDrawingStyles().getElementAttributes(t).drawing),r=n?(i=Math.round(S.convertCssLength(t.css("left"),"px")),Math.round(S.convertCssLength(t.css("top"),"px"))):(i=S.convertHmmToLength(e.left,"px",1),S.convertHmmToLength(e.top,"px",1)),i+=A,r+=P;e=t.width(),t=t.height();return new R(i,r,e,t)}return T&&(_.isNumber(e.pageX)&&_.isNumber(e.pageY)?(f=(e.pageX-E.left)/s,h=(e.pageY-E.top)/s):m=!0),g&&function(t){var e=[];for(e.push(O.getGroupNode(t));O.isGroupedDrawingFrame(_.last(e));)e.push(O.getGroupNode(_.last(e)));e=e.reverse(),_.each(e,function(t){var e=y.getExplicitAttributes(t,"drawing"),i=null;T&&_.isNumber(e.rotation)&&(i=C(t,e),L=w.rotatePointWithAngle(i.centerX(),i.centerY(),f,h,e.rotation),f=L.left,h=L.top),A+=Math.round(S.convertCssLength(t.css("left"),"px")),P+=Math.round(S.convertCssLength(t.css("top"),"px"))})}(t),i=C(t,x),T&&_.isNumber(b)&&0!==b&&(L=w.rotatePointWithAngle(i.centerX(),i.centerY(),f,h,b),f=L.left,h=L.top),D&&(r=i,n=x,l=O.getCanvasNode(t),a=l.width(),p=l.height(),d=n.flipH,c=n.flipV,n=u=0,u=d?-(a-r.width+Math.round(S.convertCssLength(l.css("left"),"px"))):Math.round(S.convertCssLength(l.css("left"),"px")),n=c?-(p-r.height+Math.round(S.convertCssLength(l.css("top"),"px"))):Math.round(S.convertCssLength(l.css("top"),"px")),H=_.copy(r),r.left+=u,r.top+=n,r.width=a,r.height=p),{rect:i,drawingRect:H||i,point:m?null:{left:f,top:h}}},L.getBackgroundTextPosition=function(r,t,e,n){var i,o,l=null,a=r.getModel().getCurrentRootNode();return(e=$(e)).parent().is(".emptytextframe")?l=p.getLastTextPositionInTextFrame(a,t):(i=e.find("div.p"),o=e.offset(),_.each(i,function(t){var e,i;l||(e=((i=$(t).offset()).left-o.left)/r.getView().getZoomFactor(),i=(i.top-o.top)/r.getView().getZoomFactor(),e=n.posX-n.rect.left-e,i=n.posY-n.rect.top-i,(i=p.getPositionInsideParagraph(a,t,e,i,100*r.getView().getZoomFactor()))&&i.pos&&(l=i.pos))})),l=l||(O.isTableDrawingFrame(t)?p.getLastTextPositionInTableCell(a,e):p.getLastTextPositionInTextFrame(a,t))},L});