define("io.ox/office/rt2/rt2protocol",["io.ox/office/rt2/jss_objectutils","io.ox/office/rt2/jss_stringutils","io.ox/office/rt2/jss_hashmap","io.ox/office/rt2/rt2messageflags"],function(h,r,S,D){"use strict";function i(){var A=null,R=null,n=null,o=null;this.encode=function(_){var e=A.get(_);if(r.isEmpty(e))throw Error('RT2Protocol-Error : no encoded value for "'+_+'"');return e},this.decode=function(_){var e=R.get(_);if(r.isEmpty(e))throw Error('RT2Protocol-Error : no decoded value for "'+_+'"');return e},this.getFlags4Type=function(_){var e=n.get(_);if(h.isNull(e))throw Error('RT2Protocol-Error : no flags value for type "'+_+'"');return e},this.getFlag4Header=function(_){if(r.startsWithIgnoreCase(_,i.HEADER_PREFIX_JMS)||r.startsWithIgnoreCase(_,i.HEADER_PREFIX_DEBUG)||r.startsWithIgnoreCase(_,i.HEADER_PREFIX_INTERNAL)||r.equalsIgnoreCase(_,"breadcrumbId"))return D.FLAG_NONE;var e=o.get(_);if(h.isNull(e))throw Error('RT2Protocol-Error : no flag value for header "'+_+'"');return e},this.init=function(){var _,e,r,E,t,a,p,d,s,u;(h.isNull(A)||h.isNull(R)||h.isNull(n)||h.isNull(o))&&((d=new S).put("ping","ping"),d.put("pong","pong"),d.put("simple_ack","ak0"),d.put("error_ack","ak1"),d.put("simple_nack","nk0"),d.put("close_doc_route_admintask","at0"),d.put("close_doc_route_admintask_completed","at1"),d.put("cleanup_for_crashed_node_admintask","at2"),d.put("cleanup_for_crashed_node_admintask_completed","at3"),d.put("join_request","rq0"),d.put("leave_request","rq1"),d.put("open_doc_request","rq2"),d.put("save_doc_request","rq3"),d.put("close_doc_request","rq4"),d.put("apply_ops_request","rq5"),d.put("app_action_request","rq6"),d.put("switch_docstate_request","rq7"),d.put("update_slide_request","rq8"),d.put("reset_request","rq9"),d.put("sync_request","rq10"),d.put("editrights_request","rq11"),d.put("unavailability_request","rq12"),d.put("abort_open_request","rq13"),d.put("emergency_leave_request","rq14"),d.put("sync_stable_request","rq15"),d.put("close_and_leave_request","rq16"),d.put("generic_error_response","rp0"),d.put("join_response","rp1"),d.put("leave_response","rp2"),d.put("open_doc_response","rp3"),d.put("open_doc_chunk_response","rp4"),d.put("save_doc_response","rp5"),d.put("close_doc_response","rp6"),d.put("apply_ops_response","rp7"),d.put("app_action_response","rp8"),d.put("switch_docstate_response","rp9"),d.put("update_slide_response","rp10"),d.put("reset_response","rp11"),d.put("sync_response","rp12"),d.put("editrights_response","rp13"),d.put("unavailability_response","rp14"),d.put("abort_open_response","rp15"),d.put("emergency_leave_response","rp16"),d.put("sync_stable_response","rp17"),d.put("close_and_leave_response","rp18"),d.put("update_broadcast","bc0"),d.put("update_clients_broadcast","bc1"),d.put("chat_message_broadcast","bc2"),d.put("editrequest_state_broadcast","bc3"),d.put("shutdown_broadcast","bc4"),d.put("crashed_broadcast","bc5"),d.put("renamed_reload_broadcast","bc6"),d.put("hangup_broadcast","bc7"),d.put("ot_reload_broadcast","bc8"),d.put("msg_id_header","h0"),d.put("seq_nr_header","h1"),d.put("client_uid_header","h2"),d.put("session_id_header","h3"),d.put("doc_uid_header","h4"),d.put("drive_doc_id_header","h5"),d.put("folder_id_header","h6"),d.put("file_id_header","h7"),d.put("doc_type_header","h8"),d.put("doc_state_header","h9"),d.put("app_action_header","h10"),d.put("useragent_header","h11"),d.put("node_uid_header","h12"),d.put("storage_version_header","h13"),d.put("storage_osn_header","h14"),d.put("old_client_uid_header","h15"),d.put("preview_header","h16"),d.put("err_class_header","h17"),d.put("err_code_header","h18"),d.put("err_name_header","h19"),d.put("err_desc_header","h20"),d.put("err_value_header","h21"),d.put("fast_empty_header","h22"),d.put("fast_empty_osn_header","h23"),d.put("active_slide_header","h24"),d.put("auth_code_header","h25"),d.put("new_doc_header","h26"),d.put("auto_close_header","h27"),d.put("no_restore_header","h28"),d.put("unavail_time_header","h29"),d.put("ack_start_header","h30"),d.put("ack_end_header","h31"),d.put("nack_start_header","h32"),d.put("nack_end_header","h33"),d.put("admin_id_header","h34"),d.put("admin_hz_member_uuid_header","h35"),d.put("admin_hz_master_uuid_header","h36"),d.put("cause_header","h37"),d.put("origin_hostname_header","h38"),d.put("advisory_lock_header","h39"),d.put("internal_chunk_header","hi0"),d.put("internal_doctype_header","hi1"),d.put("internal_recipients_header","hi2"),d.put("internal_client_ep_id_header","hi3"),d.put("internal_client_ep_uri_header","hi4"),d.put("internal_time_queued_header","hi5"),d.put("internal_force_header","hi6"),d.put("internal_referrer_header","hi7"),d.put("internal_is_response_header","hi8"),d.put("internal_is_broadcast_header","hi9"),d.put("dbg_seqnum_header","hd0"),d.put("dbg_disable_session_validation_header","hd1"),d.put("dbg_perf_client_in_header","hd2"),d.put("dbg_perf_client_out_header","hd3"),d.put("dbg_perf_server_in_header","hd4"),d.put("dbg_perf_server_out_header","hd5"),d.put("dbg_perf_server_load_start_header","hd6"),d.put("dbg_perf_server_load_end_header","hd7"),d.put("dbg_perf_server_applyops_start_header","hd8"),d.put("dbg_perf_server_applyops_end_header","hd9"),d.put("dbg_perf_server_save_start_header","hd10"),d.put("dbg_perf_server_save_end_header","hd11"),d.put("dbg_perf_server_recentlist_start_header","hd12"),d.put("dbg_perf_server_recentlist_end_header","hd13"),d.put("dbg_perf_server_sequencer_start_header","hd14"),d.put("dbg_perf_server_sequencer_end_header","hd15"),d.put("dbg_perf_server_route_doc_in_header","hd16"),d.put("dbg_perf_server_route_doc_out_header","hd17"),d.put("dbg_stat_node_id_header","hd18"),A=d,(s=new S).put("ping","ping"),s.put("pong","pong"),s.put("ak0","simple_ack"),s.put("ak1","error_ack"),s.put("nk0","simple_nack"),s.put("at0","close_doc_route_admintask"),s.put("at1","close_doc_route_admintask_completed"),s.put("at2","cleanup_for_crashed_node_admintask"),s.put("at3","cleanup_for_crashed_node_admintask_completed"),s.put("rq0","join_request"),s.put("rq1","leave_request"),s.put("rq2","open_doc_request"),s.put("rq3","save_doc_request"),s.put("rq4","close_doc_request"),s.put("rq5","apply_ops_request"),s.put("rq6","app_action_request"),s.put("rq7","switch_docstate_request"),s.put("rq8","update_slide_request"),s.put("rq9","reset_request"),s.put("rq10","sync_request"),s.put("rq11","editrights_request"),s.put("rq12","unavailability_request"),s.put("rq13","abort_open_request"),s.put("rq14","emergency_leave_request"),s.put("rq15","sync_stable_request"),s.put("rq16","close_and_leave_request"),s.put("rp0","generic_error_response"),s.put("rp1","join_response"),s.put("rp2","leave_response"),s.put("rp3","open_doc_response"),s.put("rp4","open_doc_chunk_response"),s.put("rp5","save_doc_response"),s.put("rp6","close_doc_response"),s.put("rp7","apply_ops_response"),s.put("rp8","app_action_response"),s.put("rp9","switch_docstate_response"),s.put("rp10","update_slide_response"),s.put("rp11","reset_response"),s.put("rp12","sync_response"),s.put("rp13","editrights_response"),s.put("rp14","unavailability_response"),s.put("rp15","abort_open_response"),s.put("rp16","emergency_leave_response"),s.put("rp17","sync_stable_response"),s.put("rp18","close_and_leave_response"),s.put("bc0","update_broadcast"),s.put("bc1","update_clients_broadcast"),s.put("bc2","chat_message_broadcast"),s.put("bc3","editrequest_state_broadcast"),s.put("bc4","shutdown_broadcast"),s.put("bc5","crashed_broadcast"),s.put("bc6","renamed_reload_broadcast"),s.put("bc7","hangup_broadcast"),s.put("bc8","ot_reload_broadcast"),s.put("h0","msg_id_header"),s.put("h1","seq_nr_header"),s.put("h2","client_uid_header"),s.put("h3","session_id_header"),s.put("h4","doc_uid_header"),s.put("h5","drive_doc_id_header"),s.put("h6","folder_id_header"),s.put("h7","file_id_header"),s.put("h8","doc_type_header"),s.put("h9","doc_state_header"),s.put("h10","app_action_header"),s.put("h11","useragent_header"),s.put("h12","node_uid_header"),s.put("h13","storage_version_header"),s.put("h14","storage_osn_header"),s.put("h15","old_client_uid_header"),s.put("h16","preview_header"),s.put("h17","err_class_header"),s.put("h18","err_code_header"),s.put("h19","err_name_header"),s.put("h20","err_desc_header"),s.put("h21","err_value_header"),s.put("h22","fast_empty_header"),s.put("h23","fast_empty_osn_header"),s.put("h24","active_slide_header"),s.put("h25","auth_code_header"),s.put("h26","new_doc_header"),s.put("h27","auto_close_header"),s.put("h28","no_restore_header"),s.put("h29","unavail_time_header"),s.put("h30","ack_start_header"),s.put("h31","ack_end_header"),s.put("h32","nack_start_header"),s.put("h33","nack_end_header"),s.put("h34","admin_id_header"),s.put("h35","admin_hz_member_uuid_header"),s.put("h36","admin_hz_master_uuid_header"),s.put("h37","cause_header"),s.put("h38","origin_hostname_header"),s.put("h39","advisory_lock_header"),s.put("hi0","internal_chunk_header"),s.put("hi1","internal_doctype_header"),s.put("hi2","internal_recipients_header"),s.put("hi3","internal_client_ep_id_header"),s.put("hi4","internal_client_ep_uri_header"),s.put("hi5","internal_time_queued_header"),s.put("hi6","internal_force_header"),s.put("hi7","internal_referrer_header"),s.put("hi8","internal_is_response_header"),s.put("hi9","internal_is_broadcast_header"),s.put("hd0","dbg_seqnum_header"),s.put("hd1","dbg_disable_session_validation_header"),s.put("hd2","dbg_perf_client_in_header"),s.put("hd3","dbg_perf_client_out_header"),s.put("hd4","dbg_perf_server_in_header"),s.put("hd5","dbg_perf_server_out_header"),s.put("hd6","dbg_perf_server_load_start_header"),s.put("hd7","dbg_perf_server_load_end_header"),s.put("hd8","dbg_perf_server_applyops_start_header"),s.put("hd9","dbg_perf_server_applyops_end_header"),s.put("hd10","dbg_perf_server_save_start_header"),s.put("hd11","dbg_perf_server_save_end_header"),s.put("hd12","dbg_perf_server_recentlist_start_header"),s.put("hd13","dbg_perf_server_recentlist_end_header"),s.put("hd14","dbg_perf_server_sequencer_start_header"),s.put("hd15","dbg_perf_server_sequencer_end_header"),s.put("hd16","dbg_perf_server_route_doc_in_header"),s.put("hd17","dbg_perf_server_route_doc_out_header"),s.put("hd18","dbg_stat_node_id_header"),R=s,u=new S,_=D.FLAG_SESSION_BASED|D.FLAG_DOC_BASED,e=D.FLAG_SESSION_BASED|D.FLAG_SEQUENCE_NR_BASED|D.FLAG_DOC_BASED,r=D.FLAG_DOC_BASED,E=D.FLAG_SESSION_BASED|D.FLAG_DOC_BASED,t=D.FLAG_SESSION_BASED|D.FLAG_SEQUENCE_NR_BASED|D.FLAG_DOC_BASED,a=D.FLAG_SESSION_BASED|D.FLAG_DOC_BASED,p=D.FLAG_ALL,d=D.FLAG_NONE,s=D.FLAG_DOC_BASED,u.put(i.PING,d),u.put(i.PONG,d),u.put(i.ACK_SIMPLE,a),u.put(i.ACK_ERROR,a),u.put(i.NACK_SIMPLE,a),u.put(i.ADMIN_TASK_CLOSE_DOC_ROUTE,e),u.put(i.ADMIN_TASK_COMPLETED_CLOSE_DOC_ROUTE,e),u.put(i.ADMIN_TASK_CLEANUP_FOR_CRASHED_NODE,d),u.put(i.ADMIN_TASK_COMPLETED_CLEANUP_FOR_CRASHED_NODE,d),u.put(i.REQUEST_JOIN,_),u.put(i.REQUEST_LEAVE,_),u.put(i.REQUEST_OPEN_DOC,e),u.put(i.REQUEST_SAVE_DOC,e),u.put(i.REQUEST_CLOSE_DOC,e),u.put(i.REQUEST_APPLY_OPS,e),u.put(i.REQUEST_APP_ACTION,e),u.put(i.REQUEST_SWITCH_DOCSTATE,r),u.put(i.REQUEST_UPDATE_SLIDE,e),u.put(i.REQUEST_RESET,E),u.put(i.REQUEST_SYNC,E),u.put(i.REQUEST_SYNC_STABLE,t),u.put(i.REQUEST_EDITRIGHTS,e),u.put(i.REQUEST_UNAVAILABILITY,r),u.put(i.REQUEST_ABORT_OPEN,E),u.put(i.REQUEST_EMERGENCY_LEAVE,_),u.put(i.REQUEST_CLOSE_AND_LEAVE,r),u.put(i.RESPONSE_GENERIC_ERROR,p),u.put(i.RESPONSE_JOIN,_),u.put(i.RESPONSE_LEAVE,_),u.put(i.RESPONSE_OPEN_DOC,e),u.put(i.RESPONSE_OPEN_DOC_CHUNK,e),u.put(i.RESPONSE_SAVE_DOC,e),u.put(i.RESPONSE_CLOSE_DOC,e),u.put(i.RESPONSE_APPLY_OPS,e),u.put(i.RESPONSE_APP_ACTION,e),u.put(i.RESPONSE_SWITCH_DOCSTATE,r),u.put(i.RESPONSE_UPDATE_SLIDE,e),u.put(i.RESPONSE_RESET,E),u.put(i.RESPONSE_SYNC,t),u.put(i.RESPONSE_SYNC_STABLE,t),u.put(i.RESPONSE_EDITRIGHTS,e),u.put(i.RESPONSE_UNAVAILABILITY,r),u.put(i.RESPONSE_ABORT_OPEN,E),u.put(i.RESPONSE_EMERGENCY_LEAVE,_),u.put(i.RESPONSE_CLOSE_AND_LEAVE,r),u.put(i.BROADCAST_UPDATE,e),u.put(i.BROADCAST_UPDATE_CLIENTS,e),u.put(i.BROADCAST_CHAT_MESSAGE,d),u.put(i.BROADCAST_SHUTDOWN,E),u.put(i.BROADCAST_CRASHED,E),u.put(i.BROADCAST_RENAMED_RELOAD,e),u.put(i.BROADCAST_HANGUP,s),u.put(i.BROADCAST_OT_RELOAD,s),n=u,(u=new S).put(i.HEADER_MSG_ID,D.FLAG_NONE),u.put(i.HEADER_SEQ_NR,D.FLAG_SEQUENCE_NR_BASED),u.put(i.HEADER_CLIENT_UID,D.FLAG_NONE),u.put(i.HEADER_SESSION_ID,D.FLAG_SESSION_BASED),u.put(i.HEADER_DOC_UID,D.FLAG_DOC_BASED),u.put(i.HEADER_DRIVE_DOC_ID,D.FLAG_DOC_BASED),u.put(i.HEADER_FOLDER_ID,D.FLAG_DOC_BASED),u.put(i.HEADER_FILE_ID,D.FLAG_DOC_BASED),u.put(i.HEADER_DOC_TYPE,D.FLAG_DOC_BASED),u.put(i.HEADER_DOC_STATE,D.FLAG_DOC_BASED),u.put(i.HEADER_APP_ACTION,D.FLAG_DOC_BASED),u.put(i.HEADER_OLD_CLIENT_UID,D.FLAG_DOC_BASED),u.put(i.HEADER_USERAGENT,D.FLAG_NONE),u.put(i.HEADER_UNAVAIL_TIME,D.FLAG_DOC_BASED),u.put(i.HEADER_NODE_UID,D.FLAG_NONE),u.put(i.HEADER_AUTO_CLOSE,D.FLAG_NONE),u.put(i.HEADER_NO_RESTORE,D.FLAG_DOC_BASED),u.put(i.HEADER_PREVIEW,D.FLAG_NONE),u.put(i.HEADER_ERROR_CLASS,D.FLAG_NONE),u.put(i.HEADER_ERROR_CODE,D.FLAG_NONE),u.put(i.HEADER_ERROR_NAME,D.FLAG_NONE),u.put(i.HEADER_ERROR_DESCRIPTION,D.FLAG_NONE),u.put(i.HEADER_ERROR_VALUE,D.FLAG_NONE),u.put(i.HEADER_FAST_EMPTY,D.FLAG_NONE),u.put(i.HEADER_FAST_EMPTY_OSN,D.FLAG_NONE),u.put(i.HEADER_ACTIVE_SLIDE,D.FLAG_NONE),u.put(i.HEADER_AUTH_CODE,D.FLAG_NONE),u.put(i.HEADER_NEW_DOC,D.FLAG_NONE),u.put(i.HEADER_STORAGE_VERSION,D.FLAG_NONE),u.put(i.HEADER_STORAGE_OSN,D.FLAG_NONE),u.put(i.HEADER_ACK_START,D.FLAG_SIMPLE_MSG),u.put(i.HEADER_ACK_END,D.FLAG_SIMPLE_MSG),u.put(i.HEADER_NACK_START,D.FLAG_SIMPLE_MSG),u.put(i.HEADER_NACK_END,D.FLAG_SIMPLE_MSG),u.put(i.HEADER_ADMIN_ID,D.FLAG_NONE),u.put(i.HEADER_ADMIN_HZ_MEMBER_UUID,D.FLAG_NONE),u.put(i.HEADER_ADMIN_HZ_MASTER_UUID,D.FLAG_NONE),u.put(i.HEADER_CAUSE,D.FLAG_NONE),u.put(i.HEADER_ORIGIN_HOSTNAME,D.FLAG_NONE),u.put(i.HEADER_ADVISORY_LOCK,D.FLAG_DOC_BASED),o=u)}}i.HEADER_PREFIX_JMS="JMS",i.HEADER_PREFIX_INTERNAL="internal",i.HEADER_PREFIX_DEBUG="dbg",i.HEADER_PREFIX_DEBUG_STATISTIC="dbg_stat",i.HEADER_PREFIX_DEBUG_PERFORMANCE="dbg_perf",i.PING="ping",i.PONG="pong",i.ACK_SIMPLE="simple_ack",i.ACK_ERROR="error_ack",i.NACK_SIMPLE="simple_nack",i.ADMIN_TASK_CLOSE_DOC_ROUTE="close_doc_route_admintask",i.ADMIN_TASK_COMPLETED_CLOSE_DOC_ROUTE="close_doc_route_admintask_completed",i.ADMIN_TASK_CLEANUP_FOR_CRASHED_NODE="cleanup_for_crashed_node_admintask",i.ADMIN_TASK_COMPLETED_CLEANUP_FOR_CRASHED_NODE="cleanup_for_crashed_node_admintask_completed",i.REQUEST_JOIN="join_request",i.REQUEST_LEAVE="leave_request",i.REQUEST_OPEN_DOC="open_doc_request",i.REQUEST_SAVE_DOC="save_doc_request",i.REQUEST_CLOSE_DOC="close_doc_request",i.REQUEST_APPLY_OPS="apply_ops_request",i.REQUEST_APP_ACTION="app_action_request",i.REQUEST_SWITCH_DOCSTATE="switch_docstate_request",i.REQUEST_UPDATE_SLIDE="update_slide_request",i.REQUEST_RESET="reset_request",i.REQUEST_SYNC="sync_request",i.REQUEST_SYNC_STABLE="sync_stable_request",i.REQUEST_EDITRIGHTS="editrights_request",i.REQUEST_UNAVAILABILITY="unavailability_request",i.REQUEST_ABORT_OPEN="abort_open_request",i.REQUEST_EMERGENCY_LEAVE="emergency_leave_request",i.REQUEST_CLOSE_AND_LEAVE="close_and_leave_request",i.RESPONSE_GENERIC_ERROR="generic_error_response",i.RESPONSE_JOIN="join_response",i.RESPONSE_LEAVE="leave_response",i.RESPONSE_OPEN_DOC="open_doc_response",i.RESPONSE_OPEN_DOC_CHUNK="open_doc_chunk_response",i.RESPONSE_SAVE_DOC="save_doc_response",i.RESPONSE_CLOSE_DOC="close_doc_response",i.RESPONSE_APPLY_OPS="apply_ops_response",i.RESPONSE_APP_ACTION="app_action_response",i.RESPONSE_SWITCH_DOCSTATE="switch_docstate_response",i.RESPONSE_UPDATE_SLIDE="update_slide_response",i.RESPONSE_RESET="reset_response",i.RESPONSE_SYNC="sync_response",i.RESPONSE_SYNC_STABLE="sync_stable_response",i.RESPONSE_EDITRIGHTS="editrights_response",i.RESPONSE_UNAVAILABILITY="unavailability_response",i.RESPONSE_ABORT_OPEN="abort_open_response",i.RESPONSE_EMERGENCY_LEAVE="emergency_leave_response",i.RESPONSE_CLOSE_AND_LEAVE="close_and_leave_response",i.BROADCAST_UPDATE="update_broadcast",i.BROADCAST_UPDATE_CLIENTS="update_clients_broadcast",i.BROADCAST_CHAT_MESSAGE="chat_message_broadcast",i.BROADCAST_EDITREQUEST_STATE="editrequest_state_broadcast",i.BROADCAST_SHUTDOWN="shutdown_broadcast",i.BROADCAST_CRASHED="crashed_broadcast",i.BROADCAST_RENAMED_RELOAD="renamed_reload_broadcast",i.BROADCAST_HANGUP="hangup_broadcast",i.BROADCAST_OT_RELOAD="ot_reload_broadcast",i.HEADER_MSG_ID="msg_id_header",i.HEADER_SEQ_NR="seq_nr_header",i.HEADER_CLIENT_UID="client_uid_header",i.HEADER_SESSION_ID="session_id_header",i.HEADER_DOC_UID="doc_uid_header",i.HEADER_DRIVE_DOC_ID="drive_doc_id_header",i.HEADER_FOLDER_ID="folder_id_header",i.HEADER_FILE_ID="file_id_header",i.HEADER_DOC_TYPE="doc_type_header",i.HEADER_DOC_STATE="doc_state_header",i.HEADER_APP_ACTION="app_action_header",i.HEADER_USERAGENT="useragent_header",i.HEADER_NODE_UID="node_uid_header",i.HEADER_STORAGE_VERSION="storage_version_header",i.HEADER_STORAGE_OSN="storage_osn_header",i.HEADER_OLD_CLIENT_UID="old_client_uid_header",i.HEADER_PREVIEW="preview_header",i.HEADER_ERROR_CLASS="err_class_header",i.HEADER_ERROR_CODE="err_code_header",i.HEADER_ERROR_NAME="err_name_header",i.HEADER_ERROR_DESCRIPTION="err_desc_header",i.HEADER_ERROR_VALUE="err_value_header",i.HEADER_FAST_EMPTY="fast_empty_header",i.HEADER_FAST_EMPTY_OSN="fast_empty_osn_header",i.HEADER_ACTIVE_SLIDE="active_slide_header",i.HEADER_AUTH_CODE="auth_code_header",i.HEADER_NEW_DOC="new_doc_header",i.HEADER_AUTO_CLOSE="auto_close_header",i.HEADER_NO_RESTORE="no_restore_header",i.HEADER_UNAVAIL_TIME="unavail_time_header",i.HEADER_ACK_START="ack_start_header",i.HEADER_ACK_END="ack_end_header",i.HEADER_NACK_START="nack_start_header",i.HEADER_NACK_END="nack_end_header",i.HEADER_ADMIN_ID="admin_id_header",i.HEADER_ADMIN_HZ_MEMBER_UUID="admin_hz_member_uuid_header",i.HEADER_ADMIN_HZ_MASTER_UUID="admin_hz_master_uuid_header",i.HEADER_CAUSE="cause_header",i.HEADER_ORIGIN_HOSTNAME="origin_hostname_header",i.HEADER_ADVISORY_LOCK="advisory_lock_header",i.HEADER_INTERNAL_CHUNK_ID="internal_chunk_header",i.HEADER_INTERNAL_DOCTYPE="internal_doctype_header",i.HEADER_INTERNAL_RECIPIENTS="internal_recipients_header",i.HEADER_INTERNAL_CLIENT_ENDPOINT_ID="internal_client_ep_id_header",i.HEADER_INTERNAL_CLIENT_ENDPOINT_URI="internal_client_ep_uri_header",i.HEADER_INTERNAL_TIME_QUEUED="internal_time_queued_header",i.HEADER_INTERNAL_FORCE="internal_force_header",i.HEADER_INTERNAL_REFERRER="internal_referrer_header",i.HEADER_INTERNAL_IS_RESPONSE="internal_is_response_header",i.HEADER_INTERNAL_IS_BROADCAST="internal_is_broadcast_header",i.HEADER_DEBUG_SEQNUM="dbg_seqnum_header",i.HEADER_DEBUG_DISABLE_SESSION_VALIDATION="dbg_disable_session_validation_header",i.HEADER_DEBUG_PERFORMANCE_CLIENT_IN="dbg_perf_client_in_header",i.HEADER_DEBUG_PERFORMANCE_CLIENT_OUT="dbg_perf_client_out_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_IN="dbg_perf_server_in_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_OUT="dbg_perf_server_out_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_LOAD_START="dbg_perf_server_load_start_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_LOAD_END="dbg_perf_server_load_end_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_APPLYOPS_START="dbg_perf_server_applyops_start_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_APPLYOPS_END="dbg_perf_server_applyops_end_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_SAVE_START="dbg_perf_server_save_start_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_SAVE_END="dbg_perf_server_save_end_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_RECENTLIST_START="dbg_perf_server_recentlist_start_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_RECENTLIST_END="dbg_perf_server_recentlist_end_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_SEQUENCER_START="dbg_perf_server_sequencer_start_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_SEQUENCER_END="dbg_perf_server_sequencer_end_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_ROUTE_DOC_IN="dbg_perf_server_route_doc_in_header",i.HEADER_DEBUG_PERFORMANCE_SERVER_ROUTE_DOC_OUT="dbg_perf_server_route_doc_out_header",i.HEADER_DEBUG_STATISTIC_NODEID="dbg_stat_node_id_header",i.BODYPART_ACKS="ACKS",i.BODYPART_NACKS="NACKS";var e=null;return i.get=function(){var _;return h.isNull(e)&&((_=new i).init(),e=_),e},i});