define("io.ox/office/spreadsheet/controller/chartmixin",["io.ox/office/tk/dom","io.ox/office/tk/utils/logger","io.ox/office/drawinglayer/view/drawinglabels","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/view/chartcreator","gettext!io.ox/office/spreadsheet/main"],function(e,t,f,p,b,w){"use strict";var x=e.TOUCH_DEVICE,v=t.globalLogger;return function(i){var u=i.docApp,s=i.docModel;function a(e){switch(e){case"sheets":i.yell({type:"warning",message:w("Data references are located on different sheets.")});break;case"directions":i.yell({type:"warning",message:w("Data references are too complex for this operation.")});break;default:v.warn('$badge{ChartMixin} yellChartDirection: unknown warning type: "'+e+'"')}return $.Deferred().reject()}function o(){var e=i.getSelectedDrawings();return 1===e.length?e[0]:void 0}function l(e){var t=o();return t&&i.getSheetModel().drawingCollection.getModel(t,{type:e})}function c(u,s,l){return i.getSheetModel().createAndApplyOperations(function(e){var t=o(),r={};switch(s){case p.CHANGE_CHART_LEGEND:var n=u.getLegendModel(l.axis);r.attrs=n.getUndoAttributeSet(l.attrs);break;case p.CHANGE_CHART_TITLE:var a=_.isNumber(l.axis)?l.axis:null,n=u.getTitleModel(a);null!==a&&(r.axis=a),r.attrs=n.getUndoAttributeSet(l.attrs);break;case p.CHANGE_CHART_AXIS:var i=u.getAxisModel(l.axis);(r={axis:l.axis,axPos:l.axPos,crossAx:l.crossAx}).attrs=i.getUndoAttributeSet(l.attrs);break;case p.CHANGE_CHART_GRID:i=u.getAxisModel(l.axis).getGrid();r.axis=l.axis,r.attrs=i.getUndoAttributeSet(l.attrs);break;case p.CHANGE_DRAWING:r.attrs=u.getUndoAttributeSet(l.attrs);break;default:return void v.error('$badge{ChartMixin} generateChartOperation: unknown operation "'+s+'"')}e.generateDrawingOperation(s,t,r,{undo:!0}),e.generateDrawingOperation(s,t,l)},{storeSelection:!0})}function g(e){return e&&_.isArray(e.text.link)?(e.text.link[0]||"").trim():""}function d(e,t,r){r={attrs:r};return _.isNumber(t)&&(r.axis=t),c(e,p.CHANGE_CHART_TITLE,r)}function h(e,t,r){return d(e,t,{text:{link:[r]},character:b.getHeadChar(s)})}function t(e,t){if(!e)return!1;var r=e.getDataSourceInfo();return!r.warn&&(1===(t=r.axis?Math.abs(t-1):t)?function(e){if(e.isTitleLabel())return!0;var t=1;e.isAreaOrLine()&&(t=2);return e.getFirstPointsCount()>t}(e):e.isNamesLabel()||1<e.getSeriesCount())}function r(e,t){if(!e)return!1;var r=e.getDataSourceInfo();return!r.warn&&(1===(t=r.axis?Math.abs(t-1):t)?e.isTitleLabel():e.isNamesLabel())}function n(e,t,r){if(!e)return null;var n,a=e.getDataSourceInfo();return a.warn?null:(r=1===(t=a.axis?Math.abs(t-1):t)?(n=e.isNamesLabel(),r):(n=r,e.isTitleLabel()),b.updateSeries({app:u,sourceRange:a.range,sourceSheet:a.sheet,chartModel:e,axis:a.axis,forceTitle:r,forceNames:n}))}this.registerItemsOnSuccess({"chart/insert":{parent:"drawing/insert/enable",enable:function(){var e=i.getSelectedRanges();return 1===e.length&&!i.getSheetModel().isSingleCellInRange(e[0])},set:function(e){return b.createChart(u,f.CHART_TYPE_STYLES[e])}},"drawing/chart":{parent:"drawing/operation",enable:function(){return _.isObject(this.value)},get:function(){return l("chart")||null}},"drawing/chart/valid":{parent:"drawing/chart",enable:function(e){return e.isRestorable()}},"drawing/chartlabels":{parent:"drawing/chart/valid",get:function(){return i.chartLabelsMenu.isVisible()},set:function(e){i.chartLabelsMenu.toggle(e)}},"drawing/chartexchange":{parent:"drawing/chart/valid",enable:function(e){var t=0;return e.isAreaOrLine()&&(t=1),e.getSeriesCount()>t},set:function(){return function(e){var t=e.getDataSourceInfo();if(t.warn)return a(t.warn);var r=e.isNamesLabel(),n=e.isTitleLabel();return b.updateSeries({app:u,sourceRange:t.range,sourceSheet:t.sheet,chartModel:e,axis:1-t.axis,forceTitle:r,forceNames:n,switchRowColumn:!0})}(this.parentValue)}},"drawing/chartfirstcol":{parent:"drawing/chart/valid",enable:function(e){return t(e,0)},get:function(e){return r(e,0)},set:function(e){return n(this.parentValue,0,e)}},"drawing/chartfirstrow":{parent:"drawing/chart/valid",enable:function(e){return t(e,1)},get:function(e){return r(e,1)},set:function(e){return n(this.parentValue,1,e)}},"drawing/charttype":{parent:"drawing/chart/valid",get:function(e){return e?e.getChartTypeForGui():null},set:function(e){var t,r=l("chart"),n=f.CHART_TYPE_STYLES[e];return(e=r.getDataSourceInfo()).warn?a(e.warn):(r.isXYType()&&(t=r.isNamesLabel()),b.updateSeries({app:u,sourceRange:e.range,sourceSheet:e.sheet,chartModel:r,axis:e.axis,chartData:n,forceNames:t}))}},"drawing/chart/attributes":{parent:"drawing/chart/valid",get:function(e){return e?e.getMergedAttributeSet(!0):null}},"drawing/chartvarycolor":{parent:["drawing/chart/valid","drawing/chart/attributes"],enable:function(e){return e.isVaryColorEnabled()},get:function(e){return e?e.isVaryColor():null},set:function(e){return this.parentValue.changeVaryColors(e)}},"drawing/chartdatalabel":{parent:"drawing/chart/valid",get:function(e){return e?!_.isEmpty(e.getDataLabel()):null},set:function(e){return this.parentValue.setDataLabel(e)}},"drawing/chartcolorset":{parent:"drawing/chart/valid",get:function(e){return e?e.getColorSet():null},set:function(e){return this.parentValue.changeColorSet(e)}},"drawing/chartstyleset":{parent:"drawing/chart/valid",get:function(e){return e?e.getStyleSet():null},set:function(e){return this.parentValue.changeStyleSet(e)}},"drawing/chartdatasource":{parent:"drawing/chart/valid"},"drawing/chartsource":{parent:"drawing/chart/valid",get:function(){return!1},set:function(){i.enterCustomSelectionMode("chartsource",{statusLabel:w("Select source data")}).done(function(e){var t,r=e.ranges[0],n=i.getActiveSheet(),a=l("chart"),e=a.getDataSourceInfo();return e.warn?b.updateSeries({app:u,sourceRange:r,sourceSheet:n,chartModel:a}):(a.isXYType()&&(t=a.isNamesLabel()),b.updateSeries({app:u,sourceRange:r,sourceSheet:n,chartModel:a,axis:e.axis,forceNames:t}))})},enable:function(){return!x}},"drawing/chartlegend/pos":{parent:"drawing/chart/valid",get:function(e){return e?e.getLegendModel().getMergedAttributeSet(!0).legend.pos:null},set:function(e){return c(this.parentValue,p.CHANGE_CHART_LEGEND,{attrs:{legend:{pos:e}}})}},"drawing/chart/axes/enabled":{parent:"drawing/chart/valid",enable:function(e){return e.isAxesEnabled()}},"drawing/chart/title/model":{parent:"drawing/chart/valid",get:function(e){return e?e.getTitleModel(null):null}},"drawing/chart/title/attributes":{parent:["drawing/chart/title/model","drawing/chart/valid"],get:function(e){return e?e.getMergedAttributeSet(!0):null},set:function(e){return d(this.getParentValue(1),null,e)}},"drawing/chart/title/text":{parent:["drawing/chart/title/attributes","drawing/chart/valid"],get:g,set:function(e){return h(this.getParentValue(1),null,e)}},"drawing/chart/title/delete":{parent:["drawing/chart/title/text","drawing/chart/valid"],enable:function(){return 0<this.value.length},set:function(){return h(this.getParentValue(1),null,"")}}}),["x","y"].forEach(function(n){var e="drawing/chart/axis/"+n+"/",t={};function r(e){return e?e.getAxisIdForType(n):null}function a(e){return{line:e?b.getStandardShape(s):b.getNoneShape()}}function i(e,t){var r,r=(r=e)?r.getAxisForType(n):null;return c(e,p.CHANGE_CHART_AXIS,{axis:r.axisId,axPos:r.axPos,crossAx:r.crossAx,attrs:t})}function u(e,t){return c(e,p.CHANGE_CHART_GRID,{axis:r(e),attrs:t})}t[e+"model"]={parent:["drawing/chart/valid","drawing/chart/axes/enabled"],get:function(e){return e?e.getAxisModel(r(e)):null}},t[e+"attributes"]={parent:[e+"model","drawing/chart/valid"],get:function(e){return e?e.getMergedAttributeSet(!0):null},set:function(e){return i(this.getParentValue(1),e)}},t[e+"labels/visible"]={parent:[e+"attributes","drawing/chart/valid"],get:function(e){return this.parentsEnabled&&_.isObject(e)&&!0===e.axis.label},set:function(e){return i(this.getParentValue(1),{axis:{label:e}})}},t[e+"line/visible"]={parent:[e+"attributes","drawing/chart/valid"],get:function(e){return _.isObject(e)&&"none"!==e.line.type},set:function(e){return i(this.getParentValue(1),a(e))}},t[e+"grid/model"]={parent:e+"model",get:function(e){return e?e.getGrid():null}},t[e+"grid/attributes"]={parent:[e+"grid/model","drawing/chart/valid"],get:function(e){return e?e.getMergedAttributeSet(!0):null},set:function(e){return u(this.getParentValue(1),e)}},t[e+"grid/visible"]={parent:[e+"grid/attributes","drawing/chart/valid"],get:function(e){return _.isObject(e)&&"none"!==e.line.type},set:function(e){return u(this.getParentValue(1),a(e))}},t[e+"title/model"]={parent:e+"model",get:function(e){return e?e.getTitle():null}},t[e+"title/attributes"]={parent:[e+"title/model","drawing/chart/valid"],get:function(e){return e?e.getMergedAttributeSet(!0):null},set:function(e){var t=this.getParentValue(1);return d(t,r(t),e)}},t[e+"title/text"]={parent:[e+"title/attributes","drawing/chart/valid"],get:g,set:function(e){var t=this.getParentValue(1);return h(t,r(t),e)}},t[e+"title/delete"]={parent:[e+"title/text","drawing/chart/valid"],enable:function(){return 0<this.value.length},set:function(){var e=this.getParentValue(1);return h(e,r(e),"")}},this.registerItemsOnSuccess(t)},this)}});