define("io.ox/office/spreadsheet/model/addressfactory",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/intervalarray","io.ox/office/spreadsheet/utils/addressarray","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/utils/cellanchor"],function(t,e,r,o,n,a,s,i,p,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AddressFactory=void 0;var d=Math.min,f=Math.max,g=(Object.defineProperty(c.prototype,"colCount",{get:function(){return this._maxCol+1},enumerable:!1,configurable:!0}),Object.defineProperty(c.prototype,"rowCount",{get:function(){return this._maxRow+1},enumerable:!1,configurable:!0}),Object.defineProperty(c.prototype,"maxCol",{get:function(){return this._maxCol},enumerable:!1,configurable:!0}),Object.defineProperty(c.prototype,"maxRow",{get:function(){return this._maxRow},enumerable:!1,configurable:!0}),c.prototype.getMaxIndex=function(t){return t?this._maxCol:this._maxRow},c.prototype.getSize=function(t){return(t?this._maxCol:this._maxRow)+1},c.prototype.updateSheetSize=function(t,e){this._maxCol=t-1,this._maxRow=e-1},c.prototype.parseInterval=function(t,e){t=n.Interval.parseAs(t,e);return t&&t.last<=this.getMaxIndex(e)?t:void 0},c.prototype.parseIntervalList=function(t,e){var r=this,t=i.IntervalArray.map(o.splitTokens(t),function(t){return r.parseInterval(t,e)});return t.empty()?void 0:t},c.prototype.isValidInterval=function(t,e){return 0<=t.first&&t.first<=t.last&&t.last<=this.getMaxIndex(e)},c.prototype.getEndInterval=function(t,e){return new n.Interval(t,this.getMaxIndex(e))},c.prototype.getFullInterval=function(t){return new n.Interval(0,this.getMaxIndex(t))},c.prototype.parseAddress=function(t){t=a.Address.parse(t);return t&&t[0]<=this._maxCol&&t[1]<=this._maxRow?t:void 0},c.prototype.parseAddressList=function(t){var e=this,t=p.AddressArray.map(o.splitTokens(t),function(t){return e.parseAddress(t)});return t.empty()?void 0:t},c.prototype.isValidAddress=function(t){return 0<=t[0]&&t[0]<=this._maxCol&&0<=t[1]&&t[1]<=this._maxRow},c.prototype.getClampedAddress=function(t){return new a.Address(o.clamp(t[0],0,this._maxCol),o.clamp(t[1],0,this._maxRow))},c.prototype.parseRange=function(t){t=s.Range.parse(t);return t&&t.end[0]<=this._maxCol&&t.end[1]<=this._maxRow?t:void 0},c.prototype.parseRangeList=function(t){var e=this,t=u.RangeArray.map(o.splitTokens(t),function(t){return e.parseRange(t)});return t.empty()?void 0:t},c.prototype.isValidRange=function(t){return 0<=t.start[0]&&t.start[0]<=t.end[0]&&t.end[0]<=this._maxCol&&0<=t.start[1]&&t.start[1]<=t.end[1]&&t.end[1]<=this._maxRow},c.prototype.isSheetRange=function(t){return this.isColRange(t)&&this.isRowRange(t)},c.prototype.getSheetRange=function(){return s.Range.fromIndexes(0,0,this._maxCol,this._maxRow)},c.prototype.isColRange=function(t){return 0===t.start[1]&&t.end[1]===this._maxRow},c.prototype.getColRange=function(t){return r.isNumber(t)?s.Range.fromIndexes(t,0,t,this._maxRow):s.Range.fromIndexes(t.first,0,t.last,this._maxRow)},c.prototype.getColRangeList=function(t){var e=this;return u.RangeArray.map(t,function(t){return e.getColRange(t)})},c.prototype.isRowRange=function(t){return 0===t.start[0]&&t.end[0]===this._maxCol},c.prototype.getRowRange=function(t){return r.isNumber(t)?s.Range.fromIndexes(0,t,this._maxCol,t):s.Range.fromIndexes(0,t.first,this._maxCol,t.last)},c.prototype.getRowRangeList=function(t){var e=this;return u.RangeArray.map(t,function(t){return e.getRowRange(t)})},c.prototype.isFullRange=function(t,e){return e?this.isColRange(t):this.isRowRange(t)},c.prototype.getFullRange=function(t,e){return e?this.getColRange(t):this.getRowRange(t)},c.prototype.getFullRangeList=function(t,e){return e?this.getColRangeList(t):this.getRowRangeList(t)},c.prototype.getRangeGroups=function(t){var e=this;return u.RangeArray.cast(t).group(function(t){return e.isColRange(t)?"colRanges":e.isRowRange(t)?"rowRanges":"cellRanges"})},c.prototype.getBoundedMovedRange=function(t,e,r){return e=o.clamp(e,-t.start[0],this._maxCol-t.end[0]),r=o.clamp(r,-t.start[1],this._maxRow-t.end[1]),s.Range.fromIndexes(t.start[0]+e,t.start[1]+r,t.end[0]+e,t.end[1]+r)},c.prototype.getCroppedMovedRange=function(t,e,r){var o=f(0,t.start[0]+e),n=f(0,t.start[1]+r),e=d(this._maxCol,t.end[0]+e),r=d(this._maxRow,t.end[1]+r);return o<=e&&n<=r?s.Range.fromIndexes(o,n,e,r):void 0},c.prototype.parseCellAnchor=function(t){var e=l.CellAnchor.parseOpStr(t),r=e.point1,o=e.point2,n=r.a=this.getClampedAddress(r.a),t=o.a=this.getClampedAddress(o.a);return t[0]=f(n[0],t[0]),t[1]=f(n[1],t[1]),n[0]===t[0]&&(o.x=f(r.x,o.x)),n[1]===t[1]&&(o.y=f(r.y,o.y)),e},c);function c(t,e){this._maxCol=t-1,this._maxRow=e-1}e.AddressFactory=g});