define("io.ox/office/spreadsheet/model/cellcollection",["exports","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/iterators","io.ox/office/tk/utils/dateutils","io.ox/office/editframework/utils/border","io.ox/office/editframework/utils/attributeutils","io.ox/office/editframework/utils/hyperlinkutils","io.ox/office/editframework/utils/operationerror","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/subtotalresult","io.ox/office/spreadsheet/model/addresstransformer","io.ox/office/spreadsheet/model/usedrangecollection","io.ox/office/spreadsheet/model/cellmodel","io.ox/office/spreadsheet/model/cellmodelmatrix","io.ox/office/spreadsheet/model/operation/stylecache","io.ox/office/spreadsheet/model/operation/builder","io.ox/office/spreadsheet/model/operation/celloperationbuilder","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/updatetask"],function(e,V,t,r,n,a,G,l,H,z,o,$,i,s,u,d,c,f,g,v,m,p){"use strict";var q=t.isNumber,K=t.isString,W=t.isDict,j=t.isEmpty,X=t.newDict,Y=t.makeUid,J=t.newFulfilled,Z=r.capitalizeFirst,Q=r.splitTokens,ee=r.compareArrays,te=r.arrayForEachReverse,re=r.flatClone,ne=r.hasSingleProperty,ae=r.fastThen,le=n.consumeArraySource,oe=n.someInArraySource,ie=n.TMap,se=n.KeySet,ue=a.DONE,de=a.BaseIterator,ce=a.ArrayValueIterator,fe=a.ArrayEntryIterator,ge=a.ParallelIterator,ve=l.NO_BORDER,me=l.isVisibleBorder,pe=l.equalBorders,he=o.OperationError,ye=$.ATTR_BORDER_KEYS,Ce=$.Direction,Ie=$.MergeMode,Re=$.SortDirection,be=$.ErrorCode,Me=$.Interval,xe=$.Address,we=$.Range,Se=$.IntervalArray,Oe=$.AddressArray,ke=$.RangeArray,Ee=$.RangeSet,Te=$.FindMatchType,Ae=$.modelLogger,Fe=i.SubtotalResult,_e=s.AddressTransformer,Le=u.UsedRangeCollection,De=d.SharedFormulaRefreshResult,Be=d.SharedFormulaModel,Ue=d.CellModel,Ne=c.CellModelMatrix,Pe=f.createBorderChangeSet,Ve=f.createVisibleBorderChangeSet,Ge=g.cloneWithCacheKey,He=g.OperationBuilder,ze=v.ContentRangeMode,$e=v.mergeRangeMode,qe=v.CellOperationBuilder,Ke=m.Math,We=m.GrammarType,je=m.ScalarTypeId,Xe=m.CompareNullMode,Ye=m.getCellValue,Je=m.isScalar,Ze=m.getScalarType,Qe=m.compareScalars,et=p.CutPasteUpdateTask,tt=/^(\d+)(.*)$/i,rt=/^(.*?)(\d+)$/i;function nt(e){e=e&&e.visible;return{cols:!0===e||"columns"===e,rows:!0===e||"rows"===e}}var h,at=(h={any:_.constant(!0),defined:_.identity,value:function(e){return e&&!e.isBlank()},formula:function(e){return e&&e.isAnyFormula()},anchor:function(e){return e&&e.isAnyAnchor()}},function(e){return h[e]||h.any});e.CellCollection=Le.extend(function(I){Le.call(this,I);var T=this,x=I.docModel,A=x.numberFormatter,d=x.addressFactory,C=x.autoStyles,F=x.sortListCollection,R=I.colCollection,b=I.rowCollection,r=new se,w=this.member(new Ne(I,!0)),S=this.member(new Ne(I,!1)),i=new ie,l=new Ee,o=x.getApp().isODF();function O(e,t){return t?e.suid:C.resolveStyleId(e.suid)}function M(e){return e.suid!==T.getDefaultStyleId(e.a,{useUid:!0})}function s(e){e.registerSharedFormula(),e.mr&&l.insert(e.mr.clone())}function u(e){e.unregisterSharedFormula(),e.mr&&l.remove(e.mr)}function c(e,t){r.insert(e),t&&t.skipColMatrix||w.insertModel(e),t&&t.skipRowMatrix||S.insertModel(e),t&&t.skipFormula||s(e)}function f(e,t){t&&t.skipFormula||u(e),t&&t.skipColMatrix||w.removeModel(e),t&&t.skipRowMatrix||S.removeModel(e),r.remove(e)}function g(t,e,r){function n(){return a||(c(e=new Ue(e=t)),a=e);var e}var a=T.getCellModel(t),l=a?a.suid:T.getDefaultStyleId(t,{useUid:!0}),o={address:t,model:null,value:!1,formula:!1,style:!1};return"v"in e&&n().setValue(e.v)&&(o.value=!0),"f"in e&&n().setFormula(I,e.f,r)&&(o.formula=!0),a&&u(a),"si"in e&&(null===(r=e.si)&&a&&a.sf?(delete a.sf,o.formula=!0):!q(r)||a&&a.sf&&a.sf.index===r||(n().sf=i.getOrConstruct(String(r),Be,I,r,t),o.formula=!0)),"mr"in e&&n().setMatrixRange(e.mr)&&(o.formula=!0),a&&s(a),"s"in e&&(n().suid=e.s,o.style=l!==e.s),!a||!o.style&&a.pf||a.updateParsedFormat(C),(o.value||o.style)&&a.updateDisplayString(A),o.value&&(a.cv.clearSubtotals(),a.rv.clearSubtotals()),o.model=a,o}function t(n,a){i.forEach(function(e,t){var r=e.refreshDirty();r===De.DELETED?i.remove(t):n&&r===De.MOVED&&n.call(a,e)})}function v(e,t,r){var n=r&&r.type||"all",r=r&&r.reverse,a=at(n);if(!a(null))return(1===e.size()?w.createCellIterator(e,t,r):S.createCellIterator(t,e,r)).mapIterator(function(e){return a(e)?{address:e.a.clone(),model:e,value:e.v,blank:e.isBlank()}:void 0});t=(t=Se.cast(t)).indexIterator({reverse:r}),r=(e=Se.cast(e)).indexIterator.bind(e,{reverse:r});return t.nestedMapIterator(r,function(e,t){t=new xe(t,e),e=T.getCellModel(t);return{address:t,model:e,value:e?e.v:null,blank:!e||e.isBlank()}})}function k(e,t){var r=nt(t),n=r.cols?R.getVisibleIntervals(e.colInterval()):new Se(e.colInterval()),e=r.rows?b.getVisibleIntervals(e.rowInterval()):new Se(e.rowInterval());return n&&e?v(n,e,t):null}function m(e,t){return fe.from(e,{reverse:t&&t.reverse}).nestedMapIterator(function(e){return k(e.value,t)},function(e,t){return t.orig=e.value,t.index=e.index,t})}function p(e,t){if(t.isStandard())return null;e=T.getParsedFormat(e);return t.hasEqualCategory(e,{anyDateTime:!0})?null:t.formatCode}function h(e){var t=!0===e.u,r=t||null===e.v&&null===e.f;return{undefine:t,blank:r,value:!r&&"v"in e,formula:!r&&("f"in e||"si"in e||"sr"in e),style:!t&&("s"in e||"a"in e||"format"in e||"table"in e)}}function y(e){var t=d.getRangeGroups(e),r=new ke;return t.rowRanges&&(e=Se.map(t.rowRanges,function(e){var t=e.rowInterval();return t.rangeMode=e.rangeMode,t.fillData=e.fillData,t}),b.createStyleIterator(e).forEach(function(e){var t=x.makeRowRange(e.interval);t.rangeMode=e.origInterval.rangeMode||(null===e.style?ze.ROW_MERGE:ze.ROW_DEF),t.fillData=e.origInterval.fillData,r.push(t)})),t.colRanges&&(t.colRanges.forEach(function(e){e.rangeMode=e.rangeMode||ze.COL_MERGE}),r.append(t.colRanges)),t.cellRanges&&r.append(t.cellRanges),r}function E(e,t,r){var n=r?0:d.getMaxIndex(t),a=r?function(e){return 0<e.getStart(t)}:function(e){return e.getEnd(t)<n},l=r?function(e){return e.lineRange(t,-1)}:function(e){return e.lineRange(t,e.size(t))};return ke.map(e,function(e){return a(e)?l(e):null})}this.calculateUsedRange=function(){var e=w.getUsedInterval(),t=S.getUsedInterval();return e&&t?we.fromIntervals(e,t):void 0};var a=Ae.profileMethod("$badge{CellCollection} generateTaggedRangeOperations",function(e,t,n,r){if(Ae.trace("ranges="+t),t.empty())return T.createResolvedPromise(new ke);var a=0<n.length,t=t.partition().map(function(e){var t=e.coveredBy.reduce(function(e,t){return $e(e,t.rangeMode||ze.CELL_MERGE)},ze.COL_MERGE),r=a?_.pluck(e.coveredBy,"fillData").filter(_.identity):null,r=re(n(r));return r.rangeMode=t,r.address=e,r});return T.generateCellsOperations(e,t,r)});function L(o,e,r,i,n){var s=I.createOperationGenerator({applyImmediately:!0}),u=I.createOperationGenerator({applyImmediately:!0}),t=T.createResolvedPromise(new ke);return[!1,!0].forEach(function(a){var l=a?e.colRanges:e.rowRanges;l&&(t=t.then(function(t){var r=a?u:s,e=a?R:b,n=Se.map(l,function(e){var t=e.interval(a);return t.fillData=e.fillData,t});return i(r,e,n).then(function(e){return o.appendOperations(r),t.append(x.makeFullRanges(e,a))})}))}),(t=t.then(function(t){return a(o,r,n).then(function(e){return t=t.append(e).merge(),Ae.trace("changed="+t),t})})).done(function(){o.appendOperations(u,{undo:!0}),o.appendOperations(s,{undo:!0})})}function D(e,t){var r=null,n=null,a=$.isVerticalDir(t);if(T.createLinearCellIterator(e,t,{type:"value",skipStart:!0}).some(function(e){if(!q(e.value))return null!==r;e=e.address;if(n&&1<Math.abs(n.get(!a)-e.get(!a)))return!0;r=r||e,n=e}),r&&n){t=e[0],e=e[1];return a?e--:t--,{address1:r,range:we.fromIndexes(t,e,n[0],n[1])}}}function B(S,O,k,E){var e=S.indexIterator(!O,{reverse:k}),u=0,d=null,c=null,f=null,g=null,e=e.map(function(){var e,r,n,t,a,l,o=S.addressAt(u),i=T.getCellModel(o),s=null;return g=i?(s=function(e){if(e.isAnyFormula())return"formula";if(e.isError())return"error";if(e.isNumber()){var t=e.pf.category;return"standard"!==t&&"custom"!==t&&"percent"!==t?t:"number"}return e.isText()?F.listContains(e.v)?"definedList":rt.test(e.v)?"stringNumber":tt.test(e.v)?"numberString":"string":e.isBlank()?"":null}(i),null!==c&&null!==f&&(s===f&&("stringNumber"!==s&&"numberString"!==s&&"definedList"!==s||null!==g&&(e=s,r=g,n=i.v,l=a=t=null,"stringNumber"===e?(t=rt.exec(r),l=rt.exec(n),t[1].toLowerCase()===l[1].toLowerCase()):"numberString"===e?(t=tt.exec(r),l=tt.exec(n),t[2].toLowerCase()===l[2].toLowerCase()):"definedList"===e&&(l=[],a=[],F.each(function(e,t){_.contains(e,r.toLowerCase())&&a.push(t),_.contains(e,n.toLowerCase())&&l.push(t)}),t=1<a.length&&0<_.intersection(a,l).length?_.first(_.intersection(a,l)):_.first(a),null===d&&(d=t),-1!==l.indexOf(t)&&(l=t),null!==t&&t===l&&d===t)))?c.end.move(1,!O):f=c=d=null),null===c&&(c=new we(o.clone(),o.clone())),null===f&&(f=s),i.v):f=c=null,u++,{baseCell:o,baseRange:c,valueType:s}});return e.forEach(function(e){var t,r,n,a,l,o,i,s,u,d,c,f,g,v,m,p,h,y,C,I,R,b,M,x,w;"stringNumber"===e.valueType||"numberString"===e.valueType?e.fillType=function(e,t,r,n){var a=e.baseRange;if(a.size(!t)<3)return n?"copy":"increase";var l,r=a.indexIterator(!t,{reverse:r}),o=[],i=0,s="stringNumber"===e.valueType?2:1,u="stringNumber"===e.valueType?rt:tt,d=null,c=null;return r.forEach(function(){var e=a.addressAt(i),t=T.getCellModel(e);l=u.exec(t.v),e=parseInt(l[s],10),o.push(e),0<i&&(c=(null===c||c===e-d)&&e-d),d=e,i++}),r=Ke.slope(o),!1===c||c!==r||n?"copy":"increase"}(e,O,k,E):"date"===e.valueType||"time"===e.valueType||"datetime"===e.valueType?!1===(d=(d=_.reduce(T.getRangeContents(e.baseRange,{blanks:!0}),function(e,t){return e.push(t.value),e},[]),c=e.valueType,w=!1,1<d.length?(f=0,x=M=b=R=I=C=y=h=p=m=v=g=null,_.every(d,function(e){e=A.convertNumberToDate(e),e=moment({year:e.getFullYear(),month:e.getMonth(),day:e.getDate(),hours:e.getHours(),minutes:e.getMinutes(),seconds:e.getSeconds(),milliseconds:e.getMilliseconds()}).utc();if(0<f)if(y=-1*x.diff(e,"milliseconds",!0),C=-1*x.diff(e,"seconds",!0),I=-1*x.diff(e,"minutes",!0),R=-1*x.diff(e,"hours",!0),m=-1*x.diff(e,"days",!0),p=-1*x.diff(e,"month",!0),(h=-1*x.diff(e,"years",!0))%1==0?(v="years",g=h):p%1==0?(v="months",g=p):m%1==0?(v="days",g=m):R%1==0?(v="hours",g=R):I%1==0?(v="minutes",g=I):C%1==0?(v="seconds",g=C):y%1==0&&(v="milliseconds",g=y),null===b&&null===M)b=v,M=g;else if(b!==v||M!==g)return!1;return x=e,f++,!0})&&null!==g&&null!==v&&(w={interval:g,unit:v})):w={interval:1,unit:"time"===c?"hour":"day"},w))||E?e.fillType="copy":(e.fillType="increase",e.unit=d.unit,e.interval=d.interval):"number"===e.valueType?S.singleLine(!O)===E?e.fillType="increase":e.fillType="copy":"formula"!==e.valueType||E?"definedList"===e.valueType&&!E&&(u=(c=_.reduce(T.getRangeContents(e.baseRange,{blanks:!0}),function(e,t){return e.push(t.value),e},[]),i=[],s={},u=w=o=null,u=1<c.length?(_.each(c,function(e){var r=e.toLowerCase();F.each(function(e,t){s[t]=s[t]||[],(0===i.length&&_.contains(e,r)||_.contains(e,r)&&-1!==i.indexOf(t)||_.contains(e,r)&&-1===i.indexOf(t))&&(i.push(t),s[t].push(_.indexOf(e,r)))})}),t={},i.forEach(function(e){t[e]=(t[e]||0)+1}),d=_.values(t),r=Math.max.apply(null,d),_.some(t,function(e,t){if(e===r)return o=t,!0}),a=n=null,1<s[o].length?(w=_.every(s[o],function(e){var t=null;if(null===n&&null===a)a=e;else if(null===n)(n=e-a)<0&&(n+=F.getList(o).length),a=e;else{if((t=e-a)<0&&(t+=F.getList(o).length),n!==t)return!1;n=t,a=e}return!0}))?n:null:(w=!0,1)):(l=c[0].toLowerCase(),F.some(function(e,t){if(_.contains(e,l))return s[o=t]=s[o]||[],s[o].push(_.indexOf(e,l)),!0}),w=!0,1),{list:parseInt(o,10),indexArr:s[o],linear:w,interval:u})).linear?(e.fillType="increase",e.list=u.list,e.interval=u.interval,e.rangeIndexes=u.indexArr):e.fillType="copy":e.fillType="relocate"}),e}function U(e,r,n,s,t){function u(e,t,r){var n,a=T.getCellModel(e.baseCell),l=null,o=null;if("increase"===e.fillType)if(C[e.baseRange.toString()]=C[e.baseRange.toString()]+1||0,"date"===e.valueType||"time"===e.valueType||"datetime"===e.valueType){var i=A.convertNumberToDate(T.getCellModel(e.baseRange.start).v),s=moment.utc({year:i.getUTCFullYear(),month:i.getUTCMonth(),day:i.getUTCDate(),hours:i.getUTCHours(),minutes:i.getUTCMinutes(),seconds:i.getUTCSeconds(),milliseconds:i.getUTCMilliseconds()}),u=C[e.baseRange.toString()];y?s.subtract((u+1)*e.interval,e.unit):s.add((e.baseRange.size(!h)+u)*e.interval,e.unit),l=A.convertDateToNumber(s.toDate())}else if("definedList"===e.valueType){var d=F.getList(e.list),c=C[e.baseRange.toString()]+1,f=null;if(y)for(f=e.rangeIndexes[0]-c*e.interval;f<0;)f=d.length+f;else(f=e.rangeIndexes[e.rangeIndexes.length-1]+c*e.interval)>=d.length&&(f%=d.length);l=d[f],T.getCellModel(e.baseRange.start).v.toUpperCase()===T.getCellModel(e.baseRange.start).v?l=l.toUpperCase():T.getCellModel(e.baseRange.start).v[0].toUpperCase()===T.getCellModel(e.baseRange.start).v[0]&&(l=Z(l))}else{var g=(e.baseRange.size(!h)+1)/2,v=e.baseRange.size(!h)+1-g+C[e.baseRange.toString()],i="stringNumber"===e.valueType?1:2,m="stringNumber"===e.valueType?2:1,p="stringNumber"===e.valueType?rt:tt,u="number"===e.valueType?function(e,t){return e.push(t.value),e}:function(e,t){t=p.exec(t.value),t=t&&t[m]?t[m]:null,t=t?parseInt(t,10):null;return e.push(t),e},g=(s=_.reduce(T.getRangeContents(e.baseRange,{blanks:!0}),u,[]),c=y,g=null,{slope:1<s.length?(u=c?s.reverse():s,g=_.reduce(u,function(e,t){return e+parseFloat(t)},0)/s.length,Ke.slope(u)):(g=parseFloat(s[0]),c?-1:1),average:g}),l=g.average+v*g.slope;"stringNumber"!==e.valueType&&"numberString"!==e.valueType||(n=p.exec(T.getCellModel(e.baseRange.start).v)[i],l="stringNumber"===e.valueType?n+Math.abs(l):Math.abs(l)+n)}else"relocate"===e.fillType?(r=a.a.clone().move(t*r*(y?-1:1),!h),o=a.getFormula(We.OP,r)):e.baseRange&&("formula"===e.valueType&&(o=T.getFormula(a.a,We.OP)),l=a?a.v:null);return{model:a,style:T.getStyleId(e.baseCell),value:o&&null===l&&a?a.v:l,formula:o}}var h=$.isVerticalDir(n),y=$.isLeadingDir(n),a=x.isColRange(r),d=x.isRowRange(r),l=r.size(!h),o=$.getAdjacentRange(r,n,s),c=!(!t||!t.copy),f=[],i=xe.A1.clone(),C={};if(d||a){a=r.interval(!h),a=(h?S:w).createIndexIterator(a).map(d?function(e){return we.fromIndexes(0,e,r.end[0],e)}:function(e){return we.fromIndexes(e,0,e,r.end[1])});T.createParallelAddressIterator(a,{type:"defined"}).forEach(function(e){var t=d?we.fromIndexes(e[0][0],r.start[1],e[0][0],r.end[1]):we.fromIndexes(r.start[0],e[0][1],r.end[0],e[0][1]),e=$.getAdjacentRange(t,n,s),a=0,l=0,o=B(t,h,y,c),i=t.size(!h);y&&o.reverse(),e.addressIterator({reverse:y}).forEach(function(e){var t,r=a%i,n=o[r];0==r&&l++,t=u(n,l,i),f.push({address:e,v:t.value,f:t.formula,s:t.model?O(t.model):null}),a++})})}else for(var g=o.start.get(h),v=(y?o.end:o.start).get(!h),m=0,p=r.size(h);m<p;m+=1){i.set(g+m,h),i.set(v,!h);var I=B(r.lineRange(h,m),h,y,c);y&&I.reverse();for(var R=0;R<s;R+=1){var b=R%l,M=Math.floor(R/l)+1,M=u(I[b],M,l);f.push({address:i.clone(),v:M.value,f:M.formula,s:null!==M.style?M.style:null}),i.move(y?-1:1,!h)}}return T.generateCellsOperations(e,f)}function N(e,t,r,n){var a=new ke;function l(e,t){return a.append(V.addProperty(e,"fillData",t))}var o=$.getOuterBorderKey(r,n),i=$.getInnerBorderKey(r),s=t[$.getBorderName(o)],t=t[$.getBorderName(i)];if(!s&&!t)return null;if(s&&l(E(e,r,n),{key:$.getOuterBorderKey(r,!n),keepBorder:s}),s&&t&&pe(s,t))return l(e.deepClone(),{key:o,border:s,cacheType:"outer"});var u,i=e.group(function(e){return x.isFullRange(e,!r)?"fullRanges":"cellRanges"});return t&&i.fullRanges&&l(i.fullRanges.deepClone(),{key:o,border:t,cacheType:"outer"}),s&&i.cellRanges&&(e=r?n?function(e){return e.leadingCol()}:function(e){return e.trailingCol()}:n?function(e){return e.headerRow()}:function(e){return e.footerRow()},l((new ke).appendMapped(i.cellRanges,e),{key:o,border:s,cacheType:"outer"})),t&&i.cellRanges&&(u=n?1:0,l(ke.map(i.cellRanges,function(e){return e.singleLine(r)?null:e.lineRange(r,u,e.size(r)-1)}),{key:o,border:t,cacheType:"inner"})),a}function P(e,t,r){e=E(e,t,r),r=$.getOuterBorderKey(t,!r);return V.addProperty(e,"fillData",{keys:[r]})}this._getCloneData=function(){return{sharedModelMap:i,matrixRangeSet:l,modelSet:r}},this.applyCopySheetOperation=function(e,t){t=t._getCloneData();t.sharedModelMap.forEach(function(e){i.insert(String(e.index),e.cloneFor(I))}),l=t.matrixRangeSet.deepClone();var r={skipFormula:!0};t.modelSet.forEach(function(e){var t=e.sf?i.get(String(e.sf.index)):void 0;c(e.cloneFor(I,t),r)}),this.updateUsedRange()},this.applyChangeCellsOperation=function(n){var r,a=n.importing,e=a?null:new ie,l=a?_.noop:function(t){e.update(t.address.key,function(e){return e?(e.model=e.model||t.model,e.value=e.value||t.value,e.formula=e.formula||t.formula,e.style=e.style||t.style,e):t})};_.forEach(n.getDict("contents"),function(e,t){t=n.parseRange(t);Je(e)&&(e={v:e}),n.ensure(W(e),"cell data must be an object or a scalar"),!0===e.u&&k(t,{type:"defined",reverse:!0}).forEach(function(e){var t;l((t=e.address,e={address:t,model:null,value:!1,formula:!1,style:!1},(t=T.getCellModel(t))&&(e.value=null!==t.v,e.formula=t.isAnyFormula(),e.style=M(t),f(t),t.destroy()),e))});var r=function(e,t,r){var n,a=X();if("v"in t?(e.ensure(!("e"in t),"unexpected cell error code"),e.ensure(Je(t.v),"invalid cell value type"),a.v=t.v):"e"in t&&(e.ensure(K(t.e),"invalid cell error code"),a.v=x.formulaGrammarOP.getErrorCode(t.e)||be.NA),"f"in t&&(null===t.f?a.f=null:(e.ensure(K(t.f)&&0<t.f.length,"invalid formula expression"),a.f=t.f)),"si"in t&&(null===t.si?a.si=null:(e.ensure(q(t.si)&&0<=t.si,"invalid shared formula identifier"),a.si=Math.floor(t.si))),"sr"in t&&null!==t.sr&&(e.ensure(r.single(),"shared formula range cannot be set to multiple cells"),n=K(t.sr)&&d.parseRange(t.sr),e.ensure(n,"invalid shared formula range")),"mr"in t&&(null===t.mr?a.mr=null:(e.ensure(r.single(),"matrix formula range cannot be set to multiple cells"),a.mr=K(t.mr)?d.parseRange(t.mr):void 0,e.ensure(a.mr,"invalid matrix formula range"))),"s"in t&&(e.ensure(K(t.s),"invalid auto-style identifier"),n=C.resolveStyleUid(t.s),e.ensure(null!==n,'invalid auto-style identifier "%s"',t.s),a.s=n),!j(a)){if(!(o&&r.cells()>=d.colCount/2&&ne(a)&&"s"in a))return e.ensure(r.cells()<=$.MAX_FILL_CELL_COUNT,"too many cells"),a;Ae.warn("$badge{CellCollection} createChangeSet: Overflow error! Skipping formatting of "+r.cells()+" cells.")}}(n,e,t);r&&t.addressIterator().forEach(function(e){l(g(e,r,a))})}),t(function(e){e.addressSet.forEach(function(e){l({address:e,formula:!0})})}),e&&!e.empty()&&(r={valueCells:new Oe,formulaCells:new Oe,styleCells:new Oe,allCells:new Oe},e.forEach(function(e){var t=e.address;e.value&&r.valueCells.push(t),e.formula&&r.formulaCells.push(t),e.style&&r.styleCells.push(t),(e.value||e.formula||e.style)&&r.allCells.push(t)}),r.results="filter"===n.optStr("scope"),n.fire(this.changeHook,r)),this.updateUsedRange()},this.applyMoveCellsOperation=function(e){var t=e.getRange("range"),r=e.getEnum("dir",Ce),r=_e.fromRange(d,t,r);this.implTransformCells(e,r)},this.postProcessImport=function(){return this.iterateSliced(r.valueIterator(),function(e){e.updateTokenArray(I)})},this.implTransformCells=function(e,a){var l=a.columns;a.createBandRanges(a.deleteIntervals).forEach(function(e){k(e,{type:"defined",reverse:!0}).forEach(function(e){f(e.model),e.model.destroy()})});var o=[];a.moveFromIntervals.forEach(function(e,t){var r={};o.push(r);var n=a.createBandRange(e);r.moveDist=a.moveToIntervals[t].first-e.first;e=l?S.getUsedInterval():null;r.skipColMatrix=!e||n.rowInterval().contains(e);e=l?null:w.getUsedInterval();r.skipRowMatrix=!e||n.colInterval().contains(e),r.cellModels=k(n,{type:"defined",reverse:!0}).map(function(e){e=e.model;return f(e,r),e})}),o.forEach(function(t){var r=t.moveDist;t.cellModels.forEach(function(e){e.a.move(r,l),c(e,t)})}),t(),e.fire(this.moveHook,{transformer:a}),this.updateUsedRange()},this.getSheetIndex=function(){return I.getIndex()},this.getDefaultStyleId=function(e,t){var r=t&&t.ignoreRowStyle?null:b.getEntry(e[1]),e=r&&r.merged.customFormat?r:R.getEntry(e[0]);return t&&t.useUid?e.suid:e.style},this.isVisibleCell=function(e){return R.isEntryVisible(e[0])&&b.isEntryVisible(e[1])},this.getCellModel=function(e){return r.get(e.key)||null},this.isBlankCell=function(e){e=this.getCellModel(e);return!e||e.isBlank()},this.getValue=function(e){e=this.getCellModel(e);return e?e.v:null},this.getDisplayString=function(e){e=this.getCellModel(e);return e?e.d:""},this.isFormulaCell=function(e){var t=this.getCellModel(e);return!(!t||!t.isAnyFormula())||l.containsAddress(e)},this.isAnchorCell=function(e){e=this.getCellModel(e);return!!e&&e.isAnyAnchor()},this.getTokenArray=function(e,t){var r=this.getCellModel(e),n=t&&t.grammarType;if(r&&r.sf)return{tokenArray:r.sf.tokenArray,refAddress:r.sf.anchorAddress,matrixRange:null,formula:n?r.sf.getFormula(n,e):null};var a=e;return(r=!(r&&r.t||!t)&&t.fullMatrix?(a=(e=l.findOneByAddress(e))?e.start:null)?this.getCellModel(a):null:r)&&r.t?{tokenArray:r.t,refAddress:a.clone(),matrixRange:r.mr?r.mr.clone():null,formula:n?r.getFormula(n):null}:null},this.getFormula=function(e,t,r){t=this.getTokenArray(e,_.extend({},r,{grammarType:t}));return t?t.formula:null},this.getMatrixRange=function(e){var t=this.getCellModel(e);if(t&&t.mr)return t.mr.clone();e=l.findOneByAddress(e);return e?e.clone():null},this.coversAnyMatrixRange=function(e,t){return oe(e,function(e){return!!l.findOne(e,t)})},this.getSharedModel=function(e){return q(e)?i.get(String(e)):void 0},this.createSharedModelIterator=function(){return i.valueIterator()},this.getStyleId=function(e,t){var r=this.getCellModel(e);return r?O(r,t):this.getDefaultStyleId(e,{useUid:t})},this.getAttributeSet=function(e){return C.getMergedAttributeSet(this.getStyleId(e))},this.getParsedFormat=function(e){return C.getParsedFormat(this.getStyleId(e))},this.getTextOrientation=function(e){var t=this.getCellModel(e),r=this.getStyleId(e),e=C.getMergedAttributeSet(r),r=C.getParsedFormat(r).isText();return $.getTextOrientation(t?t.v:null,e.cell.alignHor,t?t.d:"",r)},this.isTextFormat=function(e){return this.getParsedFormat(e).isText()},this.getFormulaURL=function(e){e=this.getCellModel(e);return e&&e.url||null},this.setFormulaURL=function(e,t){e=this.getCellModel(e);return e&&e.setURL(t),this},this.getEffectiveURL=function(e){var t=I.hlinkCollection.getCellURL(e);return null===t?this.getFormulaURL(e):t},this.getEditFormula=function(e,t){var r=this.getTokenArray(e,{grammarType:We.UI,fullMatrix:!0});if(!r)return null;if(I.isLocked()&&this.getAttributeSet(e).cell.hidden)return"";e="="+r.formula;return e=r.matrixRange&&t&&t.matrixBraces?"{"+e+"}":e},this.getEditString=function(e,t){t=this.getEditFormula(e,t);if(null!==t)return t;var r=this.getValue(e),t=Ze(r);if(t===je.STRING&&0<r.length)return/^['=]/.test(r)||!K(A.parseValue(r))?"'"+r:r;if(t===je.BOOLEAN)return x.formulaGrammarUI.getBooleanName(r);if(t===je.ERROR)return x.formulaGrammarUI.getErrorName(r);if(t===je.NUMBER&&isFinite(r)){var n=null,a=this.getParsedFormat(e).category;switch(a){case"percent":r*=100,isFinite(r)&&(n=A.autoFormatNumber(r,{stdLen:$.MAX_LENGTH_STANDARD_EDIT}).text+"%");break;case"date":case"time":case"datetime":var l=Math.round(r*G.MSEC_PER_DAY),o=Math.floor(l/G.MSEC_PER_DAY),l=Math.floor(l%G.MSEC_PER_DAY),l=A.getSystemDateTimeFormat({hideDate:"time"===a&&0===o,hideTime:"date"===a||0===l}),n=A.formatValue(l,r).text}return null!==n?n:A.autoFormatNumber(r,{stdLen:$.MAX_LENGTH_STANDARD_EDIT}).text}return""},this.createCellIterator=function(e,n){var a=I.mergeCollection,t=nt(n),l=n&&n.skipCovered,r=n&&n.reverse,o=t.cols?t.rows?"both":"columns":t.rows?"rows":"none";return ke.splitRanges(e,n).valueIterator({reverse:r}).nestedMapIterator(function(t){var e=k(t,n);if(!l||a.isEmpty())return e;var r=_.once(function(){var e=a.getMergedRanges(t);return e=o&&!e.empty()?ke.map(e,function(e){return(e=I.shrinkRangeToVisible(e,o))&&!e.single()?e:null}):e});return e.filterIterator(function(e){var t=e.address,e=r().findByAddress(t);return!e||e.startsAt(t)})},function(e,t){return t.orig=e.orig,t.index=e.index,t})},this.createLinearCellIterator=function(n,e,a){var l=a&&a.boundRange||x.getSheetRange(),o=a&&a.skipStart?1:0;return ce.from(e).nestedMapIterator(function(e){var t=!$.isVerticalDir(e),r=$.isLeadingDir(e),e=x.makeFullRange(n.get(!t),!t);return r?e.setEnd(n.get(t)-o,t):e.setStart(n.get(t)+o,t),(e=e.getStart(t)<=e.getEnd(t)?l.intersect(e):null)?T.createCellIterator(e,_.extend({},a,{reverse:r})):null},function(e,t){return{address:t.address,model:t.model,value:t.value,blank:t.blank,direction:e}})},this.createParallelAddressIterator=function(r,t){var e=r.map(function(e){return k(e,t)});return new ge(e,function(e,t){return r[t].indexAt(e.address)}).mapIterator(function(e){var t=e.offset;return r.map(function(e){return e.addressAt(t)})})},this.createStyleIterator=function(e,r){var n=I.mergeCollection,a=r&&r.visible,v=r&&r.skipCovered,m=r&&r.reverse;function p(e){return v&&n.isHiddenCell(e)?de.empty():de.once({range:new we(e.clone()),style:T.getStyleId(e)})}var h=_.memoize(function(e,t){e=a?R.getVisibleIntervals(e):new Se(e.clone());return V.addProperty(e,"style",t)},function(e,t){return e.toString()+":"+t}),y=_.memoize(function(e){return R.createStyleIterator(e,{visible:a}).reduce(new Se,function(e,t){return t.interval.style=t.style,e.push(t.interval),e})},function(e){return e.toString()});function l(e,l,t){if(e.single()&&l.single())return p(new xe(e.first,l.first));var r=we.fromIntervals(e,l),o=null===t?y(e):h(e,t),i=k(r,{type:"defined",visible:a,reverse:m}).filterIterator(function(e){return M(e.model)}).mergeIterator(function(e,t){var r=e.address,n=t.address;if(r[1]===n[1]){var a=u(e),r=m?a.first():a.last();if(C.areEqualStyleIds(r.style,O(t.model))){if(!m&&r.last+1===n[0])return r.last+=1,e;if(m&&n[0]+1===r.first)return--r.first,e}return r=s(t),m?a.unshift(r):a.push(r),e}}).mergeIterator(function(e,t){var r=t.address,n=d(e);if(m?r[1]+1===n.first:n.last+1===r[1]){var r=u(e),a=u(t);return r.length===a.length&&r.every(function(e,t){t=a[t];return e.equals(t)&&C.areEqualStyleIds(e.style,t.style)})?(m?--n.first:n.last+=1,e):void 0}}).mapIterator(function(e){return u(e),d(e),{colIntervals:e.colIntervals,rowInterval:e.rowInterval}});function s(e){var t=new Me(e.address[0]);return t.style=O(e.model),t}function u(e){return e.colIntervals||(e.colIntervals=new Se(s(e)))}function d(e){return e.rowInterval||(e.rowInterval=new Me(e.address[1]))}var c=i.next().value,f=v?function(e){var t=n.getMergedRanges(e);if(t.empty())return null;var r=new ke;return t.forEach(function(e){e.singleCol()||r.push(we.fromIndexes(e.start[0]+1,e.start[1],e.end[0],e.start[1])),e.singleRow()||r.push(we.fromIndexes(e.start[0],e.start[1]+1,e.end[0],e.end[1]))}),(r=(r=a?ke.map(r,function(e){return I.shrinkRangeToVisible(e)}):r).intersect(e)).empty()?null:r.getRowBands({intervals:!0})}(r):null,g=m?l.last:l.first;return new de(function(){if(!l.containsIndex(g))return ue;var e,t,r=null,n=null,n=c?c.rowInterval.containsIndex(g)?(r=m?new Me(c.rowInterval.first,g):new Me(g,c.rowInterval.last),R.mergeStyleIntervals(o,c.colIntervals)):(r=m?new Me(c.rowInterval.last+1,g):new Me(g,c.rowInterval.first-1),o):(r=m?new Me(l.first,g):new Me(g,l.last),o),a=f?m?f.last():f.first():null;return a&&(a.containsIndex(g)?(m?r.first=Math.max(r.first,a.first):r.last=Math.min(r.last,a.last),e=n,t=a.intervals,n=e.concat(t).partition().reject(function(t){return t.coveredBy.some(function(e){return!("style"in e)||(t.style=e.style,void delete t.coveredBy)})})):m?r.first=Math.max(r.first,a.last+1):r.last=Math.min(r.last,a.first-1)),g=m?r.first-1:r.last+1,c&&(m?g<c.rowInterval.first:c.rowInterval.last<g)&&(c=i.next().value),a&&(m?g<a.first:a.last<g)&&(m?f.pop():f.shift()),{value:{rowInterval:r,colIntervals:n}}}).nestedIterator(function(t){return t.colIntervals.valueIterator({reverse:m}).mapIterator(function(e){return{range:we.fromIntervals(e,t.rowInterval),style:e.style}})})}return ke.splitRanges(e,r).valueIterator({reverse:m}).nestedMapIterator(function(t){return a&&!(t=I.shrinkRangeToVisible(t))?null:t.single()?p(t.start):b.createStyleIterator(t.rowInterval(),r).nestedIterator(function(e){return l(t.colInterval(),e.interval,e.style)})},function(e,t){return t.origRange=e.orig,t.origIndex=e.index,t})},this.createSubtotalIterator=function(e){var t=this.getVisibleUsedRange();if(!(e=t?ke.cast(e).intersect(t):null)||e.empty())return de.once(new Fe);var r=ke.filter(e,function(e){return e.equalRows(t)}).colIntervals().merge(),n=ke.filter(e,function(e){return e.equalCols(t)}).rowIntervals().merge(),a=r.size()*t.rows();e=n.size()*t.cols()<a?(n.clear(),e.difference(ke.fromIntervals(r,t.rowInterval()))):(r.clear(),e.difference(ke.fromIntervals(t.colInterval(),n)));a=de.empty();return r.empty()?n.empty()||(a=S.createSubtotalIterator(n),e=e.difference(ke.fromIntervals(t.colInterval(),n))):(a=w.createSubtotalIterator(r),e=e.difference(ke.fromIntervals(r,t.rowInterval()))),e.empty()||(e=m(e.merge(),{type:"value",visible:!0}).pluckIterator("value"),a=a.chainIterator(e)),a},this.findFirstCell=function(e,t){t=this.createCellIterator(e,t).next().value;return t?t.address:null},this.findFirstCellLinear=function(e,t,r){r=this.createLinearCellIterator(e,t,_.extend({},r,{skipStart:!0})).next().value;return r?r.address:null},this.areRangesBlank=function(e){return!!m(ke.mergeRanges(e),{type:"value"}).next().done},this.areRangesUndefined=function(e){return!!m(ke.mergeRanges(e),{type:"defined"}).next().done},this.getRangeContents=function(e,t){var r=t&&t.blanks,a=t&&t.visible,n=t&&t.compressed,l=t&&t.maxCount,o=[];o.count=0;var i=t&&t.display?function(e,t){return{value:e,display:null===t?"#######":t}}:function(e){return{value:e}};function s(e,t){if(0!==(t=l?Math.min(t,l-o.count):t)){o.count+=t;var r=n?_.last(o):null;if(r&&(e.count=r.count,r.value===e.value&&r.style===e.style&&r.display===e.display))r.count+=t;else if(n)e.count=t,o.push(e);else for(;0<t;--t)o.push(e)}}var u=r?function(e){s(i(null,""),e)}:_.noop;return le(e,t&&t.attributes?function(e){T.createCellIterator(e,{type:r?"all":"value",visible:a}).some(function(e){var t=e.address,e=i(e.value,T.getDisplayString(t));return e.style=T.getStyleId(t),e.attributes=C.getMergedAttributeSet(e.style),e.format=C.getParsedFormat(e.style),s(e,1),l===o.count})}:function(r){var n=0;T.createCellIterator(r,{type:"value",visible:a}).some(function(e){var t=r.indexAt(e.address),e=e.model;return u(t-n),s(i(e.v,e.d),1),n=t+1,l===o.count}),u(r.cells()-n)}),o},this.findContentRange=Ae.profileMethod("$badge{CellCollection} findContentRange",function(e,t){var r,n=I.mergeCollection,o=n.expandRangeToMergedRanges(e),i=Q(t&&t.directions||"up down left right");function s(e,t,r){e=t?e.getEnd(r)+1:e.getStart(r)-1;return(t?e>d.getMaxIndex(r):e<0)?-1:e}function a(e,t){var r,n=/^(down|right)$/.test(e),a=/^(left|right)$/.test(e),l=s(o,n,a);l<0?i.splice(t,1):((t=o.clone()).setBoth(l,a),_.contains(i,a?Ce.UP:Ce.LEFT)&&0<=(l=s(t,!1,!a))&&t.setStart(l,!a),_.contains(i,a?Ce.DOWN:Ce.RIGHT)&&0<=(l=s(t,!0,!a))&&t.setEnd(l,!a),(t=k(t,{type:"value"}).next().value)&&((r=n?o.end:o.start).set(t.address.get(a),a),T.createLinearCellIterator(t.address,e,{skipStart:!0}).some(function(e){return!!e.blank||void r.set(e.address.get(a),a)})))}for(;r=o.clone(),te(i,a),o=n.expandRangeToMergedRanges(o),0<i.length&&o.differs(r););return o}),this.findCellWithAttributes=Ae.profileMethod("$badge{CellCollection} findCellWithAttributes",function(e,t,r){var n=r&&r.reverse,r=this.createStyleIterator(e,r).filterIterator(function(e){e=C.getMergedAttributeSet(e.style);return H.matchesAttributesSet(e,t)}).next().value;return r?{address:(n?r.range.end:r.range.start).clone(),range:r.origRange,index:r.origIndex}:null}),this.hasHeaderRow=function(r){if(r.singleRow())return!1;function n(e){return e?e.isAnyFormula()?"formula":e.isNumber()?e.pf.isAnyDateTime()?"date":"number":e.isText()?F.listContains(e.v)?"definedList":"string":e.isBlank()?"":null:null}function a(e,t){return"definedList"===e&&1<=_.uniq(t).length||"date"===e&&1<=_.uniq(t).length||null===e&&1<=_.uniq(t).length||1===_.uniq(t).length&&t[0]!==e?"yes":"number"===e&&1<=_.uniq(t).length||"string"===e&&1===_.uniq(t).length&&"string"===t[0]||"number"===e&&1===_.uniq(t).length&&"number"===t[0]||"date"===e&&1===_.uniq(t).length&&"date"===t[0]||"formula"===e&&1===_.uniq(t).length&&"formula"===t[0]||"formula"===e&&1<=_.uniq(t).length?"no":"maybe"}var l=r.start[0],o=r.start[1],i=[],s=[],u={yes:0,no:0,maybe:0},e=I.tableCollection.createModelIterator({overlapRange:r,autoFilter:!0}),t=e.next().value;return t&&e.next().done&&t.getRange().equals(r)?t.hasHeaderRow():(r.colIterator().forEach(function(e){var t=r.colRange(e-l),e=t.clone().setStart(o+1,!1),t=n(T.getCellModel(t.start));i.push(t);e=e.addressIterator().map(function(e){return n(T.getCellModel(e))});s=s.concat(e),"yes"===a(t,e)?u.yes++:"no"===a(t,e)?u.no++:u.maybe++}),(1!==_.uniq(i).length||null!==i[0])&&(u.yes>u.no||(u.no>u.yes?u.yes+u.maybe>u.no:0<u.maybe)))},this.findAutoFormulaRange=function(e){var t=D(e,Ce.UP),r=D(e,Ce.LEFT);return t&&r?(Math.abs(e[0]-r.address1[0])<Math.abs(e[1]-t.address1[1])?r:t).range:t?t.range:r?r.range:null},this.checkMaxRangeSize=function(e){return e.cells()>$.MAX_FILL_CELL_COUNT?$.makeRejected("cells:overflow"):null},this.parseCellValue=function(e,t,r,n){var a={v:e,f:null,result:null};if(this.isTextFormat(r))return a;/^[-+=]+$/.test(e)&&(e="'"+e);var l=A.parseFormattedValue(e,{blank:!0});a.v=l.value;var o=A.getParsedFormat(l.format),l=K(a.v)?$.splitFormulaParts(e):void 0;l&&0<l.expr.length&&((e=I.createCellTokenArray()).parseFormula(We.UI,l.expr,r,{autoCorrect:!0}),a.f=e.getFormula(We.OP,r,r),n=a.result=e.interpretFormula(t,r,r,{matrixRange:n}),a.v=Ye(n.value),"format"in n&&(o=n.format));o=o?p(r,o):null;return o&&(a.format=o),null===a.v?I.hlinkCollection.getCellURL(r)&&(a.url=""):!a.f&&K(a.v)&&(r=z.checkForHyperlink(a.v),K(r)&&0<r.length&&(a.url=r)),a},this.generateUpdateTaskOperations=Ae.profileMethod("$badge{CellCollection} generateUpdateTaskOperations",function(e,t){var r=I.isOwnMoveTask(t)?t.transformer:void 0;return r&&r.insert&&(r=r.createBandRanges(r.deleteIntervals),he.assertCause(!this.findFirstCell(r,{type:"value"}),"cells:pushoff")),e.cellCache.updateFormulas(t)}),this.generateBreakSharedFormulaOperations=Ae.profileMethod("$badge{CellCollection} generateBreakSharedFormulaOperations",function(e,n){var a=new qe(I,e);return this.asyncForEach(i,function(r){r.addressSet.forEach(function(e){var t;n.containsAddress(e)&&(t=this.getCellModel(e).isSharedAnchor()?{si:null,sr:null}:{f:r.getFormula(We.OP,e)},a.insertCell(e,t))},this)}).then(function(){return a.finalizeOperations()})}),this.generateCellOperations=function(e,t,r){return this.generateCellsOperations(e,[_.extend({address:t},r)])},this.generateCellsOperations=Ae.profileMethod("$badge{CellCollection} generateCellsOperations",function(n,e,t){Ae.trace("changeSets=",e);var a=new qe(I,n,t),u=new ie,r=0,e=this.iterateArraySliced(e,function(l){var o=l.address instanceof xe?new we(l.address):l.address,i=h(l),s=i.blank&&!i.style;"url"in l&&u.getOrConstruct(l.url,ke).push(o);var e=function(){if(i.undefine)return k(o,{type:"defined"});if(null===l.v&&null!==l.f)return Ae.error("$badge{CellCollection} generateCellsOperations: illegal operation (clearing values without formulas)"),null;if(s)return k(o,{type:"value"});if(i.value||i.formula)return k(o,{type:"all"});var e=l.rangeMode||ze.CELL_MERGE;if(i.style&&e===ze.CELL_MERGE)return k(o,{type:"all"});if(!i.blank&&!i.style)return null;switch(e){case ze.ROW_DEF:return k(o,{type:"defined"});case ze.ROW_MERGE:var t=new Se,r=new Se;R.createStyleIterator(o.colInterval()).forEach(function(e){(C.isDefaultStyleId(e.style)?t:r).push(e.interval)});var n=v(t.merge(),o.rowInterval(),{type:"defined"}),a=v(r.merge(),o.rowInterval(),{type:"all"});return n.chainIterator(a);case ze.COL_MERGE:return b.createStyleIterator(o.rowInterval()).nestedIterator(function(e){return k(we.fromIntervals(o.colInterval(),e.interval),{type:null===e.style?"defined":"all"})})}return Ae.error('$badge{CellCollection} generateCellsOperations: invalid range mode "'+e+'"'),null}();if(e)return T.iterateSliced(e,function(e){e=a.insertCell(e.address,l);if(e&&!s&&(r+=1)>$.MAX_FILL_CELL_COUNT)return $.makeRejected("cells:overflow")})});return(e=ae(e,function(){var r=I.hlinkCollection;return u.with("",function(e){r.generateHlinkOperations(n,e.merge(),""),u.remove("")}),u.forEach(function(e,t){r.generateHlinkOperations(n,e.merge(),t)}),a.finalizeOperations()})).done(function(e){Ae.trace("changed="+e)})}),this.generateRangeOperations=Ae.profileMethod("$badge{CellCollection} generateRangeOperations",function(e,t){return Ae.trace("ranges="+t),L(e,d.getRangeGroups(t),y(t),function(e,t,r){return t.generateIntervalOperations(e,r)},function(e){return e.reduce(_.extend,{})})}),this.generateFillOperations=Ae.profileMethod("$badge{CellCollection} generateFillRangeOperations",function(t,e,n){Ae.trace("ranges="+e+" changes=",n),n=Ge(n);var r=d.getRangeGroups(e),a=y(e),l=h(n),o=l.style&&r.cellRanges?this.checkMaxRangeSize(r.cellRanges.merge()):null;if(o)return o;if(o=l.value||l.formula?this.checkMaxRangeSize(a.merge()):null)return o;return(K(n.url)?(o=n.url,delete n.url,I.hlinkCollection.generateHlinkOperations(t,e,o)):this.createResolvedPromise()).then(function(){var e=_.constant(n);return L(t,r,a,function(e,t,r){return t.generateFillOperations(e,r,n)},e)})}),this.generateAutoFillOperations=Ae.profileMethod("$badge{CellCollection} generateAutoFillOperations",function(e,t,r,n,a){Ae.trace(function(){return"source="+t+" dir="+r+" count="+n});var l=this.getUsedRange(),o=$.getAdjacentRange(t,r,n),i=I.createOperationGenerator({applyImmediately:!0}),s=l&&!this.areRangesUndefined(t);!s||(l=l.intersect(o))&&e.generateClearCellsOperation(l,{undo:!0});var o=this.generateFillOperations(i,o,{u:!0}).done(function(){e.appendOperations(i)}),u=!$.isVerticalDir(r);return(o=(o=(o=(o=x.isFullRange(t,u)?o.then(function(){return(u?R:b).generateAutoFillOperations(e,t.interval(u),r,n)}):o).then(function(){return I.mergeCollection.generateAutoFillOperations(e,t,r,n)})).then(function(){return I.hlinkCollection.generateAutoFillOperations(e,t,r,n)})).then(function(){if(s)return U(e,t,r,n,a)})).done(function(){e.appendOperations(i,{undo:!0})}),o}),this.generateBorderOperations=Ae.profileMethod("$badge{CellCollection} generateBorderOperations",function(e,t,n){Ae.trace("ranges="+t+" attributes=",n),t=ke.cast(t).unify();var r=d.getRangeGroups(t),a=N(t,n,!1,!0),l=N(t,n,!1,!1),o=N(t,n,!0,!0),t=N(t,n,!0,!1),t=y(new ke(a,l,o,t)),i=Y();return L(e,r,t,function(e,t,r){return t.generateBorderOperations(e,r,n,i)},function(e){return Pe(e,i)})}),this.generateVisibleBorderOperations=Ae.profileMethod("$badge{CellCollection} generateVisibleBorderOperations",function(e,t,n){Ae.trace(function(){return"ranges="+t+" border="+JSON.stringify(n)}),t=ke.cast(t).unify();var r=d.getRangeGroups(t),a=V.addProperty(t.deepClone(),"fillData",{keys:ye}),l=P(t,!1,!0),o=P(t,!1,!1),i=P(t,!0,!0),s=P(t,!0,!1),s=y(new ke(a,l,o,i,s)),u=Y();return L(e,r,s,function(e,t,r){return t.generateVisibleBorderOperations(e,r,n,u)},function(e){return Ve(e,n,u)})}),this.generateMergeCellsOperations=Ae.profileMethod("$badge{CellCollection} generateMergeCellsOperations",function(e,t,r){if(Ae.trace(function(){return"ranges="+t+" mode="+r.toString()}),r===Ie.UNMERGE)return this.createResolvedPromise(new ke);var f=r===Ie.VERTICAL,g=r===Ie.HORIZONTAL,v=new ke,m=new ke,n=I.createOperationGenerator({applyImmediately:!0}),p=T.getUsedRange();t=ke.filter(t,function(e){return g?!e.singleCol():f?!e.singleRow():!e.single()});var a=this.iterateArraySliced(t,function(c){var e=f?c.cols():g?c.rows():1;return this.repeatSliced(function(e){var t=f?c.colRange(e):g?c.rowRange(e):c.clone();v.push(t);var r=k(t,{type:"value"}).next().value,e=r?r.model:null,r=e?O(e):this.getStyleId(t.start);t.fillData={s:r};var n,a,l=(n=t,a={},T.createStyleIterator(n).forEach(function(e){var t=C.getBorderMap(e.style),e=e.range;n.start[0]===e.start[0]&&o(t,"l"),n.start[1]===e.start[1]&&o(t,"t"),n.end[0]===e.end[0]&&o(t,"r"),n.end[1]===e.end[1]&&o(t,"b"),o(t,"d"),o(t,"u")}),a);function o(e,t){e=e[t];t in a?null===a[t]||pe(a[t],e)||(a[t]=null):a[t]=e}var i=C.getBorderMap(r),s={};t.singleCol()||!i.l&&!i.r||(s.borderLeft=s.borderRight=ve),t.singleRow()||!i.t&&!i.b||(s.borderTop=s.borderBottom=ve),["d","u"].forEach(function(e){null===l[e]&&i[e]&&(s[$.getBorderName(e)]=ve)}),_.isEmpty(s)||(t.fillData.a={cell:s});var u,d={};_.each(l,function(e,t){var r;"d"!==t&&"u"!==t&&(r=$.getBorderName(t),null===e?d[r]=ve:me(e)?d[r]=e:i[t]&&(d[r]=ve))}),_.isEmpty(d)||((u=t.clone()).borderAttrs=d,m.push(u)),e&&(u=new we(t.start),t.startsAt(e.a)||(u.rangeMode=ze.SKIP,u.fillData={v:e.v,f:e.f},v.push(u)),new ke(t.intersect(p)).difference(u).forEach(function(e){e.rangeMode=ze.SKIP,e.fillData={v:null,f:null},v.push(e)}))},{cycles:e})});return(a=(a=a.then(function(){return T.generateRangeOperations(e,v)})).then(function(){return T.iterateArraySliced(m,function(e){return T.generateBorderOperations(n,e,e.borderAttrs)})})).done(function(){e.appendOperations(n),e.prependOperations(n,{undo:!0})})}),this.generateAutoFormulaOperations=function(e,n,r){var a=I.createCellTokenArray(),l=[];function t(e,t){var r;T.areRangesBlank(e)||(r=x.formulaGrammarOP.generateAutoFormula(x,n,e,t),a.parseFormula(We.OP,r,t),e=a.interpretFormula("val",t,t),r={address:t.clone(),v:e.value,f:r},(e=e.format?p(t,e.format):null)&&(r.format=e),l.push(r))}function o(e,t,r){r=T.createLinearCellIterator(new xe(e,t),r).find(function(e){return e.blank});return r?r.address:null}var i=r.singleRow(),s=null,u=null;if(i&&!T.findFirstCell(r,{type:"value"})){var s=r,i=!1,d=D(r.start,Ce.UP).range;if(!d)return T.createResolvedPromise(r);r=we.fromIndexes(d.start[0],d.start[1],r.end[0],r.end[1])}if(i){if(!(u=o(r.end[0],Math.max(r.start[1],r.end[1]),Ce.RIGHT)))return T.createResolvedPromise(r);t(we.fromIndexes(r.start[0],r.start[1],Math.min(r.end[0],u[0]-1),r.end[1]),u);var c=u[0]<=r.end[0]?r.end[0]:r.end[0]+1;s=we.fromIndexes(r.start[0],r.start[1],c,r.end[1])}else{var f=w.createIndexIterator(r.colInterval()).reduce(-1,function(e,t){t=o(t,r.start[1],Ce.DOWN);return t?Math.max(e,t[1]):e}),c=r.end[1]+(f<=r.end[1]?0:1),u=new xe(r.start[0],Math.max(f,r.end[1])),g=we.fromIndexes(r.start[0],r.start[1],r.start[0],c-1);w.createIndexIterator(r.colInterval()).forEach(function(e){g.setBoth(e,!0),t(g,new xe(e,Math.max(f,r.end[1])))}),s=s||we.fromIndexes(r.start[0],r.start[1],r.end[0],c)}return T.generateCellsOperations(e,l).then(_.constant(s))},this.generateSortOperations=Ae.profileMethod("$badge{CellCollection} generateSortOperations",function(t,a,e,n){if(Ae.trace("range="+a),I.mergeCollection.coversAnyMergedRange(a))return $.makeRejected("sort:merge:overlap");var l=e===Re.VERTICAL,e=(l?b:R).getVisibleIntervals(a.interval(!l)),r=e.indexIterator().map(function(e){var t=new xe(e,e);return{fromIndex:e,values:n.map(function(e){return t.set(e.index,l),this.getValue(t)},this)}},this),o=n.map(function(e){return{nullMode:e.descending?Xe.NULL_MIN:Xe.NULL_MAX}});r.sort(function(e,t){return ee(e.values,t.values,function(e,t,r){t=Qe(e,t,o[r]);return n[r].descending?-t:t})});var i=e.indexIterator();if(0===(r=r.filter(function(e){return e.toIndex=i.next().value,e.fromIndex!==e.toIndex})).length)return J();var s=new qe(I,t,{skipShared:!0}),u=I.hlinkCollection,d=new ke,c=new ie,f=u.getLinkRanges(a,Te.CONTAIN).filter(function(e){return e.singleLine(!l)}).group(function(e){return e.start.get(!l)}),g=I.noteCollection,v=new Oe,m=new Oe,p=I.commentCollection,h=new Oe,y=new Oe,C=I.createOperationGenerator({applyImmediately:!0}),e=this.generateBreakSharedFormulaOperations(C,a);return(e=(e=(e=(e=(e=(e=e.then(function(){r.forEach(function(r){var t=new xe(r.fromIndex,r.fromIndex),n=new xe(r.toIndex,r.toIndex);a.indexIterator(l).forEach(function(e){t=t.clone().set(e,l),n=n.clone().set(e,l);e=T.getCellModel(t),e=e?{v:e.v,f:e.getFormula(We.OP,n),s:O(e)}:{u:!0};s.insertCell(n,e),g.getByAddress(t)&&(v.push(t),m.push(n)),p.getByAddress(t)&&(h.push(t),y.push(n),v.push(t),m.push(n))});var e=f[r.fromIndex];e&&(d.append(e),e.forEach(function(e){var t=e.clone().setBoth(r.toIndex,!l);c.getOrConstruct(e.url,ke).push(t)}))})})).then(function(){if(!d.empty())return u.generateHlinkOperations(C,d,"")})).then(function(){return t.appendOperations(C),s.finalizeOperations()})).then(function(){return T.asyncForEach(c.entryIterator(),function(e){return u.generateHlinkOperations(t,e.value,e.key)})})).then(function(){if(0<v.length)return I.noteCollection.generateMoveAnchorOperations(t,v,m)})).then(function(){if(0<h.length)return I.commentCollection.generateMoveAnchorOperations(t,h,y)})).done(function(){t.appendOperations(C,{undo:!0})})}),this.generateCutPasteOperations=function(t,e,r,n){var a=new He(x),n=new et(e,r,n,{afterChange:!0});return x.generateUpdateTaskOperations(a,n).then(function(){return a.flushOperations()}).done(function(e){t.appendOperations(e.generator),t.prependOperations(e.generator,{undo:!0})}).always(function(){a.destroy()})},this.changeHook=this.createHook(),this.moveHook=this.createHook(),I.waitForImportSuccess(function(){this.listenTo(x,"transform:sheets",function(e,t){r.forEach(function(e){e.t&&e.t.transformSheets(t)})})},this),this.listenTo(x,"change:locale",function(){r.forEach(function(e){e.updateParsedFormat(C),e.updateDisplayString(A)})})})});