define("io.ox/office/spreadsheet/model/formula/deps/dependencymanager",["exports","io.ox/office/tk/types","io.ox/office/tk/containers","io.ox/office/tk/utils","io.ox/office/tk/utils/logger","io.ox/office/tk/object/baseobject","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/operation/builder","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/deps/dependencyutils","io.ox/office/spreadsheet/model/formula/deps/timerhelper","io.ox/office/spreadsheet/model/formula/deps/formuladescriptor","io.ox/office/spreadsheet/model/formula/deps/sheetdescriptor","io.ox/office/spreadsheet/model/formula/deps/formuladictionary","io.ox/office/spreadsheet/model/formula/deps/pendingcollection"],function(e,t,r,C,n,R,x,o,a,i,L,N,l,u,c,s){"use strict";var I=t.toBoolean,O=r.KeySet,P=r.UidSet,U=r.TMap,K=n.LogLevel,V=o.ErrorCode,j=o.isErrorCode,B=o.AddressArray,X=o.RangeArray,Y=a.OperationBuilder,f=i.getCellValue,H=L.depsLogger,q=L.FormulaSet,z=L.getCellKey,G=l.FormulaDescriptor,J=u.SheetDescriptor,Q=c.FormulaDictionary,W=s.PendingCollection,d=O.extend(function(){O.call(this)});function Z(){this.formulaSet=new q,this.cellFormulaSet=new q,this.modelFormulasMap=new U,this.resultsMap=new U,this.referenceCycles=[],this.hasErrors=!1}d.prototype.insert=function(e,t,r){return O.prototype.insert.call(this,{address:e,key:e.key,value:f(t),time:r})},Z.prototype.insertFormula=function(e){return this.formulaSet.insert(e),e.tokenModel?this.modelFormulasMap.getOrConstruct(e.sheetUid,q).insert(e):e.cellAddress?this.cellFormulaSet.insert(e):H.error("$badge{ResultCollection} insertFormula: unknown formula type"),this},Z.prototype.createResultSet=function(e){return this.resultsMap.getOrConstruct(e,d)},Z.prototype.getResult=function(e,t){return this.resultsMap.with(e,function(e){return e.get(t.key)})||null},e.DependencyManager=R.extend({constructor:function(d){R.call(this);var c=this,t=d.docApp,f=this.member(new N),g=new q,r=0,h=new U,n=new Q(d),m=new W,p=null,v=!0,l=!1,o=!1;function y(){return v&&d.getDocumentAttribute("calcOnLoad")}var a=0<x.MAX_FORMULA_COUNT?function(){return r<=x.MAX_FORMULA_COUNT||(c.disconnect(),c.trigger("recalc:overflow"),v||(o=!0),l=!1)}:_.constant(!0);function M(e){return r+=1,!!a()&&(g.insert(e),h.get(e.sheetUid).insertFormula(e),n.insertFormula(e),!0)}function b(t){return!!g.remove(t)&&(--r,h.with(t.sheetUid,function(e){e.removeFormula(t)}),n.removeFormula(t),!0)}function s(e){return!!b(e)&&(e.refreshReferences(),M(e))}var w,i=H.profileMethod("$badge{DepManager} registerTokenModel",function(e,t){t&&t.update&&u(e),m.registerTokenModel(e)}),u=H.profileMethod("$badge{DepManager} unregisterTokenModel",function(t){m.unregisterTokenModel(t),h.with(t.sheetModel.uid,function(e){e.modelFormulasMap.with(t.uid,function(e){e.forEach(b)})})}),F=H.profileMethod("$badge{DepManager} registerSheetModel",function(e){H.log(function(){return'sheet="'+e.getName()+'" key='+e.uid}),h.insert(e.uid,new J(e)),m.registerSheetModel(e)}),A=H.profileMethod("$badge{DepManager} unregisterSheetModel",function(e){H.log(function(){return'sheet="'+e.getName()+'" key='+e.uid}),m.unregisterSheetModel(e);var t=h.remove(e.uid);t&&t.formulaSet.forEach(b)}),E=H.profileMethod("$badge{DepManager} processPendingCollection",function(){return f.iterate(m.changedSheetMap.valueIterator(),function(a){var e=a.sheetModel,i=e.uid,l=e.cellCollection,r=a.dirtyRanges=a.dirtyRanges.merge(),t=a.dirtyFormulaCells,u={};function n(e){return f.iterate(e.valueIterator(),function(e){e=z(i,e);g.with(e,b)})}function o(e,o){return f.iterate(e,function(e){var t=z(i,e);if(!(t in u)){u[t]=!0;var r=l.getTokenArray(e);if(r){var n=new G(t,r.tokenArray,r.refAddress,e,r.matrixRange),t=o||a.recalcAddressSet.has(e);if(t||!v||r.matrixRange||function(e,t){var r=l.getValue(t);if(null!==r){if(j(r))return 1;e=e.compileFormula().root.resource;switch(e?e.valType:"any"){case"num":case"date":return"number"==typeof r;case"str":case"comp":return"string"==typeof r;case"bool":return"boolean"==typeof r;case"err":return j(r)}return 1}}(r.tokenArray,e)||(H.warn("recalculating all formulas caused by wrong result type in "+n),t=o=m.recalcAll=!0),t||!n.isFixed()){if(!M(n))return C.BREAK}else H.log("skipped fixed formula "+n);t&&a.recalcAddressSet.insert(e)}}})}a.initialUpdate&&(H.log(function(){return'collecting all formulas of new sheet "'+e.getName()+'"...'}),r=a.dirtyRanges=r.append(l.getUsedRange()).merge(),e.cfRuleCollection.createModelIterator().forEach(a.registerTokenModel,a),a.initialUpdate=!1);var c=n(t);c=(c=(c=c.then(function(){var t=h.get(i,null);return f.iterate(r.valueIterator(),function(e){return n(t.addressSet.findAddresses(e))})})).then(function(){return o(t.valueIterator(),!0).done(function(){t.clear()})})).then(function(){return o(l.createCellIterator(r,{type:"formula"}).pluckIterator("address"),y()).done(function(){r.clear()})});var s=a.dirtyModelSet;return c=!s.empty()?c.then(function(){return f.iterate(s.valueIterator(),function(r){var n=r.uid,o=r.getRefAddress();r.createTokenArrayIterator().forEach(function(e){var t=n+"!"+e.key,e=new G(t,e.value,o,null,null,r);e.isFixed()||M(e)})})}):c})}),S=H.profileMethod("$badge{DepManager} recalcDirtyFormulas",function(){if(m.recalcAll)return f.iterate(d.createSheetIterator(),function(t){var e=t.cellCollection.createCellIterator(d.getSheetRange(),{type:"formula"});return f.iterate(e,function(e){c.getCellValue(t,e.address)})});var i=n.clone(),e=c.createResolvedPromise(null);function l(e){i.removeFormula(e),p.insertFormula(e)}function u(e){e&&e.forEach(l)}return m.changedNamesSet.empty()||(e=e.then(H.profileMethod("collecting formulas for dirty names...",function(){return f.iterate(m.changedNamesSet.keyIterator(),function(e){u(i.findFormulasForName(e))})}))),e=(e=!m.changedTablesSet.empty()?e.then(H.profileMethod("collecting formulas for dirty table ranges...",function(){return f.iterate(m.changedTablesSet.keyIterator(),function(e){u(i.findFormulasForTable(e))})})):e).then(function(){if(!p.formulaSet.empty())return H.takeTime("refreshing formulas for dirty names and tables...",function(){return f.iterate(p.formulaSet.valueIterator(),s)})}),e=(e=(e=(e=!m.changedLabelsSet.empty()?e.then(H.profileMethod("refreshing formulas for dirty name labels...",function(){return f.iterate(h.valueIterator(),function(e){return f.iterate(m.changedLabelsSet.valueIterator(),function(t){return e.missingNamesMap.with(t.getKey(),function(e){return f.iterate(e.valueIterator(),function(e){p.formulaSet.has(e)||(s(e),e.references.containsName(t)&&l(e))})})})})})):e).then(H.profileMethod("collecting initially dirty formulas...",function(){return f.iterate(h.valueIterator(),function(t){(v||m.recalcVolatile)&&u(t.recalcAlwaysSet),v&&u(t.recalcOnceSet);var r=t.sheetModel,n=r.uid,e=m.getPendingSheetData(r),o=e?e.recalcAddressSet.clone():new O,e=e?e.dirtyValueCells.reject(function(e){if(g.hasKey(z(n,e)))return o.insert(e),!0}):new B;if(!o.empty()||!e.empty()){var a=X.mergeAddresses(e);H.log(function(){if(!o.empty()){var e=o.appendTo(new B);return"outdated formula results in "+r.getName()+"!"+X.mergeAddresses(e)}}),H.log(function(){return a.empty()?void 0:"dirty cells in "+r.getName()+"!"+a});e=c.createResolvedPromise(null);return o.empty()||(e=e.then(function(){return f.iterate(o.valueIterator(),function(e){e=z(n,e);t.formulaSet.with(e,l)})})),e=!a.empty()?e.then(function(){return f.iterate(a.valueIterator(),function(e){u(i.findFormulasForRange(n,e))})}):e}}).done(function(){H.logFormulaSet(p.formulaSet)})}))).then(function(){var r=p.cellFormulaSet.clone();return f.loop(function(e){return r.empty()?C.BREAK:H.takeTime("collecting dependent formulas for chain depth: "+(e+1)+"...",function(){var t=new q;return f.iterate(r.valueIterator(),function(e){e=i.findFormulasForFormula(e);if(e)return f.iterate(e.valueIterator(),function(e){p.formulaSet.has(e)||(l(e),t.insert(e))})}).done(function(){r=t,H.logFormulaSet(t)})})})})).then(H.profileMethod("recalculating all dirty formulas...",function(){return f.loop(function(){var e=p.cellFormulaSet.getAny();if(!e)return C.BREAK;c.getCellValue(e.sheetModel,e.cellAddress)})}))}),D=H.profileMethod("$badge{DepManager} sendFormulaResults",function(){var e=c.createResolvedPromise(),n=new Y(d);return(e=(e=(e=e.then(function(){return d.waitForActionsProcessed()})).then(H.profileMethod("building operations...",function(){return p.resultsMap.forEach(function(e,t){var t=h.get(t).sheetModel,r=n.createSheetCache(t,{skipUndo:!0,filter:!0}).cellCache;e.forEach(function(e){r.changeCell(e.address,{v:e.value})})}),n.flushOperations()}))).then(H.profileMethod("applying and sending operations...",function(e){t.isEditable()&&t.isLocallyModified()&&d.sendOperations(e.generator),o=p.hasErrors;try{d.invokeOperationHandlers(e.generator)}catch(e){H.exception(e),o=!0}}))).always(function(){n.destroy()}),e.done(H.profileMethod("updating models with token arrays...",function(){var n=new U;function r(r,e){e.forEach(function(e){var t=e.tokenModel;n.getOrConstruct(r,P).insert(t),e.tokenArray.clearResultCache()})}m.recalcAll?h.forEach(function(e,t){e.modelFormulasMap.forEach(function(e){r(t,e)})}):p.modelFormulasMap.forEachKey(r),n.forEach(function(e){e.forEach(function(e){e.refreshFormulas()})})})),e}),k=function(){var t=null,r=!0,n=null,o=null;function a(){t&&(H.log("cancelling update cycle"),t.abort())}c.on("recalc:overflow",a);var i=c.debounce(function(){p=new Z,l=!0;var e=r?L.IMPORT_UPDATE_DELAY:0;return t=c.executeDelayed(function(){c.trigger("recalc:start")},e),r=!1,(t=(t=t.then(function(){return d.waitForActionsProcessed()})).then(H.profileMethod("$badge{DepManager} dependency update cycle",function(){var e=E();return e=(e=e.then(S)).then(D)},K.INFO))).always(function(){l=!1}),t.done(function(){var e=p.referenceCycles;m=new W,v=!1,t=p=null,c.trigger("recalc:end",e),n&&n.resolve()}),t.fail(function(){t=null,c.trigger("recalc:cancel")}),t},{delay:L.UPDATE_DEBOUNCE_DELAY});return function(e){return m?(e&&e.continue||a(),e&&e.priority&&f.setPriority("high"),n||(n=$.Deferred(),(o=c.createAbortablePromise(n)).done(function(){f.setPriority("low")}),o.always(function(){n=null})),m.recalcVolatile=I(e&&e.volatile,!0),t||i(),o):c.createResolvedPromise()}}();function T(e,t,r,n,o){var a=_.now();H.log(function(){return"calculating formula in cell "+e.getName()+"!"+n});var i=n.clone();i.sheetUid=e.uid,i.sheet=e.getIndex(),w.push(i);t=t.interpretFormula(o?"mat":"val",r,o?r:n,{matrixRange:o,recalcDirty:!0});"circular"===t.code?(H.warn(function(){return"reference cycle found: "+w.map(function(e){return d.getSheetName(e.sheet)+"!"+e}).join()}),p.referenceCycles.push(w.clone())):"valid"!==t.type&&(p.hasErrors=!0),w.pop();var l=p.createResultSet(e.uid),r=n.key;if(l.hasKey(r))return null;e.cellCollection.setFormulaURL(n,t.url||null);var u=_.now()-a;if(o){var c=t.value,s=o.start[0],f=o.start[1];return o.addressIterator().forEach(function(e){var t=c.get(e[1]-f,e[0]-s,V.NA);l.insert(e,t,u)}),l.get(r,null)}return l.insert(n,t.value,u)}this.disconnect=function(){this.stopListeningTo(d),g.clear(),h.clear(),n.clear(),p=m=null},this.isConnected=function(){return null!==m},this.needsCalcOnLoad=function(){return o||l||y()},this.registerLinkModel=function(e){this.isConnected()&&(H.log(function(){return"$badge{DepManager} inserted source link "+L.getLinkLabel(e)}),i(e),this.listenTo(e,"change:sourcelinks",function(){i(e,{update:!0})}),k())},this.unregisterLinkModel=function(e){this.isConnected()&&(H.log(function(){return"$badge{DepManager} deleted source link "+L.getLinkLabel(e)}),this.stopListeningTo(e),u(e),k())},this.recalcFormulas=function(e){if(!this.isConnected())return this.createResolvedPromise();e&&e.all&&(m.recalcAll=!0);var t,r=k({continue:!m.recalcAll,priority:!0,volatile:I(e&&e.volatile,!0)});return e&&e.timeout&&(t=$.Deferred(),r.done(t.resolve.bind(t)),r.fail(t.reject.bind(t)),r.progress(t.notify.bind(t)),r=this.createAbortablePromise(t,function(){o=!0},e.timeout)),r},this.getCellValue=(w=new B,function(t,r){var e=t.uid,n={value:null,type:null,time:0},o=p.getResult(e,r);if(o)return n.value=o.value,n.type="cached",n;var a,i=t.cellCollection;return m.recalcAll?(a=i.getTokenArray(r,{fullMatrix:!0}),o=a?T(t,a.tokenArray,a.refAddress,r,a.matrixRange):null):(e=z(e,r),p.cellFormulaSet.with(e,function(e){o=T(t,e.tokenArray,e.refAddress,r,e.matrixRange),p.cellFormulaSet.remove(e)})),o?(n.value=o.value,n.type="calculated",n.time=o.time):(n.value=i.getValue(r),n.type="fixed"),n}),this.getMissingFunctionKeys=function(){var t=new U;return h.forEach(function(e){t.merge(e.missingFuncMap)}),t.keys()},d.waitForImportSuccess(function(){d.createSheetIterator().forEach(F),this.listenTo(d,"change:locale",function(){H.log("$badge{DepManager} Event: changed locale"),this.recalcFormulas({all:!0})}),this.listenTo(d,"insert:sheet:after",function(e,t,r){H.log(function(){return'$badge{DepManager} Event: inserted sheet "'+r.getName()+'"'}),F(r),k()}),this.listenTo(d,"delete:sheet:before",function(e,t,r){H.log(function(){return'$badge{DepManager} Event: deleted sheet "'+r.getName()+'"'}),A(r),k()}),this.listenTo(d,"move:sheets:before",function(){H.log("$badge{DepManager} Event: moved sheets"),k()}),this.listenTo(d,"rename:sheet",function(e,t,r){H.log(function(){return'$badge{DepManager} Event: changed sheet name to "'+r+'"'}),k()}),this.listenTo(d,"insert:name",function(e,t,r){H.log(function(){return"$badge{DepManager} Event: inserted "+L.getNameLabel(r)}),m.registerNameModel(r,!0,!0),k()}),this.listenTo(d,"delete:name",function(e,t,r){H.log(function(){return"$badge{DepManager} Event: deleted "+L.getNameLabel(r)}),m.unregisterNameModel(r),k()}),this.listenTo(d,"change:name",function(e,t,r,n){H.log(function(){return"$badge{DepManager} Event: changed "+L.getNameLabel(r)}),m.registerNameModel(r,n.formula,n.label),k()}),this.listenTo(d,"delete:table",function(e,t,r){H.log(function(){return"$badge{DepManager} Event: deleted "+L.getTableLabel(r)}),m.unregisterTableModel(r),k()}),this.listenTo(d,"change:table",function(e,t,r,n){switch(n){case"change:range":H.log(function(){return"$badge{DepManager} Event: changed target range of "+L.getTableLabel(r)}),m.registerTableModel(r),k();break;case"change:name":H.log(function(){return"$badge{DepManager} Event: changed name of "+L.getTableLabel(r)}),k()}}),this.listenTo(d,"change:cells",function(e,t){t.results||(H.log(function(){if(!t.valueCells.empty())return"$badge{DepManager} Event: changed values in "+t.sheetModel.getName()+"!"+X.mergeAddresses(t.valueCells)}),H.log(function(){if(!t.formulaCells.empty())return"$badge{DepManager} Event: changed formulas in "+t.sheetModel.getName()+"!"+X.mergeAddresses(t.formulaCells)}),m.registerDirtyCells(t.sheetModel,t)&&k())}),this.listenTo(d,"move:cells",function(e,t){H.log(function(){return"$badge{DepManager} Event: moved cells in "+t.sheetModel.getName()+"!"+t.transformer.dirtyRange}),m.moveDirtyCells(t.sheetModel,t.transformer),k()}),this.listenTo(d,"change:rows",function(e,t){t.visibility&&(H.log(function(){return"$badge{DepManager} Event: changed row visibility in "+t.sheetModel.getName()+"!"+t.intervals.join()}),k())}),this.listenTo(d,"insert:cfrule",function(e,t,r){H.log(function(){return"$badge{DepManager} Event: inserted "+L.getRuleLabel(r)}),i(r),k()}),this.listenTo(d,"delete:cfrule",function(e,t,r){H.log(function(){return"$badge{DepManager} Event: deleted "+L.getRuleLabel(r)}),u(r),k()}),this.listenTo(d,"change:cfrule",function(e,t,r){H.log(function(){return"$badge{DepManager} Event: changed "+L.getRuleLabel(r)}),i(r,{update:!0}),k()}),k()},this),this.registerDestructor(function(){g.clear(),h.clear(),n.clear()})}})});