define("io.ox/office/spreadsheet/model/formula/funcs/conversionfuncs",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/model/formula/funcs/types"],function(t,r,o,a,i,s,l,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var u=a.repeatString("0",255),f={Y:24,Z:21,E:18,P:15,T:12,G:9,M:6,k:3,h:2,da:1,e:1,d:-1,c:-2,m:-3,u:-6,n:-9,p:-12,f:-15,a:-18,z:-21,y:-24},m={Yi:80,Zi:70,Ei:60,Pi:50,Ti:40,Gi:30,Mi:20,ki:10},h=(n.prototype.toBase=function(t){return t*this.factor},n.prototype.toUnit=function(t){return t/this.factor},n);function n(t){this.factor=t}var c=(p.prototype.toBase=function(t){return(t+this.offset)*this.factor},p.prototype.toUnit=function(t){return t/this.factor-this.offset},p);function p(t,r){this.factor=t,this.offset=r}var e=new e.FunctionSpecBuilder("conversion"),v=new i.TMap,g=new i.TMap;function E(t,r,e,n){if(t.length>e)throw l.ErrorCode.NUM;if(o.isNumber(r)){if(n&&r<t.length||e<r)throw l.ErrorCode.NUM;t.length<r&&(t=(u+t).slice(-r))}return t}function w(t){if(!/^[01]{0,10}$/.test(t))throw l.ErrorCode.NUM;var r=0<t.length?parseInt(t,2):0;return 10===t.length&&/^1/.test(t)?r-1024:r}function d(t){if(!/^[0-7]{0,10}$/.test(t))throw l.ErrorCode.NUM;var r=0<t.length?parseInt(t,8):0;return 10===t.length&&/^[4-7]/.test(t)?r-1073741824:r}function y(t){if(!/^[0-9a-f]{0,10}$/i.test(t))throw l.ErrorCode.NUM;var r=0<t.length?parseInt(t,16):0;return 10===t.length&&/^[89a-f]/i.test(t)?r-1099511627776:r}function C(t,r){if(512<-t||511<t)throw l.ErrorCode.NUM;return t<0&&(t+=1024),E(t.toString(2),r,10,!0)}function M(t,r){if(536870912<-t||536870911<t)throw l.ErrorCode.NUM;return t<0&&(t+=1073741824),E(t.toString(8),r,10,!0)}function N(t,r){if(549755813888<-t||549755813887<t)throw l.ErrorCode.NUM;return t<0&&(t+=1099511627776),E(t.toString(16).toUpperCase(),r,10,!0)}function O(t,r,e){var n=g.getOrConstruct(r,i.TMap);n.has(t)&&s.globalLogger.error('duplicate measurement unit "'+r+'" in category "'+t+'"'),n.insert(t,e)}function U(o,t,i,r){a.splitTokens(t).forEach(function(e){var n;O(o,e,new h(i)),null!=r&&r.si&&(n=Math.pow(10,r.si),a.forEachInDict(f,function(t,r){return O(o,r+e,new h(i*Math.pow(n,t)))})),null!=r&&r.bin&&a.forEachInDict(m,function(t,r){return O(o,r+e,new h(i*Math.pow(2,t)))})})}function b(r,t,e,n){a.splitTokens(t).forEach(function(t){return O(r,t,new c(e,n))})}r.default={ARABIC:e.unary("val:num","val:str",{name:{ooxml:"_xlfn.ARABIC"},resolve:function(t){if(255<(t=t.replace(/^ +| +$/g,"")).length)throw l.ErrorCode.VALUE;var r=1;"-"===t[0]&&(r=-1,t=t.substr(1));t=a.parseRoman(t);return isFinite(t)?r*t:l.ErrorCode.VALUE.throw()}}),BASE:e.ternaryUniOpt1("val:str","val:int",{name:{ooxml:"_xlfn.BASE"},resolve:function(t,r,e){if(t<0||9007199254740991<t)throw l.ErrorCode.NUM;if(r<2||36<r)throw l.ErrorCode.NUM;if(o.isNumber(e)&&(e<0||255<e))throw l.ErrorCode.NUM;return E(t.toString(r).toUpperCase(),e,255)}}),BIN2DEC:e.unary("val:num","val:str",w),BIN2HEX:e.binaryOpt("val:str",["val:str","val:int"],function(t,r){return N(w(t),r)}),BIN2OCT:e.binaryOpt("val:str",["val:str","val:int"],function(t,r){return M(w(t),r)}),COLOR:e.genericFixed("val:num",3,4,{name:{ooxml:null,odf:"ORG.LIBREOFFICE.COLOR"},signature:["val:int","val:int","val:int","val:int"],resolve:function(t,r,e,n){if(t<0||255<t)throw l.ErrorCode.VALUE;if(r<0||255<r)throw l.ErrorCode.VALUE;if(e<0||255<e)throw l.ErrorCode.VALUE;if((n=n||0)<0||255<n)throw l.ErrorCode.VALUE;return 16777216*n+65536*t+256*r+e}}),CONVERT:e.ternary("val:num",["val:num","val:str","val:str"],function(t,r,e){g.empty()&&function(){var t=453.59237;U("mass","g",1,{si:1}),U("mass","u",1660538782e-33,{si:1}),U("mass","lbm",t),U("mass","ozm",t/16),U("mass","grain",t/7e3),U("mass","cwt shweight",100*t),U("mass","ton",2e3*t),U("mass","stone",14*t),U("mass","uk_cwt lcwt hweight",112*t),U("mass","uk_ton LTON brton",2240*t),U("mass","sg",14593.9029372064);var r=9460730472580800,e=.3048,n=.9144,o=1609.344,i=(u=(f=.0254)/6)/12,a=1/39.37*12*3;U("length","m",1,{si:1}),U("length","ang",1e-10,{si:1}),U("length","ly",9460730472580800,{si:1}),U("length","pc parsec",0x6da012f93c9a8c,{si:1}),U("length","in",f),U("length","ft",e),U("length","yd",n),U("length","ell",1.143),U("length","mi",o),U("length","pica",u),U("length","Picapt Pica",i),U("length","Nmi",1852),U("length","survey_mi",1609.3472186944375);var s=Math.pow(f,2);U("area","m2 m^2",1,{si:2}),U("area","ang2 ang^2",1e-20,{si:2}),U("area","ar",100),U("area","Morgen",2500),U("area","ha",1e4),U("area","ly2 ly^2",Math.pow(r,2)),U("area","in2 in^2",s),U("area","ft2 ft^2",Math.pow(e,2)),U("area","yd2 yd^2",Math.pow(n,2)),U("area","mi2 mi^2",Math.pow(o,2)),U("area","Picapt2 Picapt^2 Pica2 Pica^2",Math.pow(i,2)),U("area","Nmi2 Nmi^2",Math.pow(1852,2)),U("area","uk_acre",4840*Math.pow(n,2)),U("area","us_acre",4840*Math.pow(a,2));var l=Math.pow(f,3),u=Math.pow(e,3),a=492892159375e-17,f=.00056826125;U("volume","m3 m^3",1,{si:3}),U("volume","ang3 ang^3",1e-30,{si:3}),U("volume","l L lt",.001,{si:1}),U("volume","ly3 ly^3",Math.pow(r,3)),U("volume","in3 in^3",l),U("volume","ft3 ft^3",u),U("volume","yd3 yd^3",Math.pow(n,3)),U("volume","mi3 mi^3",Math.pow(o,3)),U("volume","Picapt3 Picapt^3 Pica3 Pica^3",Math.pow(i,3)),U("volume","Nmi3 Nmi^3",Math.pow(1852,3)),U("volume","bushel",2150.42*l),U("volume","MTON",40*u),U("volume","GRT regton",100*u),U("volume","tspm",5e-6),U("volume","tsp",a),U("volume","tbs",3*a),U("volume","oz",6*a),U("volume","cup",48*a),U("volume","pt us_pt",96*a),U("volume","qt",192*a),U("volume","gal",768*a),U("volume","barrel",32256*a),U("volume","uk_pt",f),U("volume","uk_qt",2*f),U("volume","uk_gal",8*f),f=3600,U("time","s sec",1),U("time","mn min",60),U("time","hr",f),U("time","d day",86400),U("time","yr",8766*f),U("speed","m/s m/sec",1,{si:1}),U("speed","m/h m/hr",1/f,{si:1}),U("speed","mph",o/f),U("speed","kn",1852/f),U("speed","admkn",1853.184/f),t=t*(o=9.80665)/1e3,U("force","N",1,{si:1}),U("force","dy dyn",1e-5,{si:1}),U("force","pond",o/1e3,{si:1}),U("force","lbf",t),U("pressure","Pa p",1,{si:1}),U("pressure","atm at",101325,{si:1}),U("pressure","mmHg",133.322,{si:1}),U("pressure","Torr",101325/760),U("pressure","psi",t/s),s=e*t*550,U("power","W w",1,{si:1}),U("power","PS",75*o),U("power","HP h",s),U("energy","J",1,{si:1}),U("energy","e",1e-7,{si:1}),U("energy","c",4.184,{si:1}),U("energy","cal",4.1868,{si:1}),U("energy","eV ev",1602176487e-28,{si:1}),U("energy","Wh wh",f,{si:1}),U("energy","HPh hh",s*f),U("energy","flb",e*t),U("energy","BTU btu",1055.05585262),U("magnetism","T",1,{si:1}),U("magnetism","ga",1e-4,{si:1}),U("temperature","K kel",1,{si:1}),b("temperature","C cel",1,273.15),b("temperature","F fah",5/9,459.67),U("temperature","Rank",5/9),b("temperature","Reau",5/4,218.52),U("information","bit",1,{si:1,bin:!0}),U("information","byte",8,{si:1,bin:!0})}();var n,o,r=g.get(r),i=g.get(e);if(!r||!i)throw l.ErrorCode.NA;if(r.forEach(function(t,r){if(i.has(r)){if(n)throw l.ErrorCode.NA;n=t,o=i.get(r)}}),!n||!o)throw l.ErrorCode.NA;return o.toUnit(n.toBase(t))}),"CONVERT.ODF":e.ternary("val:num",["val:num","val:str","val:str"],{name:{ooxml:null,odf:"ORG.OPENOFFICE.CONVERT"},hidden:!0}),DEC2BIN:e.binaryUniOpt("val:str","val:int",C),DEC2HEX:e.binaryUniOpt("val:str","val:int",N),DEC2OCT:e.binaryUniOpt("val:str","val:int",M),DECIMAL:e.binary("val:num",["val:str","val:int"],{name:{ooxml:"_xlfn.DECIMAL"},resolve:function(t,r){if(r<2||36<r)throw l.ErrorCode.NUM;if(!v.getOrCreate(r.toString(),function(){var t=r<=10?"0-"+(r-1):"0-9A-"+a.formatAlphabetic(r-10,a.AlphabeticMethod.DIGIT);return new RegExp("^["+t+"]+$","i")}).test(t))throw l.ErrorCode.NUM;t=parseInt(t,r);return isFinite(t)&&0<=t?t:l.ErrorCode.NUM.throw()}}),HEX2BIN:e.binaryOpt("val:str",["val:str","val:int"],function(t,r){return C(y(t),r)}),HEX2DEC:e.unary("val:num","val:str",y),HEX2OCT:e.binaryOpt("val:str",["val:str","val:int"],function(t,r){return M(y(t),r)}),OCT2BIN:e.binaryOpt("val:str",["val:str","val:int"],function(t,r){return C(d(t),r)}),OCT2DEC:e.unary("val:num","val:str",d),OCT2HEX:e.binaryOpt("val:str",["val:str","val:int"],function(t,r){return N(d(t),r)}),ROMAN:e.binaryUniOpt("val:str","val:int",function(t,r){if((r=r||0)<0||5<=r||t<0||3999<t)throw l.ErrorCode.VALUE;return a.formatRoman(t,r)})}});