define("io.ox/office/spreadsheet/model/formula/funcs/referencefuncs",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/model/cellmodel","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/dimension","io.ox/office/spreadsheet/model/formula/utils/matrix","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/funcs/types","io.ox/office/spreadsheet/model/formula/tokenarray"],function(e,r,l,i,v,u,m,E,c,o,d,f,t,a){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var y,C=Math.floor;(x=y=y||{}).EXACT="exact",x.LESS="less";var w={emptyParam:!0,blankCells:!(x.GREATER="greater"),acceptErrors:!0},n=new t.FunctionSpecBuilder("reference"),s=n.param("val:int",{mat:"pass"}),p=n.param("ref",{dep:"skip"}),h=n.param("ref:single",{dep:"skip"}),g=n.param("ref:multi",{dep:"skip"}),A=n.param("any",{mat:"pass"}),R=n.param("any",{dep:"skip"}),T=n.param("any",{dep:"skip",mat:"pass"}),x=n.param("any:lazy",{dep:"pass"}),t=n.param("any:lazy",{dep:"pass",mat:"forward"});function S(e,r,t,o){if(r<1||t<=r)throw v.ErrorCode.VALUE;return e.getOperand(r,o?"val:any":"any")}function M(r,t,e,o,a,n){function s(e){return e||v.ErrorCode.NA.throw()}if(1<(a?o.rows:o.cols))switch(e.type){case E.ContextType.MAT:var i=e.getMatrix(),i=a?i.toRowVector(0):i.toColVector(0);e=r.createOperand(i);break;case E.ContextType.REF:i=e.getRanges()[0].clone();i.setEnd(i.getStart(!a),!a),e=r.createOperand(i)}if(n===y.EXACT){var l=r.createScalarIterator(e,w),u=r.createScalarMatcher(t);return s(l.find(function(e){return u(e.value)}))}for(var c,d=function(s,e){switch(e.type){case E.ContextType.VAL:var r=e.getRawValue();return function(){return{value:r,offset:0}};case E.ContextType.MAT:var t=e.getMatrix();return function(e){return{value:t.getByIndex(e),offset:e}};case E.ContextType.REF:var o=s.convertToValueRange(e.getRanges()),i=s.getSheetModel(o.sheet1),l=i.cellCollection,u=o.toRange();return function(e,r,t){var o=u.addressAt(e),a=s.getCellValue(i,o);if(null!==a)return{value:a,offset:e};e=l.findFirstCell(u,{startAddress:o,skipStart:!0,type:m.CellType.VALUE});if(e){var n=u.indexAt(e);if(n<=t)return{value:s.getCellValue(i,e),offset:n}}n=l.findFirstCell(u,{startAddress:o,skipStart:!0,type:m.CellType.VALUE,reverse:!0});if(n){o=u.indexAt(n);if(r<=o)return{value:s.getCellValue(i,n),offset:o}}};default:E.throwEngineError("createNearestScalarResolver(): unknown operand type")}}(r,e),f=n===y.LESS?function(e){return r.compareScalars(e,t)<=v.CompareResult.EQUAL}:function(e){return r.compareScalars(e,t)>=v.CompareResult.EQUAL},p=0,h=(a?o.cols:o.rows)-1;p<=h;){var g=d(C((p+h)/2),p,h);if(!g)return s(c);f(g.value)?p=(c=g).offset+1:h=g.offset-1}return s(c)}function O(e,r,t,o,a){var n=t?o:a,s=t?a:o;switch(r.type){case E.ContextType.VAL:if(0!==n||0!==s)throw v.ErrorCode.NA;return r.getRawValue();case E.ContextType.MAT:var i=r.getMatrix();if(n>=i.rows()||s>=i.cols())throw v.ErrorCode.NA;return i.values()[n][s];case E.ContextType.REF:var l=r.getRanges()[0],i=e.getSheetModel(l.sheet1),l=l.start.clone();return l[0]+=s,l[1]+=n,e.getCellValue(i,l);default:E.throwEngineError("getScalarAt(): unknown operand type")}}function V(e,r,t,o,a,n){var s=t.getDimension({errorCode:v.ErrorCode.VALUE}),i=o?s.rows:s.cols;if(a<1||i<a)throw v.ErrorCode.NA;n=M(e,r,t,s,o,l.toBoolean(n,!0)?y.LESS:y.EXACT);return 1===a?n.value:O(e,t,o,a-1,n.offset)}r.default={ADDRESS:n.genericFixed("val:str",2,5,{signature:["val:int","val:int","val:int","val:bool","val:str"],resolve:function(e,r,t,o,a){var n="";if((t=this.isMissingOrEmptyOperand(2)?1:t)<1||4<t)throw v.ErrorCode.VALUE;o=this.isMissingOrEmptyOperand(3)||o;var s=new d.CellRef(0,0,0<t%2,t<=2),i=new u.Address(0,0);return o||s.absCol?s.col=r-1:r<0?(t=this.addressFactory.maxCol,s.col=t+r,i[0]=t):(s.col=r,i[0]=0),o||s.absRow?s.row=e-1:e<0?(r=this.addressFactory.maxRow,s.row=r+e,i[1]=r):(s.row=e,i[1]=0),this.checkCellRef(s),(n=l.isString(a)?(a=0<a.length&&!this.formulaGrammar.isSimpleSheetName(this.docModel,a,{range:!0,external:!0})?f.encodeComplexSheetName(a):a)+"!":n)+this.docModel.getFormulaGrammarUI(!o).formatReference(this.docModel,i,s)}}),AREAS:n.unary("val:num",p,function(e){return e.length}),CHOOSE:n.generic("any",2,{signature:[s,t],resolve:function(e){var r=this,t=this.getOperandCount();if(!E.isValType(this.contextType)&&E.isMatType(this.getOperand(0).type)||E.isMatType(this.contextType)&&!E.isValType(this.getOperand(0).type)){var o=this.getOperands(0).reduce(function(e,r){return c.Dimension.boundary(e,r.getDimension({errorCode:v.ErrorCode.NA}))},null);return this.aggregateMatrix(o,function(){return S(r,r.getOperand(0,"val:int"),t,!0)})}return S(this,e,t)}}),COLUMN:n.unaryOpt("val:num",h,{resolve:function(e){if(e&&E.isMatType(this.contextType)){o.ensureMatrixDim(1,e.cols());var t=e.start[0]+1;return new o.NumberMatrix(1,e.cols(),function(e,r){return t+r})}return(e?this.getMatrixAddress(e):this.getTargetAddress())[0]+1},relColRef:function(e){return 0===e}}),COLUMNS:n.unary("val:num",R,function(e){var r=e.getRawValue();switch(e.type){case E.ContextType.VAL:return v.isErrorCode(r)?r.throw():1;case E.ContextType.MAT:return r.cols();case E.ContextType.REF:return this.convertToRange(r).cols();default:E.throwEngineError("ReferenceFuncs.COLUMNS.resolve(): unknown operand type")}}),FORMULATEXT:n.unary("val:str",h,{name:{ooxml:"_xlfn.FORMULATEXT",odf:"FORMULA"},recalc:E.RecalcMode.ALWAYS,resolve:function(e){var r=e.start,e=this.getSheetModel(e.sheet1),e=this.getCellFormula(e,r);if(!e)throw v.ErrorCode.NA;r="="+e.formula;return e.matrix?"{"+r+"}":r}}),GETPIVOTDATA:n.generic("val:any",2,{hidden:!0,repeatParams:2}),HLOOKUP:n.genericFixed("any",3,4,{signature:["val",A,"val:int","val:bool"],resolve:function(e,r,t,o){return V(this,e,r,!0,t,o)}}),INDEX:n.genericFixed("any",2,4,{recalc:E.RecalcMode.ALWAYS,signature:[R,s,s,s],resolve:function(e,r,t,o){var a,n,s=l.isNumber(o)?o-1:0;if(s<0)throw v.ErrorCode.REF;o=i.block(function(){switch(e.type){case E.ContextType.VAL:if(0<s)throw v.ErrorCode.REF;return new c.Dimension(1,1);case E.ContextType.MAT:if(0<s)throw v.ErrorCode.REF;return(a=e.getRawValue()).dim();case E.ContextType.REF:if(!(n=e.getRawValue()[s]))throw v.ErrorCode.REF;if(!n.singleSheet())throw v.ErrorCode.VALUE;return c.Dimension.createFromRange(n);default:E.throwEngineError("function INDEX: invalid operand type")}});if(l.isNumber(t)||(1===o.rows?(t=r,r=1):t=0),r<0||r>o.rows||t<0||t>o.cols)throw v.ErrorCode.REF;if(a)return 0===r&&0===t?a:0===r?a.toColVector(t-1):0===t?a.toRowVector(r-1):a.values()[r-1][t-1];if(n){o=this.getSheetModel(n.sheet1);return 0<r&&(n=n.rowRange(r-1)),0<t&&(n=n.colRange(t-1)),this.isMatrixMode()&&n.single()?this.getCellValue(o,n.start):n}return e}}),INDIRECT:n.binaryOpt("ref",["val:str","val:bool"],{recalc:E.RecalcMode.ALWAYS,resolve:function(e,r){r=this.isMissingOrEmptyOperand(1)||r;var t=this.getRefSheetModel(),o=new a.TokenArray(t,E.FormulaType.LINK),t=r?E.GrammarType.UI_A1:E.GrammarType.UI_RC,r=this.getTargetAddress();o.parseFormula(t,e,r);r=o.resolveRangeList(r,r,{resolveNames:a.ResolveNamesMode.SIMPLE});return 1===r.length?r.first():v.ErrorCode.REF.throw()}}),LOOKUP:n.ternaryOpt1("any",["val",A,T],{recalc:E.RecalcMode.ALWAYS,resolve:function(e,r,t){E.isValType(r.type)&&v.throwErrorCode(r.getRawValue());var o=r.getDimension({errorCode:v.ErrorCode.VALUE}),a=o.rows<o.cols,n=null==t?void 0:t.getDimension({errorCode:v.ErrorCode.VALUE});if(n&&1<n.rows&&1<n.cols)throw v.ErrorCode.NA;e=M(this,e,r,o,a,y.LESS);if(t&&n)return O(this,t,1<n.cols||1===n.rows&&a,0,e.offset);o=(a?o.rows:o.cols)-1;return 0==o?e.value:O(this,r,a,o,e.offset)}}),MATCH:n.ternaryOpt1("val:num",["val",A,"val:num"],function(e,r,t){if(E.isValType(r.type))throw v.throwErrorCode(r.getRawValue()),v.ErrorCode.NA;var o=r.getDimension({errorCode:v.ErrorCode.VALUE});if(1<o.rows&&1<o.cols)throw v.ErrorCode.NA;t=!l.isNumber(t)||0<t?y.LESS:t<0?y.GREATER:y.EXACT;return M(this,e,r,o,1<o.cols,t).offset+1}),OFFSET:n.genericFixed("ref",3,5,{recalc:E.RecalcMode.ALWAYS,signature:[p,"val:int","val:int","val:int","val:int"],resolve:function(e,r,t,o,a){e=this.convertToRange(e,{errorCode:v.ErrorCode.VALUE});return e.start[0]+=t,e.start[1]+=r,e.end[0]+=t,e.end[1]+=r,this.isMissingOrEmptyOperand(4)||(e.end[0]=e.start[0]+a-1),this.isMissingOrEmptyOperand(3)||(e.end[1]=e.start[1]+o-1),this.addressFactory.isValidRange(e)?e:v.ErrorCode.REF.throw()}}),ROW:n.unaryOpt("val:num",h,{resolve:function(e){if(e&&E.isMatType(this.contextType)){o.ensureMatrixDim(e.rows(),1);var r=e.start[1]+1;return new o.NumberMatrix(e.rows(),1,function(e){return r+e})}return(e?this.getMatrixAddress(e):this.getTargetAddress())[1]+1},relRowRef:function(e){return 0===e}}),ROWS:n.unary("val:num",R,function(e){var r=e.getRawValue();switch(e.type){case E.ContextType.VAL:return v.isErrorCode(r)?r.throw():1;case E.ContextType.MAT:return r.rows();case E.ContextType.REF:return this.convertToRange(r).rows();default:E.throwEngineError("function ROWS: unknown operand type")}}),SHEET:n.unaryOpt("val:num",R,{name:{ooxml:"_xlfn.SHEET"},recalc:E.RecalcMode.ALWAYS,resolve:function(e){if(!e)return this.getRefSheet()+1;var r=e.getRawValue();if(E.isRefType(e.type))return this.convertToRange(r).sheet1+1;if(E.isValType(e.type)){r=this.docModel.getSheetIndex(this.convertToString(r));return r<0?v.ErrorCode.NA.throw():r+1}throw v.ErrorCode.NA}}),SHEETS:n.unaryOpt("val:num",g,{name:{ooxml:"_xlfn.SHEETS"},recalc:E.RecalcMode.ALWAYS,resolve:function(e){return e?e.sheets():this.docModel.getSheetCount()}}),SWITCH:n.generic("any",3,{name:{ooxml:"_xlfn.SWITCH",odf:null},signature:["val",x,x],resolve:function(e){for(var r=this.getOperandCount(),t=C((r-1)/2),o=0;o<t;o+=1){var a=this.getOperand(2*o+1,"val");if(this.equalScalars(e,a))return this.getOperand(2*o+2)}return this.getOperand(2*t+1)}}),VLOOKUP:n.genericFixed("any",3,4,{signature:["val",A,"val:int","val:bool"],resolve:function(e,r,t,o){return V(this,e,r,!1,t,o)}})}});