define("io.ox/office/spreadsheet/model/formula/funcs/textfuncs",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/locale/locale","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/mathutils","io.ox/office/spreadsheet/model/formula/funcs/types"],function(r,t,o,a,i,l,e,u,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var s=Math.floor,v=Math.round,c=Math.abs,f=String.fromCharCode,h={128:"€",138:"Š",150:"–",130:"‚",139:"‹",151:"—",131:"ƒ",140:"Œ",152:"˜",132:"„",142:"Ž",153:"™",133:"…",145:"‘",154:"š",134:"†",146:"’",155:"›",135:"‡",147:"“",156:"œ",136:"ˆ",148:"”",158:"ž",137:"‰",149:"•",159:"Ÿ"},d=a.generateArray(256,function(r){var t;return null!==(t=h[r])&&void 0!==t?t:f(r)}),E=a.reduceDict(h,o.newDict(),function(r,t,e){return r[t]=parseInt(e,10),r}),g=/[\x00-\x1f\x80-\x9f\xad]/g,m=/[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02B8\u02BB-\u02C1\u02D0-\u02D1\u02E0-\u02E4\u02EE\u0370-\u0373\u0376-\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0523]+/g,A="ศูนย์",C="หนึ่ง",p="เอ็ด",x=[null,C,"สอง","สาม","สี่","ห้า","หก","เจ็ด","แปด","เก้า"],L="สิบ",S="ยี่",y="ร้อย",O="พัน",T="หมื่น",N="แสน",U="ล้าน",b="บาท",R="ถ้วน",w="."+a.repeatString("0",127),I=new n.FunctionSpecBuilder("text"),n=I.param("any",{mat:"pass"});function V(r){return 0<r?w.slice(0,r+1):""}function F(r,t,e,n){n=u.dround(e,n,"round"),n=r.numberFormatter.formatValue(t,n).text;return n&&n.length<=255?n:l.ErrorCode.VALUE.throw()}function D(r,t,e){t=s(r/t)%10;return 0<t?x[t]+e:""}function B(r,t,e){var n="";n+=D(r,1e5,N),n+=D(r,1e4,T),n+=D(r,1e3,O),n+=D(r,100,y);var a=s(r/10)%10;return 1==a?n+=L:2==a?n+=S+L:3<=a&&(n+=x[a]+L),t&&1===r?n+=C:1==(r=r%10)?n+=p:2<=r&&(n+=x[r]),e?n+U:n}t.default={ASC:I.unaryStr({hidden:!0}),BAHTTEXT:I.unary("val:str","val:num",{name:{odf:"COM.MICROSOFT.BAHTTEXT"},resolve:function(r){var t=r<0,r=v(100*c(r)),e=s(r/100);if(r%=100,0===e&&0==r)return t?"ลบ"+A+b+"ถ้":A+b+R;var n="";if(0<e){for(var a=!1;0<e;)n=B(e%1e6,e<1e6,a)+n,e=s(e/1e6),a=!0;n+=b}return(n=t?"ลบ"+n:n)+(0<r?B(r,!0,!1)+"สตางค์":R)}}),CHAR:I.unary("val:str","val:int",function(r){return 1<=r&&r<=255?d[r]:l.ErrorCode.VALUE.throw()}),CLEAN:I.unaryStr(function(r){return r.replace(g,"")}),CODE:I.unary("val:num","val:str",function(r){var t;if(0===r.length)throw l.ErrorCode.VALUE;r=null!==(t=E[r[0]])&&void 0!==t?t:r.charCodeAt(0);return 1<=r&&r<=255?r:63}),CONCAT:I.generic("val:str",1,{name:{ooxml:"_xlfn.CONCAT",odf:null},signature:[n],resolve:function(){for(var e=this,r=[],t=0;t<arguments.length;t++)r[t]=arguments[t];return this.aggregateStrings(r,"",function(r,t){return e.concatStrings(r,t)},a.identity)}}),CONCATENATE:I.generic("val:str",1,{signature:["val:str"],resolve:function(){for(var r=[],t=0;t<arguments.length;t++)r[t]=arguments[t];return this.concatStrings.apply(this,r)}}),DBCS:I.unaryStr({name:{odf:"JIS"},hidden:!0}),DOLLAR:I.binaryOpt("val:str",["val:num","val:int"],function(r,t){if(127<(t=!o.isNumber(t)?2:t))throw l.ErrorCode.VALUE;var e=V(t),e=this.numberFormatter.getCurrencyFormat().formatCode.replace(/\.00/g,e);return F(this,e,r,t)}),EXACT:I.binaryUni("val:bool","val:str",function(r,t){return r===t}),FIND:I.ternaryOpt1("val:num",["val:str","val:str","val:int"],function(r,t,e){if(o.isNumber(e)||(e=1),this.checkStringIndex(e),--e>t.length-r.length)throw l.ErrorCode.VALUE;if((e=t.indexOf(r,e))<0)throw l.ErrorCode.VALUE;return e+1}),FINDB:I.ternaryOpt1("val:num",["val:str","val:str","val:int"],{hidden:!0,resolve:"FIND"}),FIXED:I.ternaryOpt2("val:str",["val:num","val:int","val:bool"],function(r,t,e){if(127<(t=!o.isNumber(t)?2:t))throw l.ErrorCode.VALUE;return F(this,(e?"0":"#,##0")+V(t),r,t)}),LEFT:I.binaryOpt("val:str",["val:str","val:int"],function(r,t){return o.isNumber(t)||(t=1),this.checkStringLength(t),a.unicodeSlice(r,0,t)}),LEFTB:I.binaryOpt("val:str",["val:str","val:int"],{hidden:!0,resolve:"LEFT"}),LEN:I.unary("val:num","val:str",function(r){return r.length}),LENB:I.unary("val:num","val:str",{hidden:!0,resolve:"LEN"}),LOWER:I.unaryStr(function(r){return r.toLowerCase()}),MID:I.ternary("val:str",["val:str","val:int","val:int"],function(r,t,e){return this.checkStringIndex(t),this.checkStringLength(e),r.substr(t-1,e).replace(/^[\udc00-\udfff]|[\ud800-\udbff]$/,"�")}),MIDB:I.ternary("val:str",["val:str","val:int","val:int"],{hidden:!0,resolve:"MID"}),NUMBERVALUE:I.ternaryOpt2("val:num",["val:str","val:str","val:str"],{name:{ooxml:"_xlfn.NUMBERVALUE"},resolve:function(r,t,e){if(0===(t=!o.isString(t)?i.LOCALE_DATA.dec:t).length)throw l.ErrorCode.VALUE;if(0===(e=!o.isString(e)?i.LOCALE_DATA.group:e).length)throw l.ErrorCode.VALUE;if((t=t[0])===(e=e[0]))throw l.ErrorCode.VALUE;if(0===r.length)return 0;t=r.split(t,3);if(2<t.length)throw l.ErrorCode.VALUE;var n=new RegExp(_.escapeRegExp(e),"g");if(2===t.length&&n.test(t[1]))throw l.ErrorCode.VALUE;var a,e=(t=t.map(function(r){return r.replace(n,"")})).join(i.LOCALE_DATA.dec),t=/%+/.exec(e);t&&(a=t[0],e=e.replace(a,"%"));e=this.numberFormatter.parseValue(e);if(!o.isNumber(e))throw l.ErrorCode.VALUE;return a&&1<a.length&&(e/=Math.pow(10,2*a.length-2)),e}}),PHONETIC:I.unary("val:str","ref:single",{name:{odf:null},hidden:!0}),PROPER:I.unaryStr(function(r){return r.replace(m,a.capitalizeFirst)}),REPLACE:I.genericFixed("val:str",4,4,{signature:["val:str","val:int","val:int","val:str"],resolve:function(r,t,e,n){return this.checkStringIndex(t),this.checkStringLength(e),a.replaceSubString(r,--t,t+e,n)}}),REPLACEB:I.genericFixed("val:str",4,4,{hidden:!0,signature:["val:str","val:int","val:int","val:str"],resolve:"REPLACE"}),REPT:I.binary("val:str",["val:str","val:int"],function(r,t){return this.repeatString(r,t)}),RIGHT:I.binaryOpt("val:str",["val:str","val:int"],function(r,t){return o.isNumber(t)||(t=1),this.checkStringLength(t),t?a.unicodeSlice(r,-t):""}),RIGHTB:I.binaryOpt("val:str",["val:str","val:int"],{hidden:!0,resolve:"RIGHT"}),ROT13:I.unaryStr({name:{ooxml:null,odf:"ORG.OPENOFFICE.ROT13"},resolve:function(r){return r.replace(/[a-zA-Z]/g,function(r){r=r.charCodeAt(0);return f(r<(r<91?78:110)?r+13:r-13)})}}),SEARCH:I.ternaryOpt1("val:num",["val:str","val:str","val:int"],function(r,t,e){if(o.isNumber(e)||(e=1),this.checkStringIndex(e),--e,/^\**$/.test(r)){if(t.length<=e)throw l.ErrorCode.VALUE;return e+1}t=t.slice(e);t=this.convertPatternToRegExp(r).exec(t);if(!t)throw l.ErrorCode.VALUE;return t.index+e+1}),SEARCHB:I.ternaryOpt1("val:num",["val:str","val:str","val:int"],{hidden:!0,resolve:"SEARCH"}),SUBSTITUTE:I.genericFixed("val:str",3,4,{signature:["val:str","val:str","val:str","val:int"],resolve:function(r,t,e,n){if(o.isNumber(n)&&n<=0)throw l.ErrorCode.VALUE;if(0===t.length)return r;var a=new RegExp(_.escapeRegExp(t),"g");if(!o.isNumber(n))return r.replace(a,e);a=r.split(a);return n<a.length?(a[n-1]+=e+a[n],a.splice(n,1),a.join(t)):r}}),T:I.unary("val:str","val",function(r){return o.isString(r)?r:""}),TEXT:I.binary("val:str",["val","val:str"],{recalc:e.RecalcMode.ONCE,resolve:function(r,t){var e=o.isString(r)?this.numberFormatter.convertScalarToNumber(r):null,r=this.numberFormatter.formatValue(t,null!=e?e:r,{uiGrammar:!0}).text;return null===r?l.ErrorCode.VALUE.throw():r}}),TEXTJOIN:I.generic("val:str",3,{name:{ooxml:"_xlfn.TEXTJOIN",odf:null},signature:["val:str","val:bool",n],resolve:function(o,i){for(var l=this,r=[],t=2;t<arguments.length;t++)r[t-2]=arguments[t];var u=0;return this.aggregateStrings(r,"",function(r,t,e,n){if(0===t.length)return r;var a=i?u<n?1:0:n-u,a=0<a?l.repeatString(o,a):"";return u=n,l.concatStrings(r,a,t)},function(r,t,e){return i?r:r+l.repeatString(o,e-u-1)})}}),TRIM:I.unaryStr(function(r){return r.replace(/^ +| +$/g,"").replace(/ {2,}/g," ")}),UNICHAR:I.unary("val:str","val:int",{name:{ooxml:"_xlfn.UNICHAR"},resolve:function(r){if(r<1||1114111<r)throw l.ErrorCode.VALUE;if(55296<=r&&r<=57343)throw l.ErrorCode.NA;if(64976<=r&&r<=65007)throw l.ErrorCode.NA;if(65534==(65534&r))throw l.ErrorCode.NA;return a.fromCodePoint(r)}}),UNICODE:I.unary("val:num","val:str",{name:{ooxml:"_xlfn.UNICODE"},resolve:function(r){return r?a.codePointAt(r,0):l.ErrorCode.VALUE.throw()}}),UPPER:I.unaryStr(function(r){return r.toUpperCase()}),USDOLLAR:I.binaryOpt("val:str",["val:num","val:int"],{name:{odf:null},hidden:!0,resolve:"DOLLAR"}),VALUE:I.unary("val:num","val",function(r){return o.isNumber(r)?r:o.isString(r)?this.convertToNumber(r):null===r?0:l.ErrorCode.VALUE.throw()})}});