define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["exports","io.ox/office/tk/utils","io.ox/office/tk/object/dobject","io.ox/office/editframework/model/formatter/presetformattable","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(e,l,r,t,o,a,n,s,i){"use strict";var u=r.DObject,c=t.PresetCodeId,p=o.ErrorCode,d=o.isErrorCode,f=o.Address,h=o.Range,m=o.Range3DArray,y=a.ContextType,v=a.InternalErrorCode,g=a.isValType,R=a.isMatType,O=a.isRefType,T=a.isAnyType,w=a.isInternalError,E=a.Dimension,x=a.CompareNullMode,A=a.equalScalars,N=a.compareScalars,F=a.scalarToString,k=a.isValidMatrixDim,M=a.Matrix,C=a.throwEngineError,S=a.FormulaErrorCode,I=a.FormulaError,D=a.formulaLogger,b=n.TokenType,P=s.Operand,V=s.OperandResolver,L=i.combineParsedFormats,U=i.FormulaContext;function j(e,r){if(O(r)&&!O(e)&&!T(e))throw new I("expected reference token",S.REFERENCE)}function z(e,r,t,o){var a=R(e)?new M(o):o;return D.info(function(){return"result: type="+r+" code="+t+" value="+F(a)}),{type:r,code:t,value:a}}var W=u.extend(function(e,r,t,o,a){u.call(this),this.docModel=e,this.rootNode=r,this.refAddress=t,this.targetAddress=o,this.refSheet=l.getIntegerOption(a,"refSheet",null),this.wrapReferences=a&&a.wrapReferences,this.recalcDirty=a&&a.recalcDirty,this.formulaContext=new U(e,o,a)});W.prototype.getResult=function(e,r){var t=function(){try{return this.resolveNode(this.rootNode,e,r)}catch(e){if(d(e))return this.createOperand(e);throw e}}.call(this),o=T(e)?t.type:e,a={value:function(){try{switch(o){case y.VAL:return t.getScalar(null,null);case y.MAT:return t.getMatrix();case y.REF:return t.getRanges();default:C('InterpreterInstance.getResult(): unknown context type: "'+o+'"')}}catch(e){if(d(e))return e;throw e}}.call()},n=t.format;n&&!n.isStandard()&&(a.format=n);n=t.url;return null!==n&&(a.url=n),a},W.prototype.resolveReference=function(e){e=e.getRange3D(this.refAddress,this.targetAddress,this.refSheet,this.wrapReferences);return e?new m(e):p.REF},W.prototype.resolveDefinedName=function(e,r,t){var o=this.docModel.resolveNameModel(e,this.refSheet);if(!o)return p.NAME;var a=this.formulaContext.getRefAddress(),e={refSheet:this.refSheet,recalcDirty:this.recalcDirty};return t&&(e.matrixRange=h.fromAddressAndSize(a,t.cols,t.rows)),R(r)&&!t&&(r=y.ANY),o.tokenArray.interpretFormula(r,f.A1,a,e).value},W.prototype.resolveTableRange=function(e){e=e.getRange3D(this.targetAddress);return e?new m(e):p.REF},W.prototype.createOperand=function(e,r){return!r&&e instanceof P?e:this.formulaContext.createOperand(e,r)},W.prototype.resolveOperandNode=function(e,r,t){var o=e.token,a=null,n=null;switch(D.log("> resolving operand token "+o+" with context type "+r),o.type){case b.LIT:a=(n=o.value)===p.REF?y.REF:y.VAL;break;case b.MAT:n=o.value,a=y.MAT;break;case b.REF:n=this.resolveReference(o),a=y.REF;break;case b.NAME:n=this.resolveDefinedName(o,r,t),a=y.ANY;break;case b.TABLE:n=this.resolveTableRange(o),a=y.REF;break;default:C('InterpreterInstance.resolveOperandNode(): unknown token type: "'+o.type+'"')}return j(a,r),this.createOperand(n)},W.prototype.getParsedFormat=function(e,r){var t=this.docModel.numberFormatter;if("infer"===r){for(var o=t.standardFormat,a=0;o&&a<e.size();a+=1)var n=e.get(a),n=n&&n.format||t.standardFormat,o=L(o,n);return o}switch(r){case"percent":return t.getPercentFormat({int:!0});case"currency":return t.getCurrencyFormat({red:!0});case"fraction":return t.getParsedFormat(c.FRACTION_LONG);case"date":return t.getSystemDateFormat();case"time":return t.getSystemTimeFormat();case"datetime":return t.getSystemDateTimeFormat()}},W.prototype.getOperand=function(r,t,o,a,n){var s=this.formulaContext;s.checkEvalTime();var e=function(){try{s.setMatrixPosition(a,n);var e=o.map(function(e,r){return e?s.convertOperandToValue(e,t[r].typeKey):null});return D.logTokens("  resolving with parameters",e),r.resolve.apply(s,e)}catch(e){if(d(e))return e;throw e}}();return this.createOperand(e)},W.prototype.resolveOperatorNode=function(o,a,n){if(o.error)throw o.error;var e=o.token;D.log("> processing operator "+e+" with "+o.operands.length+" parameters and context type "+a);var s=o.resource;if(!s)return this.createOperand(p.NAME);if(j(s.retType,a),!_.isFunction(s.resolve))return D.warn('$badge{InterpreterInstance} resolveOperatorNode: unsupported operator or function "'+e+'"'),this.createOperand(v.UNSUPPORTED);if(n&&!k(n))return this.createOperand(v.UNSUPPORTED);var i=new V,l=o.signature;l.forEach(function(e,r){var t=o.operands[r],r=R(a)&&e.preferMat?y.MAT:e.contextType,e=R(r)&&e.forwardDim;i.push(this.resolveNode.bind(this,t,r,e?n:null))},this);var u=l.map(function(e,r){return"any:lazy"===e.typeKey?null:i.resolve(r)});if(!n&&g(s.retType)){var t=R(a);if(t||s.allValType){try{u.forEach(function(e,r){e&&(t?g(l[r].baseType)&&!g(e.type):R(e.type))&&(e=e.getDimension({errorCode:p.VALUE}),n=E.boundary(n,e))})}catch(e){if(d(e))return this.createOperand(e);throw e}if(n){if(!k(n))return this.createOperand(v.UNSUPPORTED);a=y.MAT}}}var r=D.takeTime(s.key,function(){try{this.formulaContext.pushOperandResolver(i,a,n);var e,t=this.getOperand(s,l,u,0,0),r=s.retType;return R(r)&&g(t.type)&&(t=this.createOperand(new M(t.getRawValue()))),T(r)||r===t.type||O(r)&&g(t.type)&&d(t.getRawValue())||g(r)&&R(a)&&R(t.type)||C("InterpreterInstance.resolveOperatorNode(): "+s.key+": operator result type does not match operator return type"),n&&g(t.type)&&(D.info("  expand scalar result to "+n+" matrix"),e=new M(n.rows,n.cols,function(e,r){if(0===e&&0===r)return t.getRawValue();r=this.getOperand(s,l,u,e,r);if(g(r.type))return r.getRawValue();C("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")},this),t=this.createOperand(e)),t}finally{this.formulaContext.popOperandResolver()}}.bind(this)),e=s.format&&!R(a)?this.getParsedFormat(i,s.format):null;return e?this.createOperand(r,{format:e}):r},W.prototype.resolveNode=function(e,r,t){t=e.operands?this.resolveOperatorNode(e,r,t):this.resolveOperandNode(e,r,t);return D.log("< result of "+e+": "+t),t};e=e.FormulaInterpreter=u.extend(function(e){u.call(this),this.docModel=e,this.COMPARE_OPTIONS={withCase:e.docApp.isODF(),nullMode:x.CONVERT}});e.prototype.equalScalars=function(e,r){return A(e,r,this.COMPARE_OPTIONS)},e.prototype.compareScalars=function(e,r){return N(e,r,this.COMPARE_OPTIONS)},e.prototype.createWarnResult=function(e,r){var t=w(r)?r.value:r;return z(e,"warn",r.key,t)},e.prototype.createErrorResult=function(e,r){return z(e,"error",r,p.NA)},e.prototype.interpretTokens=D.profileMethod("$badge{FormulaInterpreter} interpretTokens",function(r,e,t,o,a){D.log("contextType="+r);o=new W(this.docModel,e,t,o,a);try{var n=R(r)?l.getOption(a,"matrixRange",null):null,s=n?E.createFromRange(n):null,i=o.getResult(r,s);return w(i.value)?this.createWarnResult(r,i.value):(i.type="valid",D.info(function(){return"result: type=valid value="+F(i.value)+" format="+i.format+" url="+i.url}),i)}catch(e){if(d(e))return this.createWarnResult(r,e);if(e instanceof I)return D.info('  error="'+e.message+'"'),this.createErrorResult(r,e.code);throw e}finally{o.destroy()}})});