var __extends=this&&this.__extends||function(){var o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])})(e,t)};return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}}();define("io.ox/office/spreadsheet/model/formula/parser/formulagrammar",["require","exports","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/object/dobject","io.ox/office/baseframework/utils/apputils","io.ox/office/editframework/model/formatter/autoformat","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/logger","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/parser/referencegrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/parser/rangelistparser"],function(e,t,a,r,o,T,n,i,s,p,R,x,E,l,f,S,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FormulaGrammar=void 0;var h="_xludf.",g=new r.TMap;function m(e){return e instanceof l.SheetRef?e:null==e?void 0:e.r1}function d(e){return e instanceof l.SheetRef||null==e?void 0:e.r2}function N(e){return new RegExp("^(?:"+e[0]+"(\\d*))?(?:"+e[1]+"(\\d*))?$","i")}var y,o=(y=o.DObject,__extends(A,y),A.get=function(e,t){var r=e.getResource(t),o=t!==x.GrammarType.OP&&t!==x.GrammarType.OP_OOX,n=t===x.GrammarType.UI_RC||t===x.GrammarType.EN_RC,t=r.uid+":"+(o?1:0)+(n?1:0);return g.getOrCreate(t,function(){return new A(r,o,n)})},A.prototype.isReservedSymbol=function(e,t){return this._isBooleanLiteral(t)||this._isReferenceSymbol(e,t)},A.prototype.isSimpleSheetName=function(e,t,r){t=this.SIMPLE_EXT_SHEET_NAME_RE.exec(t);return!!t&&(!(t[1]&&(null==r||!r.external))&&(!(t[3]&&(null==r||!r.range))&&(!this.isReservedSymbol(e,t[2])&&(!t[3]||!this.isReservedSymbol(e,t[3])))))},A.prototype.validateNameLabel=function(e,t){return 0===t.length?"name:empty":!this.VALID_NAME_RE.test(t)||!this.odf&&this._isBooleanLiteral(t)?"name:invalid":this._isReferenceSymbol(e,t)?"name:address":""},A.prototype.formatScalar=function(e){switch(i.getScalarType(e)){case i.ScalarTypeId.NUMBER:var t=e;return isFinite(t)?a.isZero(t)?"0":n.autoFormatNumber(t,{dec:this.DEC,stdLen:R.MAX_LENGTH_STANDARD_EDIT}).text:this.getErrorName(i.ErrorCode.NUM);case i.ScalarTypeId.STRING:return'"'+e.replace(/"/g,'""')+'"';case i.ScalarTypeId.BOOLEAN:return this.getBooleanName(e);case i.ScalarTypeId.ERROR:return this.getErrorName(e)||this.NA_ERROR;case i.ScalarTypeId.NULL:return"";default:return E.formulaLogger.warn("$badge{FormulaGrammar} formatScalar: unsupported scalar value type"),""}},A.prototype.formatGenericRange=function(e,t,r,o){if(this.REF_SYNTAX===x.RefSyntaxType.OF){var n=m(o),a=this._generateOFSheetPrefix(e,n);if(null===a)return this.REF_ERROR;n=d(o),n=n?this._generateOFSheetPrefix(e,n):"";if(null===n)return this.REF_ERROR;a=a+t;return(n||r)&&(a+=":"+n+(r||t)),a}o=this._generateSheetRangePrefix(e,o);return null===o?this.REF_ERROR:""+o+t+(r?":"+r:"")},A.prototype.formatReference=function(e,t,r,o){var n=this.RC_STYLE,a=this.PREFIX_CHARS,i=this.REF_ERROR;if(!this.UI&&n)return E.formulaLogger.error("$badge{FormulaGrammar} formatReference: R1C1 notation not supported in native grammar"),this.NA_ERROR;var s=r instanceof f.CellRef?r:null==r?void 0:r.r1,r=r instanceof f.CellRef||null==r?void 0:r.r2;if(this.REF_SYNTAX===x.RefSyntaxType.OF){if(!s)return"["+i+"]";var R=s.refText();m(o)||(R="."+R);var l="";return r&&(l=r.refText(),d(o)||(l="."+l)),"["+this.formatGenericRange(e,R,l,o)+"]"}if(!s)return this.odf?i:this.formatGenericRange(e,i,null,o);R=p.Range.fromAddresses(s.toAddress(),null==r?void 0:r.toAddress()),l="",i="";return s.absCol&&null!=r&&r.absCol&&e.addressFactory.isRowRange(R)?(l=n?s.rowTextRC(a,t):s.rowText(),n&&R.singleRow()&&s.absRow===r.absRow||(i=n?r.rowTextRC(a,t):r.rowText())):s.absRow&&null!=r&&r.absRow&&e.addressFactory.isColRange(R)?(l=n?s.colTextRC(a,t):s.colText(),n&&R.singleCol()&&s.absCol===r.absCol||(i=n?r.colTextRC(a,t):r.colText())):(l=n?s.refTextRC(a,t):s.refText(),r&&(i=n?r.refTextRC(a,t):r.refText())),this.formatGenericRange(e,l,i,o)},A.prototype.formatName=function(e,t,r,o){if(this.odf&&(r||o))return this.NA_ERROR;o=this._generateSheetRangePrefix(e,r,o);return null===o?this.REF_ERROR:o+t},A.prototype.formatMacro=function(e,t,r,o){if(this.odf&&(r||o))return this.NA_ERROR;var n=h.length<t.length&&a.stringStartsWith(t.toLowerCase(),h);return this.UI&&n?t=t.substr(h.length):this.UI||n||!this.functionMap.getKey(t,!1)||(t=h+t),this.formatName(e,t,r,o)},A.prototype.getBooleanName=function(e){return this.booleanMap.getName(e?"t":"f",this.UI)},A.prototype.getBooleanValue=function(e){e=this.booleanMap.getKey(e,this.UI);return e?"t"===e:null},A.prototype.getErrorName=function(e){return this.errorMap.getName(e.key,this.UI)},A.prototype.getErrorCode=function(e){e=this.errorMap.getKey(e,this.UI);return e?i.ErrorCode[e]:null},A.prototype.getOperatorName=function(e){return this.operatorMap.getName(e,this.UI)},A.prototype.getOperatorKey=function(e){return this.operatorMap.getKey(e,this.UI)},A.prototype.getFunctionName=function(e){return this.functionMap.getName(e,this.UI)},A.prototype.getFunctionKey=function(e){return this.functionMap.getKey(e,this.UI)},A.prototype.getTableRegionName=function(e){return this.regionMap.getName(e,this.UI)},A.prototype.getTableRegionKey=function(e){return this.regionMap.getKey(e,this.UI)},A.prototype.isSimpleTableColumn=function(e){return this.SIMPLE_TABLE_COLUMN_NAME_RE.test(e)},A.prototype.decodeTableColumn=function(e){return e.replace(/'(.)/g,"$1")},A.prototype.encodeTableColumn=function(e){return e.replace(this.TABLE_COL_ESCAPE_RE,"'$&")},A.prototype.generateAutoFormula=function(e,t,r,o){var n=this.getFunctionName(t);if(!r)return n+"()";t=new f.CellRef(r.start[0],r.start[1],!1,!1),r=r.single()?void 0:new f.CellRef(r.end[0],r.end[1],!1,!1);return n+"("+this.formatReference(e,o,{r1:t,r2:r})+")"},A.prototype.parseFormula=function(e,t,r,o){return(this._formulaParser||(this._formulaParser=u.createFormulaParser(this))).parse(e,t,r,o)},A.prototype.parseRangeList=function(e,t,r){return(this._rangeListParser||(this._rangeListParser=c.createRangeListParser(this))).parse(e,t,r)},A.prototype.formatRangeList=function(e,t,r){return(this._rangeListParser||(this._rangeListParser=c.createRangeListParser(this))).format(e,t,r)},A.prototype._isBooleanLiteral=function(e){return null!==this.booleanMap.getKey(e,this.UI)},A.prototype._isReferenceSymbol=function(e,t){if(0===t.length)return!1;if(e.addressFactory.parseAddress(t))return!0;var r=this.SIMPLE_RCREF_RE.exec(t)||(null===(r=this.SIMPLE_RCREF_EN_RE)||void 0===r?void 0:r.exec(t));if(!r)return!1;t=r[1]?parseInt(r[1],10)-1:0,r=r[2]?parseInt(r[2],10)-1:0;return e.addressFactory.isValidAddress(new s.Address(r,t))},A.prototype._encodeAbsSheetName=function(e,t,r){return t&&!this.isSimpleSheetName(e,t)&&(t=l.encodeComplexSheetName(t)),(r&&t?"$":"")+t},A.prototype._generateSheetRangePrefix=function(e,t,r){var o=r?"["+r.index+"]":"",n=m(t);if(n){var a=n.resolve(e,r);if(null===a)return null;t=d(t),r=t&&!n.equals(t)?t.resolve(e,r):"";if(null===r)return null;o+=this.odf?this._encodeAbsSheetName(e,a,n.abs):a,r&&(o+=":"+(this.odf?this._encodeAbsSheetName(e,r,t.abs):r)),this.odf||this.isSimpleSheetName(e,a)&&(!r||this.isSimpleSheetName(e,r))||(o=l.encodeComplexSheetName(o))}return o?o+"!":""},A.prototype._generateOFSheetPrefix=function(e,t){if(!t)return"";var r=t.resolve(e);return r?this._encodeAbsSheetName(e,r,t.abs)+".":null},A);function A(e,t,r){var o=y.call(this)||this,n=o.odf=e.fileFormat===T.FileFormatType.ODF;o.UI=t,o.REF_SYNTAX=n?t?x.RefSyntaxType.ODF_UI:x.RefSyntaxType.OF:x.RefSyntaxType.OOX,o.RC_STYLE=r,o.DEC=e.getDec(t);var a=o.SEP=e.getSeparator(t);o.TABLE_SEP=a,o.MAT_OPEN="{",o.MAT_ROW=n||t?"|":";",o.MAT_COL=n||t?";":",",o.MAT_CLOSE="}",o.PREFIX_CHARS=e.getRCPrefixChars(t);var i=o.booleanMap=e.booleanMap,s=o.errorMap=e.errorMap,R=o.regionMap=e.regionMap,l=o.operatorMap=e.operatorMap;o.functionMap=e.functionMap,o.ISECT_SPACE=" "===l.getName("isect",t),o.NA_ERROR=s.getName("NA",t),o.REF_ERROR=s.getName("REF",t),o.refGrammar=S.createReferenceGrammar(e,t,r);var p=o.refGrammar.sheetConfig,E=p.PATTERNS,f=E.TERMINATE_REF,u=E.NAME_INNER_CHAR_CLASS,c=E.DEFINED_NAME,h=_.escapeRegExp(a),g=_.escapeRegExp(o.TABLE_SEP),m="\\[\\]'#"+(t?"@":""),d="\\x00-\\x2B\\x2D-\\x2F\\x3A-\\x40\\x5B-\\x60\\x7B\\x7D\\x7E"+(","===a?a:""),A="([^"+d+"]+)",n="((?:[^"+m+"]|'.)+)",r="(?:"+A+"|\\["+n+"\\])",E="(["+S.WHITESPACE_CHARS+"]*)",a="(?:(["+S.WHITESPACE_CHARS+"]+)(?=\\[|\\]|"+g+(t?"|@":"")+"|$))?";o.SIMPLE_RCREF_RE=N(o.PREFIX_CHARS);e=e.getRCPrefixChars(!1);return o.SIMPLE_RCREF_EN_RE=o.PREFIX_CHARS!==e?N(e):void 0,o.SIMPLE_EXT_SHEET_NAME_RE=p.RE.SIMPLE_EXT_SHEET_NAME,o.VALID_NAME_RE=new RegExp("^"+c+"$","i"),o.TABLE_COL_ESCAPE_RE=new RegExp("["+m+"]","g"),o.SIMPLE_TABLE_COLUMN_NAME_RE=new RegExp("^[^"+d+"]+$","i"),o.RE={STRING_LIT:/^(".*?")+/,BOOLEAN_LIT:new RegExp("^"+i.getAllPattern(t)+f,"i"),ERROR_LIT:new RegExp("^"+s.getAllPattern(t)+"(?!"+u+")","i"),FRACTION_LIT:/^(\d+) (\d+)\/(0*[1-9]\d*)/,MATRIX_OPEN:new RegExp("^"+_.escapeRegExp(o.MAT_OPEN)),MATRIX_COL_SEPARATOR:new RegExp("^"+_.escapeRegExp(o.MAT_COL)),MATRIX_ROW_SEPARATOR:new RegExp("^"+_.escapeRegExp(o.MAT_ROW)),MATRIX_CLOSE:new RegExp("^"+_.escapeRegExp(o.MAT_CLOSE)),WHITESPACE:new RegExp("^["+S.WHITESPACE_CHARS+"]+"),SEPARATOR:new RegExp("^"+h),OPERATOR:new RegExp("^"+l.getAllPattern(t)),OPEN:/^\(/,CLOSE:/^\)/,TABLE_OPEN:new RegExp("^\\["+a),TABLE_CLOSE:new RegExp("^"+E+"(\\]|$)"),TABLE_SEPARATOR:new RegExp("^"+E+g+a),TABLE_SINGLE_REGION_NAME:new RegExp("^"+R.getAllPattern(t)+"(?=\\])","i"),TABLE_SINGLE_COLUMN_NAME:new RegExp("^"+n+"(?=\\])","i"),TABLE_SIMPLE_COLUMN_NAME:new RegExp("^"+A,"i"),TABLE_REGION_REF:new RegExp("^\\["+R.getAllPattern(t)+"\\]","i"),TABLE_COLUMN_REF:new RegExp("^\\["+n+"\\]","i"),TABLE_MIXED_COLUMN_REF:new RegExp("^"+E+r,"i"),TABLE_COLUMN_RANGE_REF:new RegExp("^\\["+n+"\\]:\\["+n+"\\]","i"),TABLE_MIXED_COLUMN_RANGE_REF:new RegExp("^"+E+r+":"+r,"i"),TABLE_THISROW_REF:/^@/},o}t.FormulaGrammar=o});