define("io.ox/office/spreadsheet/model/formula/parser/formulaparser",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/object/dobject","io.ox/office/editframework/model/formatter/numberparser","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,s,n,a,c,i){"use strict";var R=t.isNumber,h=t.toNumber,f=t.toBoolean,o=r.stringStartsWith,l=s.TArray,E=n.DObject,T=a.parseLeadingNumber,u=c.Matrix,x=c.SheetRef,p=c.RefSyntaxType,g=c.formulaLogger,m=i.TokenType,k=i.FixedToken,A=i.ScalarToken,C=i.MatrixToken,S=i.OperatorToken,N=i.FunctionToken,d=i.SeparatorToken,F=i.ParenthesisToken,O=i.ReferenceToken,L=i.DefNameToken,w=i.MacroToken,I=i.TableToken;function b(e,t){this.token=t,this.index=-1,this.text=e,this.start=0,this.end=0}b.fixed=function(e,t){return new b(e,new k(t,e))},b.scalar=function(e,t){return new b(e,new A(t))},b.operator=function(e,t){return new b(e,new S(t))},b.prototype.toString=function(){return this.token.toString()};var v=E.extend(function(e){E.call(this),this.grammar=e,this.RE=e.RE,this.refGrammar=e.refGrammar});v.prototype._parseNextToken=function(e){var t=this.RE,r=null,s=null;return(r=t.STRING_LIT.exec(e))?b.scalar(r[0],r[0].slice(1,r[0].length-1).replace(/""/g,'"')):(r=t.BOOLEAN_LIT.exec(e))?b.scalar(r[0],this.grammar.getBooleanValue(r[0])):(r=t.ERROR_LIT.exec(e))?b.scalar(r[0],this.grammar.getErrorCode(r[0])):(r=t.FRACTION_LIT.exec(e))?b.scalar(r[0],parseInt(r[1],10)+parseInt(r[2],10)/parseInt(r[3],10)):(r=t.WHITESPACE.exec(e))?b.fixed(r[0],m.WS):(r=t.SEPARATOR.exec(e))?new b(r[0],new d):(r=t.OPERATOR.exec(e))?b.operator(r[0],this.grammar.getOperatorKey(r[0])):(r=t.OPEN.exec(e))?new b(r[0],new F(!0)):(r=t.CLOSE.exec(e))?new b(r[0],new F(!1)):(r=t.MATRIX_OPEN.exec(e))?this._parseMatrixLit(e):(s=this.parseNextRefToken(e))?s:(r=T(e,{dec:this.grammar.DEC}))?b.scalar(r.text,r.number):(s=this.parseNextNameToken(e))?s:void 0},v.prototype._parseMatrixLit=function(e){var t=e,r="start",s=this.RE,n=null,a=[],c=null;function i(){return a.every(function(e,t){return 0===t||e.length===a[t-1].length})}for(;"end"!==r;){switch(r){case"start":(n=s.MATRIX_OPEN.exec(e))&&(a.push(c=[]),r="open");break;case"open":case"sep":(n=s.WHITESPACE.exec(e))||((n=s.FRACTION_LIT.exec(e))?(c.push(parseInt(n[1],10)+parseInt(n[2],10)/parseInt(n[3],10)),r="lit"):(n=T(e,{dec:this.grammar.DEC,sign:!0}))?(c.push(n.number),n=[n.text],r="lit"):(n=s.STRING_LIT.exec(e))?(c.push(n[0].slice(1,n[0].length-1).replace(/""/g,'"')),r="lit"):(n=s.BOOLEAN_LIT.exec(e))?(c.push(this.grammar.getBooleanValue(n[0])),r="lit"):(n=s.ERROR_LIT.exec(e))&&(c.push(this.grammar.getErrorCode(n[0])),r="lit"));break;case"lit":0===e.length?(n=this.autoCorrect&&i()?[""]:null,r="end"):(n=s.WHITESPACE.exec(e))||((n=s.MATRIX_ROW_SEPARATOR.exec(e))?(a.push(c=[]),r="sep"):(n=s.MATRIX_COL_SEPARATOR.exec(e))?r="sep":(n=s.MATRIX_CLOSE.exec(e))&&(i()||(n=null),r="end"))}if(!n)return null;e=e.substr(n[0].length)}return new b(t.substr(0,t.length-e.length),new C(new u(a)))},v.prototype.createReferenceToken=function(e,t,r){return!r&&this.extendSheet&&0<=this.refSheet&&(r={r1:new x(this.refSheet,!0)}),new b(e,new O(this.docAccess,t,r))},v.prototype.createNameToken=function(e,t,r){var s=!(r=!r&&this.extendSheet&&0<=this.refSheet&&this.docAccess.resolveName(this.refSheet,t)?new x(this.refSheet,!0):r)&&o(e,"[0]!")?{index:0}:void 0;return new b(e,new L(this.docAccess,t,r,s))},v.prototype.createFunctionToken=function(e,t,r){var s=r?null:this.grammar.getFunctionKey(t);return new b(e,s?new N(s):new w(this.docAccess,t,r))},v.prototype.createTableToken=function(e,t,r){return new b(e,new I(this.docAccess,t,r))},v.prototype.createNameOrTableToken=function(e,t,r){r=this.createNameToken(e,t,r);return r.token.resolveTable()?this.createTableToken(e,t):r},v.prototype.createSheetRef=function(e,t){return this.refGrammar.createSheetRef(this.docAccess,e,t)},v.prototype.createSheetRefs=function(e,t,r){return this.refGrammar.createSheetRefs(this.docAccess,e,t,r)},v.prototype.createCellRangeRefs=function(e,t,r){return this.refGrammar.createCellRangeRefs(this.docAccess,this.refAddress,this.wrapReferences,e,t,r)},v.prototype.createColRangeRefs=function(e,t,r){return this.refGrammar.createColRangeRefs(this.docAccess,this.refAddress,this.wrapReferences,e,t,r)},v.prototype.createRowRangeRefs=function(e,t,r){return this.refGrammar.createRowRangeRefs(this.docAccess,this.refAddress,this.wrapReferences,e,t,r)},v.prototype.parseNextRefToken=function(){return g.error("$badge{FormulaParserBase} parseNextRefToken: missing implementation"),null},v.prototype.parseNextNameToken=function(){return g.error("$badge{FormulaParserBase} parseNextNameToken: missing implementation"),null},v.prototype.parse=g.profileMethod("$badge{FormulaParser} parse",function(e,t,r,s){g.log(function(){return'formula="'+t+'"'}),this.docAccess=e,this.refAddress=r,this.refSheet=h(s&&s.refSheet,-1),this.wrapReferences=f(s&&s.wrapReferences),this.autoCorrect=f(s&&s.autoCorrect),this.extendSheet=f(s&&s.extendSheet),this.unqualifiedTables=f(s&&s.unqualifiedTables);for(var i=new l;0<t.length;){var n=this._parseNextToken(t)||b.fixed(t,m.BAD);i.push(n),t=t.substr(n.text.length)}g.logTokens("tokenize",i);var o=this.grammar.ISECT_SPACE;return i.forEachReverse(function(e,t){var r,s,n=e.token,a=i[t-1],c=i[t+1];n.type===m.OP&&"sub"===n.value&&c&&c.token.type===m.LIT&&(s=c.token.value,R(s)&&0<s&&((r=a&&a.token.type===m.WS?i[t-2]:a)&&!r.token.isType(m.OP,m.SEP,m.OPEN)||(e.token=new A(-s),e.text+=c.text,i.deleteAt(t+1)))),!o||n.type!==m.WS||0<=(s=e.text.indexOf(" "))&&a&&a.token.isType(m.REF,m.NAME,m.CLOSE)&&c&&c.token.isType(m.REF,m.NAME,m.OPEN,m.FUNC)&&(s+1<e.text.length&&(c=e.text.slice(s+1),i.insertAt(t+1,b.fixed(c,m.WS))),i.insertAt(t+1,b.operator(" ","isect")),0<s?(n.setValue(e.text.slice(0,s)),e.text=n.value):i.deleteAt(t))},this),g.logTokens("postprocess",i),i.forEach(function(e,t){e.index=t,e.start=0===t?0:i[t-1].end,e.end=e.start+e.text.length}),i});var B=v.extend(function(e){v.call(this,e)});B.prototype._parseTableRef=function(e,t){var r=this.RE,s=e;t&&(e=e.substr(t.text.length));var n=t?t.token:null,a=r.TABLE_OPEN.test(e),c=n?n.resolveTable():void 0;if(n&&a&&!c)return null;if(n&&!a&&c)return this.createTableToken(t.text,n.value);if(!a)return t;if(!(c=!n&&this.grammar.UI&&this.unqualifiedTables&&0<=this.refSheet?this.docAccess.resolveTableAt(this.refSheet,this.refAddress):c))return null;var i=this.grammar,o=this.autoCorrect,R="start",h=null,f={},l={};function E(){l[i.getTableRegionKey(h[1])]=!0,R="ref"}function T(e,t){R="col1Name"in f?(h=null,"end"):(f.col1Name=i.decodeTableColumn(e),f.col2Name=t?i.decodeTableColumn(t):null,"ref")}function u(){T(h[1],h[2])}function x(e){e&&h[1]&&(f.openWs=!0),T(h[2]||h[3],h[4]||h[5])}function p(){h[1]&&(f.closeWs=!0),o||0!==h[2].length||(h=null),R="end"}for(;"end"!==R;){switch(R){case"start":(h=r.TABLE_OPEN.exec(e))&&(h[1]&&(f.openWs=!0),R="open");break;case"open":(h=r.TABLE_CLOSE.exec(e))?p():(h=r.TABLE_SINGLE_REGION_NAME.exec(e))?E():(h=r.TABLE_SINGLE_COLUMN_NAME.exec(e))?u():(h=r.TABLE_REGION_REF.exec(e))?E():!this.grammar.UI&&(h=r.TABLE_COLUMN_RANGE_REF.exec(e))||!this.grammar.UI&&(h=r.TABLE_COLUMN_REF.exec(e))?u():this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))||this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_REF.exec(e))?x(!0):this.grammar.UI&&(h=r.TABLE_THISROW_REF.exec(e))&&(l.ROW=!0,R="row");break;case"ref":(h=r.TABLE_CLOSE.exec(e))?p():(h=r.TABLE_SEPARATOR.exec(e))&&(h[2]&&(f.sepWs=!0),R="sep");break;case"sep":(h=r.TABLE_REGION_REF.exec(e))?E():!this.grammar.UI&&(h=r.TABLE_COLUMN_RANGE_REF.exec(e))||!this.grammar.UI&&(h=r.TABLE_COLUMN_REF.exec(e))?u():(this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))||this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_REF.exec(e)))&&x();break;case"row":(h=r.TABLE_CLOSE.exec(e))?(p(),f.closeWs&&(h=null)):(h=r.WHITESPACE.exec(e))||((h=r.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))||(h=r.TABLE_MIXED_COLUMN_REF.exec(e)))&&x()}if(!h)return null;e=e.substr(h[0].length)}switch((l=_.keys(l)).length){case 0:break;case 1:f.regionSpec=l[0];break;case 2:if("HEADERS,DATA"===(l=l.join(","))||"DATA,HEADERS"===l)f.regionSpec="HEADERS,DATA";else{if("DATA,TOTALS"!==l&&"TOTALS,DATA"!==l)return null;f.regionSpec="DATA,TOTALS"}break;default:return null}s=s.substr(0,s.length-e.length);return this.createTableToken(s,c.name,f)},B.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,s=null;return(r=t.RANGE_REF.exec(e))&&(s=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(r[0],s):(r=t.RANGE_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,4,8))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.RANGE_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.CELL_REF.exec(e))&&(s=this.createCellRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.CELL_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,4))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.CELL_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.COLS_REF.exec(e))&&(s=this.createColRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.COLS_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,4,6))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COLS_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.COL_REF.exec(e))&&(s=this.createColRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.COL_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,4))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COL_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.ROWS_REF.exec(e))&&(s=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.ROWS_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,4,6))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROWS_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.ROW_REF.exec(e))&&(s=this.createRowRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.ROW_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,4))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROW_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRefs(r,1)):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRefs(r,1,!0)):void 0},B.prototype.parseNextNameToken=function(e){var t=this.RE,r=this.refGrammar.RE,s=null;return(s=r.FUNCTION_REF.exec(e))?this.createFunctionToken(s[0],s[1]):(s=r.FUNCTION_3D_REF.exec(e))?this.createFunctionToken(s[0],s[4],this.createSheetRef(s,1)):(s=r.NAME_3D_REF.exec(e))?this._parseTableRef(e,this.createNameToken(s[0],s[4],this.createSheetRef(s,1))):(s=r.NAME_REF.exec(e))?this._parseTableRef(e,this.createNameToken(s[0],s[1])):this.grammar.UI&&(s=t.TABLE_OPEN.exec(e))?this._parseTableRef(e,null):void 0};var y=v.extend(function(e){v.call(this,e)});y.prototype.createSheetRangeRefs=function(e,t){return{r1:x.create(this.docAccess,e[t+1],e[t+2],void 0,!!e[t]),r2:x.create(this.docAccess,e[t+4],e[t+5],void 0,!!e[t+3])}},y.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,s=null;return(r=t.RANGE_REF.exec(e))&&(s=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(r[0],s):(r=t.RANGE_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.RANGE_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,7,11))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.CELL_REF.exec(e))&&(s=this.createCellRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.CELL_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.CELL_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,7))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.COLS_REF.exec(e))&&(s=this.createColRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.COLS_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COLS_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,7,9))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.COL_REF.exec(e))&&(s=this.createColRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.COL_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COL_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,7))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.ROWS_REF.exec(e))&&(s=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.ROWS_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROWS_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,7,9))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.ROW_REF.exec(e))&&(s=this.createRowRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.ROW_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROW_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,7))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRefs(r,1)):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRangeRefs(r,1)):void 0},y.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(r[0],r[1]):(r=t.NAME_REF.exec(e))?this.createNameOrTableToken(r[0],r[1]):void 0};var U=v.extend(function(e){v.call(this,e)});U.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.CELL_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,1)):(r=t.CELL_3D_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,5),this.createSheetRefs(r,1)):(r=t.RANGE_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,1,5)):(r=t.RANGE_3D_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,5,9),this.createSheetRefs(r,1)):(r=t.RANGE_CUBE_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,5,13),this.createSheetRefs(r,1,9)):void 0},U.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(r[0],r[1]):(r=t.NAME_REF.exec(e))?this.createNameOrTableToken(r[0],r[1]):void 0},e.createFormulaParser=function(e){switch(e.REF_SYNTAX){case p.OOX:return new B(e);case p.ODF_UI:return new y(e);case p.OF:return new U(e)}throw g.error('$badge{FormulaParser} createFormulaParser: invalid reference syntax "'+e.REF_SYNTAX+'"'),new TypeError('invalid enumeration value "'+e.REF_SYNTAX+'"')}});