define("io.ox/office/spreadsheet/model/formula/parser/rangelistparser",["exports","io.ox/office/tk/types","io.ox/office/tk/object/dobject","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/model/formula/formulautils"],function(e,t,r,n,s,i,a){"use strict";var o=t.toString,R=t.toNumber,g=t.toBoolean,c=r.DObject,l=n.stringifyCol,h=n.stringifyRow,u=s.Range,f=i.RangeArray,p=a.SheetRef,d=a.RefSyntaxType,m=a.formulaLogger,_=c.extend(function(e){c.call(this),this.grammar=e,this.refGrammar=e.refGrammar,this.addrConfig=this.refGrammar.addrConfig,this.RE=this.refGrammar.RE});_.prototype._initDocAccess=function(e){this.docAccess=e,this.addressFactory=e.addressFactory,this.MAXCOL=this.addressFactory.maxCol,this.MAXROW=this.addressFactory.maxRow},_.prototype._parseSeparator=function(e){var t=this.RE,r=null;return(r=t.RL_SEP_WS.exec(e))?{sep:" ",text:r[0]}:this.extSep&&(r=t.RL_SEP_OTHER.exec(e))?{sep:r[0],text:r[0]}:null},_.prototype.getAddress=function(e,t){return this.addrConfig.getAddress(e,t,this.MAXCOL,this.MAXROW)},_.prototype.getRange=function(e,t,r){t=this.getAddress(e,t),r="number"==typeof r?this.getAddress(e,r):t;return t&&r?u.fromAddresses(t,r):null},_.prototype.getColRange=function(e,t,r){t=this.addrConfig.getCol(e,t,this.MAXCOL),r="number"==typeof r?this.addrConfig.getCol(e,r,this.MAXCOL):t;return 0<=t&&0<=r?u.fromIndexes(t,0,r,this.MAXROW):null},_.prototype.getRowRange=function(e,t,r){t=this.addrConfig.getRow(e,t,this.MAXROW),r="number"==typeof r?this.addrConfig.getRow(e,r,this.MAXROW):t;return 0<=t&&0<=r?u.fromIndexes(0,t,this.MAXCOL,r):null},_.prototype.createRangeDesc=function(e,t,r){if(!t)return null;if(e){if(e.r1.sheet!==this.refSheet)return null;if(e.r2&&e.r2.sheet!==this.refSheet)return null}return{range:t,text:r}},_.prototype.implParseRange=function(){return m.error("$badge{RangeListParserBase} implParseRange: missing implementation"),null},_.prototype.implFormatRange=function(){return m.error("$badge{RangeListParserBase} implFormatRange: missing implementation"),null},_.prototype.parse=m.profileMethod("$badge{RangeListParser} parse",function(e,t,r){m.log(function(){return'formula="'+t+'"'}),this._initDocAccess(e),this.refSheet=R(r&&r.refSheet,-1),this.extSep=g(r&&r.extSep),this.skipSheets=g(r&&r.skipSheets);for(var n="start",s=new f,i=null;"end"!==n;)switch(n){case"start":n="range";break;case"range":var a=this.implParseRange(t);if(!a)return;s.push(a.range),t=t.substr(a.text.length),n="sep";break;case"sep":if(0===t.length){n="end";break}a=this._parseSeparator(t);if(!a||null!==i&&i!==a.sep)return;i=a.sep,t=t.substr(a.text.length),n="range"}return s}),_.prototype.format=m.profileMethod("$badge{RangeListParser} format",function(e,t,r){this._initDocAccess(e);var e=o(r&&r.sep," "),n=r&&r.sheetName;return f.map(t,function(e){return this.implFormatRange(e,n)},this).join(e)});var x=_.extend(function(e){_.call(this,e)});x.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0]);if(r=t.RL_COLS_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3,4),r[0]);if(r=t.RL_COL_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3),r[0]);if(r=t.RL_ROWS_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3,4),r[0]);if(r=t.RL_ROW_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):(r=t.RL_COLS_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1,2),r[0]):(r=t.RL_COL_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1),r[0]):(r=t.RL_ROWS_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1,2),r[0]):(r=t.RL_ROW_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1),r[0]):void 0},x.prototype.implFormatRange=function(e,t){var r=null,n=null;e.single()?r=e.start.toString():n=this.addressFactory.isRowRange(e)?(r=h(e.start[1]),h(e.end[1])):this.addressFactory.isColRange(e)?(r=l(e.start[0]),l(e.end[0])):(r=e.start.toString(),e.end.toString());t=t?new p(t,!1):void 0;return this.grammar.formatGenericRange(this.docAccess,r,n,t)};var L=_.extend(function(e){_.call(this,e)});L.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_CUBE_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,7),r[0]);if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):void 0},L.prototype.implFormatRange=function(e,t){var r=e.start.toString(),n=e.single()?null:e.end.toString(),e=t?new p(t,!1):void 0;return this.grammar.formatGenericRange(this.docAccess,r,n,{r1:e,r2:t&&n?e:void 0})},e.createRangeListParser=function(e){switch(e.REF_SYNTAX){case d.OOX:case d.ODF_UI:return new x(e);case d.OF:return new L(e)}throw m.error('$badge{RangeListParser} createRangeListParser: invalid reference syntax "'+e.REF_SYNTAX+'"'),new TypeError('invalid enumeration value "'+e.REF_SYNTAX+'"')}});