define("io.ox/office/spreadsheet/model/numberformatter",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/locale/locale","io.ox/office/tk/locale/parser","io.ox/office/baseframework/utils/apputils","io.ox/office/editframework/model/formatter/presetformattable","io.ox/office/editframework/model/formatter/baseformatter","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(e,t,r,o,a,n,i,s,l,u,m,c){"use strict";var f=t.isNumber,d=t.isString,p=t.isFiniteNumber,h=t.isBoolean,g=t.toNumber,T=t.newDict,F=r.isZero,b=r.trimString,r=r.createDict,v=o.TMap,N=a.LOCALE_DATA,I=n.parseBrackets,y=n.parseLeadingNumber,S=n.parseLeadingPercent,D=n.parseLeadingCurrency,x=n.checkFollowingCurrency,C=i.FileFormatType,E=s.getDecimalId,R=s.getTimeId,O=l.PresetCodeId,s=l.CURRENCY_FORMAT_IDS,A=l.ParsedFormat,w=l.BaseFormatter,M=m.modelLogger,L=m.isErrorCode,U=c.Complex,k=r(s,!0);function P(e){function t(e,t,r){return{type:e,value:t,options:r}}var r=y(e,{sign:!0,group:!0});if(!r)return null;if(0===r.remaining.length)return t("number",r.number,{scientific:r.scientific,dec:r.dec,grouped:r.grouped});var o=/^\s*(\d+\/\d+)(.*)/.exec(r.remaining),a=null,n=null,i=!1;if(o){a=o[2],e=o[1],o=b(e).split("/"),e=parseInt(o[0],10),o=parseInt(o[1],10);if(0<o){if(n=Math.abs(r.number)+e/o,"-"===r.sign&&(n=-n),0===a.length)return t("fraction",n,{});i=!0}}else a=r.remaining,n=r.number;return/^\s*%$/.test(a)?t("percent",n/100,{scientific:r.scientific,dec:r.dec||i,grouped:r.grouped}):x(a)?t("currency",n,{scientific:r.scientific,dec:r.dec||i,grouped:r.grouped}):null}function B(e){this.code=e,this.persistent=!1,this.transient=0}e=e.NumberFormatter=w.extend(function(e){w.call(this,e.docApp.getFileFormat(),{stdLen:m.MAX_LENGTH_STANDARD_CELL}),this._docModel=e,this._formatTable=new v,this._reverseTable=new v,this._firstFreeId=O.USER_START,e.docApp.isOOXML()&&(e.registerOperationHandler(u.INSERT_NUMBER_FORMAT,this._applyInsertOperation.bind(this)),e.registerOperationHandler(u.DELETE_NUMBER_FORMAT,this._applyDeleteOperation.bind(this))),this.listenTo(e,"change:attributes",function(e,t){t=/^(\d{4})-(\d{2})-(\d{2})$/.exec(t.nullDate);t&&(t=Date.UTC(parseInt(t[1],10),parseInt(t[2],10)-1,parseInt(t[3],10)),this.configure({nullDate:t}))})});e.prototype.getParsedFormat=function(e,t){var r=f(e)?this._formatTable.get(e):void 0;return w.prototype.getParsedFormat.call(this,r?r.code:e,t)},e.prototype.getParsedFormatForAttributes=function(e){switch(this.fileFormat){case C.OOX:return this.getParsedFormat(e.formatId);case C.ODF:return this.getParsedFormat(e.formatCode)}return M.error('$badge{NumberFormatter} parseAttributesFormat: unknown file format "'+this.fileFormat+'"'),this.standardFormat},e.prototype.resolveFormatId=function(e){if(f(e))return e;var t=e instanceof A?e.formatCode:e,e=d(t)?this._reverseTable.get(t):void 0;if(f(e))return e;t=w.prototype.resolveFormatId.call(this,t);return f(t)&&!this._formatTable.has(t)?t:null},e.prototype.parseFormattedValue=function(s,e){function l(e,t){return{value:e,format:t||0}}if(""===s)return l(e&&e.blank?null:s);var t=this._docModel.formulaGrammarUI.getBooleanValue(s);if(_.isBoolean(t))return l(t);t=this._docModel.formulaGrammarUI.getErrorCode(s);if(t)return l(t);t=function(){var r=this;function e(e,t){return r.getCurrencyFormat({int:!t.dec,red:!0}).formatCode}var t=I(b(s)),o=P(t);if(o){var a=o.options;switch(o.type){case"fraction":return l(o.value,O.FRACTION);case"percent":return l(o.value,a.dec?O.PERCENT:O.PERCENT_INT);case"currency":0<=t.indexOf(N.isoCurrency)?N.isoCurrency:N.currency;return l(o.value,e(0,_.extend(a,{leading:!1})))}return l(o.value,a.scientific?O.SCIENTIFIC:a.grouped?E({int:!a.dec,group:!0}):O.STANDARD)}var n=D(t);if(n&&(o=P(I(b(n[1]))))){var i=e(n[2],_.extend(o.options,{leading:!0}));return l(o.value,i)}n=S(t);if(n&&(o=P(I(b(n[1])))))return l(o.value/100,o.options.dec?O.PERCENT:O.PERCENT_INT);i=null,n=null;if(i=this.parseLeadingDate(t)){if(0<(t=i.remaining).length&&!(n=this.parseLeadingTime(b(t),{complete:!0})))return null}else if((n=this.parseLeadingTime(t))&&0<(t=n.remaining).length&&(!/^\s/.test(t)||!(i=this.parseLeadingDate(b(t),{complete:!0}))))return null;return i&&n?l(this.convertDateToNumber(i.date)+n.serial,22):i?l(this.convertDateToNumber(i.date),null===i.Y?16:null===i.D?17:14):n?l(n.serial,null!==n.ms?47:1<=n.serial?46:R({hours24:!n.ampm,seconds:null!==n.s})):null}.call(this);return t||l(e&&e.keepApos?s:s.replace(/^'/,""))},e.prototype.parseValue=function(e,t){return this.parseFormattedValue(e,t).value},e.prototype.convertComplexToString=function(e,t){var r=this.autoFormatNumber(e.real,{stdLen:t}).text,o=this.autoFormatNumber(e.imag,{stdLen:t}).text,t=e.unit||"i";return 0===e.imag?r:(0===e.real?"":r)+(0!==e.real&&0<e.imag?"+":"")+(/^-?1$/.test(o)?"":o)+t},e.prototype.convertStringToComplex=function(e){var t,r,o=null;return 0===e.length?null:(o=/^([-+]?)([ij])$/.exec(e))?new U(0,"-"===o[1]?-1:1,o[2]):(t=y(e,{sign:!0}))?(r=t.number,""===(e=t.remaining)?new U(r,0):"i"===e||"j"===e?new U(0,r,e):(o=/^([-+])([ij])$/.exec(e))?new U(r,"-"===o[1]?-1:1,o[2]):(t=y(e,{sign:!0}))&&0!==t.sign.length&&("i"===(e=t.remaining)||"j"===e)?new U(r,t.number,e):null):null},e.prototype.convertScalarToNumber=function(e,t){return d(e)?e=this.parseValue(e):h(e)?e=e?1:0:e instanceof Date?e=this.convertDateToNumber(e):null===e&&(e=0),p(e)?t?Math.floor(e):e:null},e.prototype.convertScalarToDate=function(e,t){if(!(e instanceof Date)){if(null===(e=this.convertScalarToNumber(e,t)))return null;e=this.convertNumberToDate(e)}return e instanceof Date&&this.isValidDate(e)?e:null},e.prototype.convertScalarToString=function(e,t){return e instanceof Date&&null===(e=this.convertScalarToNumber(e))?null:(p(e)?e=this.autoFormatNumber(e,{stdLen:t}).text:"boolean"==typeof e?e=this._docModel.formulaGrammarUI.getBooleanName(e):null===e&&(e=""),d(e)?e:null)},e.prototype.convertScalarToBoolean=function(e){return e instanceof Date&&null===(e=this.convertScalarToNumber(e))?null:(p(e)?e=!F(e):d(e)?e=this._docModel.formulaGrammarUI.getBooleanValue(e):null===e&&(e=!1),h(e)?e:null)},e.prototype.generateNumberFormatOperations=function(o,e){var a=this.getParsedFormat(e).formatCode;return o.numFmtAttrCache.getOrCreate(a,function(){var e=this.resolveFormatId(a),t=T();switch(this.fileFormat){case C.OOX:null===e&&(e=g(o.nextFormatId,this._firstFreeId),o.nextFormatId=e+1),e>=O.USER_START&&((r=this._formatTable.get(e))&&r.persistent||o.generateNumberFormatOperation(u.INSERT_NUMBER_FORMAT,e,{code:a,_SKIP_REDO_:!0})),t.formatId=e;break;case C.ODF:var r=null!==e&&e<O.USER_START;t.formatId=r?e:null,t.formatCode=a}return t},this)},e.prototype.prepareFormatValue=function(e){return null===e?{value:"",format:this.standardFormat}:L(e)?{value:this._docModel.formulaGrammarUI.getErrorName(e),format:this.standardFormat}:{value:h(e)?this._docModel.formulaGrammarUI.getBooleanName(e):e}},e.prototype.registerTransientFormat=function(e){this._updateTransientFormat(e,function(e,t,r){r?r.code!==t&&M.warn("$badge{NumberFormatter} registerTransientFormat: format code mismatch: id: "+e+", old code: "+r.code+", new code: "+t):r=this._createNumberFormat(e,t),r.transient+=1})},e.prototype.unregisterTransientFormat=function(e){this._updateTransientFormat(e,function(e,t,r){r?(--r.transient,!r.persistent&&r.transient<=0&&this._removeNumberFormat(e)):M.warn("$badge{NumberFormatter} unregisterTransientFormat: missing format code: id: "+e)})},e.prototype._createNumberFormat=function(e,t){var r=new B(t);return this._formatTable.insert(e,r),this._firstFreeId=Math.max(this._firstFreeId,e+1),this._reverseTable.insert(t,e),r},e.prototype._removeNumberFormat=function(e){var t=this._formatTable.remove(e);if(t){if(e+1===this._firstFreeId)for(;this._firstFreeId>O.USER_START&&!this._formatTable.has(this._firstFreeId-1);)--this._firstFreeId;this._reverseTable.remove(t.code)}},e.prototype._updateTransientFormat=function(e,t){var r;e&&this.fileFormat===C.OOX&&(r=e.formatId,e=e.formatCode,_.isNumber(r)&&_.isString(e)&&t.call(this,r,e,this._formatTable.get(r,null)))},e.prototype._applyInsertOperation=function(e){var t,r=e.getInt("id");e.ensure(0<=r,"unexpected negative format identifier"),!(r<O.USER_START)||r in k?(t=e.getStr("code",!0),(e=this._formatTable.get(r,null))?(this._reverseTable.remove(e.code),e.code=t,this._reverseTable.insert(t,r)):e=this._createNumberFormat(r,t),e.persistent=!0):M.warn("$badge{NumberFormatter} applyInsertOperation: attempted to replace predefined number format "+r)},e.prototype._applyDeleteOperation=function(e){var t=e.getInt("id");e.ensure(t>=O.USER_START,"invalid format identifier");var r=this._formatTable.get(t,null);e.ensure(r&&r.persistent,"invalid format identifier"),r.transient<=0?this._removeNumberFormat(t):r.persistent=!1}});