var __extends=this&&this.__extends||function(){var n=function(e,t){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])})(e,t)};return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}}(),__assign=this&&this.__assign||function(){return(__assign=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)},__spreadArray=this&&this.__spreadArray||function(e,t){for(var r=0,n=t.length,o=e.length;r<n;r++,o++)e[o]=t[r];return e};define("io.ox/office/spreadsheet/model/sheetcollection",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/dom","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/utils/operationerror","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/editframework/utils/otutils","io.ox/office/textframework/utils/dom","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/formula/parser/updatetask"],function(e,l,p,d,r,c,t,u,f,g,n,i,S,v,E,m){"use strict";Object.defineProperty(l,"__esModule",{value:!0}),l.SheetCollection=l.SHEET_TO_DOCUMENT_INSERT_EVENTS=l.SHEET_TO_DOCUMENT_INJECT_EVENTS=l.FindVisibleSheetMethod=void 0;var o,a,s=Math.min;(a=o=l.FindVisibleSheetMethod||(l.FindVisibleSheetMethod={})).NEXT="next",a.PREV="prev",a.NEAREST="nearest",l.SHEET_TO_DOCUMENT_INJECT_EVENTS=["move:columns","change:columns","move:rows","change:rows","change:cells","move:cells","merge:cells"],l.SHEET_TO_DOCUMENT_INSERT_EVENTS=["change:sheetattrs","change:sheetprops","insert:name","delete:name","change:name:before","change:name","insert:table","delete:table","change:table:before","change:table","insert:cfrule","delete:cfrule","change:cfrule","insert:drawing","delete:drawing","change:drawing","change:drawing:text","move:drawing","insert:note","delete:note","change:note","change:note:text","move:notes","move:comments","change:usedarea","refresh:ranges"];var h,y=/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]|'$/,T=/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]/,t=(__extends(M,h=t),M.prototype.destructor=function(){this._sheetArr.forEach(function(e){return e.model.destroy()})},M.prototype.getSheetName=function(e){return null!==(e=null===(e=this._sheetArr[e])||void 0===e?void 0:e.name)&&void 0!==e?e:null},M.prototype.getSheetIndex=function(e){var r=this;return this._indexKeyMap.getOrCreate(v.mapKey(e),function(t){return r._sheetArr.findIndex(function(e){return e.key===t})})},M.prototype.getSheetIndexByUid=function(t){var e=this;return this._indexUidMap.getOrCreate(t,function(){return e._sheetArr.findIndex(function(e){return e.model.uid===t})})},M.prototype.getSheetModel=function(e){return null===(e=this._sheetArr[e])||void 0===e?void 0:e.model},M.prototype.getSheetModelByUid=function(e){return null===(e=this._sheetMap.get(e))||void 0===e?void 0:e.model},M.prototype.getSheetCount=function(e){return p.isEmpty(e)?this._sheetArr.length:this.createModelIterator(e).count()},M.prototype.createModelIterator=function(e){var t=null!==(r=null==e?void 0:e.first)&&void 0!==r?r:0,r=null!==(n=null==e?void 0:e.last)&&void 0!==n?n:this._sheetArr.length-1,n=null==e?void 0:e.reverse,n=this._sheetArr.entryIterator({begin:n?r:t,end:n?t-1:r+1,reverse:n}),o=null==e?void 0:e.supported,i=p.isBoolean(o)?function(e){return o===e.isSupported}:d.trueFn,a=null==e?void 0:e.cells,s=p.isBoolean(a)?function(e){return a===e.isCellType}:d.trueFn,h=null==e?void 0:e.visible,l=p.isBoolean(h)?function(e){return h===e.isVisible()}:d.trueFn;return n.mapIterator(function(e){e=e.value.model;return i(e)&&s(e)&&l(e)?e:void 0})},M.prototype.findVisibleSheet=function(e,t){var r=d.block(function(){switch(t){case o.NEXT:return{first:e,supported:!0,visible:!0};case o.PREV:return{last:e,reverse:!0,supported:!0,visible:!0};default:return}});if(r){var n=this.createModelIterator(r).next();return n.done?-1:n.value.getIndex()}n=this.findVisibleSheet(e,o.NEXT);return n<0?this.findVisibleSheet(e,o.PREV):n},M.prototype.canInsertSheet=function(){return i.MAX_SHEET_COUNT<1||this._sheetArr.length<i.MAX_SHEET_COUNT},M.prototype.generateUnusedSheetName=function(){for(var e="",t=this._sheetArr.length;0===e.length||0<=this.getSheetIndex(e);)e=v.generateSheetName(t),t+=1;return e},M.prototype.generateUpdateTaskOperations=function(r,n){var o=n instanceof m.DeleteSheetUpdateTask?this.getSheetModel(n.sheet):void 0;return this.asyncForEach(this.createModelIterator(),function(e){var t=e===o?void 0:r.getSheetCache(e);return t?e.generateUpdateTaskOperations(t,n):void 0})},M.prototype.generateInsertSheetOperations=function(e,t,r,n,o){u.OperationError.throwCauseIf(this._validateSheetName(n));n={sheet:t,sheetName:n};r!==v.SheetType.WORKSHEET&&(n.type=r),o&&(n.attrs=o);e=e.headGenerator;e.generateOperation(S.INSERT_SHEET,n),e.generateOperation(S.DELETE_SHEET,{sheet:t},{undo:!0})},M.prototype.generateDeleteSheetOperations=function(t,r){var n=this,e=this._ensureSheetModel(r),o=t.createSheetCache(e);return e.generateRestoreOperations(o).then(function(){var e=new m.DeleteSheetUpdateTask(r);return n.docModel.generateUpdateTaskOperations(t,e)}).then(function(){t.tailGenerator.generateOperation(S.DELETE_SHEET,{sheet:r})})},M.prototype.generateMoveSheetOperations=function(e,t,r){e=e.headGenerator;e.generateOperation(S.MOVE_SHEET,{sheet:t,to:r}),e.generateOperation(S.MOVE_SHEET,{sheet:r,to:t},{undo:!0})},M.prototype.generateMoveSheetsOperations=function(e,t){e=e.headGenerator;e.generateOperation(S.MOVE_SHEETS,{sheets:t}),e.generateOperation(S.MOVE_SHEETS,{sheets:v.inverseSortVector(t)},{undo:!0})},M.prototype.generateCopySheetOperations=function(e,t,r,n){var o=this;u.OperationError.throwCauseIf(this._validateSheetName(n));var i=p.newDict();this.tableModelSet.forEachKey(function(e){return i[e]=!0});var a=this._ensureSheetModel(t),s=p.newDict();a.tableCollection.createModelIterator().forEach(function(e){for(var t=e.getName(),e=/^(.*?)(\d+)$/.exec(t),r=(null==e?void 0:e[1])||v.getTableName(),n=e?parseInt(e[2],10)+1:1;v.mapKey(""+r+n)in i;)n+=1;e=""+r+n;i[v.mapKey(e)]=!0,s[t]=e});var h=e.headGenerator,l={sheet:t,to:r,sheetName:n};p.isEmpty(s)||(l.tableNames=s),h.generateOperation(S.COPY_SHEET,l),h.generateOperation(S.DELETE_SHEET,{sheet:r},{undo:!0});var d=e.createSheetCache(a,{targetSheet:r,skipUndo:!0}),n=new m.RenameSheetUpdateTask(t,n,s);return a.generateUpdateTaskOperations(d,n).then(function(){var e=a.drawingCollection.createModelIterator({deep:!0,reverse:!0});return o.asyncForEach(e,function(e){e.drawingType!==f.DrawingType.CHART||e.isRestorable()||d.generateDrawingOperation(S.DELETE_DRAWING,e.getPosition())})})},M.prototype.generateRenameSheetOperations=function(e,t,r){var n=this.getSheetName(t);if(n===r)return p.newFulfilled();u.OperationError.throwCauseIf(this._validateSheetName(r,{skipSheet:t}));var o=e.headGenerator;o.generateOperation(S.CHANGE_SHEET,{sheet:t,sheetName:r}),o.generateOperation(S.CHANGE_SHEET,{sheet:t,sheetName:n},{undo:!0});r=new m.RenameSheetUpdateTask(t,r);return this.docModel.generateUpdateTaskOperations(e,r)},M.prototype._ensureSheetModel=function(e){e=this.getSheetModel(e);if(!e)throw new RangeError("invalid sheet index");return e},M.prototype._resolveSheetInfo=function(e){var t=e.getInt("sheet"),r=this._sheetArr[t];return e.ensure(r,"invalid sheet index %d",t),{sheet:t,sheetInfo:r}},M.prototype._validateSheetName=function(e,t){if(0===e.length)return"sheet:name:empty";if((null!=t&&t.importing&&this.docApp.isOOXML()?T:y).test(e))return"sheet:name:invalid";e=this.getSheetIndex(e);return 0<=e&&e!==(null==t?void 0:t.skipSheet)?"sheet:name:used":""},M.prototype._isValidSheetName=function(e,t){return!this._validateSheetName(e,t)},M.prototype._ensureValidSheetName=function(e,t,r){e.importing&&(r=__assign({importing:!0},r)),e.ensure(this._isValidSheetName(t,r),"invalid sheet name")},M.prototype._createSheetAndTrigger=function(t,e,r,n){var o=this;if(this.canInsertSheet()){this.trigger("insert:sheet:before",t);var i=this.docModel.getActiveSheet(),a=g.transformIndexInsert(i,t,1),i=i!==a;i&&this.docModel.setActiveSheet(-1);var s=new E.SheetModel(this.docModel,e,n),n=s.drawingCollection.getContainerNode(),r={model:s,node:n,name:r,key:v.mapKey(r)};this._sheetArr.insertAt(t,r),this._sheetMap.insert(s.uid,r),c.insertChildren(this._drawingRootNode,t,n);n=this._sheetArr.length;t===n?(this._indexKeyMap.insert(r.key,t),this._indexUidMap.insert(s.uid,t)):(this._indexKeyMap.clear(),this._indexUidMap.clear()),i&&this.docModel.setActiveSheet(a),this.listenTo(s.tableCollection,"insert:table",function(e,t){t.isAutoFilter()||o.tableModelSet.insert(t)}),this.listenTo(s.tableCollection,"delete:table",function(e,t){t.isAutoFilter()||o.tableModelSet.remove(t)}),this.listenTo(s.tableCollection,"change:table:before",function(e,t,r){"change:name"===r&&o.tableModelSet.remove(t)}),this.listenTo(s.tableCollection,"change:table",function(e,t,r){"change:name"===r&&o.tableModelSet.insert(t)}),this.trigger("insert:sheet:after",t,s);n=d.generateArray(n-1,function(e){return g.transformIndexInsert(e,t,1)});this.trigger("transform:sheets",n),l.SHEET_TO_DOCUMENT_INJECT_EVENTS.forEach(function(e){o.forwardEvent(s,e,{transformFn:function(e){e.sheetModel=s,e.sheet=s.getIndex()}})});var h=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return __spreadArray([s.getIndex()],e)};return l.SHEET_TO_DOCUMENT_INSERT_EVENTS.forEach(function(e){switch(e){case"change:sheetattrs":o.forwardEvent(s,"change:attributes",{triggerType:e,transformFn:h});break;case"change:sheetprops":o.forwardHook(s.propSet,e,{transformFn:h});break;default:o.forwardEvent(s,e,{transformFn:h})}}),s}},M.prototype._sortSheetsAndTrigger=function(t,e){var r=this,n=v.inverseSortVector(e);this.trigger("move:sheets:before",n);var o=this.docModel.getActiveSheet(),i=g.transformIndexSort(o,e),o=o!==i;o&&this.docModel.setActiveSheet(-1),this._sheetArr.permute(e);try{this._sheetArr.forEach(function(e,t){c.insertChildren(r._drawingRootNode,t,e.node)})}catch(e){v.modelLogger.exception(e),t.error("failed to reorder drawing page nodes")}this._indexKeyMap.clear(),this._indexUidMap.clear(),this.trigger("move:sheets:after",n),this.trigger("transform:sheets",n),o&&this.docModel.setActiveSheet(i)},M.prototype._applyInsertSheetOperation=function(e){var t=e.getInt("sheet"),r=e.getStr("sheetName"),n=e.optEnum("type",v.SheetType,v.SheetType.WORKSHEET),o=e.optDict("attrs");i.getDebugFlag("spreadsheet:failing-import")&&(i.setDebugFlag("spreadsheet:failing-import",!1),e.error("debug mode: insert sheet fails")),e.ensure(0<=t&&t<=this._sheetArr.length,"invalid sheet index"),this._ensureValidSheetName(e,r);o=this._createSheetAndTrigger(t,n,r,o);e.ensure(o,"cannot create sheet")},M.prototype._applyDeleteSheetOperation=function(e){var t=this,r=this._resolveSheetInfo(e),n=r.sheet,o=r.sheetInfo,i=o.model;e.ensure(1<this._sheetArr.length,"cannot delete last sheet"),this.trigger("delete:sheet:before",n,i);r=this.docModel.getActiveSheet(),e=g.transformIndexDelete(r,n,1),r=r!==e;r&&this.docModel.setActiveSheet(-1),n+1===this._sheetArr.length?(this._indexKeyMap.remove(o.key),this._indexUidMap.remove(i.uid)):(this._indexKeyMap.clear(),this._indexUidMap.clear()),c.detachNode(o.node),i.tableCollection.createModelIterator().forEach(function(e){t.tableModelSet.remove(e)}),this._sheetMap.remove(i.uid),this._sheetArr.deleteAt(n),i.destroy(),r&&(p.isNumber(e)||(e=s(n,this._sheetArr.length-1)),this.docModel.setActiveSheet(this.findVisibleSheet(e))),this.trigger("delete:sheet:after",n);e=d.generateArray(this._sheetArr.length+1,function(e){return null!==(e=g.transformIndexDelete(e,n,1))&&void 0!==e?e:null});this.trigger("transform:sheets",e)},M.prototype._applyChangeSheetOperation=function(e){var t=this._resolveSheetInfo(e),r=t.sheet,n=t.sheetInfo,o=n.model,t=e.optStr("sheetName");t&&(this._ensureValidSheetName(e,t,{skipSheet:r}),n.name!==t&&(this.trigger("rename:sheet:before",r,t,o),this._indexKeyMap.remove(n.key),n.name=t,n.key=v.mapKey(t),this._indexKeyMap.insert(n.key,r),this.trigger("rename:sheet",r,t,o)));e=e.optDict("attrs");e&&o.setAttributes(e)},M.prototype._applyMoveSheetOperation=function(e){var t,r=this._resolveSheetInfo(e).sheet,n=e.getInt("to");e.ensure(0<=n&&n<this._sheetArr.length,"invalid target index %d",n),r!==n&&((t=d.generateArray(this._sheetArr.length,d.identity)).splice(r,1),t.splice(n,0,r),this._sortSheetsAndTrigger(e,t))},M.prototype._applyMoveSheetsOperation=function(e){var t=e.getPos("sheets"),r=this._sheetArr.length;e.ensure(t.length===r,"invalid length of transformation vector");var n=_.unique(_.sortBy(t),!0);e.ensure(n.length===r,"duplicate sheet indexes in transformation vector"),e.ensure(0===n[0]&&_.last(n)===r-1,"invalid sheet indexes in transformation vector"),this._sortSheetsAndTrigger(e,t)},M.prototype._applyCopySheetOperation=function(e){var t=this._resolveSheetInfo(e).sheetInfo.model,r=e.getInt("to");e.ensure(0<=r&&r<=this._sheetArr.length,"invalid target index");var n=e.getStr("sheetName");this._ensureValidSheetName(e,n);n=this._createSheetAndTrigger(r,t.sheetType,n);e.ensure(n,"cannot create sheet"),n.applyCopySheetOperation(e,t)},M);function M(e){var t=h.call(this,e)||this;return t.tableModelSet=new r.TSet(function(e){return e.getKey()}),t._sheetMap=new r.TMap,t._sheetArr=new r.TArray,t._indexKeyMap=new r.TMap,t._indexUidMap=new r.TMap,t._drawingRootNode=n.getPageContentNode(e.getNode())[0],c.detachChildren(t._drawingRootNode),e.registerOperationHandler(S.INSERT_SHEET,t._applyInsertSheetOperation.bind(t)),e.registerOperationHandler(S.DELETE_SHEET,t._applyDeleteSheetOperation.bind(t)),e.registerOperationHandler(S.CHANGE_SHEET,t._applyChangeSheetOperation.bind(t)),e.registerOperationHandler(S.MOVE_SHEET,t._applyMoveSheetOperation.bind(t)),e.registerOperationHandler(S.MOVE_SHEETS,t._applyMoveSheetsOperation.bind(t)),e.registerOperationHandler(S.COPY_SHEET,t._applyCopySheetOperation.bind(t)),t}l.SheetCollection=t});