define("io.ox/office/spreadsheet/model/tablecollection",["exports","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/utils/operationerror","io.ox/office/editframework/model/attributedmodel","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/scalarset","io.ox/office/spreadsheet/model/cellvaluecache"],function(e,p,t,n,r,s,o,m,b,a,i,l){"use strict";var C=t.isString,c=t.getString,R=t.newFulfilled,v=n.createDict,u=r.DSet,A=r.TMap,E=o.OperationError,d=a.MergeMode,M=a.SortDirection,O=a.Interval,w=a.Address,T=a.Range,y=a.IntervalArray,S=a.RangeArray,F=a.mapKey,x=a.modelLogger,D=i.ScalarSet,N=l.CellValueCache,I=e.TableColumnModel=m.extend(function(e,t,n){m.call(this,e.docModel,n,{families:"filter sort",autoClear:!0}),this.clone=function(e,t){return new I(e,t,this.getExplicitAttributeSet(!0))},this.isButtonVisible=function(){return!this.getMergedAttributeSet(!0).filter.hideButton},this.isFiltered=function(){return"none"!==this.getMergedAttributeSet(!0).filter.type},this.isSorted=function(){return"none"!==this.getMergedAttributeSet(!0).sort.type},this.isDescending=function(){return this.getMergedAttributeSet(!0).sort.descending},this.isRefreshable=function(){return this.isFiltered()||this.isSorted()}}),L=e.TableModel=m.extend(function(l,u,c,e){m.call(this,l.docModel,e,{styleFamily:"table",autoClear:!0});var d=this,o=l.docModel,f=(this.sheetModel=l).cellCollection,s=new A,t=this.member(new I(l,this)),r=this.member(new N(l,c)),i=[];function a(e,r){var o={tableCol:e,columnModel:r},a=r.uid;s.insert(e,o),d.listenTo(r,"change:attributes",function(e,t,n){d.trigger("change:column",o.tableCol,t,n),r.isSorted()&&i.push(a),r.hasExplicitAttributes()||(r.destroy(),s.remove(o.tableCol),i=_.without(i,a))})}function g(e){e=s.get(e);return e?e.columnModel:null}function h(r,o){s.forEach(function(e){var t,n;!e.columnModel.isSorted()||o&&0<=o.indexOf(e.tableCol)||(n=e.columnModel.getUndoAttributeSet(t={sort:{type:"none",descending:!1}}),r.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:e.tableCol,attrs:n},{undo:!0}),r.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:e.tableCol,attrs:t}))})}this.clone=function(e,t){return new L(e,t,c,this.getExplicitAttributeSet(!0),s)},this.applyChangeOperation=function(e){var t=e.getInt("col");e.ensure(0<=t&&t<c.cols(),"invalid table column");var n=e.getDict("attrs");(t=g(e=t))||a(e,t=new I(l,d)),t.setAttributes(n)},this.getName=function(){return u},this.getKey=function(){return F(u)},this.isAutoFilter=function(){return 0===u.length},this.getRange=function(){return c.clone()},this.containsCell=function(e){return c.containsAddress(e)},this.overlapsRange=function(e){return c.overlaps(e)},this.hasHeaderRow=function(){return this.getMergedAttributeSet(!0).table.headerRow},this.hasFooterRow=function(){return this.getMergedAttributeSet(!0).table.footerRow},this.getStyleId=function(){return this.getMergedAttributeSet(!0).styleId||null},this.getStyleFlags=function(){var e=this.getMergedAttributeSet(!0).table;return{firstRow:e.headerRow,lastRow:e.footerRow,firstCol:e.firstCol,lastCol:e.lastCol,bandsHor:e.bandsHor,bandsVert:e.bandsVert}},this.areButtonsVisible=function(){var e=this.getMergedAttributeSet(!0).table;return e.headerRow&&!e.hideButtons},this.isFiltered=function(){return s.some(function(e){return e.columnModel.isFiltered()})},this.isSorted=function(){return s.some(function(e){return e.columnModel.isSorted()})},this.getSortRules=function(){var r=c.start[0],e=s.reduce([],function(e,t){var n=t.columnModel;return n.isSorted()&&e.push({order:i.indexOf(n.uid),index:r+t.tableCol,descending:n.isDescending()}),e});return _.sortBy(e,"order")},this.getHeaderRange=function(){return this.hasHeaderRow()?c.headerRow():null},this.getFooterRange=function(){return this.hasFooterRow()?c.footerRow():null},this.getDataRange=function(){var e,t=this.hasHeaderRow(),n=this.hasFooterRow(),r=c.clone();return!n&&this.isAutoFilter()&&(r=f.findContentRange(r,{directions:"down"}),c.end[1]<r.end[1]&&(e=T.fromIndexes(c.start[0],c.end[1]+1,c.end[0],o.getMaxRow()),l.tableCollection.createModelIterator({overlapRange:e}).forEach(function(e){r.end[1]=Math.min(r.end[1],e.getRange().start[1]-1)}))),t&&(r.start[1]+=1),n&&--r.end[1],r.start[1]<=r.end[1]?r:null},this.getVisibleDataRows=function(){var e=this.getDataRange();return e?l.rowCollection.getVisibleIntervals(e.rowInterval()).move(-e.start[1]):new y},this.canRestoreDeletedRanges=function(e){return this.isAutoFilter()||e.every(function(e){return!e.contains(c)})},this.setName=function(e){u=e},this.setRange=function(e){if(c.equals(e))return this;c=e.clone(),r.setRanges(this.getHeaderRange());var n=c.cols();s.forEach(function(e,t){e.tableCol>=n&&(e.columnModel.destroy(),s.remove(t))})},this.transformRange=function(n){if(!n.bandContainsRange(c))return!0;if(!n.insert&&!n.columns){var e=this.getHeaderRange();if(e&&n.transformRanges(e).empty())return!1}var r,o=c.start[0],a=n.transformRanges(c).first();a?c.equals(a)||n.columns&&(r=new A,s.forEach(function(e){var t=new w(o+e.tableCol,c.start[1]);(t=n.transformAddress(t))?(e.tableCol=t[0]-a.start[0],r.insert(e.tableCol,e)):e.columnModel.destroy()}),s=r):x.error("$badge{TableModel} transformRange: unexpected deleted table, range="+c)},this.getColumnKeys=function(){return r.getCustom("colKeys",function(e){return e.map(function(e){return C(e.value)?F(e.value):""})})},this.getColumnModel=function(e){return g(e)||t},this.getColumnDataRange=function(e){var t=this.getDataRange(),e=c.start[0]+e;return t&&c.containsCol(e)?t.setBoth(e,!0):null},this.getColumnContents=function(e,t){var n=this.getColumnDataRange(e);if(!n)return[];e=n.rowInterval();if((t=t?t.deepClone().move(e.first).intersect(e):new y(e)).empty())return[];n=S.fromRowIntervals(t,n.start[0]);return f.getRangeContents(n,{blanks:!0,display:!0,compressed:!0})},this.isRefreshable=function(){return s.some(function(e){return e.columnModel.isRefreshable()})},this.createFilterMatcher=function(e){e=this.getColumnModel(e).getMergedAttributeSet(!0).filter;return"discrete"===e.type?function(e){if(0===e.length)return _.constant(!1);var n=D.from(e);return o.getApp().isODF()?function(e){return n.has(e)}:function(e,t){return n.has(t.replace(/^ +| +$/g,""))}}(e.entries):null},this.queryFilterResult=function(e){var t=this.getDataRange();if(!t)return this.createResolvedPromise([]);var n=[],r=v(e&&e.skipColumns||[],!0),t=t.rowInterval(),d=new y(new O(0,t.size()-1));return s.forEach(function(e){!e.columnModel.isFiltered()||e.tableCol in r||n.push(e.tableCol)}),this.iterateArraySliced(n,function(e){if(d.empty())return p.BREAK;var s,l,u,c=this.createFilterMatcher(e);c&&(e=this.getColumnContents(e,d),s=new y,u=l=0,e.forEach(function(e){for(var t,n,r,o,a=e.count,i=c(e.value,e.display);0<a;)t=d[u],l=Math.max(l,t.first),n=Math.min(a,t.last-l+1),i&&(o=void 0,o=l+(r=n)-1,(r=s.last())&&r.last+1===l?r.last=o:s.push(new O(l,o))),a-=n,l+=n,t.last<l&&(u+=1)}),d=s)}).then(function(){return d})},this.generateRefreshOperations=function(e,t){var n=this.getDataRange();if(!n)return this.createResolvedPromise();var r=c.boundary(n),o=this.createResolvedPromise();c.differs(r)&&(e.generateTableRangeOperation(b.CHANGE_TABLE,u,c,null,{undo:!0}),e.generateTableRangeOperation(b.CHANGE_TABLE,u,r),this.isAutoFilter()&&(o=o.then(function(){return l.nameCollection.generateFilterDatabaseOperations(e,r)})));var a,i=l.createOperationGenerator({applyImmediately:!0}),s=l.createOperationGenerator({applyImmediately:!0});return t&&t.updateFilter&&(o=o.then(function(){return d.queryFilterResult(t).then(function(e){var t=n.rowInterval(),e=e.deepClone().move(t.first);p.addProperty(e,"fillData",{attrs:{visible:!0,filtered:!1}});t=new y(t).difference(e);p.addProperty(t,"fillData",{attrs:{visible:!1,filtered:!0}});t=e.concat(t);return l.rowCollection.generateIntervalOperations(i,t)})})),t&&t.updateSort&&(0<(a=this.getSortRules()).length&&(o=o.then(function(){return f.generateSortOperations(s,n,M.VERTICAL,a)}))),o.done(function(){e.appendOperations(i),e.appendOperations(s),e.appendOperations(s,{undo:!0}),e.appendOperations(i,{undo:!0})})},this.generateChangeOperations=function(e,t){return e.generateTableOperation(b.CHANGE_TABLE,u,{attrs:this.getUndoAttributeSet(t)},{undo:!0}),e.generateTableOperation(b.CHANGE_TABLE,u,{attrs:t}),this.generateRefreshOperations(e)},this.generateChangeColumnOperations=function(e,t,n,r){r&&r.resetSort&&h(e,[t]);r=this.getColumnModel(t).getUndoAttributeSet(n);return e.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:t,sort:"sort"in r,attrs:r},{undo:!0}),e.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:t,sort:"sort"in n,attrs:n}),this.generateRefreshOperations(e,{updateFilter:"filter"in n,updateSort:"sort"in n})},this.generateDeleteOperations=function(t,e){t.rowCache.changeIntervals(c.rowInterval(),{attrs:{row:{visible:!0,filtered:!1}}});var n={attrs:d.getExplicitAttributeSet(!0)};t.generateTableRangeOperation(b.INSERT_TABLE,u,c,n,{undo:!0}),s.forEach(function(e){e={col:e.tableCol,attrs:e.columnModel.getExplicitAttributeSet(!0)};t.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,e,{undo:!0})}),t.generateTableOperation(b.DELETE_TABLE,u,void 0,e)},this.generateUpdateTaskOperations=function(n,e){var r=e.transformer,t=!r.insert&&!r.columns&&this.hasHeaderRow()&&r.deleteIntervals.containsIndex(c.start[1])?null:r.transformRanges(c).first();if(!t)return this.generateDeleteOperations(n,{prepend:!0}),R();if(c.equals(t))return R();E.assertCause(function(t){if(!(n=c.intersect(t.dirtyRange)))return!0;var e=c.interval(!t.columns),n=n.interval(!t.columns);return!e.differs(n)&&(!!(t.insert||t.columns||d.isAutoFilter())||(n=function(e){return!e||!t.transformRanges(e).empty()})(d.getHeaderRange())&&n(d.getFooterRange())&&n(d.getDataRange()))}(r),"table:move");e={range:t.toOpStr()},t={range:c.toOpStr()};!r.insert&&!r.columns&&this.hasFooterRow()&&r.deleteIntervals.containsIndex(c.end[1])&&(e.attrs={table:{footerRow:!1}},t.attrs={table:{footerRow:!0}}),n.generateTableOperation(b.CHANGE_TABLE,u,e),n.generateTableOperation(b.CHANGE_TABLE,u,t,{undo:!0});var o,a,i,t=R();return r.columns&&!s.empty()&&(o=c.start[0],a=c.start[1],i=[],s.forEach(function(e){var t=new w(o+e.tableCol,a);r.transformAddress(t)||(t={col:e.tableCol,attrs:e.columnModel.getExplicitAttributeSet(!0)},n.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,t,{undo:!0}),i.push(e.tableCol))}),t=this.generateRefreshOperations(n,{skipColumns:i})),t},this.generateSortOperations=function(r,e){var o=c.start[0],t=e.map(function(e){return e.index-o});return h(r,t),e.forEach(function(e){var t=e.index-o,n={sort:{type:"value",descending:!!e.descending}},e=d.getColumnModel(t).getUndoAttributeSet(n);r.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{sort:!0,col:t,attrs:e},{undo:!0}),r.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{sort:!0,col:t,attrs:n})}),this.generateRefreshOperations(r,{updateSort:!0})},c=c.clone(),this.on("change:attributes",function(e,t,n){t.table.headerRow!==n.table.headerRow&&r.setRanges(d.getHeaderRange())}),arguments[L.length]instanceof A&&arguments[L.length].forEach(function(e){a(e.tableCol,e.columnModel.clone(l,this))},this),this.registerDestructor(function(){s.forEach(function(e){e.columnModel.destroy()}).clear()})}),f=u.extend(function(){u.call(this,function(e){return e.getKey()})});e.TableCollection=s.extend(function(l){s.call(this,l.docModel);var r=this,u=l.docModel,a=this.member(new f);function o(e,t){var n=e.optStr("table",!0),r=0===n.length,o=a.get(F(n),null);return t&&t.insert?e.ensure(!o&&(r||!u.hasTable(n)),"table exists"):e.ensure(o,"missing table"),{name:n,model:o}}function i(t){a.insert(t),r.trigger("insert:table",t),r.forwardEvents(t,{transformFn:function(e){return["change:table",t,e].concat(_.rest(arguments,2))}})}function t(e){var t=e.transformer;a.forEach(function(e){e.transformRange(t)})}this._getCloneData=function(){return{tableModelSet:a}},this.applyCopySheetOperation=function(r,e){var o=r.optDict("tableNames");e._getCloneData().tableModelSet.forEach(function(e){var t=e.getName(),n=t;e.isAutoFilter()||(n=c(o,t),r.ensure(n,'missing replacement name for table "%s"',t)),i(e.clone(l,n))})},this.applyInsertOperation=function(e){var t=o(e,{insert:!0}),n=e.getRange("range");t.model=new L(l,t.name,n,e.optDict("attrs")),i(t.model)},this.applyDeleteOperation=function(e){e=o(e);e=e.model,r.trigger("delete:table",e),a.remove(e),e.destroy()},this.applyChangeOperation=function(e){var t=o(e).model,n=t.getRange(),r=e.optRange("range");r&&r.differs(n)&&(this.trigger("change:table:before",t,"change:range",r.clone()),t.setRange(r),this.trigger("change:table",t,"change:range",n));r=t.getName(),n=e.optStr("newName");n&&n!==r&&(e.ensure(!t.isAutoFilter(),"auto-filter cannot be renamed"),e.ensure(!u.hasTable(n),"table name already used"),this.trigger("change:table:before",t,"change:name",n),a.remove(t),t.setName(n),a.insert(t),this.trigger("change:table",t,"change:name",r)),e.has("attrs")&&t.setAttributes(e.getDict("attrs"))},this.applyChangeColumnOperation=function(e){o(e).model.applyChangeOperation(e)},this.hasTable=function(e){return a.hasKey(F(e))},this.hasAutoFilter=function(){return a.hasKey("")},this.getTableModel=function(e){return a.get(F(e))},this.getAutoFilterModel=function(){return a.get("")},this.getTableModelAt=function(t){return a.find(function(e){return e.containsCell(t)})||null},this.createModelIterator=function(e){var t=a.valueIterator();e&&e.autoFilter||(t=t.filterIterator(function(e){return!e.isAutoFilter()}));var n=e&&e.overlapRange;return t=n?t.filterIterator(function(e){return e.overlapsRange(n)}):t},this.hasFilteredTables=function(){return a.some(function(e){return e.isFiltered()})},this.canRestoreDeletedRanges=function(t){return a.every(function(e){return e.canRestoreDeletedRanges(t)})},this.generateInsertTableOperations=function(a,i,s,t){var e=0===i.length,n=e?this.hasAutoFilter():u.hasTable(i);E.assertCause(!n,"table:duplicate");n=this.createModelIterator({overlapRange:s,autoFilter:!0});E.assertCause(n.next().done,"table:overlap");n=(n=e?R():l.mergeCollection.generateMergeCellsOperations(a,s,d.UNMERGE)).then(function(){var e={range:s.toOpStr()};t&&(e.attrs=t),a.generateTableOperation(b.DELETE_TABLE,i,null,{undo:!0}),a.generateTableOperation(b.INSERT_TABLE,i,e)});return n=e?(n=n.then(function(){var e=l.mergeCollection.getMergedRanges(s.headerRow());return r.asyncForEach(e,function(e){for(var t=Math.max(e.start[0],s.start[0]),n=Math.min(e.end[0],s.end[0]),r={filter:{hideButton:!0}},o=t;o<n;o+=1)a.generateTableOperation(b.CHANGE_TABLE_COLUMN,i,{col:o-s.start[0],attrs:r})})})).then(function(){return l.nameCollection.generateFilterDatabaseOperations(a,s)}):n},this.generateUpdateTaskOperations=function(t,n){return l.isOwnMoveTask(n)?this.asyncForEach(a,function(e){return e.generateUpdateTaskOperations(t,n)}):R()},this.waitForImportSuccess(function(e){this.listenTo(l.cellCollection.moveHook,t),!e&&l.isActive()&&a.forEach(function(e){l.refreshRanges(e.getRange())})},this)})});