define("io.ox/office/spreadsheet/utils/range",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/iterators","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address"],function(t,e,n,r,s,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.rangeKey=e.rangeKeyFromIndexes=void 0;var a=Math.min,u=Math.max,d=Math.floor,h="("+i.COL_PATTERN+")("+i.ROW_PATTERN+")",p=new RegExp("^"+h+":"+h+"$","i");function c(t,e){return t.key+":"+e.key}e.rangeKeyFromIndexes=function(t,e,r,n){return i.addressKey(t,e)+":"+i.addressKey(r,n)},e.rangeKey=c;f.fromIndexes=function(t,e,r,n){return new f(new i.Address(a(t,r),a(e,n)),new i.Address(u(t,r),u(e,n)))},f.fromIntervals=function(t,e){return f.fromIndexes(t.first,e.first,t.last,e.last)},f.fromColInterval=function(t,e,r){return n.isNumber(r)||(r=e),f.fromIndexes(t.first,e,t.last,r)},f.fromRowInterval=function(t,e,r){return n.isNumber(r)||(r=e),f.fromIndexes(e,t.first,r,t.last)},f.fromAddresses=function(t,e){return e?f.fromIndexes(t[0],t[1],e[0],e[1]):new f(t.clone())},f.fromAddressAndSize=function(t,e,r){return f.fromIndexes(t[0],t[1],t[0]+e-1,t[1]+r-1)},f.parse=function(t){var e=p.exec(t);if(e){var r=i.parseCol(e[1]),n=i.parseRow(e[2]),s=i.parseCol(e[3]),e=i.parseRow(e[4]);return 0<=a(r,n,s,e)?f.fromIndexes(r,n,s,e):null}t=i.Address.parse(t);return t?new f(t):null},f.compare=function(t,e){return r.comparePairs(t.start,t.end,e.start,e.end,i.Address.compare)},Object.defineProperty(f.prototype,"key",{get:function(){return c(this.start,this.end)},enumerable:!1,configurable:!0}),f.prototype.clone=function(){return new f(this.start.clone(),this.end.clone())},f.prototype.equals=function(t){return this.start.equals(t.start)&&this.end.equals(t.end)},f.prototype.differs=function(t){return this.start.differs(t.start)||this.end.differs(t.end)},f.prototype.compareTo=function(t){return f.compare(this,t)},f.prototype.cols=function(){return this.end[0]-this.start[0]+1},f.prototype.rows=function(){return this.end[1]-this.start[1]+1},f.prototype.size=function(t){return t?this.cols():this.rows()},f.prototype.cells=function(){return this.cols()*this.rows()},f.prototype.singleCol=function(){return this.start[0]===this.end[0]},f.prototype.singleRow=function(){return this.start[1]===this.end[1]},f.prototype.singleLine=function(t){return t?this.singleCol():this.singleRow()},f.prototype.single=function(){return this.start.equals(this.end)},f.prototype.equalSize=function(t){return this.cols()===t.cols()&&this.rows()===t.rows()},f.prototype.equalCols=function(t){return this.start[0]===t.start[0]&&this.end[0]===t.end[0]},f.prototype.equalRows=function(t){return this.start[1]===t.start[1]&&this.end[1]===t.end[1]},f.prototype.sizeFitsInto=function(t){return t.cols()%this.cols()==0&&t.rows()%this.rows()==0},f.prototype.startsAt=function(t){return this.start.equals(t)},f.prototype.endsAt=function(t){return this.end.equals(t)},f.prototype.indexAt=function(t){return(t[1]-this.start[1])*this.cols()+(t[0]-this.start[0])},f.prototype.addressAt=function(t){var e=this.cols();return new i.Address(this.start[0]+d(t%e),this.start[1]+d(t/e))},f.prototype.containsCol=function(t){return this.start[0]<=t&&t<=this.end[0]},f.prototype.containsRow=function(t){return this.start[1]<=t&&t<=this.end[1]},f.prototype.containsIndex=function(t,e){return e?this.containsCol(t):this.containsRow(t)},f.prototype.containsAddress=function(t){return this.containsCol(t[0])&&this.containsRow(t[1])},f.prototype.isBorderAddress=function(t){return this.containsAddress(t)&&(this.start[0]===t[0]||this.end[0]===t[0]||this.start[1]===t[1]||this.end[1]===t[1])},f.prototype.contains=function(t){return this.containsAddress(t.start)&&this.containsAddress(t.end)},f.prototype.overlaps=function(t){return this.start[0]<=t.end[0]&&t.start[0]<=this.end[0]&&this.start[1]<=t.end[1]&&t.start[1]<=this.end[1]},f.prototype.colInterval=function(){return new o.Interval(this.start[0],this.end[0])},f.prototype.rowInterval=function(){return new o.Interval(this.start[1],this.end[1])},f.prototype.interval=function(t){return t?this.colInterval():this.rowInterval()},f.prototype.colRange=function(t,e){t=this.start[0]+t;return f.fromIndexes(t,this.start[1],t+(e=void 0===e?1:e)-1,this.end[1])},f.prototype.rowRange=function(t,e){t=this.start[1]+t;return f.fromIndexes(this.start[0],t,this.end[0],t+((e=void 0===e?1:e)||1)-1)},f.prototype.lineRange=function(t,e,r){return void 0===r&&(r=1),t?this.colRange(e,r):this.rowRange(e,r)},f.prototype.leadingCol=function(){return f.fromIndexes(this.start[0],this.start[1],this.start[0],this.end[1])},f.prototype.trailingCol=function(){return f.fromIndexes(this.end[0],this.start[1],this.end[0],this.end[1])},f.prototype.headerRow=function(){return f.fromIndexes(this.start[0],this.start[1],this.end[0],this.start[1])},f.prototype.footerRow=function(){return f.fromIndexes(this.start[0],this.end[1],this.end[0],this.end[1])},f.prototype.mirror=function(){return f.fromIndexes(this.start[1],this.start[0],this.end[1],this.end[0])},f.prototype.expand=function(t){return f.fromIndexes(a(this.start[0],t[0]),a(this.start[1],t[1]),u(this.end[0],t[0]),u(this.end[1],t[1]))},f.prototype.boundary=function(t){return f.fromIndexes(a(this.start[0],t.start[0]),a(this.start[1],t.start[1]),u(this.end[0],t.end[0]),u(this.end[1],t.end[1]))},f.prototype.intersect=function(t){return this.overlaps(t)?f.fromIndexes(u(this.start[0],t.start[0]),u(this.start[1],t.start[1]),a(this.end[0],t.end[0]),a(this.end[1],t.end[1])):null},f.prototype.getStart=function(t){return this.start.get(t)},f.prototype.getEnd=function(t){return this.end.get(t)},f.prototype.setStart=function(t,e){return this.start.set(t,e),this},f.prototype.setEnd=function(t,e){return this.end.set(t,e),this},f.prototype.setBoth=function(t,e){return this.start.set(t,e),this.end.set(t,e),this},f.prototype.moveBoth=function(t,e){return this.start.move(t,e),this.end.move(t,e),this},f.prototype.colIterator=function(t){return s.IndexIterator.interval(this.start[0],this.end[0],t)},f.prototype.rowIterator=function(t){return s.IndexIterator.interval(this.start[1],this.end[1],t)},f.prototype.indexIterator=function(t,e){return t?this.colIterator(e):this.rowIterator(e)},f.prototype.addressIterator=function(t){var e=this,r=!(null==t||!t.columns);return this.indexIterator(r,t).nestedMapIterator(function(){return e.indexIterator(!r,t)},r?function(t,e){return new i.Address(t,e)}:function(t,e){return new i.Address(e,t)})},f.prototype.toOpStr=function(){var t=this.start.toOpStr();return this.single()?t:t+":"+this.end.toOpStr()},f.prototype.toString=function(){return this.start+":"+this.end},h=f;function f(t,e){this.start=t,this.end=e||t.clone()}e.Range=h});