define("io.ox/office/spreadsheet/view/view",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/iterators","io.ox/office/tk/utils","io.ox/office/tk/dom","io.ox/office/tk/utils/logger","io.ox/office/tk/locale/locale","io.ox/office/baseframework/view/popup/contextmenu","io.ox/office/editframework/view/commentspane","io.ox/office/drawinglayer/view/popup/chartlabelsmenu","io.ox/office/textframework/view/view","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/paneutils","io.ox/office/spreadsheet/model/formula/parser/updatetask","io.ox/office/spreadsheet/model/model","io.ox/office/spreadsheet/view/viewpropset","io.ox/office/spreadsheet/view/statuspane","io.ox/office/spreadsheet/view/formulapane","io.ox/office/spreadsheet/view/cornerpane","io.ox/office/spreadsheet/view/headerpane","io.ox/office/spreadsheet/view/gridpane","io.ox/office/spreadsheet/view/labels","io.ox/office/spreadsheet/view/controls","io.ox/office/spreadsheet/view/toolbars","io.ox/office/spreadsheet/view/popup/namesmenu","io.ox/office/spreadsheet/view/mixin/selectionmixin","io.ox/office/spreadsheet/view/mixin/viewfuncmixin","io.ox/office/spreadsheet/view/render/renderutils","io.ox/office/spreadsheet/view/render/rendercache","io.ox/office/spreadsheet/view/edit/rangehighlighter","io.ox/office/spreadsheet/view/edit/texteditorbase","io.ox/office/spreadsheet/view/edit/celltexteditor","io.ox/office/spreadsheet/view/edit/drawingtexteditor","gettext!io.ox/office/spreadsheet/main","less!io.ox/office/spreadsheet/view/style"],function(e,t,o,r,i,U,n,a,s,V,W,X,Y,Z,l,d,c,u,h,g,f,p,w,m,j,q,J,Q,ee,te,T,oe,b,v,re,ie,ne){"use strict";var ae=t.isNumber,se=t.isString,le=t.getString,de=t.getArray,ce=t.newFulfilled,ue=t.newRejected,he=o.clamp,ge=o.roundp,fe=o.hasProperty,pe=r.KeySet,we=r.TMap,me=r.DMap,Te=r.DSet,be=i.ArrayValueIterator,ve=n.COMPACT_DEVICE,Se=n.deviceResolutionHook,Ee=n.addDeviceMarkers,Pe=n.hasModifierKeys,Be=n.matchKeyCode,ye=n.enableTracking,xe=a.globalLogger,Ce=s.LOCALE_DATA,_e=q.Button,Ae=q.CheckBox,Oe=q.CompoundButton,Le=l.Address,Me=l.Interval,Ne=l.IntervalArray,Re=l.RangeArray,ke=d.ALL_PANE_SIDES,He=d.ALL_PANE_POSITIONS,Ge=d.MIN_PANE_SIZE,Ie=d.PaneSide,De=d.PanePos,Fe=d.isColumnSide,ze=d.getColPaneSide,Ke=d.getRowPaneSide,Ue=d.getNextColPanePos,Ve=d.getNextRowPanePos,We=d.getPanePos,$e=c.DeleteSheetUpdateTask,Xe=c.RenameSheetUpdateTask,Ye=c.RelabelNameUpdateTask,Ze=c.RenameTableUpdateTask,je=c.MoveCellsUpdateTask,qe=u.SHEET_TO_DOCUMENT_INJECT_EVENTS,Je=u.SHEET_TO_DOCUMENT_INSERT_EVENTS,Qe=h.ViewPropertySet,et=g.StatusPane,tt=f.FormulaPane,ot=p.CornerPane,S=w.HeaderPane,rt=m.GridPane,it=T.renderLogger,nt=b.RangeHighlighter,at=v.editLogger;function st(e,t){this.headerPane=new S(e,t),this.paneSide=t,this.offset=0,this.size=1,this.frozen=!1,this.showOppositeScroll=!1,this.hiddenSize=0}st.prototype.destroy=function(){this.headerPane.destroy()},e.SpreadsheetView=Y.extend(function(r,n){Y.call(this,r,n,{initHandler:function(){var t=n.dependencyManager,o=new we;w.insertContentNode(m),w.insertHiddenNodes(a),m.append(c),g.forEach(function(e){m.append(e.getNode())}),T.forEach(function(e){m.append(e.headerPane.getNode())}),m.append(w.cornerPane.getNode()),m.append(p,b,v,S,E),(_.browser.iOS||_.browser.Android)&&(r.registerGlobalEventHandler(document,"touchstart",function(e){h=e.originalEvent.changedTouches[0]}),r.registerGlobalEventHandler(document,"touchend",function(){w.setTimeout(function(){h=null},100)}));w.one("change:activesheet",function(){w.grabFocus()}),w.listenTo(r,"docs:editmode",function(e){m.toggleClass("edit-mode",e)}),w.listenTo(r,"docs:users:selection",function(e){e=e.filter(function(e){return e.remote&&_.isObject(e.userData)&&ae(e.userData.sheet)&&se(e.userData.ranges)});this.propSet.set("remoteClients",e)}),w.listenTo(t,"recalc:start",function(){r.setUserState("recalc")}),w.listenTo(t,"recalc:end recalc:cancel",function(){r.setUserState(null)}),w.registerStatusCaption("recalc",j.CALCULATING_LABEL,{busy:!0,delay:1e3}),w.listenTo(n,"change:cells",function(e,t){t.external||o.getOrConstruct(t.sheetModel.uid,pe).merge(t.formulaCells)}),w.listenTo(t,"recalc:end",function(e,t){t=t.some(function(e){return e.some(function(e){var t=o.get(e.sheetUid,null);return t&&t.has(e)})});o.clear(),t&&w.yell({headline:ne("Circular Reference"),message:ne("A reference in the formula is dependent on the result of the formula cell."),skipPlugged:!0})}),w.listenTo(t,"recalc:overflow",function(){w.yell({type:"error",message:ne("This document exceeds the spreadsheet size and complexity limits. Calculation has been stopped. Formula results are not updated anymore."),skipPlugged:!0})},{once:!0}),w.listenTo(t,"recalc:end",function(){var e=n.formulaGrammarUI,e=t.getMissingFunctionKeys().map(e.getFunctionName,e).filter(_.identity).sort();0<e.length&&(e=e.map(function(e){return"\n • "+e}).join(),w.yell({type:"warning",message:_.noI18n(ne("This spreadsheet contains formulas with unsupported functions:")+e),duration:3e4,skipPlugged:!0}))},{once:!0}),w.listenTo(n.propSet,function(e){"activeSheet"in e&&function(e){0<=B&&(w.cancelTextEditMode(),L(null,null,{hide:!0}),w.trigger("before:activesheet",B));0<=e&&(B=e,y=n.getSheetModel(B),x=y.colCollection,C=y.rowCollection,A=y.drawingCollection,w.trigger("change:activesheet",B,y),N(y.propSet.all()),M())}(e.activeSheet)}),qe.forEach(function(e){w.forwardEvent(n,e,{filterFn:function(e){return e.sheet===B}})}),Je.forEach(function(e){"change:sheetprops"===e?w.listenTo(n,e,function(e,t,o){t===B&&N(o)}):w.forwardEvent(n,e,{filterFn:function(e){return e===B},transformFn:function(){return _.rest(arguments)}})}),w.listenTo(n,"rename:sheet:before",function(e,t,o){w.trigger("update:formulas",new Xe(t,o))}),w.listenTo(n,"delete:sheet:before",function(e,t){w.trigger("update:formulas",new $e(t))}),w.listenTo(n,"change:name:before",function(e,t,o,r,i){r.label&&w.trigger("update:formulas",new Ye(t,o.getLabel(),i))}),w.listenTo(n,"change:table:before",function(e,t,o,r,i){"change:name"===r&&w.trigger("update:formulas",new Ze(o.getName(),i))}),w.listenTo(n,"move:cells",function(e,t){w.trigger("update:formulas",new je(t.sheet,t.transformer))}),w.waitForImportSuccess(function(){var e=r.isViewerMode()?r.getRootNode():document;r.registerGlobalEventHandler(e,"contextmenu",z),ye(P),P.on("tracking:start tracking:move tracking:end tracking:cancel",I),m.on({keydown:D,keypress:F});var o,e=r.getLaunchOption("comment_id");se(e)&&e&&(o=parseInt(e,10),n.createSheetIterator().some(function(e){var t=_.find(e.commentCollection.getCommentModels(),function(e){return new Date(e.getDate()).getTime()===o});if(t)return n.setActiveSheet(e.getIndex()),w.commentsPane.selectThread(t),!0}))}),w.waitForImportFailure(function(){m.hide(),w.statusPane.hide(),w.commentsPane.hide()}),w.addPane(w.formulaPane=new tt(w)),w.addPane(w.statusPane=new et(w)),w.addPane(w.commentsPane=new W(w,ne("There are no comments on this sheet."))),w.on("refresh:layout",function(){var e={width:m[0].clientWidth,height:m[0].clientHeight};i.width===e.width&&i.height===e.height||(i=e,M())}),w.on("change:activesheet change:sheetattrs",function(){m.toggleClass("sheet-locked",y.isLocked()),m.toggleClass("cell-sheet",y.isCellType)}),w.on("move:columns change:columns move:rows change:rows",G),w.on("change:sheetprops",function(e,t){"zoom"in t?M({full:!0}):fe(t,/^split/)?M({force:!0}):fe(t,/^anchor/)&&L(null,null)}),this.listenTo(n,"change:locale",function(){M({full:!0})}),w.listenTo(Se,function(){M({full:!0})}),w.on("change:selection",function(e,t){m.toggleClass("drawing-selection",0<t.drawings.length)}),w.on("change:activesheet",function(){w.commentsPane.repaintAllComments()}),w.on("textedit:enter",function(e,t){m.attr("data-text-edit",t)}),w.on("textedit:leave",function(){m.removeAttr("data-text-edit")}),w.on("textedit:leave:drawing",function(){w.insertHiddenNodes(a)}),T.forEach(function(o){var r=o.headerPane,i=Fe(o.paneSide),n=i?"left":"top",a=i?"width":"height",s=null;function l(e,t){e=o.offset+e-r.getVisiblePosition().offset;c.toggleClass("collapsed",0===t),c.find(">.leading").css(a,Math.max(0,e)+10+"px"),c.find(">.trailing").css(n,e+t+"px")}w.listenTo(r,"resize:start",function(e,t,o){t=t,o=o,c.attr("data-orientation",i?"columns":"rows"),l(t,o),s=w.setTimeout(function(){m.addClass("tracking-active")},200)}),w.listenTo(r,"resize:move",function(e,t,o){l(t,o)}),w.listenTo(r,"resize:end",function(){s&&(s.abort(),s=null),m.removeClass("tracking-active"),c.find(">.leading").css(a,""),c.find(">.trailing").css(n,"")}),w.forwardEvent(r,"change:scrollpos",{transform:function(e){return[o.paneSide,e]}})})},initGuiHandler:function(e){function t(){return new J.FontStyleToolBar(w,{hideTextPosition:!0})}switch(e){case"toolbartabs":Z.COMBINED_TOOL_PANES?(w.createToolBarTab("font",{label:j.FONT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1}),w.createToolBarTab("alignment",{label:j.ALIGNMENT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1}),w.createToolBarTab("cell",{label:j.CELL_HEADER_LABEL,visibleKey:"document/editable/cell",priority:1}),w.createToolBarTab("numberformat",{label:j.NUMBERFORMAT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1})):w.createToolBarTab("format",{label:j.FORMAT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1}),w.createToolBarTab("data",{label:j.DATA_HEADER_LABEL,visibleKey:"view/toolbartab/data/visible",priority:1}),Z.COMBINED_TOOL_PANES||w.createToolBarTab("insert",{label:j.INSERT_HEADER_LABEL,visibleKey:"view/toolbartab/insert/visible",priority:1}),w.createToolBarTab("colrow",{label:j.COL_ROW_HEADER_LABEL,visibleKey:"view/toolbartab/colrow/visible",priority:1}),Z.COMBINED_TOOL_PANES||w.createToolBarTab("table",{label:j.TABLE_HEADER_LABEL,visibleKey:"view/toolbartab/table/visible"}),w.createToolBarTab("drawing",{labelKey:"drawing/type/label",visibleKey:"view/toolbartab/drawing/visible"}),w.createToolBarTab("comments",{label:j.REVIEW_HEADER_LABEL,visibleKey:"view/toolbartab/comments/visible",priority:1});break;case"viewmenu":var o=w.topPane.viewButton;o.addSection("zoom",j.ZOOM_LABEL),o.addGroup("view/zoom/dec",new _e(j.ZOOMOUT_BUTTON_OPTIONS),{inline:!0,sticky:!0}),o.addGroup("view/zoom/inc",new _e(j.ZOOMIN_BUTTON_OPTIONS),{inline:!0,sticky:!0}),o.addGroup("view/zoom",new q.PercentageLabel,{inline:!0}),o.addSection("split",ne.pgettext("sheet-split","Split and freeze")),o.addGroup("view/split/dynamic",new q.DynamicSplitCheckBox),o.addGroup("view/split/frozen",new q.FrozenSplitCheckBox(w)),o.addSection("options",j.OPTIONS_LABEL),o.addGroup("view/toolbars/show",new Ae(j.SHOW_TOOLBARS_CHECKBOX_OPTIONS)),o.addGroup("view/commentspane/show",new Ae(j.SHOW_COMMENTSPANE_CHECKBOX_OPTIONS),{visibleKey:"document/ooxml"}),o.addGroup("document/users",new Ae(j.SHOW_COLLABORATORS_CHECKBOX_OPTIONS)),o.addGroup("view/formulapane/show",new Ae({label:ne("Show formula bar"),tooltip:ne("Show or hide the formula bar")})),o.addGroup("view/grid/show",new Ae({label:ne("Show grid lines"),tooltip:ne("Show or hide the cell grid lines in the current sheet")})),o.addGroup("view/statuspane/show",new Ae({label:ne("Show sheet tabs"),tooltip:ne("Show or hide the sheet tabs below the sheet area")}));break;case"format":Z.COMBINED_TOOL_PANES||(w.addToolBar("format",new J.FontFamilyToolBar(w),{priority:1}),w.addToolBar("format",t(),{priority:2}),w.addToolBar("format",new J.FormatPainterToolBar(w),{priority:3}),w.addToolBar("format",new J.CellColorToolBar(w),{priority:4}),w.addToolBar("format",new J.CellAlignmentToolBar(w),{priority:5}),w.addToolBar("format",new J.NumberFormatToolBar(w),{priority:6}),w.addToolBar("format",new J.CellBorderToolBar(w),{priority:7}),w.addToolBar("format",new J.CellStyleToolBar(w),{priority:8}),w.addToolBar("format",new J.BoxAlignmentToolBar(w),{priority:9,visibleKey:"view/selection/drawing"}),w.addToolBar("format",new J.ListStyleToolBar(w),{priority:10,visibleKey:"view/selection/drawing"}));break;case"font":Z.COMBINED_TOOL_PANES&&(w.addToolBar("font",new J.FontFamilyToolBar(w),{priority:1}),w.addToolBar("font",t(),{priority:2}),w.createToolBar("font",{priority:3}).addGroup("character/color",new q.TextColorPicker(w)));break;case"alignment":Z.COMBINED_TOOL_PANES&&w.addToolBar("alignment",new J.CellAlignmentToolBar(w));break;case"cell":Z.COMBINED_TOOL_PANES&&(w.createToolBar("cell").addGroup("cell/fillcolor",new q.CellFillColorPicker(w)),w.addToolBar("cell",new J.CellBorderToolBar(w)));break;case"numberformat":Z.COMBINED_TOOL_PANES&&w.addToolBar("numberformat",new J.NumberFormatToolBar(w));break;case"data":o=w.createToolBar("data");Z.COMBINED_TOOL_PANES&&o.addGroup("cell/autoformula",new q.InsertAutoSumButton).addGroup("function/insert/dialog",new q.InsertFunctionButton).addSeparator(),o.addGroup("table/sort",new q.SortMenuButton(w)).addSeparator().addGroup("table/filter",new q.FilterButton).addGroup("table/refresh",new q.RefreshButton),Z.COMBINED_TOOL_PANES||o.addSeparator().addGroup("view/namesmenu/toggle",new q.NamesMenuButton(w)),o.addSeparator().addGroup("sheet/operation/unlocked/cell",new q.CellProtectionMenuButton(w));break;case"insert":Z.COMBINED_TOOL_PANES||(w.addToolBar("insert",new J.InsertContentToolBar(w)),w.addToolBar("insert",new J.InsertDrawingToolBar(w)),w.addToolBar("insert",new J.InsertCommentToolBar(w)));break;case"colrow":w.addToolBar("colrow",new J.ColRowToolBar(w,!1)),w.addToolBar("colrow",new J.ColRowToolBar(w,!0));break;case"table":Z.COMBINED_TOOL_PANES||w.addToolBar("table",new J.TableToolBar(w));break;case"drawing":w.createToolBar("drawing").addGroup("shape/insert",new q.ShapeTypePicker(w,{label:null}),{visibleKey:"drawing/type/shape"}).addGroup("drawing/delete",new _e(j.DELETE_DRAWING_BUTTON_OPTIONS)),Z.COMBINED_TOOL_PANES||(w.createToolBar("drawing",{visibleKey:"view/toolbar/drawing/connector/visible"}).addGroup("drawing/border/style",new q.BorderPresetStylePicker(w,{label:j.LINE_STYLE_LABEL})).addGroup("drawing/border/color",new q.BorderColorPicker(w,{label:ne("Line color"),smallerVersion:{hideLabel:!0}})).addGroup("drawing/connector/arrows",new q.ArrowPresetStylePicker),w.createToolBar("drawing",{visibleKey:"view/toolbar/drawing/border/visible"}).addGroup("drawing/border/style",new q.BorderPresetStylePicker(w,{label:j.BORDER_STYLE_LABEL})).addGroup("drawing/border/color",new q.BorderColorPicker(w,{label:ne("Border color"),smallerVersion:{hideLabel:!0}})),w.createToolBar("drawing",{visibleKey:"view/toolbar/drawing/fill/visible",hideable:!0}).addGroup("drawing/fill/color",new q.FillColorPicker(w,{label:ne("Background color"),icon:"docs-drawing-fill-color",splitValue:{type:"scheme",value:"accent2"},smallerVersion:{hideLabel:!0}})),w.createToolBar("drawing",{visibleKey:"drawing/chart",priority:1}).addGroup("drawing/charttype",new q.ChartTypePicker(w)).addGap().addGroup("drawing/chartlabels",new _e(_.extend({"aria-owns":w.chartLabelsMenu.uid},j.CHART_LABELS_BUTTON_OPTIONS))).addSeparator().addGroup("drawing/chartcolorset",new q.ChartColorSetPicker(w)).addGroup("drawing/chartstyleset",new q.ChartStyleSetPicker(w)),w.createToolBar("drawing",{visibleKey:"drawing/chart",priority:2,hideable:!0}).addGroup("view/chart/datapoints/menu",new Oe(w,j.CHART_DATA_POINTS_BUTTON_OPTIONS).addGroup("drawing/chartdatalabel",new Ae(j.CHART_SHOW_POINT_LABELS_BUTTON_OPTIONS)).addGroup("drawing/chartvarycolor",new Ae(j.CHART_VARY_POINT_COLORS_BUTTON_OPTIONS))),w.createToolBar("drawing",{visibleKey:"drawing/chart",priority:3,hideable:!0}).addGroup("drawing/chartlegend/pos",new q.ChartLegendPicker(w)),w.createToolBar("drawing",{visibleKey:"drawing/chart",priority:4,hideable:!0}).addGroup("drawing/chartdatasource",new Oe(w,{label:ne.pgettext("chart-source","Data source")}).addGroup("drawing/chartsource",new _e({label:ne.pgettext("chart-source","Edit data references")})).addGroup("drawing/chartexchange",new _e({label:ne.pgettext("chart-source","Switch rows and columns")})).addGroup("drawing/chartfirstrow",new Ae({attributes:{class:"highlight"},label:ne.pgettext("chart-source","First row as label")})).addGroup("drawing/chartfirstcol",new Ae({attributes:{class:"highlight"},label:ne.pgettext("chart-source","First column as label")})))),w.createToolBar("drawing").addGroup("drawing/order",new q.DrawingArrangementPicker(w));break;case"comments":r.isOOXML()&&w.addToolBar("comments",new J.CommentsToolBar(w)),w.addToolBar("comments",new J.NotesToolBar(w),{visibleKey:"note/available/any"})}},grabFocusHandler:function(e){y&&(d&&d.isActive()?d:(e=e&&e.target)instanceof Le?w.getTargetGridPane(e):w.getActiveGridPane()).grabFocus()}});var w=this;this.propSet=this.member(new Qe(this));var t,e,m=$('<div class="abs pane-root">'),i={width:0,height:0},a=n.getNode(),T=new me,g=new me,f=0,o=!1,s=null,l=new Te(_.property("editMode")),d=null,p=$('<div class="split-line columns">'),b=$('<div class="split-line rows">'),v=$('<div class="abs split-tracking columns" style="width:4px;padding:0 3px;" tabindex="-1">'),S=$('<div class="abs split-tracking rows" style="height:4px;padding:3px 0;" tabindex="-1">'),E=$('<div class="abs split-tracking columns rows" style="width:4px;height:4px;padding:3px;" tabindex="-1">'),P=v.add(S).add(E),c=$('<div class="abs resize-tracking"><div class="abs leading"></div><div class="abs trailing"></div></div>'),u=null,h=null,B=-1,y=null,x=null,C=null,A=null,O=it.profileMethod("$badge{SpreadsheetView} updateHeaderAndGridPanes",function(e){var t,o,r,i,n,a,s,l,d,c,u=T.reduce(3,function(e,t){var o=t.headerPane.getRenderInterval();return e=o&&!Fe(t.paneSide)?Math.max(e,String(o.last).length):e}),h=f!==u;f=u,!h&&e||(o=!(t=y.hasFrozenSplit())&&y.hasSplit(),r=t?1:2,i=y.getSplitWidth(),n=y.getSplitHeight(),o&&(0<i&&(i=Math.max(i,Ge)),0<n&&(n=Math.max(n,Ge))),(a={}).left=(o||t)&&0<i,a.top=(o||t)&&0<n,w.cornerPane.initializePaneLayout(f),c=w.cornerPane.getWidth(),s=w.cornerPane.getHeight(),l=T.get(Ie.L),a.left?(l.offset=c,l.size=i,l.hiddenSize=t?x.convertScrollAnchorToPixel(y.propSet.get("anchorLeft")):0):l.offset=l.size=l.hiddenSize=0,d=T.get(Ie.T),a.top?(d.offset=s,d.size=n,d.hiddenSize=t?C.convertScrollAnchorToPixel(y.propSet.get("anchorTop")):0):d.offset=d.size=d.hiddenSize=0,i=l.offset+l.size,n=d.offset+d.size,a.right=!a.left||i+r+Ge+U.SCROLLBAR_WIDTH<=m.width(),a.bottom=!a.top||n+r+Ge+U.SCROLLBAR_HEIGHT<=m.height(),u=a.left&&a.right,h=a.top&&a.bottom,e=T.get(Ie.R),a.right?(e.offset=u?i+r:c,e.size=m.width()-e.offset,e.hiddenSize=t?l.hiddenSize+l.size:0):a.left&&(l.size=m.width()-c,e.offset=e.size=e.hiddenSize=0),c=T.get(Ie.B),a.bottom?(c.offset=h?n+r:s,c.size=m.height()-c.offset,c.hiddenSize=t?d.hiddenSize+d.size:0):a.top&&(d.size=m.height()-s,c.offset=c.size=c.hiddenSize=0),l.frozen=d.frozen=t,e.frozen=c.frozen=!1,l.showOppositeScroll=!a.right,d.showOppositeScroll=!a.bottom,e.showOppositeScroll=c.showOppositeScroll=!0,T.forEach(function(e){e.headerPane.initializePaneLayout(e)}),g.forEach(function(e,t){e.initializePaneLayout(T.get(ze(t)),T.get(Ke(t)))}),p.toggle(u).css({left:i,width:r}),b.toggle(h).css({top:n,height:r}),v.toggle(o&&u).css({left:i-4}),S.toggle(o&&h).css({top:n-4}),E.toggle(o&&u&&h).css({left:i-4,top:n-4}))}),L=it.profileMethod("$badge{SpreadsheetView} updateRenderingLayers",function(e,t,o){O(!(o&&o.initialize));var r=new Re;o&&o.full?r.push(n.getSheetRange()):(e&&r.append(n.makeColRanges(e)),t&&r.append(n.makeRowRanges(t)),r=r.merge()),r.empty()||(it.log("dirty ranges: "+r),(o=o||{}).force=!0);var i=new we;T.forEach(function(e){var t=e.headerPane.updateLayerInterval(o);t&&i.insert(e.paneSide,t)}),O(!0),i.empty()||w.renderCache.updateLayerRanges(i,r).forEach(function(e,t){g.get(t).setLayerRange(e,r,o)})}),M=(t={},e=it.profileMethod("$badge{SpreadsheetView} initializePanes",function(){var e;y&&(e=w.hasAppFocus(),t.initialize=!0,L(null,null,t),t={},o=!0,e&&w.grabFocus())}),r.createDebouncedFor(w,function(e){t.full=t.full||e&&e.full,t.force=t.force||e&&e.force,o=!1},e));function N(e){var t=e.selection;t&&w.trigger("change:selection:prepare",t),w.trigger("change:sheetprops",e),t&&w.trigger("change:selection",t)}var R,k,H,G=(R=new Ne,k=new Ne,r.createDebouncedFor(w,function(e,t){switch(e.type){case"move:columns":R.push(new Me(t.intervals.boundary().first,n.getMaxCol()));break;case"change:columns":t.size?(R.push(new Me(0,n.getMaxCol())),y.hasFrozenSplit()&&M()):R.append(t.intervals);break;case"move:rows":k.push(new Me(t.intervals.boundary().first,n.getMaxRow()));break;case"change:rows":t.size?(k.push(new Me(t.intervals.boundary().first,n.getMaxRow())),y.hasFrozenSplit()&&M()):k.append(t.intervals);break;default:xe.error('$badge{SpreadsheetView} colRowHandler: unknown event "'+e.type+'"')}},function(){L(R,k),R.clear(),k.clear()}));function I(t){var e=$(this),o=e.hasClass("columns"),r=e.hasClass("rows"),i=w.getHeaderWidth(),n=m.width()-U.SCROLLBAR_WIDTH-2,a=w.getHeaderHeight(),s=m.height()-U.SCROLLBAR_HEIGHT-2,l=T.get(Ie.L),d=T.get(Ie.T);function c(){var e=l.offset+l.size+(o?t.offsetX:0);return e-Ge<i?i:n<e+Ge?n:e}function u(){var e=d.offset+d.size+(r?t.offsetY:0);return e-Ge<a?a:s<e+Ge?s:e}function h(e,t,o,r,i){e.toggleClass("collapsed",o<=r||i<=o).add(E).css(t,o-4+"px")}function g(){P.removeClass("tracking-active"),w.grabFocus()}switch(t.type){case"tracking:start":v.toggleClass("tracking-active",o),S.toggleClass("tracking-active",r);break;case"tracking:move":o&&h(v,"left",c(),i,n),r&&h(S,"top",u(),a,s);break;case"tracking:end":var f=null,p=null,f=o?(f=c(),i<f&&f<n?y.convertPixelToHmm(f-w.getHeaderWidth()):0):y.getSplitWidthHmm(),p=r?(p=u(),a<p||p<s?y.convertPixelToHmm(p-w.getHeaderHeight()):0):y.getSplitHeightHmm();y.setDynamicSplit(f,p),g();break;case"tracking:cancel":M(),g()}}function D(e){if(!w.isTextEditMode())return w.hasDrawingSelection()?Be(e,"F2")?(w.enterTextEditMode("drawing"),!1):Be(e,"DELETE")||Be(e,"BACKSPACE")?(w.requireEditMode()&&w.executeControllerItem("drawing/delete"),!1):void 0:Be(e,"F2")?(w.enterTextEditMode("cell"),!1):Be(e,"F10")?(z(e),!1):!_.browser.MacOS&&Be(e,"BACKSPACE")?(w.enterTextEditMode("cell",{text:""}),!1):Be(e,"DELETE")||_.browser.MacOS&&Be(e,"BACKSPACE")?(w.requireEditMode()&&w.executeControllerItem("cell/clear/values"),!1):void 0}function F(e){if(!w.isTextEditMode()){var t=!!e.ctrlKey,o=!!e.metaKey,r=!!e.altKey;if(32<e.charCode&&(_.browser.MacOS?t==o:(t||o)==r)||32===e.charCode&&!Pe(e)){var i=String.fromCharCode(e.charCode),r=w.hasDrawingSelection()?"drawing":"cell",e={text:i};return"cell"==r&&(e.quick=!0,e.autoComplete=!0,"percent"!==w.getNumberFormatCategory()||!/^[-+0-9]$/.test(i)&&i!==Ce.dec||(e.text+="%",e.pos=1)),w.enterTextEditMode(r,e),!1}}}function z(e){var t=$(e.target);if(!t.is("input, textarea")){var o=_.browser.IE?t.is(".clipboard"):U.isContextEventTriggeredByKeyboard(e),r=w.getSelectedDrawings(),i=w.getActiveGridPane(),n=i.getLayerRootNode(),a=n.parent(),s=n.offset(),l=n.position(),d=a.scrollLeft(),n=a.scrollTop(),a=null;return t.is(".header-pane .cell")?a=t:t.is(".status-pane .button, .status-pane .button *")||o&&0<$(".status-pane .active-sheet-group.focused .selected").length?o&&0<$(".status-pane .active-sheet-group.focused .selected").length?(a=$(".status-pane .active-sheet-group.focused .button.selected"),e.pageX+=Math.round(a.width()/2),e.pageY+=Math.round(a.height()/2)):(e.pageX||e.pageY||(e.pageX=t.offset().left,e.pageY=t.offset().top),a=t):0<r.length?(a=i.drawingRenderer.getDrawingFrame(r[0]),h?(e.pageX=h.pageX,e.pageY=h.pageY):o&&(r=A.getModel(r[0]).getRectangle(),e.target=a,e.pageX=Math.round(r.centerX())-l.left+s.left-d,e.pageY=Math.round(r.centerY())-l.top+s.top-n)):t.is(".grid-pane *, html")&&(a=i.getNode(),h?(e.pageX=h.pageX,e.pageY=h.pageY):o&&(o=y.getCellRectangle(w.getActiveCell(),{pixel:!0,expandMerged:!0}),e.pageX=Math.round(o.centerX())-l.left+s.left-d,e.pageY=Math.round(o.centerY())-l.top+s.top-n)),a&&V.triggerShowEvent(a,e),!1}}function K(e){l.insert(e),w.forwardEvents(e),w.listenTo(e,"textedit:enter",function(){d=e}),w.listenTo(e,"textedit:leave",function(){d=null})}this.addSheetActionButtons=function(e,t){return t&&t.insertSheet&&(e.addGroup("document/insertsheet",new _e({label:j.INSERT_SHEET_LABEL})),e.addSeparator()),e.addGroup("sheet/rename/dialog",new _e({label:j.RENAME_SHEET_LABEL})),e.addGroup("document/copysheet/dialog",new _e({label:j.COPY_SHEET_LABEL}),{visibleKey:"document/ooxml"}),e.addGroup("document/deletesheet",new _e({label:j.DELETE_SHEET_LABEL})),e.addGroup("sheet/visible",new q.ShowSheetButton),e.addGroup("sheet/locked",new q.LockSheetButton),e.addSeparator(),e.addGroup("document/movesheets/dialog",new _e({label:j.REORDER_SHEETS_LABEL})),e.addGroup("document/showsheets/dialog",new _e({label:j.UNHIDE_SHEETS_LABEL})),this},this.getGridPane=function(e){return g.get(e)},this.getVisibleGridPane=function(e){return 0===T.get(ze(e)).size&&(e=Ue(e)),0===T.get(Ke(e)).size&&(e=Ve(e)),g.get(e)},this.getActiveGridPane=function(){return this.getVisibleGridPane(y.propSet.get("activePane"))},this.getTargetGridPane=function(e){if(!y.hasFrozenSplit())return this.getActiveGridPane();var t=y.getSplitColInterval(),o=y.getSplitRowInterval(),t=t&&e[0]<=t.last?Ie.L:Ie.R,o=o&&e[1]<=o.last?Ie.T:Ie.B;return this.getVisibleGridPane(We(t,o))},this.getGridPaneForEvent=function(t){return g.find(function(e){return e.containsEventOffset(t)})||null},this.updateActiveGridPane=function(e){o&&!this.isTextEditMode("cell")&&y.propSet.set("activePane",e)},this.iterateGridPanes=function(e,t){g.forEach(e,t)},this.getHeaderPane=function(e){return T.get(e).headerPane},this.getColHeaderPane=function(e){return this.getHeaderPane(ze(e))},this.getRowHeaderPane=function(e){return this.getHeaderPane(Ke(e))},this.getVisibleHeaderPane=function(e){e=e?0<T.get(Ie.L).size?Ie.L:Ie.R:0<T.get(Ie.T).size?Ie.T:Ie.B;return this.getHeaderPane(e)},this.getActiveHeaderPane=function(e){return this.getActiveGridPane().getHeaderPane(e)},this.iterateHeaderPanes=function(t,o){T.forEach(function(e){t.call(o,e.headerPane,e.paneSide)})},this.getHeaderWidth=function(){return this.cornerPane.getWidth()},this.getHeaderHeight=function(){return this.cornerPane.getHeight()},this.getVisibleIntervals=function(o,r){var i=new Ne;return o=Ne.cast(o),this.iterateHeaderPanes(function(e,t){Fe(t)===r&&e.isVisible()&&i.append(o.intersect(e.getRenderInterval()))}),i.merge()},this.yellMessage=function(e,t){if("readonly"===e)return r.rejectEditAttempt();if("image:insert"===e)return r.rejectEditAttempt("image");if(e in j.RESULT_MESSAGES){t=t?"success":"info",e=j.RESULT_MESSAGES[e];if(_.isObject(e)&&(e=e[r.getFileFormat()]),se(e)&&e)return this.yell({type:t,message:e,skipPlugged:!0})}return!1},this.yellOnFailure=function(e){return this.catch(e,function(e){this.yellMessage(U.getStringOption(e,"cause",""))}),e},this.requireEditMode=function(){var e=this.isEditable();return e||this.yellMessage("readonly"),e},this.getStatusLabel=function(){return u},this.setStatusLabel=function(e){u!==e&&(u=e,this.trigger("change:statuslabel",e))},this.getZoomFactor=function(){return y?y.getEffectiveZoom():1},this.getHeaderFontSize=function(){return he(ge(5*this.getZoomFactor()+6,.1),8,ve?12:30)},this.registerCanvasRenderer=function(t){g.forEach(function(e){e.cellRenderer.registerCanvasRenderer(t)})},this.getActiveSheet=function(){return B},this.getSheetModel=function(){return y},this.getCommentCollection=function(){return y?y.commentCollection:null},this.convertPixelToHmm=function(e){return y.convertPixelToHmm(e)},this.convertHmmToPixel=function(e){return y.convertHmmToPixel(e)},this.getSheetRectangle=function(){return y.getSheetRectangle({pixel:!0})},this.getRangeRectangle=function(e){return y.getRangeRectangle(e,{pixel:!0})},this.getCellRectangle=function(e,t){return y.getCellRectangle(e,_.extend({},t,{pixel:!0}))},this.createRemoteSelectionIterator=function(){return be.from(this.propSet.get("remoteClients")).mapIterator(function(e){if(e.userData.sheet===B){var t=(t=le(e.userData,"ranges"))&&n.addressFactory.parseRangeList(t),o=de(e.userData,"drawings");return o&&0===o.length&&(o=null),t||o?{userName:e.userName,colorIndex:e.colorIndex,ranges:t,drawings:o}:void 0}})},this.scrollToCell=function(e,t){var o=this.getTargetGridPane(e);t&&t.preserveFocus||this.grabFocus({target:e}),o.scrollToCell(e)},this.scrollToDrawingFrame=function(e){(y.hasFrozenSplit()?this.getVisibleGridPane(De.BR):this.getActiveGridPane()).scrollToDrawingFrame(e)},this.startProcessingScrollEvents=(H=w.debounce(function(){w.stopProcessingScrollEvents()},{delay:100}),function(e){return(!s||e===s)&&(s=e,H(),!0)}),this.isProcessingScrollEvents=function(e){return e===s},this.stopProcessingScrollEvents=function(){s=null},this.tempShowDrawingFrame=function(t){g.forEach(function(e){e.drawingRenderer.tempShowDrawingFrame(t)})},this.tempHideDrawingFrame=function(t){g.forEach(function(e){e.drawingRenderer.tempHideDrawingFrame(t)})},this.activateUnsavedCommentCollection=function(){var e=n.createSheetIterator({supported:!0,visible:!0}).find(function(e){return e.hasUnsavedComment()});if(e){var t=e.getIndex();if(t!==B)return this.leaveTextEditMode({force:!0}).then(function(){n.setActiveSheet(t)})}},this.isTextEditMode=function(e){return null!==d&&(!e||d.editMode===e)},this.getActiveTextEditor=function(e){return this.isTextEditMode(e)?d:null},this.enterTextEditMode=at.profileMethod("SpreadsheetView.enterTextEditMode",function(e,t){e=l.get(e);return e?(t&&t.restart&&e===d&&d.cancelEditMode(),((!d||e===d||d.leaveEditMode())&&e.enterEditMode(t)?ce:ue)()):ue()}),this.leaveTextEditMode=at.profileMethod("SpreadsheetView.leaveTextEditMode",function(e){return!this.isTextEditMode(e&&e.editMode)||d.leaveEditMode(e)?n.waitForActionsProcessed():ue()}),this.cancelTextEditMode=function(e){this.isTextEditMode(e&&e.editMode)&&d.cancelEditMode()},this.getTextEditFocusNode=function(e){return this.isTextEditMode(e&&e.editMode)?d.getFocusNode():void 0},this.getTextAttributeSet=function(){var e=n.getAttributePool(),t={};return e.extendAttributeSet(t,n.getAttributes("paragraph")),e.extendAttributeSet(t,n.getAttributes("character")),t},this.setTextAttributeSet=function(e){var t=(t=this.ensureUnlockedDrawings()).then(function(){return n.setAttributes("character",e)});return this.yellOnFailure(t)},this.recalculateDocumentMargin=_.noop,Ee(m),this.namesMenu=new Q(this),this.chartLabelsMenu=new X(this,{anchorBox:function(){return w.getActiveGridPane().getScrollNode()}}),this.renderCache=new oe(this),this.rangeHighlighter=new nt(n),ke.forEach(function(e){T.insert(e,new st(this,e))},this),He.forEach(function(e){g.insert(e,new rt(this,e))},this),this.cornerPane=new ot(this),K(new re(this)),K(new ie(this)),ee.call(this,m),te.call(this),this.registerDestructor(function(){this.renderCache.destroy(),g.destroy(),T.destroy(),this.cornerPane.destroy(),this.namesMenu.destroy(),this.chartLabelsMenu.destroy(),this.rangeHighlighter.destroy(),l.destroy()})})});